// A Bison parser, made by GNU Bison 3.3.2.

// Skeleton implementation for Bison LALR(1) parsers in C++

// Copyright (C) 2002-2015, 2018-2019 Free Software Foundation, Inc.

// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

// As a special exception, you may create a larger work that contains
// part or all of the Bison parser skeleton and distribute that work
// under terms of your choice, so long as that work isn't itself a
// parser generator using the skeleton or a modified version thereof
// as a parser skeleton.  Alternatively, if you modify or redistribute
// the parser skeleton itself, you may (at your option) remove this
// special exception, which will cause the skeleton and the resulting
// Bison output files to be licensed under the GNU General Public
// License without this special exception.

// This special exception was added by the Free Software Foundation in
// version 2.2 of Bison.

// Undocumented macros, especially those whose name start with YY_,
// are private implementation details.  Do not rely on them.

// //                    "%code top" blocks.
#line 30 "DynareBison.yy" // lalr1.cc:423

class ParsingDriver;

#line 42 "DynareBison.cc" // lalr1.cc:423




#include "DynareBison.hh"


// Unqualified %code blocks.
#line 48 "DynareBison.yy" // lalr1.cc:435

/* Little hack: we redefine the macro which computes the locations, because
   we need to access the location from within the parsing driver for error
   and warning messages. */
#define YYLLOC_DEFAULT(Current, Rhs, N)                         \
  do {                                                          \
    if (N)                                                      \
      {                                                         \
        (Current).begin = YYRHSLOC(Rhs, 1).begin;               \
        (Current).end   = YYRHSLOC(Rhs, N).end;                 \
      }                                                         \
    else                                                        \
      {                                                         \
        (Current).begin = (Current).end = YYRHSLOC(Rhs, 0).end;	\
      }                                                         \
    driver.location = (Current);                                \
  } while(false)

#include "ParsingDriver.hh"

/* this "connects" the bison parser in the driver to the flex scanner class
 * object. it defines the yylex() function call to pull the next token from the
 * current lexer object of the driver context. */
#undef yylex
#define yylex driver.lexer->lex

#line 78 "DynareBison.cc" // lalr1.cc:435


#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> // FIXME: INFRINGES ON USER NAME SPACE.
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

// Whether we are compiled with exception support.
#ifndef YY_EXCEPTIONS
# if defined __GNUC__ && !defined __EXCEPTIONS
#  define YY_EXCEPTIONS 0
# else
#  define YY_EXCEPTIONS 1
# endif
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K].location)
/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

# ifndef YYLLOC_DEFAULT
#  define YYLLOC_DEFAULT(Current, Rhs, N)                               \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).begin  = YYRHSLOC (Rhs, 1).begin;                   \
          (Current).end    = YYRHSLOC (Rhs, N).end;                     \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).begin = (Current).end = YYRHSLOC (Rhs, 0).end;      \
        }                                                               \
    while (false)
# endif


// Suppress unused-variable warnings by "using" E.
#define YYUSE(E) ((void) (E))

// Enable debugging if requested.
#if YYDEBUG

// A pseudo ostream that takes yydebug_ into account.
# define YYCDEBUG if (yydebug_) (*yycdebug_)

# define YY_SYMBOL_PRINT(Title, Symbol)         \
  do {                                          \
    if (yydebug_)                               \
    {                                           \
      *yycdebug_ << Title << ' ';               \
      yy_print_ (*yycdebug_, Symbol);           \
      *yycdebug_ << '\n';                       \
    }                                           \
  } while (false)

# define YY_REDUCE_PRINT(Rule)          \
  do {                                  \
    if (yydebug_)                       \
      yy_reduce_print_ (Rule);          \
  } while (false)

# define YY_STACK_PRINT()               \
  do {                                  \
    if (yydebug_)                       \
      yystack_print_ ();                \
  } while (false)

#else // !YYDEBUG

# define YYCDEBUG if (false) std::cerr
# define YY_SYMBOL_PRINT(Title, Symbol)  YYUSE (Symbol)
# define YY_REDUCE_PRINT(Rule)           static_cast<void> (0)
# define YY_STACK_PRINT()                static_cast<void> (0)

#endif // !YYDEBUG

#define yyerrok         (yyerrstatus_ = 0)
#define yyclearin       (yyla.clear ())

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYRECOVERING()  (!!yyerrstatus_)

#line 25 "DynareBison.yy" // lalr1.cc:510
namespace Dynare {
#line 173 "DynareBison.cc" // lalr1.cc:510

  /* Return YYSTR after stripping away unnecessary quotes and
     backslashes, so that it's suitable for yyerror.  The heuristic is
     that double-quoting is unnecessary unless the string contains an
     apostrophe, a comma, or backslash (other than backslash-backslash).
     YYSTR is taken from yytname.  */
  std::string
  parser::yytnamerr_ (const char *yystr)
  {
    if (*yystr == '"')
      {
        std::string yyr;
        char const *yyp = yystr;

        for (;;)
          switch (*++yyp)
            {
            case '\'':
            case ',':
              goto do_not_strip_quotes;

            case '\\':
              if (*++yyp != '\\')
                goto do_not_strip_quotes;
              else
                goto append;

            append:
            default:
              yyr += *yyp;
              break;

            case '"':
              return yyr;
            }
      do_not_strip_quotes: ;
      }

    return yystr;
  }


  /// Build a parser object.
  parser::parser (ParsingDriver &driver_yyarg)
    :
#if YYDEBUG
      yydebug_ (false),
      yycdebug_ (&std::cerr),
#endif
      driver (driver_yyarg)
  {}

  parser::~parser ()
  {}

  parser::syntax_error::~syntax_error () YY_NOEXCEPT YY_NOTHROW
  {}

  /*---------------.
  | Symbol types.  |
  `---------------*/

  // basic_symbol.
#if 201103L <= YY_CPLUSPLUS
  template <typename Base>
  parser::basic_symbol<Base>::basic_symbol (basic_symbol&& that)
    : Base (std::move (that))
    , value ()
    , location (std::move (that.location))
  {
    switch (this->type_get ())
    {
      case 840: // prior_distribution
      case 841: // prior_pdf
        value.move< PriorDistributions > (std::move (that.value));
        break;

      case 714: // change_type_arg
        value.move< SymbolType > (std::move (that.value));
        break;

      case 718: // expression
      case 721: // expression_or_empty
      case 745: // equation
      case 748: // hand_side
        value.move< expr_t > (std::move (that.value));
        break;

      case 1006: // calibration_range
        value.move< pair<expr_t,expr_t> > (std::move (that.value));
        break;

      case 704: // named_var_elem
      case 850: // subsamples_eq_opt
      case 1471: // integer_range_w_inf
        value.move< pair<string,string> > (std::move (that.value));
        break;

      case 88: // FALSE
      case 89: // FLOAT_NUMBER
      case 90: // DATES
      case 138: // INT_NUMBER
      case 235: // NAME
      case 297: // QUOTED_STRING
      case 350: // TEX_NAME
      case 351: // TRUE
      case 474: // ALPHA
      case 475: // BETA
      case 476: // ABAND
      case 477: // NINV
      case 478: // CMS
      case 479: // NCMS
      case 480: // CNUM
      case 481: // GAMMA
      case 482: // INV_GAMMA
      case 483: // INV_GAMMA1
      case 484: // INV_GAMMA2
      case 485: // NORMAL
      case 486: // UNIFORM
      case 487: // EPS
      case 488: // PDF
      case 489: // FIG
      case 490: // DR
      case 491: // NONE
      case 492: // PRIOR
      case 493: // PRIOR_VARIANCE
      case 494: // HESSIAN
      case 495: // IDENTITY_MATRIX
      case 496: // DIRICHLET
      case 497: // DIAGONAL
      case 498: // OPTIMAL
      case 819: // signed_integer
      case 820: // non_negative_number
      case 821: // signed_number
      case 822: // signed_inf
      case 823: // signed_number_w_inf
      case 824: // boolean
      case 842: // date_str
      case 843: // date_expr
      case 876: // list_sub_sampling_option
      case 877: // sub_sampling_options
      case 904: // filename
      case 905: // namespace_qualified_symbol
      case 906: // namespace_qualified_filename
      case 1469: // range
      case 1470: // integer_range
      case 1472: // signed_integer_range
      case 1479: // vec_value_1
      case 1480: // vec_value
      case 1481: // vec_value_list
      case 1482: // vec_of_vec_value
      case 1483: // vec_value_1_w_inf
      case 1484: // vec_value_w_inf
      case 1485: // symbol
      case 1486: // number
        value.move< string > (std::move (that.value));
        break;

      case 865: // prior_eq_opt
      case 870: // options_eq_opt
        value.move< tuple<string,string,string,string> > (std::move (that.value));
        break;

      case 1473: // vec_int_number
      case 1474: // vec_int_elem
      case 1475: // vec_int_1
      case 1476: // vec_int
        value.move< vector<int> > (std::move (that.value));
        break;

      case 705: // named_var_1
      case 706: // named_var
        value.move< vector<pair<string,string>> > (std::move (that.value));
        break;

      case 645: // SYMBOL_VEC
      case 715: // change_type_var_list
      case 1477: // vec_str_1
      case 1478: // vec_str
        value.move< vector<string> > (std::move (that.value));
        break;

      default:
        break;
    }

  }
#endif

  template <typename Base>
  parser::basic_symbol<Base>::basic_symbol (const basic_symbol& that)
    : Base (that)
    , value ()
    , location (that.location)
  {
    switch (this->type_get ())
    {
      case 840: // prior_distribution
      case 841: // prior_pdf
        value.copy< PriorDistributions > (YY_MOVE (that.value));
        break;

      case 714: // change_type_arg
        value.copy< SymbolType > (YY_MOVE (that.value));
        break;

      case 718: // expression
      case 721: // expression_or_empty
      case 745: // equation
      case 748: // hand_side
        value.copy< expr_t > (YY_MOVE (that.value));
        break;

      case 1006: // calibration_range
        value.copy< pair<expr_t,expr_t> > (YY_MOVE (that.value));
        break;

      case 704: // named_var_elem
      case 850: // subsamples_eq_opt
      case 1471: // integer_range_w_inf
        value.copy< pair<string,string> > (YY_MOVE (that.value));
        break;

      case 88: // FALSE
      case 89: // FLOAT_NUMBER
      case 90: // DATES
      case 138: // INT_NUMBER
      case 235: // NAME
      case 297: // QUOTED_STRING
      case 350: // TEX_NAME
      case 351: // TRUE
      case 474: // ALPHA
      case 475: // BETA
      case 476: // ABAND
      case 477: // NINV
      case 478: // CMS
      case 479: // NCMS
      case 480: // CNUM
      case 481: // GAMMA
      case 482: // INV_GAMMA
      case 483: // INV_GAMMA1
      case 484: // INV_GAMMA2
      case 485: // NORMAL
      case 486: // UNIFORM
      case 487: // EPS
      case 488: // PDF
      case 489: // FIG
      case 490: // DR
      case 491: // NONE
      case 492: // PRIOR
      case 493: // PRIOR_VARIANCE
      case 494: // HESSIAN
      case 495: // IDENTITY_MATRIX
      case 496: // DIRICHLET
      case 497: // DIAGONAL
      case 498: // OPTIMAL
      case 819: // signed_integer
      case 820: // non_negative_number
      case 821: // signed_number
      case 822: // signed_inf
      case 823: // signed_number_w_inf
      case 824: // boolean
      case 842: // date_str
      case 843: // date_expr
      case 876: // list_sub_sampling_option
      case 877: // sub_sampling_options
      case 904: // filename
      case 905: // namespace_qualified_symbol
      case 906: // namespace_qualified_filename
      case 1469: // range
      case 1470: // integer_range
      case 1472: // signed_integer_range
      case 1479: // vec_value_1
      case 1480: // vec_value
      case 1481: // vec_value_list
      case 1482: // vec_of_vec_value
      case 1483: // vec_value_1_w_inf
      case 1484: // vec_value_w_inf
      case 1485: // symbol
      case 1486: // number
        value.copy< string > (YY_MOVE (that.value));
        break;

      case 865: // prior_eq_opt
      case 870: // options_eq_opt
        value.copy< tuple<string,string,string,string> > (YY_MOVE (that.value));
        break;

      case 1473: // vec_int_number
      case 1474: // vec_int_elem
      case 1475: // vec_int_1
      case 1476: // vec_int
        value.copy< vector<int> > (YY_MOVE (that.value));
        break;

      case 705: // named_var_1
      case 706: // named_var
        value.copy< vector<pair<string,string>> > (YY_MOVE (that.value));
        break;

      case 645: // SYMBOL_VEC
      case 715: // change_type_var_list
      case 1477: // vec_str_1
      case 1478: // vec_str
        value.copy< vector<string> > (YY_MOVE (that.value));
        break;

      default:
        break;
    }

  }



  template <typename Base>
  bool
  parser::basic_symbol<Base>::empty () const YY_NOEXCEPT
  {
    return Base::type_get () == empty_symbol;
  }

  template <typename Base>
  void
  parser::basic_symbol<Base>::move (basic_symbol& s)
  {
    super_type::move (s);
    switch (this->type_get ())
    {
      case 840: // prior_distribution
      case 841: // prior_pdf
        value.move< PriorDistributions > (YY_MOVE (s.value));
        break;

      case 714: // change_type_arg
        value.move< SymbolType > (YY_MOVE (s.value));
        break;

      case 718: // expression
      case 721: // expression_or_empty
      case 745: // equation
      case 748: // hand_side
        value.move< expr_t > (YY_MOVE (s.value));
        break;

      case 1006: // calibration_range
        value.move< pair<expr_t,expr_t> > (YY_MOVE (s.value));
        break;

      case 704: // named_var_elem
      case 850: // subsamples_eq_opt
      case 1471: // integer_range_w_inf
        value.move< pair<string,string> > (YY_MOVE (s.value));
        break;

      case 88: // FALSE
      case 89: // FLOAT_NUMBER
      case 90: // DATES
      case 138: // INT_NUMBER
      case 235: // NAME
      case 297: // QUOTED_STRING
      case 350: // TEX_NAME
      case 351: // TRUE
      case 474: // ALPHA
      case 475: // BETA
      case 476: // ABAND
      case 477: // NINV
      case 478: // CMS
      case 479: // NCMS
      case 480: // CNUM
      case 481: // GAMMA
      case 482: // INV_GAMMA
      case 483: // INV_GAMMA1
      case 484: // INV_GAMMA2
      case 485: // NORMAL
      case 486: // UNIFORM
      case 487: // EPS
      case 488: // PDF
      case 489: // FIG
      case 490: // DR
      case 491: // NONE
      case 492: // PRIOR
      case 493: // PRIOR_VARIANCE
      case 494: // HESSIAN
      case 495: // IDENTITY_MATRIX
      case 496: // DIRICHLET
      case 497: // DIAGONAL
      case 498: // OPTIMAL
      case 819: // signed_integer
      case 820: // non_negative_number
      case 821: // signed_number
      case 822: // signed_inf
      case 823: // signed_number_w_inf
      case 824: // boolean
      case 842: // date_str
      case 843: // date_expr
      case 876: // list_sub_sampling_option
      case 877: // sub_sampling_options
      case 904: // filename
      case 905: // namespace_qualified_symbol
      case 906: // namespace_qualified_filename
      case 1469: // range
      case 1470: // integer_range
      case 1472: // signed_integer_range
      case 1479: // vec_value_1
      case 1480: // vec_value
      case 1481: // vec_value_list
      case 1482: // vec_of_vec_value
      case 1483: // vec_value_1_w_inf
      case 1484: // vec_value_w_inf
      case 1485: // symbol
      case 1486: // number
        value.move< string > (YY_MOVE (s.value));
        break;

      case 865: // prior_eq_opt
      case 870: // options_eq_opt
        value.move< tuple<string,string,string,string> > (YY_MOVE (s.value));
        break;

      case 1473: // vec_int_number
      case 1474: // vec_int_elem
      case 1475: // vec_int_1
      case 1476: // vec_int
        value.move< vector<int> > (YY_MOVE (s.value));
        break;

      case 705: // named_var_1
      case 706: // named_var
        value.move< vector<pair<string,string>> > (YY_MOVE (s.value));
        break;

      case 645: // SYMBOL_VEC
      case 715: // change_type_var_list
      case 1477: // vec_str_1
      case 1478: // vec_str
        value.move< vector<string> > (YY_MOVE (s.value));
        break;

      default:
        break;
    }

    location = YY_MOVE (s.location);
  }

  // by_type.
  parser::by_type::by_type ()
    : type (empty_symbol)
  {}

#if 201103L <= YY_CPLUSPLUS
  parser::by_type::by_type (by_type&& that)
    : type (that.type)
  {
    that.clear ();
  }
#endif

  parser::by_type::by_type (const by_type& that)
    : type (that.type)
  {}

  parser::by_type::by_type (token_type t)
    : type (yytranslate_ (t))
  {}

  void
  parser::by_type::clear ()
  {
    type = empty_symbol;
  }

  void
  parser::by_type::move (by_type& that)
  {
    type = that.type;
    that.clear ();
  }

  int
  parser::by_type::type_get () const YY_NOEXCEPT
  {
    return type;
  }


  // by_state.
  parser::by_state::by_state () YY_NOEXCEPT
    : state (empty_state)
  {}

  parser::by_state::by_state (const by_state& that) YY_NOEXCEPT
    : state (that.state)
  {}

  void
  parser::by_state::clear () YY_NOEXCEPT
  {
    state = empty_state;
  }

  void
  parser::by_state::move (by_state& that)
  {
    state = that.state;
    that.clear ();
  }

  parser::by_state::by_state (state_type s) YY_NOEXCEPT
    : state (s)
  {}

  parser::symbol_number_type
  parser::by_state::type_get () const YY_NOEXCEPT
  {
    if (state == empty_state)
      return empty_symbol;
    else
      return yystos_[state];
  }

  parser::stack_symbol_type::stack_symbol_type ()
  {}

  parser::stack_symbol_type::stack_symbol_type (YY_RVREF (stack_symbol_type) that)
    : super_type (YY_MOVE (that.state), YY_MOVE (that.location))
  {
    switch (that.type_get ())
    {
      case 840: // prior_distribution
      case 841: // prior_pdf
        value.YY_MOVE_OR_COPY< PriorDistributions > (YY_MOVE (that.value));
        break;

      case 714: // change_type_arg
        value.YY_MOVE_OR_COPY< SymbolType > (YY_MOVE (that.value));
        break;

      case 718: // expression
      case 721: // expression_or_empty
      case 745: // equation
      case 748: // hand_side
        value.YY_MOVE_OR_COPY< expr_t > (YY_MOVE (that.value));
        break;

      case 1006: // calibration_range
        value.YY_MOVE_OR_COPY< pair<expr_t,expr_t> > (YY_MOVE (that.value));
        break;

      case 704: // named_var_elem
      case 850: // subsamples_eq_opt
      case 1471: // integer_range_w_inf
        value.YY_MOVE_OR_COPY< pair<string,string> > (YY_MOVE (that.value));
        break;

      case 88: // FALSE
      case 89: // FLOAT_NUMBER
      case 90: // DATES
      case 138: // INT_NUMBER
      case 235: // NAME
      case 297: // QUOTED_STRING
      case 350: // TEX_NAME
      case 351: // TRUE
      case 474: // ALPHA
      case 475: // BETA
      case 476: // ABAND
      case 477: // NINV
      case 478: // CMS
      case 479: // NCMS
      case 480: // CNUM
      case 481: // GAMMA
      case 482: // INV_GAMMA
      case 483: // INV_GAMMA1
      case 484: // INV_GAMMA2
      case 485: // NORMAL
      case 486: // UNIFORM
      case 487: // EPS
      case 488: // PDF
      case 489: // FIG
      case 490: // DR
      case 491: // NONE
      case 492: // PRIOR
      case 493: // PRIOR_VARIANCE
      case 494: // HESSIAN
      case 495: // IDENTITY_MATRIX
      case 496: // DIRICHLET
      case 497: // DIAGONAL
      case 498: // OPTIMAL
      case 819: // signed_integer
      case 820: // non_negative_number
      case 821: // signed_number
      case 822: // signed_inf
      case 823: // signed_number_w_inf
      case 824: // boolean
      case 842: // date_str
      case 843: // date_expr
      case 876: // list_sub_sampling_option
      case 877: // sub_sampling_options
      case 904: // filename
      case 905: // namespace_qualified_symbol
      case 906: // namespace_qualified_filename
      case 1469: // range
      case 1470: // integer_range
      case 1472: // signed_integer_range
      case 1479: // vec_value_1
      case 1480: // vec_value
      case 1481: // vec_value_list
      case 1482: // vec_of_vec_value
      case 1483: // vec_value_1_w_inf
      case 1484: // vec_value_w_inf
      case 1485: // symbol
      case 1486: // number
        value.YY_MOVE_OR_COPY< string > (YY_MOVE (that.value));
        break;

      case 865: // prior_eq_opt
      case 870: // options_eq_opt
        value.YY_MOVE_OR_COPY< tuple<string,string,string,string> > (YY_MOVE (that.value));
        break;

      case 1473: // vec_int_number
      case 1474: // vec_int_elem
      case 1475: // vec_int_1
      case 1476: // vec_int
        value.YY_MOVE_OR_COPY< vector<int> > (YY_MOVE (that.value));
        break;

      case 705: // named_var_1
      case 706: // named_var
        value.YY_MOVE_OR_COPY< vector<pair<string,string>> > (YY_MOVE (that.value));
        break;

      case 645: // SYMBOL_VEC
      case 715: // change_type_var_list
      case 1477: // vec_str_1
      case 1478: // vec_str
        value.YY_MOVE_OR_COPY< vector<string> > (YY_MOVE (that.value));
        break;

      default:
        break;
    }

#if 201103L <= YY_CPLUSPLUS
    // that is emptied.
    that.state = empty_state;
#endif
  }

  parser::stack_symbol_type::stack_symbol_type (state_type s, YY_MOVE_REF (symbol_type) that)
    : super_type (s, YY_MOVE (that.location))
  {
    switch (that.type_get ())
    {
      case 840: // prior_distribution
      case 841: // prior_pdf
        value.move< PriorDistributions > (YY_MOVE (that.value));
        break;

      case 714: // change_type_arg
        value.move< SymbolType > (YY_MOVE (that.value));
        break;

      case 718: // expression
      case 721: // expression_or_empty
      case 745: // equation
      case 748: // hand_side
        value.move< expr_t > (YY_MOVE (that.value));
        break;

      case 1006: // calibration_range
        value.move< pair<expr_t,expr_t> > (YY_MOVE (that.value));
        break;

      case 704: // named_var_elem
      case 850: // subsamples_eq_opt
      case 1471: // integer_range_w_inf
        value.move< pair<string,string> > (YY_MOVE (that.value));
        break;

      case 88: // FALSE
      case 89: // FLOAT_NUMBER
      case 90: // DATES
      case 138: // INT_NUMBER
      case 235: // NAME
      case 297: // QUOTED_STRING
      case 350: // TEX_NAME
      case 351: // TRUE
      case 474: // ALPHA
      case 475: // BETA
      case 476: // ABAND
      case 477: // NINV
      case 478: // CMS
      case 479: // NCMS
      case 480: // CNUM
      case 481: // GAMMA
      case 482: // INV_GAMMA
      case 483: // INV_GAMMA1
      case 484: // INV_GAMMA2
      case 485: // NORMAL
      case 486: // UNIFORM
      case 487: // EPS
      case 488: // PDF
      case 489: // FIG
      case 490: // DR
      case 491: // NONE
      case 492: // PRIOR
      case 493: // PRIOR_VARIANCE
      case 494: // HESSIAN
      case 495: // IDENTITY_MATRIX
      case 496: // DIRICHLET
      case 497: // DIAGONAL
      case 498: // OPTIMAL
      case 819: // signed_integer
      case 820: // non_negative_number
      case 821: // signed_number
      case 822: // signed_inf
      case 823: // signed_number_w_inf
      case 824: // boolean
      case 842: // date_str
      case 843: // date_expr
      case 876: // list_sub_sampling_option
      case 877: // sub_sampling_options
      case 904: // filename
      case 905: // namespace_qualified_symbol
      case 906: // namespace_qualified_filename
      case 1469: // range
      case 1470: // integer_range
      case 1472: // signed_integer_range
      case 1479: // vec_value_1
      case 1480: // vec_value
      case 1481: // vec_value_list
      case 1482: // vec_of_vec_value
      case 1483: // vec_value_1_w_inf
      case 1484: // vec_value_w_inf
      case 1485: // symbol
      case 1486: // number
        value.move< string > (YY_MOVE (that.value));
        break;

      case 865: // prior_eq_opt
      case 870: // options_eq_opt
        value.move< tuple<string,string,string,string> > (YY_MOVE (that.value));
        break;

      case 1473: // vec_int_number
      case 1474: // vec_int_elem
      case 1475: // vec_int_1
      case 1476: // vec_int
        value.move< vector<int> > (YY_MOVE (that.value));
        break;

      case 705: // named_var_1
      case 706: // named_var
        value.move< vector<pair<string,string>> > (YY_MOVE (that.value));
        break;

      case 645: // SYMBOL_VEC
      case 715: // change_type_var_list
      case 1477: // vec_str_1
      case 1478: // vec_str
        value.move< vector<string> > (YY_MOVE (that.value));
        break;

      default:
        break;
    }

    // that is emptied.
    that.type = empty_symbol;
  }

#if YY_CPLUSPLUS < 201103L
  parser::stack_symbol_type&
  parser::stack_symbol_type::operator= (stack_symbol_type& that)
  {
    state = that.state;
    switch (that.type_get ())
    {
      case 840: // prior_distribution
      case 841: // prior_pdf
        value.move< PriorDistributions > (that.value);
        break;

      case 714: // change_type_arg
        value.move< SymbolType > (that.value);
        break;

      case 718: // expression
      case 721: // expression_or_empty
      case 745: // equation
      case 748: // hand_side
        value.move< expr_t > (that.value);
        break;

      case 1006: // calibration_range
        value.move< pair<expr_t,expr_t> > (that.value);
        break;

      case 704: // named_var_elem
      case 850: // subsamples_eq_opt
      case 1471: // integer_range_w_inf
        value.move< pair<string,string> > (that.value);
        break;

      case 88: // FALSE
      case 89: // FLOAT_NUMBER
      case 90: // DATES
      case 138: // INT_NUMBER
      case 235: // NAME
      case 297: // QUOTED_STRING
      case 350: // TEX_NAME
      case 351: // TRUE
      case 474: // ALPHA
      case 475: // BETA
      case 476: // ABAND
      case 477: // NINV
      case 478: // CMS
      case 479: // NCMS
      case 480: // CNUM
      case 481: // GAMMA
      case 482: // INV_GAMMA
      case 483: // INV_GAMMA1
      case 484: // INV_GAMMA2
      case 485: // NORMAL
      case 486: // UNIFORM
      case 487: // EPS
      case 488: // PDF
      case 489: // FIG
      case 490: // DR
      case 491: // NONE
      case 492: // PRIOR
      case 493: // PRIOR_VARIANCE
      case 494: // HESSIAN
      case 495: // IDENTITY_MATRIX
      case 496: // DIRICHLET
      case 497: // DIAGONAL
      case 498: // OPTIMAL
      case 819: // signed_integer
      case 820: // non_negative_number
      case 821: // signed_number
      case 822: // signed_inf
      case 823: // signed_number_w_inf
      case 824: // boolean
      case 842: // date_str
      case 843: // date_expr
      case 876: // list_sub_sampling_option
      case 877: // sub_sampling_options
      case 904: // filename
      case 905: // namespace_qualified_symbol
      case 906: // namespace_qualified_filename
      case 1469: // range
      case 1470: // integer_range
      case 1472: // signed_integer_range
      case 1479: // vec_value_1
      case 1480: // vec_value
      case 1481: // vec_value_list
      case 1482: // vec_of_vec_value
      case 1483: // vec_value_1_w_inf
      case 1484: // vec_value_w_inf
      case 1485: // symbol
      case 1486: // number
        value.move< string > (that.value);
        break;

      case 865: // prior_eq_opt
      case 870: // options_eq_opt
        value.move< tuple<string,string,string,string> > (that.value);
        break;

      case 1473: // vec_int_number
      case 1474: // vec_int_elem
      case 1475: // vec_int_1
      case 1476: // vec_int
        value.move< vector<int> > (that.value);
        break;

      case 705: // named_var_1
      case 706: // named_var
        value.move< vector<pair<string,string>> > (that.value);
        break;

      case 645: // SYMBOL_VEC
      case 715: // change_type_var_list
      case 1477: // vec_str_1
      case 1478: // vec_str
        value.move< vector<string> > (that.value);
        break;

      default:
        break;
    }

    location = that.location;
    // that is emptied.
    that.state = empty_state;
    return *this;
  }
#endif

  template <typename Base>
  void
  parser::yy_destroy_ (const char* yymsg, basic_symbol<Base>& yysym) const
  {
    if (yymsg)
      YY_SYMBOL_PRINT (yymsg, yysym);
  }

#if YYDEBUG
  template <typename Base>
  void
  parser::yy_print_ (std::ostream& yyo,
                                     const basic_symbol<Base>& yysym) const
  {
    std::ostream& yyoutput = yyo;
    YYUSE (yyoutput);
    symbol_number_type yytype = yysym.type_get ();
#if defined __GNUC__ && ! defined __clang__ && ! defined __ICC && __GNUC__ * 100 + __GNUC_MINOR__ <= 408
    // Avoid a (spurious) G++ 4.8 warning about "array subscript is
    // below array bounds".
    if (yysym.empty ())
      std::abort ();
#endif
    yyo << (yytype < yyntokens_ ? "token" : "nterm")
        << ' ' << yytname_[yytype] << " ("
        << yysym.location << ": ";
    YYUSE (yytype);
    yyo << ')';
  }
#endif

  void
  parser::yypush_ (const char* m, YY_MOVE_REF (stack_symbol_type) sym)
  {
    if (m)
      YY_SYMBOL_PRINT (m, sym);
    yystack_.push (YY_MOVE (sym));
  }

  void
  parser::yypush_ (const char* m, state_type s, YY_MOVE_REF (symbol_type) sym)
  {
#if 201103L <= YY_CPLUSPLUS
    yypush_ (m, stack_symbol_type (s, std::move (sym)));
#else
    stack_symbol_type ss (s, sym);
    yypush_ (m, ss);
#endif
  }

  void
  parser::yypop_ (int n)
  {
    yystack_.pop (n);
  }

#if YYDEBUG
  std::ostream&
  parser::debug_stream () const
  {
    return *yycdebug_;
  }

  void
  parser::set_debug_stream (std::ostream& o)
  {
    yycdebug_ = &o;
  }


  parser::debug_level_type
  parser::debug_level () const
  {
    return yydebug_;
  }

  void
  parser::set_debug_level (debug_level_type l)
  {
    yydebug_ = l;
  }
#endif // YYDEBUG

  parser::state_type
  parser::yy_lr_goto_state_ (state_type yystate, int yysym)
  {
    int yyr = yypgoto_[yysym - yyntokens_] + yystate;
    if (0 <= yyr && yyr <= yylast_ && yycheck_[yyr] == yystate)
      return yytable_[yyr];
    else
      return yydefgoto_[yysym - yyntokens_];
  }

  bool
  parser::yy_pact_value_is_default_ (int yyvalue)
  {
    return yyvalue == yypact_ninf_;
  }

  bool
  parser::yy_table_value_is_error_ (int yyvalue)
  {
    return yyvalue == yytable_ninf_;
  }

  int
  parser::operator() ()
  {
    return parse ();
  }

  int
  parser::parse ()
  {
    // State.
    int yyn;
    /// Length of the RHS of the rule being reduced.
    int yylen = 0;

    // Error handling.
    int yynerrs_ = 0;
    int yyerrstatus_ = 0;

    /// The lookahead symbol.
    symbol_type yyla;

    /// The locations where the error started and ended.
    stack_symbol_type yyerror_range[3];

    /// The return value of parse ().
    int yyresult;

#if YY_EXCEPTIONS
    try
#endif // YY_EXCEPTIONS
      {
    YYCDEBUG << "Starting parse\n";


    // User initialization code.
#line 43 "DynareBison.yy" // lalr1.cc:788
{
  // Initialize the locations' filenames to the filename maintained by the lexer
  yyla.location.begin.filename = yyla.location.end.filename = &(driver.lexer->filename);
}

#line 1221 "DynareBison.cc" // lalr1.cc:788

    /* Initialize the stack.  The initial state will be set in
       yynewstate, since the latter expects the semantical and the
       location values to have been already stored, initialize these
       stacks with a primary value.  */
    yystack_.clear ();
    yypush_ (YY_NULLPTR, 0, YY_MOVE (yyla));

  /*-----------------------------------------------.
  | yynewstate -- push a new symbol on the stack.  |
  `-----------------------------------------------*/
  yynewstate:
    YYCDEBUG << "Entering state " << yystack_[0].state << '\n';

    // Accept?
    if (yystack_[0].state == yyfinal_)
      YYACCEPT;

    goto yybackup;


  /*-----------.
  | yybackup.  |
  `-----------*/
  yybackup:
    // Try to take a decision without lookahead.
    yyn = yypact_[yystack_[0].state];
    if (yy_pact_value_is_default_ (yyn))
      goto yydefault;

    // Read a lookahead token.
    if (yyla.empty ())
      {
        YYCDEBUG << "Reading a token: ";
#if YY_EXCEPTIONS
        try
#endif // YY_EXCEPTIONS
          {
            yyla.type = yytranslate_ (yylex (&yyla.value, &yyla.location, driver));
          }
#if YY_EXCEPTIONS
        catch (const syntax_error& yyexc)
          {
            YYCDEBUG << "Caught exception: " << yyexc.what() << '\n';
            error (yyexc);
            goto yyerrlab1;
          }
#endif // YY_EXCEPTIONS
      }
    YY_SYMBOL_PRINT ("Next token is", yyla);

    /* If the proper action on seeing token YYLA.TYPE is to reduce or
       to detect an error, take that action.  */
    yyn += yyla.type_get ();
    if (yyn < 0 || yylast_ < yyn || yycheck_[yyn] != yyla.type_get ())
      goto yydefault;

    // Reduce or error.
    yyn = yytable_[yyn];
    if (yyn <= 0)
      {
        if (yy_table_value_is_error_ (yyn))
          goto yyerrlab;
        yyn = -yyn;
        goto yyreduce;
      }

    // Count tokens shifted since error; after three, turn off error status.
    if (yyerrstatus_)
      --yyerrstatus_;

    // Shift the lookahead token.
    yypush_ ("Shifting", yyn, YY_MOVE (yyla));
    goto yynewstate;


  /*-----------------------------------------------------------.
  | yydefault -- do the default action for the current state.  |
  `-----------------------------------------------------------*/
  yydefault:
    yyn = yydefact_[yystack_[0].state];
    if (yyn == 0)
      goto yyerrlab;
    goto yyreduce;


  /*-----------------------------.
  | yyreduce -- do a reduction.  |
  `-----------------------------*/
  yyreduce:
    yylen = yyr2_[yyn];
    {
      stack_symbol_type yylhs;
      yylhs.state = yy_lr_goto_state_ (yystack_[yylen].state, yyr1_[yyn]);
      /* Variants are always initialized to an empty instance of the
         correct type. The default '$$ = $1' action is NOT applied
         when using variants.  */
      switch (yyr1_[yyn])
    {
      case 840: // prior_distribution
      case 841: // prior_pdf
        yylhs.value.emplace< PriorDistributions > ();
        break;

      case 714: // change_type_arg
        yylhs.value.emplace< SymbolType > ();
        break;

      case 718: // expression
      case 721: // expression_or_empty
      case 745: // equation
      case 748: // hand_side
        yylhs.value.emplace< expr_t > ();
        break;

      case 1006: // calibration_range
        yylhs.value.emplace< pair<expr_t,expr_t> > ();
        break;

      case 704: // named_var_elem
      case 850: // subsamples_eq_opt
      case 1471: // integer_range_w_inf
        yylhs.value.emplace< pair<string,string> > ();
        break;

      case 88: // FALSE
      case 89: // FLOAT_NUMBER
      case 90: // DATES
      case 138: // INT_NUMBER
      case 235: // NAME
      case 297: // QUOTED_STRING
      case 350: // TEX_NAME
      case 351: // TRUE
      case 474: // ALPHA
      case 475: // BETA
      case 476: // ABAND
      case 477: // NINV
      case 478: // CMS
      case 479: // NCMS
      case 480: // CNUM
      case 481: // GAMMA
      case 482: // INV_GAMMA
      case 483: // INV_GAMMA1
      case 484: // INV_GAMMA2
      case 485: // NORMAL
      case 486: // UNIFORM
      case 487: // EPS
      case 488: // PDF
      case 489: // FIG
      case 490: // DR
      case 491: // NONE
      case 492: // PRIOR
      case 493: // PRIOR_VARIANCE
      case 494: // HESSIAN
      case 495: // IDENTITY_MATRIX
      case 496: // DIRICHLET
      case 497: // DIAGONAL
      case 498: // OPTIMAL
      case 819: // signed_integer
      case 820: // non_negative_number
      case 821: // signed_number
      case 822: // signed_inf
      case 823: // signed_number_w_inf
      case 824: // boolean
      case 842: // date_str
      case 843: // date_expr
      case 876: // list_sub_sampling_option
      case 877: // sub_sampling_options
      case 904: // filename
      case 905: // namespace_qualified_symbol
      case 906: // namespace_qualified_filename
      case 1469: // range
      case 1470: // integer_range
      case 1472: // signed_integer_range
      case 1479: // vec_value_1
      case 1480: // vec_value
      case 1481: // vec_value_list
      case 1482: // vec_of_vec_value
      case 1483: // vec_value_1_w_inf
      case 1484: // vec_value_w_inf
      case 1485: // symbol
      case 1486: // number
        yylhs.value.emplace< string > ();
        break;

      case 865: // prior_eq_opt
      case 870: // options_eq_opt
        yylhs.value.emplace< tuple<string,string,string,string> > ();
        break;

      case 1473: // vec_int_number
      case 1474: // vec_int_elem
      case 1475: // vec_int_1
      case 1476: // vec_int
        yylhs.value.emplace< vector<int> > ();
        break;

      case 705: // named_var_1
      case 706: // named_var
        yylhs.value.emplace< vector<pair<string,string>> > ();
        break;

      case 645: // SYMBOL_VEC
      case 715: // change_type_var_list
      case 1477: // vec_str_1
      case 1478: // vec_str
        yylhs.value.emplace< vector<string> > ();
        break;

      default:
        break;
    }


      // Default location.
      {
        stack_type::slice range (yystack_, yylen);
        YYLLOC_DEFAULT (yylhs.location, range, yylen);
        yyerror_range[1].location = yylhs.location;
      }

      // Perform the reduction.
      YY_REDUCE_PRINT (yyn);
#if YY_EXCEPTIONS
      try
#endif // YY_EXCEPTIONS
        {
          switch (yyn)
            {
  case 117:
#line 318 "DynareBison.yy" // lalr1.cc:919
    { driver.dsample(yystack_[1].value.as < string > ()); }
#line 1454 "DynareBison.cc" // lalr1.cc:919
    break;

  case 118:
#line 320 "DynareBison.yy" // lalr1.cc:919
    { driver.dsample(yystack_[2].value.as < string > (), yystack_[1].value.as < string > ()); }
#line 1460 "DynareBison.cc" // lalr1.cc:919
    break;

  case 119:
#line 323 "DynareBison.yy" // lalr1.cc:919
    { driver.rplot(); }
#line 1466 "DynareBison.cc" // lalr1.cc:919
    break;

  case 120:
#line 325 "DynareBison.yy" // lalr1.cc:919
    { driver.begin_trend(); }
#line 1472 "DynareBison.cc" // lalr1.cc:919
    break;

  case 121:
#line 326 "DynareBison.yy" // lalr1.cc:919
    { driver.end_trend_var(yystack_[3].value.as < expr_t > ()); }
#line 1478 "DynareBison.cc" // lalr1.cc:919
    break;

  case 122:
#line 330 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_trend_var(false, yystack_[0].value.as < string > ()); }
#line 1484 "DynareBison.cc" // lalr1.cc:919
    break;

  case 123:
#line 332 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_trend_var(false, yystack_[0].value.as < string > ()); }
#line 1490 "DynareBison.cc" // lalr1.cc:919
    break;

  case 124:
#line 334 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_trend_var(false, yystack_[0].value.as < string > ()); }
#line 1496 "DynareBison.cc" // lalr1.cc:919
    break;

  case 125:
#line 336 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_trend_var(false, yystack_[1].value.as < string > (), yystack_[0].value.as < string > ()); }
#line 1502 "DynareBison.cc" // lalr1.cc:919
    break;

  case 126:
#line 338 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_trend_var(false, yystack_[1].value.as < string > (), yystack_[0].value.as < string > ()); }
#line 1508 "DynareBison.cc" // lalr1.cc:919
    break;

  case 127:
#line 340 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_trend_var(false, yystack_[1].value.as < string > (), yystack_[0].value.as < string > ()); }
#line 1514 "DynareBison.cc" // lalr1.cc:919
    break;

  case 128:
#line 343 "DynareBison.yy" // lalr1.cc:919
    { driver.begin_trend(); }
#line 1520 "DynareBison.cc" // lalr1.cc:919
    break;

  case 129:
#line 344 "DynareBison.yy" // lalr1.cc:919
    { driver.end_trend_var(yystack_[3].value.as < expr_t > ()); }
#line 1526 "DynareBison.cc" // lalr1.cc:919
    break;

  case 130:
#line 348 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_trend_var(true, yystack_[0].value.as < string > ()); }
#line 1532 "DynareBison.cc" // lalr1.cc:919
    break;

  case 131:
#line 350 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_trend_var(true, yystack_[0].value.as < string > ()); }
#line 1538 "DynareBison.cc" // lalr1.cc:919
    break;

  case 132:
#line 352 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_trend_var(true, yystack_[0].value.as < string > ()); }
#line 1544 "DynareBison.cc" // lalr1.cc:919
    break;

  case 133:
#line 354 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_trend_var(true, yystack_[1].value.as < string > (), yystack_[0].value.as < string > ()); }
#line 1550 "DynareBison.cc" // lalr1.cc:919
    break;

  case 134:
#line 356 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_trend_var(true, yystack_[1].value.as < string > (), yystack_[0].value.as < string > ()); }
#line 1556 "DynareBison.cc" // lalr1.cc:919
    break;

  case 135:
#line 358 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_trend_var(true, yystack_[1].value.as < string > (), yystack_[0].value.as < string > ()); }
#line 1562 "DynareBison.cc" // lalr1.cc:919
    break;

  case 137:
#line 362 "DynareBison.yy" // lalr1.cc:919
    { driver.begin_trend(); }
#line 1568 "DynareBison.cc" // lalr1.cc:919
    break;

  case 138:
#line 363 "DynareBison.yy" // lalr1.cc:919
    { driver.end_nonstationary_var(false, yystack_[3].value.as < expr_t > ()); }
#line 1574 "DynareBison.cc" // lalr1.cc:919
    break;

  case 139:
#line 364 "DynareBison.yy" // lalr1.cc:919
    { driver.begin_trend(); }
#line 1580 "DynareBison.cc" // lalr1.cc:919
    break;

  case 140:
#line 365 "DynareBison.yy" // lalr1.cc:919
    { driver.end_nonstationary_var(true, yystack_[3].value.as < expr_t > ()); }
#line 1586 "DynareBison.cc" // lalr1.cc:919
    break;

  case 141:
#line 368 "DynareBison.yy" // lalr1.cc:919
    { driver.var_model(); }
#line 1592 "DynareBison.cc" // lalr1.cc:919
    break;

  case 142:
#line 369 "DynareBison.yy" // lalr1.cc:919
    { driver.var_model(); }
#line 1598 "DynareBison.cc" // lalr1.cc:919
    break;

  case 143:
#line 373 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_var_endogenous(yystack_[0].value.as < string > ()); }
#line 1604 "DynareBison.cc" // lalr1.cc:919
    break;

  case 144:
#line 375 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_var_endogenous(yystack_[0].value.as < string > ()); }
#line 1610 "DynareBison.cc" // lalr1.cc:919
    break;

  case 145:
#line 377 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_var_endogenous(yystack_[0].value.as < string > ()); }
#line 1616 "DynareBison.cc" // lalr1.cc:919
    break;

  case 151:
#line 389 "DynareBison.yy" // lalr1.cc:919
    { driver.trend_component_model(); }
#line 1622 "DynareBison.cc" // lalr1.cc:919
    break;

  case 157:
#line 401 "DynareBison.yy" // lalr1.cc:919
    { driver.begin_pac_model(); }
#line 1628 "DynareBison.cc" // lalr1.cc:919
    break;

  case 158:
#line 401 "DynareBison.yy" // lalr1.cc:919
    { driver.pac_model(); }
#line 1634 "DynareBison.cc" // lalr1.cc:919
    break;

  case 166:
#line 415 "DynareBison.yy" // lalr1.cc:919
    { driver.var_expectation_model(); }
#line 1640 "DynareBison.cc" // lalr1.cc:919
    break;

  case 169:
#line 424 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("variable", yystack_[0].value.as < string > ()); }
#line 1646 "DynareBison.cc" // lalr1.cc:919
    break;

  case 170:
#line 425 "DynareBison.yy" // lalr1.cc:919
    { driver.begin_model(); }
#line 1652 "DynareBison.cc" // lalr1.cc:919
    break;

  case 171:
#line 426 "DynareBison.yy" // lalr1.cc:919
    {
                                 driver.var_expectation_model_expression = yystack_[0].value.as < expr_t > ();
                                 driver.reset_data_tree();
                               }
#line 1661 "DynareBison.cc" // lalr1.cc:919
    break;

  case 172:
#line 431 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("auxiliary_model_name", yystack_[0].value.as < string > ()); }
#line 1667 "DynareBison.cc" // lalr1.cc:919
    break;

  case 173:
#line 433 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("horizon", yystack_[0].value.as < string > ()); }
#line 1673 "DynareBison.cc" // lalr1.cc:919
    break;

  case 174:
#line 435 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("horizon", "[ " + yystack_[0].value.as < pair<string,string> > ().first + ' ' + yystack_[0].value.as < pair<string,string> > ().second + " ]"); }
#line 1679 "DynareBison.cc" // lalr1.cc:919
    break;

  case 175:
#line 437 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("model_name", yystack_[0].value.as < string > ()); }
#line 1685 "DynareBison.cc" // lalr1.cc:919
    break;

  case 176:
#line 439 "DynareBison.yy" // lalr1.cc:919
    { driver.var_expectation_model_discount = yystack_[0].value.as < expr_t > (); }
#line 1691 "DynareBison.cc" // lalr1.cc:919
    break;

  case 177:
#line 442 "DynareBison.yy" // lalr1.cc:919
    { driver.begin_VAR_restrictions(); }
#line 1697 "DynareBison.cc" // lalr1.cc:919
    break;

  case 178:
#line 443 "DynareBison.yy" // lalr1.cc:919
    { driver.end_VAR_restrictions(yystack_[6].value.as < string > ()); }
#line 1703 "DynareBison.cc" // lalr1.cc:919
    break;

  case 181:
#line 451 "DynareBison.yy" // lalr1.cc:919
    { driver.add_VAR_exclusion_restriction(yystack_[2].value.as < string > ()); }
#line 1709 "DynareBison.cc" // lalr1.cc:919
    break;

  case 182:
#line 453 "DynareBison.yy" // lalr1.cc:919
    { driver.add_VAR_restriction_equation_or_crossequation_final(yystack_[3].value.as < string > ()); }
#line 1715 "DynareBison.cc" // lalr1.cc:919
    break;

  case 183:
#line 455 "DynareBison.yy" // lalr1.cc:919
    { driver.add_VAR_restriction_equation_or_crossequation_final(""); }
#line 1721 "DynareBison.cc" // lalr1.cc:919
    break;

  case 184:
#line 457 "DynareBison.yy" // lalr1.cc:919
    { driver.add_VAR_covariance_number_restriction(yystack_[6].value.as < string > (), yystack_[4].value.as < string > (), yystack_[1].value.as < string > ()); }
#line 1727 "DynareBison.cc" // lalr1.cc:919
    break;

  case 185:
#line 459 "DynareBison.yy" // lalr1.cc:919
    { driver.add_VAR_covariance_pair_restriction(yystack_[10].value.as < string > (), yystack_[8].value.as < string > (), yystack_[4].value.as < string > (), yystack_[2].value.as < string > ()); }
#line 1733 "DynareBison.cc" // lalr1.cc:919
    break;

  case 186:
#line 463 "DynareBison.yy" // lalr1.cc:919
    { driver.add_VAR_restriction_equation_or_crossequation(yystack_[0].value.as < string > ()); }
#line 1739 "DynareBison.cc" // lalr1.cc:919
    break;

  case 187:
#line 465 "DynareBison.yy" // lalr1.cc:919
    {
                                  driver.multiply_arg2_by_neg_one();
                                  driver.add_VAR_restriction_equation_or_crossequation(yystack_[0].value.as < string > ());
                                }
#line 1748 "DynareBison.cc" // lalr1.cc:919
    break;

  case 188:
#line 470 "DynareBison.yy" // lalr1.cc:919
    { driver.add_VAR_restriction_equation_or_crossequation(yystack_[0].value.as < string > ()); }
#line 1754 "DynareBison.cc" // lalr1.cc:919
    break;

  case 189:
#line 474 "DynareBison.yy" // lalr1.cc:919
    { driver.add_VAR_restriction_eq_or_crosseq(yystack_[0].value.as < expr_t > ()); }
#line 1760 "DynareBison.cc" // lalr1.cc:919
    break;

  case 190:
#line 476 "DynareBison.yy" // lalr1.cc:919
    {
                                       expr_t one = driver.add_non_negative_constant("1");
                                       driver.add_VAR_restriction_eq_or_crosseq(driver.add_divide(one, yystack_[0].value.as < expr_t > ()));
                                     }
#line 1769 "DynareBison.cc" // lalr1.cc:919
    break;

  case 191:
#line 483 "DynareBison.yy" // lalr1.cc:919
    { driver.add_VAR_restriction_coeff(yystack_[3].value.as < string > (), "", yystack_[1].value.as < string > ()); }
#line 1775 "DynareBison.cc" // lalr1.cc:919
    break;

  case 192:
#line 488 "DynareBison.yy" // lalr1.cc:919
    { driver.add_VAR_restriction_equation_or_crossequation(yystack_[0].value.as < string > ()); }
#line 1781 "DynareBison.cc" // lalr1.cc:919
    break;

  case 193:
#line 490 "DynareBison.yy" // lalr1.cc:919
    {
                                       driver.multiply_arg2_by_neg_one();
                                       driver.add_VAR_restriction_equation_or_crossequation(yystack_[0].value.as < string > ());
                                     }
#line 1790 "DynareBison.cc" // lalr1.cc:919
    break;

  case 194:
#line 495 "DynareBison.yy" // lalr1.cc:919
    { driver.add_VAR_restriction_equation_or_crossequation(yystack_[0].value.as < string > ()); }
#line 1796 "DynareBison.cc" // lalr1.cc:919
    break;

  case 195:
#line 499 "DynareBison.yy" // lalr1.cc:919
    { driver.add_VAR_restriction_eq_or_crosseq(yystack_[0].value.as < expr_t > ()); }
#line 1802 "DynareBison.cc" // lalr1.cc:919
    break;

  case 196:
#line 501 "DynareBison.yy" // lalr1.cc:919
    {
                                            expr_t one = driver.add_non_negative_constant("1");
                                            driver.add_VAR_restriction_eq_or_crosseq(driver.add_divide(one, yystack_[0].value.as < expr_t > ()));
                                          }
#line 1811 "DynareBison.cc" // lalr1.cc:919
    break;

  case 197:
#line 508 "DynareBison.yy" // lalr1.cc:919
    { driver.add_VAR_restriction_coeff(yystack_[5].value.as < string > (), yystack_[3].value.as < string > (), yystack_[1].value.as < string > ()); }
#line 1817 "DynareBison.cc" // lalr1.cc:919
    break;

  case 200:
#line 516 "DynareBison.yy" // lalr1.cc:919
    { driver.add_VAR_restriction_exclusion_equation(yystack_[3].value.as < string > ()); }
#line 1823 "DynareBison.cc" // lalr1.cc:919
    break;

  case 201:
#line 520 "DynareBison.yy" // lalr1.cc:919
    { driver.run_var_estimation(); }
#line 1829 "DynareBison.cc" // lalr1.cc:919
    break;

  case 206:
#line 532 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_nonstationary_var(yystack_[0].value.as < string > ()); }
#line 1835 "DynareBison.cc" // lalr1.cc:919
    break;

  case 207:
#line 534 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_nonstationary_var(yystack_[0].value.as < string > ()); }
#line 1841 "DynareBison.cc" // lalr1.cc:919
    break;

  case 208:
#line 536 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_nonstationary_var(yystack_[0].value.as < string > ()); }
#line 1847 "DynareBison.cc" // lalr1.cc:919
    break;

  case 209:
#line 538 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_nonstationary_var(yystack_[1].value.as < string > (), "", yystack_[0].value.as < vector<pair<string,string>> > ()); }
#line 1853 "DynareBison.cc" // lalr1.cc:919
    break;

  case 210:
#line 540 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_nonstationary_var(yystack_[1].value.as < string > (), "", yystack_[0].value.as < vector<pair<string,string>> > ()); }
#line 1859 "DynareBison.cc" // lalr1.cc:919
    break;

  case 211:
#line 542 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_nonstationary_var(yystack_[1].value.as < string > (), "", yystack_[0].value.as < vector<pair<string,string>> > ()); }
#line 1865 "DynareBison.cc" // lalr1.cc:919
    break;

  case 212:
#line 544 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_nonstationary_var(yystack_[1].value.as < string > (), yystack_[0].value.as < string > ()); }
#line 1871 "DynareBison.cc" // lalr1.cc:919
    break;

  case 213:
#line 546 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_nonstationary_var(yystack_[1].value.as < string > (), yystack_[0].value.as < string > ()); }
#line 1877 "DynareBison.cc" // lalr1.cc:919
    break;

  case 214:
#line 548 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_nonstationary_var(yystack_[1].value.as < string > (), yystack_[0].value.as < string > ()); }
#line 1883 "DynareBison.cc" // lalr1.cc:919
    break;

  case 215:
#line 550 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_nonstationary_var(yystack_[2].value.as < string > (), yystack_[1].value.as < string > (), yystack_[0].value.as < vector<pair<string,string>> > ()); }
#line 1889 "DynareBison.cc" // lalr1.cc:919
    break;

  case 216:
#line 552 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_nonstationary_var(yystack_[2].value.as < string > (), yystack_[1].value.as < string > (), yystack_[0].value.as < vector<pair<string,string>> > ()); }
#line 1895 "DynareBison.cc" // lalr1.cc:919
    break;

  case 217:
#line 554 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_nonstationary_var(yystack_[2].value.as < string > (), yystack_[1].value.as < string > (), yystack_[0].value.as < vector<pair<string,string>> > ()); }
#line 1901 "DynareBison.cc" // lalr1.cc:919
    break;

  case 223:
#line 570 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < pair<string,string> > () = { yystack_[2].value.as < string > (), yystack_[0].value.as < string > () }; }
#line 1907 "DynareBison.cc" // lalr1.cc:919
    break;

  case 224:
#line 573 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < vector<pair<string,string>> > () = vector<pair<string, string>>{yystack_[0].value.as < pair<string,string> > ()}; }
#line 1913 "DynareBison.cc" // lalr1.cc:919
    break;

  case 225:
#line 575 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < vector<pair<string,string>> > () = vector<pair<string, string>>{yystack_[0].value.as < pair<string,string> > ()}; }
#line 1919 "DynareBison.cc" // lalr1.cc:919
    break;

  case 226:
#line 577 "DynareBison.yy" // lalr1.cc:919
    {
                yylhs.value.as < vector<pair<string,string>> > () = yystack_[1].value.as < vector<pair<string,string>> > ();
                yylhs.value.as < vector<pair<string,string>> > ().push_back(yystack_[0].value.as < pair<string,string> > ());
              }
#line 1928 "DynareBison.cc" // lalr1.cc:919
    break;

  case 227:
#line 582 "DynareBison.yy" // lalr1.cc:919
    {
                yylhs.value.as < vector<pair<string,string>> > () = yystack_[2].value.as < vector<pair<string,string>> > ();
                yylhs.value.as < vector<pair<string,string>> > ().push_back(yystack_[0].value.as < pair<string,string> > ());
              }
#line 1937 "DynareBison.cc" // lalr1.cc:919
    break;

  case 228:
#line 588 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < vector<pair<string,string>> > () = yystack_[1].value.as < vector<pair<string,string>> > (); }
#line 1943 "DynareBison.cc" // lalr1.cc:919
    break;

  case 229:
#line 589 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < vector<pair<string,string>> > () = yystack_[2].value.as < vector<pair<string,string>> > (); }
#line 1949 "DynareBison.cc" // lalr1.cc:919
    break;

  case 230:
#line 593 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_endogenous(yystack_[0].value.as < string > ()); }
#line 1955 "DynareBison.cc" // lalr1.cc:919
    break;

  case 231:
#line 595 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_endogenous(yystack_[0].value.as < string > ()); }
#line 1961 "DynareBison.cc" // lalr1.cc:919
    break;

  case 232:
#line 597 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_endogenous(yystack_[0].value.as < string > ()); }
#line 1967 "DynareBison.cc" // lalr1.cc:919
    break;

  case 233:
#line 599 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_endogenous(yystack_[1].value.as < string > (), "", yystack_[0].value.as < vector<pair<string,string>> > ()); }
#line 1973 "DynareBison.cc" // lalr1.cc:919
    break;

  case 234:
#line 601 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_endogenous(yystack_[1].value.as < string > (), "", yystack_[0].value.as < vector<pair<string,string>> > ()); }
#line 1979 "DynareBison.cc" // lalr1.cc:919
    break;

  case 235:
#line 603 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_endogenous(yystack_[1].value.as < string > (), "", yystack_[0].value.as < vector<pair<string,string>> > ()); }
#line 1985 "DynareBison.cc" // lalr1.cc:919
    break;

  case 236:
#line 605 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_endogenous(yystack_[1].value.as < string > (), yystack_[0].value.as < string > ()); }
#line 1991 "DynareBison.cc" // lalr1.cc:919
    break;

  case 237:
#line 607 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_endogenous(yystack_[1].value.as < string > (), yystack_[0].value.as < string > ()); }
#line 1997 "DynareBison.cc" // lalr1.cc:919
    break;

  case 238:
#line 609 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_endogenous(yystack_[1].value.as < string > (), yystack_[0].value.as < string > ()); }
#line 2003 "DynareBison.cc" // lalr1.cc:919
    break;

  case 239:
#line 611 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_endogenous(yystack_[2].value.as < string > (), yystack_[1].value.as < string > (), yystack_[0].value.as < vector<pair<string,string>> > ()); }
#line 2009 "DynareBison.cc" // lalr1.cc:919
    break;

  case 240:
#line 613 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_endogenous(yystack_[2].value.as < string > (), yystack_[1].value.as < string > (), yystack_[0].value.as < vector<pair<string,string>> > ()); }
#line 2015 "DynareBison.cc" // lalr1.cc:919
    break;

  case 241:
#line 615 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_endogenous(yystack_[2].value.as < string > (), yystack_[1].value.as < string > (), yystack_[0].value.as < vector<pair<string,string>> > ()); }
#line 2021 "DynareBison.cc" // lalr1.cc:919
    break;

  case 242:
#line 619 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_exogenous(yystack_[0].value.as < string > ()); }
#line 2027 "DynareBison.cc" // lalr1.cc:919
    break;

  case 243:
#line 621 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_exogenous(yystack_[0].value.as < string > ()); }
#line 2033 "DynareBison.cc" // lalr1.cc:919
    break;

  case 244:
#line 623 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_exogenous(yystack_[0].value.as < string > ()); }
#line 2039 "DynareBison.cc" // lalr1.cc:919
    break;

  case 245:
#line 625 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_exogenous(yystack_[1].value.as < string > (), "", yystack_[0].value.as < vector<pair<string,string>> > ()); }
#line 2045 "DynareBison.cc" // lalr1.cc:919
    break;

  case 246:
#line 627 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_exogenous(yystack_[1].value.as < string > (), "", yystack_[0].value.as < vector<pair<string,string>> > ()); }
#line 2051 "DynareBison.cc" // lalr1.cc:919
    break;

  case 247:
#line 629 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_exogenous(yystack_[1].value.as < string > (), "", yystack_[0].value.as < vector<pair<string,string>> > ()); }
#line 2057 "DynareBison.cc" // lalr1.cc:919
    break;

  case 248:
#line 631 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_exogenous(yystack_[1].value.as < string > (), yystack_[0].value.as < string > ()); }
#line 2063 "DynareBison.cc" // lalr1.cc:919
    break;

  case 249:
#line 633 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_exogenous(yystack_[1].value.as < string > (), yystack_[0].value.as < string > ()); }
#line 2069 "DynareBison.cc" // lalr1.cc:919
    break;

  case 250:
#line 635 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_exogenous(yystack_[1].value.as < string > (), yystack_[0].value.as < string > ()); }
#line 2075 "DynareBison.cc" // lalr1.cc:919
    break;

  case 251:
#line 637 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_exogenous(yystack_[2].value.as < string > (), yystack_[1].value.as < string > (), yystack_[0].value.as < vector<pair<string,string>> > ()); }
#line 2081 "DynareBison.cc" // lalr1.cc:919
    break;

  case 252:
#line 639 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_exogenous(yystack_[2].value.as < string > (), yystack_[1].value.as < string > (), yystack_[0].value.as < vector<pair<string,string>> > ()); }
#line 2087 "DynareBison.cc" // lalr1.cc:919
    break;

  case 253:
#line 641 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_exogenous(yystack_[2].value.as < string > (), yystack_[1].value.as < string > (), yystack_[0].value.as < vector<pair<string,string>> > ()); }
#line 2093 "DynareBison.cc" // lalr1.cc:919
    break;

  case 254:
#line 645 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_exogenous_det(yystack_[0].value.as < string > ()); }
#line 2099 "DynareBison.cc" // lalr1.cc:919
    break;

  case 255:
#line 647 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_exogenous_det(yystack_[0].value.as < string > ()); }
#line 2105 "DynareBison.cc" // lalr1.cc:919
    break;

  case 256:
#line 649 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_exogenous_det(yystack_[0].value.as < string > ()); }
#line 2111 "DynareBison.cc" // lalr1.cc:919
    break;

  case 257:
#line 651 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_exogenous_det(yystack_[1].value.as < string > (), "", yystack_[0].value.as < vector<pair<string,string>> > ()); }
#line 2117 "DynareBison.cc" // lalr1.cc:919
    break;

  case 258:
#line 653 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_exogenous_det(yystack_[1].value.as < string > (), "", yystack_[0].value.as < vector<pair<string,string>> > ()); }
#line 2123 "DynareBison.cc" // lalr1.cc:919
    break;

  case 259:
#line 655 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_exogenous_det(yystack_[1].value.as < string > (), "", yystack_[0].value.as < vector<pair<string,string>> > ()); }
#line 2129 "DynareBison.cc" // lalr1.cc:919
    break;

  case 260:
#line 657 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_exogenous_det(yystack_[1].value.as < string > (), yystack_[0].value.as < string > ()); }
#line 2135 "DynareBison.cc" // lalr1.cc:919
    break;

  case 261:
#line 659 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_exogenous_det(yystack_[1].value.as < string > (), yystack_[0].value.as < string > ()); }
#line 2141 "DynareBison.cc" // lalr1.cc:919
    break;

  case 262:
#line 661 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_exogenous_det(yystack_[1].value.as < string > (), yystack_[0].value.as < string > ()); }
#line 2147 "DynareBison.cc" // lalr1.cc:919
    break;

  case 263:
#line 663 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_exogenous_det(yystack_[2].value.as < string > (), yystack_[1].value.as < string > (), yystack_[0].value.as < vector<pair<string,string>> > ()); }
#line 2153 "DynareBison.cc" // lalr1.cc:919
    break;

  case 264:
#line 665 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_exogenous_det(yystack_[2].value.as < string > (), yystack_[1].value.as < string > (), yystack_[0].value.as < vector<pair<string,string>> > ()); }
#line 2159 "DynareBison.cc" // lalr1.cc:919
    break;

  case 265:
#line 667 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_exogenous_det(yystack_[2].value.as < string > (), yystack_[1].value.as < string > (), yystack_[0].value.as < vector<pair<string,string>> > ()); }
#line 2165 "DynareBison.cc" // lalr1.cc:919
    break;

  case 266:
#line 671 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_parameter(yystack_[0].value.as < string > ()); }
#line 2171 "DynareBison.cc" // lalr1.cc:919
    break;

  case 267:
#line 673 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_parameter(yystack_[0].value.as < string > ()); }
#line 2177 "DynareBison.cc" // lalr1.cc:919
    break;

  case 268:
#line 675 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_parameter(yystack_[0].value.as < string > ()); }
#line 2183 "DynareBison.cc" // lalr1.cc:919
    break;

  case 269:
#line 677 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_parameter(yystack_[1].value.as < string > (), "", yystack_[0].value.as < vector<pair<string,string>> > ()); }
#line 2189 "DynareBison.cc" // lalr1.cc:919
    break;

  case 270:
#line 679 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_parameter(yystack_[1].value.as < string > (), "", yystack_[0].value.as < vector<pair<string,string>> > ()); }
#line 2195 "DynareBison.cc" // lalr1.cc:919
    break;

  case 271:
#line 681 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_parameter(yystack_[1].value.as < string > (), "", yystack_[0].value.as < vector<pair<string,string>> > ()); }
#line 2201 "DynareBison.cc" // lalr1.cc:919
    break;

  case 272:
#line 683 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_parameter(yystack_[1].value.as < string > (), yystack_[0].value.as < string > ()); }
#line 2207 "DynareBison.cc" // lalr1.cc:919
    break;

  case 273:
#line 685 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_parameter(yystack_[1].value.as < string > (), yystack_[0].value.as < string > ()); }
#line 2213 "DynareBison.cc" // lalr1.cc:919
    break;

  case 274:
#line 687 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_parameter(yystack_[1].value.as < string > (), yystack_[0].value.as < string > ()); }
#line 2219 "DynareBison.cc" // lalr1.cc:919
    break;

  case 275:
#line 689 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_parameter(yystack_[2].value.as < string > (), yystack_[1].value.as < string > (), yystack_[0].value.as < vector<pair<string,string>> > ()); }
#line 2225 "DynareBison.cc" // lalr1.cc:919
    break;

  case 276:
#line 691 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_parameter(yystack_[2].value.as < string > (), yystack_[1].value.as < string > (), yystack_[0].value.as < vector<pair<string,string>> > ()); }
#line 2231 "DynareBison.cc" // lalr1.cc:919
    break;

  case 277:
#line 693 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_parameter(yystack_[2].value.as < string > (), yystack_[1].value.as < string > (), yystack_[0].value.as < vector<pair<string,string>> > ()); }
#line 2237 "DynareBison.cc" // lalr1.cc:919
    break;

  case 278:
#line 697 "DynareBison.yy" // lalr1.cc:919
    { driver.add_predetermined_variable(yystack_[0].value.as < string > ()); }
#line 2243 "DynareBison.cc" // lalr1.cc:919
    break;

  case 279:
#line 699 "DynareBison.yy" // lalr1.cc:919
    { driver.add_predetermined_variable(yystack_[0].value.as < string > ()); }
#line 2249 "DynareBison.cc" // lalr1.cc:919
    break;

  case 280:
#line 701 "DynareBison.yy" // lalr1.cc:919
    { driver.add_predetermined_variable(yystack_[0].value.as < string > ()); }
#line 2255 "DynareBison.cc" // lalr1.cc:919
    break;

  case 281:
#line 705 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_model_local_variable(yystack_[0].value.as < string > ()); }
#line 2261 "DynareBison.cc" // lalr1.cc:919
    break;

  case 282:
#line 707 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_model_local_variable(yystack_[0].value.as < string > ()); }
#line 2267 "DynareBison.cc" // lalr1.cc:919
    break;

  case 283:
#line 709 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_model_local_variable(yystack_[0].value.as < string > ()); }
#line 2273 "DynareBison.cc" // lalr1.cc:919
    break;

  case 284:
#line 711 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_model_local_variable(yystack_[1].value.as < string > (), yystack_[0].value.as < string > ()); }
#line 2279 "DynareBison.cc" // lalr1.cc:919
    break;

  case 285:
#line 713 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_model_local_variable(yystack_[1].value.as < string > (), yystack_[0].value.as < string > ()); }
#line 2285 "DynareBison.cc" // lalr1.cc:919
    break;

  case 286:
#line 715 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_model_local_variable(yystack_[1].value.as < string > (), yystack_[0].value.as < string > ()); }
#line 2291 "DynareBison.cc" // lalr1.cc:919
    break;

  case 287:
#line 719 "DynareBison.yy" // lalr1.cc:919
    { driver.change_type(yystack_[3].value.as < SymbolType > (), yystack_[1].value.as < vector<string> > ()); }
#line 2297 "DynareBison.cc" // lalr1.cc:919
    break;

  case 288:
#line 723 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < SymbolType > () = SymbolType::parameter; }
#line 2303 "DynareBison.cc" // lalr1.cc:919
    break;

  case 289:
#line 725 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < SymbolType > () = SymbolType::endogenous; }
#line 2309 "DynareBison.cc" // lalr1.cc:919
    break;

  case 290:
#line 727 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < SymbolType > () = SymbolType::exogenous; }
#line 2315 "DynareBison.cc" // lalr1.cc:919
    break;

  case 291:
#line 729 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < SymbolType > () = SymbolType::exogenousDet; }
#line 2321 "DynareBison.cc" // lalr1.cc:919
    break;

  case 292:
#line 733 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < vector<string> > () = vector<string>{yystack_[0].value.as < string > ()}; }
#line 2327 "DynareBison.cc" // lalr1.cc:919
    break;

  case 293:
#line 735 "DynareBison.yy" // lalr1.cc:919
    {
                         yylhs.value.as < vector<string> > () = yystack_[1].value.as < vector<string> > ();
                         yylhs.value.as < vector<string> > ().push_back(yystack_[0].value.as < string > ());
                       }
#line 2336 "DynareBison.cc" // lalr1.cc:919
    break;

  case 294:
#line 740 "DynareBison.yy" // lalr1.cc:919
    {
                         yylhs.value.as < vector<string> > () = yystack_[2].value.as < vector<string> > ();
                         yylhs.value.as < vector<string> > ().push_back(yystack_[0].value.as < string > ());
                       }
#line 2345 "DynareBison.cc" // lalr1.cc:919
    break;

  case 295:
#line 747 "DynareBison.yy" // lalr1.cc:919
    { driver.periods(yystack_[1].value.as < string > ()); }
#line 2351 "DynareBison.cc" // lalr1.cc:919
    break;

  case 296:
#line 749 "DynareBison.yy" // lalr1.cc:919
    { driver.periods(yystack_[1].value.as < string > ()); }
#line 2357 "DynareBison.cc" // lalr1.cc:919
    break;

  case 297:
#line 752 "DynareBison.yy" // lalr1.cc:919
    { driver.init_param(yystack_[3].value.as < string > (), yystack_[1].value.as < expr_t > ()); }
#line 2363 "DynareBison.cc" // lalr1.cc:919
    break;

  case 298:
#line 755 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = yystack_[1].value.as < expr_t > ();}
#line 2369 "DynareBison.cc" // lalr1.cc:919
    break;

  case 299:
#line 757 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_expression_variable(yystack_[0].value.as < string > ()); }
#line 2375 "DynareBison.cc" // lalr1.cc:919
    break;

  case 300:
#line 759 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_non_negative_constant(yystack_[0].value.as < string > ()); }
#line 2381 "DynareBison.cc" // lalr1.cc:919
    break;

  case 301:
#line 761 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_plus(yystack_[2].value.as < expr_t > (), yystack_[0].value.as < expr_t > ()); }
#line 2387 "DynareBison.cc" // lalr1.cc:919
    break;

  case 302:
#line 763 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_minus(yystack_[2].value.as < expr_t > (), yystack_[0].value.as < expr_t > ()); }
#line 2393 "DynareBison.cc" // lalr1.cc:919
    break;

  case 303:
#line 765 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_divide(yystack_[2].value.as < expr_t > (), yystack_[0].value.as < expr_t > ()); }
#line 2399 "DynareBison.cc" // lalr1.cc:919
    break;

  case 304:
#line 767 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_times(yystack_[2].value.as < expr_t > (), yystack_[0].value.as < expr_t > ()); }
#line 2405 "DynareBison.cc" // lalr1.cc:919
    break;

  case 305:
#line 769 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_power(yystack_[2].value.as < expr_t > (), yystack_[0].value.as < expr_t > ()); }
#line 2411 "DynareBison.cc" // lalr1.cc:919
    break;

  case 306:
#line 771 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_less(yystack_[2].value.as < expr_t > (), yystack_[0].value.as < expr_t > ()); }
#line 2417 "DynareBison.cc" // lalr1.cc:919
    break;

  case 307:
#line 773 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_greater(yystack_[2].value.as < expr_t > (), yystack_[0].value.as < expr_t > ()); }
#line 2423 "DynareBison.cc" // lalr1.cc:919
    break;

  case 308:
#line 775 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_less_equal(yystack_[2].value.as < expr_t > (), yystack_[0].value.as < expr_t > ()); }
#line 2429 "DynareBison.cc" // lalr1.cc:919
    break;

  case 309:
#line 777 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_greater_equal(yystack_[2].value.as < expr_t > (), yystack_[0].value.as < expr_t > ()); }
#line 2435 "DynareBison.cc" // lalr1.cc:919
    break;

  case 310:
#line 779 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_equal_equal(yystack_[2].value.as < expr_t > (), yystack_[0].value.as < expr_t > ()); }
#line 2441 "DynareBison.cc" // lalr1.cc:919
    break;

  case 311:
#line 781 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_different(yystack_[2].value.as < expr_t > (), yystack_[0].value.as < expr_t > ()); }
#line 2447 "DynareBison.cc" // lalr1.cc:919
    break;

  case 312:
#line 783 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_uminus(yystack_[0].value.as < expr_t > ()); }
#line 2453 "DynareBison.cc" // lalr1.cc:919
    break;

  case 313:
#line 785 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = yystack_[0].value.as < expr_t > (); }
#line 2459 "DynareBison.cc" // lalr1.cc:919
    break;

  case 314:
#line 787 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_exp(yystack_[1].value.as < expr_t > ()); }
#line 2465 "DynareBison.cc" // lalr1.cc:919
    break;

  case 315:
#line 789 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_log(yystack_[1].value.as < expr_t > ()); }
#line 2471 "DynareBison.cc" // lalr1.cc:919
    break;

  case 316:
#line 791 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_log(yystack_[1].value.as < expr_t > ()); }
#line 2477 "DynareBison.cc" // lalr1.cc:919
    break;

  case 317:
#line 793 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_log10(yystack_[1].value.as < expr_t > ()); }
#line 2483 "DynareBison.cc" // lalr1.cc:919
    break;

  case 318:
#line 795 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_sin(yystack_[1].value.as < expr_t > ()); }
#line 2489 "DynareBison.cc" // lalr1.cc:919
    break;

  case 319:
#line 797 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_cos(yystack_[1].value.as < expr_t > ()); }
#line 2495 "DynareBison.cc" // lalr1.cc:919
    break;

  case 320:
#line 799 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_tan(yystack_[1].value.as < expr_t > ()); }
#line 2501 "DynareBison.cc" // lalr1.cc:919
    break;

  case 321:
#line 801 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_asin(yystack_[1].value.as < expr_t > ()); }
#line 2507 "DynareBison.cc" // lalr1.cc:919
    break;

  case 322:
#line 803 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_acos(yystack_[1].value.as < expr_t > ()); }
#line 2513 "DynareBison.cc" // lalr1.cc:919
    break;

  case 323:
#line 805 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_atan(yystack_[1].value.as < expr_t > ()); }
#line 2519 "DynareBison.cc" // lalr1.cc:919
    break;

  case 324:
#line 807 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_sqrt(yystack_[1].value.as < expr_t > ()); }
#line 2525 "DynareBison.cc" // lalr1.cc:919
    break;

  case 325:
#line 809 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_cbrt(yystack_[1].value.as < expr_t > ()); }
#line 2531 "DynareBison.cc" // lalr1.cc:919
    break;

  case 326:
#line 811 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_abs(yystack_[1].value.as < expr_t > ()); }
#line 2537 "DynareBison.cc" // lalr1.cc:919
    break;

  case 327:
#line 813 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_sign(yystack_[1].value.as < expr_t > ()); }
#line 2543 "DynareBison.cc" // lalr1.cc:919
    break;

  case 328:
#line 815 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_max(yystack_[3].value.as < expr_t > (), yystack_[1].value.as < expr_t > ()); }
#line 2549 "DynareBison.cc" // lalr1.cc:919
    break;

  case 329:
#line 817 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_min(yystack_[3].value.as < expr_t > (), yystack_[1].value.as < expr_t > ()); }
#line 2555 "DynareBison.cc" // lalr1.cc:919
    break;

  case 330:
#line 818 "DynareBison.yy" // lalr1.cc:919
    { driver.push_external_function_arg_vector_onto_stack(); }
#line 2561 "DynareBison.cc" // lalr1.cc:919
    break;

  case 331:
#line 819 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_model_var_or_external_function(yystack_[4].value.as < string > (), false); }
#line 2567 "DynareBison.cc" // lalr1.cc:919
    break;

  case 332:
#line 821 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_normcdf(yystack_[5].value.as < expr_t > (), yystack_[3].value.as < expr_t > (), yystack_[1].value.as < expr_t > ()); }
#line 2573 "DynareBison.cc" // lalr1.cc:919
    break;

  case 333:
#line 823 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_normcdf(yystack_[1].value.as < expr_t > ()); }
#line 2579 "DynareBison.cc" // lalr1.cc:919
    break;

  case 334:
#line 825 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_normpdf(yystack_[5].value.as < expr_t > (), yystack_[3].value.as < expr_t > (), yystack_[1].value.as < expr_t > ()); }
#line 2585 "DynareBison.cc" // lalr1.cc:919
    break;

  case 335:
#line 827 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_normpdf(yystack_[1].value.as < expr_t > ()); }
#line 2591 "DynareBison.cc" // lalr1.cc:919
    break;

  case 336:
#line 829 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_erf(yystack_[1].value.as < expr_t > ()); }
#line 2597 "DynareBison.cc" // lalr1.cc:919
    break;

  case 337:
#line 831 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_nan_constant(); }
#line 2603 "DynareBison.cc" // lalr1.cc:919
    break;

  case 338:
#line 833 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_inf_constant(); }
#line 2609 "DynareBison.cc" // lalr1.cc:919
    break;

  case 339:
#line 837 "DynareBison.yy" // lalr1.cc:919
    { driver.add_external_function_arg(yystack_[0].value.as < expr_t > ()); }
#line 2615 "DynareBison.cc" // lalr1.cc:919
    break;

  case 340:
#line 839 "DynareBison.yy" // lalr1.cc:919
    { driver.add_external_function_arg(yystack_[0].value.as < expr_t > ()); }
#line 2621 "DynareBison.cc" // lalr1.cc:919
    break;

  case 341:
#line 843 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_nan_constant(); }
#line 2627 "DynareBison.cc" // lalr1.cc:919
    break;

  case 342:
#line 844 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = yystack_[0].value.as < expr_t > (); }
#line 2633 "DynareBison.cc" // lalr1.cc:919
    break;

  case 343:
#line 848 "DynareBison.yy" // lalr1.cc:919
    { driver.end_initval(false); }
#line 2639 "DynareBison.cc" // lalr1.cc:919
    break;

  case 344:
#line 850 "DynareBison.yy" // lalr1.cc:919
    { driver.end_initval(true); }
#line 2645 "DynareBison.cc" // lalr1.cc:919
    break;

  case 345:
#line 854 "DynareBison.yy" // lalr1.cc:919
    { driver.initval_file(yystack_[2].value.as < string > ()); }
#line 2651 "DynareBison.cc" // lalr1.cc:919
    break;

  case 346:
#line 858 "DynareBison.yy" // lalr1.cc:919
    { driver.end_endval(false); }
#line 2657 "DynareBison.cc" // lalr1.cc:919
    break;

  case 347:
#line 860 "DynareBison.yy" // lalr1.cc:919
    { driver.end_endval(true); }
#line 2663 "DynareBison.cc" // lalr1.cc:919
    break;

  case 350:
#line 867 "DynareBison.yy" // lalr1.cc:919
    { driver.init_val(yystack_[3].value.as < string > (), yystack_[1].value.as < expr_t > ()); }
#line 2669 "DynareBison.cc" // lalr1.cc:919
    break;

  case 351:
#line 870 "DynareBison.yy" // lalr1.cc:919
    { driver.end_histval(false); }
#line 2675 "DynareBison.cc" // lalr1.cc:919
    break;

  case 352:
#line 872 "DynareBison.yy" // lalr1.cc:919
    { driver.end_histval(true); }
#line 2681 "DynareBison.cc" // lalr1.cc:919
    break;

  case 355:
#line 879 "DynareBison.yy" // lalr1.cc:919
    { driver.hist_val(yystack_[6].value.as < string > (), yystack_[4].value.as < string > (), yystack_[1].value.as < expr_t > ()); }
#line 2687 "DynareBison.cc" // lalr1.cc:919
    break;

  case 356:
#line 882 "DynareBison.yy" // lalr1.cc:919
    { driver.histval_file(yystack_[2].value.as < string > ()); }
#line 2693 "DynareBison.cc" // lalr1.cc:919
    break;

  case 357:
#line 885 "DynareBison.yy" // lalr1.cc:919
    { driver.begin_epilogue(); }
#line 2699 "DynareBison.cc" // lalr1.cc:919
    break;

  case 358:
#line 886 "DynareBison.yy" // lalr1.cc:919
    { driver.end_epilogue(); }
#line 2705 "DynareBison.cc" // lalr1.cc:919
    break;

  case 361:
#line 893 "DynareBison.yy" // lalr1.cc:919
    { driver.add_epilogue_variable(yystack_[0].value.as < string > ()); }
#line 2711 "DynareBison.cc" // lalr1.cc:919
    break;

  case 362:
#line 894 "DynareBison.yy" // lalr1.cc:919
    { driver.add_epilogue_equal(yystack_[4].value.as < string > (), yystack_[1].value.as < expr_t > ()); }
#line 2717 "DynareBison.cc" // lalr1.cc:919
    break;

  case 363:
#line 897 "DynareBison.yy" // lalr1.cc:919
    { }
#line 2723 "DynareBison.cc" // lalr1.cc:919
    break;

  case 366:
#line 904 "DynareBison.yy" // lalr1.cc:919
    { driver.compilation_setup_substitute_flags(yystack_[0].value.as < string > ()); }
#line 2729 "DynareBison.cc" // lalr1.cc:919
    break;

  case 367:
#line 906 "DynareBison.yy" // lalr1.cc:919
    { driver.compilation_setup_add_flags(yystack_[0].value.as < string > ()); }
#line 2735 "DynareBison.cc" // lalr1.cc:919
    break;

  case 368:
#line 908 "DynareBison.yy" // lalr1.cc:919
    { driver.compilation_setup_substitute_libs(yystack_[0].value.as < string > ()); }
#line 2741 "DynareBison.cc" // lalr1.cc:919
    break;

  case 369:
#line 910 "DynareBison.yy" // lalr1.cc:919
    { driver.compilation_setup_add_libs(yystack_[0].value.as < string > ()); }
#line 2747 "DynareBison.cc" // lalr1.cc:919
    break;

  case 370:
#line 912 "DynareBison.yy" // lalr1.cc:919
    { driver.compilation_setup_compiler(yystack_[0].value.as < string > ()); }
#line 2753 "DynareBison.cc" // lalr1.cc:919
    break;

  case 371:
#line 915 "DynareBison.yy" // lalr1.cc:919
    { driver.block(); }
#line 2759 "DynareBison.cc" // lalr1.cc:919
    break;

  case 374:
#line 918 "DynareBison.yy" // lalr1.cc:919
    { driver.byte_code(); }
#line 2765 "DynareBison.cc" // lalr1.cc:919
    break;

  case 375:
#line 919 "DynareBison.yy" // lalr1.cc:919
    { driver.use_dll(); }
#line 2771 "DynareBison.cc" // lalr1.cc:919
    break;

  case 376:
#line 920 "DynareBison.yy" // lalr1.cc:919
    { driver.no_static();}
#line 2777 "DynareBison.cc" // lalr1.cc:919
    break;

  case 377:
#line 921 "DynareBison.yy" // lalr1.cc:919
    { driver.differentiate_forward_vars_all(); }
#line 2783 "DynareBison.cc" // lalr1.cc:919
    break;

  case 378:
#line 922 "DynareBison.yy" // lalr1.cc:919
    { driver.differentiate_forward_vars_some(); }
#line 2789 "DynareBison.cc" // lalr1.cc:919
    break;

  case 381:
#line 925 "DynareBison.yy" // lalr1.cc:919
    { driver.linear_decomposition(); }
#line 2795 "DynareBison.cc" // lalr1.cc:919
    break;

  case 382:
#line 926 "DynareBison.yy" // lalr1.cc:919
    { driver.balanced_growth_test_tol(yystack_[0].value.as < string > ()); }
#line 2801 "DynareBison.cc" // lalr1.cc:919
    break;

  case 385:
#line 933 "DynareBison.yy" // lalr1.cc:919
    { driver.begin_model(); }
#line 2807 "DynareBison.cc" // lalr1.cc:919
    break;

  case 386:
#line 934 "DynareBison.yy" // lalr1.cc:919
    { driver.end_model(); }
#line 2813 "DynareBison.cc" // lalr1.cc:919
    break;

  case 387:
#line 935 "DynareBison.yy" // lalr1.cc:919
    { driver.begin_model(); }
#line 2819 "DynareBison.cc" // lalr1.cc:919
    break;

  case 388:
#line 936 "DynareBison.yy" // lalr1.cc:919
    { driver.end_model(); }
#line 2825 "DynareBison.cc" // lalr1.cc:919
    break;

  case 393:
#line 946 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_model_equal(yystack_[3].value.as < expr_t > (), yystack_[1].value.as < expr_t > ()); }
#line 2831 "DynareBison.cc" // lalr1.cc:919
    break;

  case 394:
#line 948 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_model_equal_with_zero_rhs(yystack_[1].value.as < expr_t > ()); }
#line 2837 "DynareBison.cc" // lalr1.cc:919
    break;

  case 395:
#line 950 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_model_equal(yystack_[3].value.as < expr_t > (), yystack_[1].value.as < expr_t > ()); }
#line 2843 "DynareBison.cc" // lalr1.cc:919
    break;

  case 396:
#line 952 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_model_equal_with_zero_rhs(yystack_[1].value.as < expr_t > ()); }
#line 2849 "DynareBison.cc" // lalr1.cc:919
    break;

  case 399:
#line 960 "DynareBison.yy" // lalr1.cc:919
    { driver.add_equation_tags(yystack_[2].value.as < string > (), yystack_[0].value.as < string > ()); }
#line 2855 "DynareBison.cc" // lalr1.cc:919
    break;

  case 400:
#line 962 "DynareBison.yy" // lalr1.cc:919
    { driver.add_equation_tags(yystack_[0].value.as < string > (), ""); }
#line 2861 "DynareBison.cc" // lalr1.cc:919
    break;

  case 401:
#line 966 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = yystack_[1].value.as < expr_t > ();}
#line 2867 "DynareBison.cc" // lalr1.cc:919
    break;

  case 402:
#line 968 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_model_variable(yystack_[0].value.as < string > ()); }
#line 2873 "DynareBison.cc" // lalr1.cc:919
    break;

  case 403:
#line 970 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.declare_or_change_type(SymbolType::endogenous, yystack_[1].value.as < string > ()); }
#line 2879 "DynareBison.cc" // lalr1.cc:919
    break;

  case 404:
#line 972 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.declare_or_change_type(SymbolType::exogenous, yystack_[1].value.as < string > ()); }
#line 2885 "DynareBison.cc" // lalr1.cc:919
    break;

  case 405:
#line 974 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.declare_or_change_type(SymbolType::parameter, yystack_[1].value.as < string > ()); }
#line 2891 "DynareBison.cc" // lalr1.cc:919
    break;

  case 406:
#line 976 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_non_negative_constant(yystack_[0].value.as < string > ()); }
#line 2897 "DynareBison.cc" // lalr1.cc:919
    break;

  case 407:
#line 978 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_plus(yystack_[2].value.as < expr_t > (), yystack_[0].value.as < expr_t > ()); }
#line 2903 "DynareBison.cc" // lalr1.cc:919
    break;

  case 408:
#line 980 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_minus(yystack_[2].value.as < expr_t > (), yystack_[0].value.as < expr_t > ()); }
#line 2909 "DynareBison.cc" // lalr1.cc:919
    break;

  case 409:
#line 982 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_divide(yystack_[2].value.as < expr_t > (), yystack_[0].value.as < expr_t > ()); }
#line 2915 "DynareBison.cc" // lalr1.cc:919
    break;

  case 410:
#line 984 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_times(yystack_[2].value.as < expr_t > (), yystack_[0].value.as < expr_t > ()); }
#line 2921 "DynareBison.cc" // lalr1.cc:919
    break;

  case 411:
#line 986 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_less(yystack_[2].value.as < expr_t > (), yystack_[0].value.as < expr_t > ()); }
#line 2927 "DynareBison.cc" // lalr1.cc:919
    break;

  case 412:
#line 988 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_greater(yystack_[2].value.as < expr_t > (), yystack_[0].value.as < expr_t > ()); }
#line 2933 "DynareBison.cc" // lalr1.cc:919
    break;

  case 413:
#line 990 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_less_equal(yystack_[2].value.as < expr_t > (), yystack_[0].value.as < expr_t > ()); }
#line 2939 "DynareBison.cc" // lalr1.cc:919
    break;

  case 414:
#line 992 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_greater_equal(yystack_[2].value.as < expr_t > (), yystack_[0].value.as < expr_t > ()); }
#line 2945 "DynareBison.cc" // lalr1.cc:919
    break;

  case 415:
#line 994 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_equal_equal(yystack_[2].value.as < expr_t > (), yystack_[0].value.as < expr_t > ()); }
#line 2951 "DynareBison.cc" // lalr1.cc:919
    break;

  case 416:
#line 996 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_different(yystack_[2].value.as < expr_t > (), yystack_[0].value.as < expr_t > ()); }
#line 2957 "DynareBison.cc" // lalr1.cc:919
    break;

  case 417:
#line 998 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_power(yystack_[2].value.as < expr_t > (), yystack_[0].value.as < expr_t > ()); }
#line 2963 "DynareBison.cc" // lalr1.cc:919
    break;

  case 418:
#line 1000 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_expectation(yystack_[4].value.as < string > (), yystack_[1].value.as < expr_t > ()); }
#line 2969 "DynareBison.cc" // lalr1.cc:919
    break;

  case 419:
#line 1002 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_var_expectation(yystack_[1].value.as < string > ()); }
#line 2975 "DynareBison.cc" // lalr1.cc:919
    break;

  case 420:
#line 1004 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_pac_expectation(yystack_[1].value.as < string > ()); }
#line 2981 "DynareBison.cc" // lalr1.cc:919
    break;

  case 421:
#line 1006 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_uminus(yystack_[0].value.as < expr_t > ()); }
#line 2987 "DynareBison.cc" // lalr1.cc:919
    break;

  case 422:
#line 1008 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = yystack_[0].value.as < expr_t > (); }
#line 2993 "DynareBison.cc" // lalr1.cc:919
    break;

  case 423:
#line 1010 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_exp(yystack_[1].value.as < expr_t > ()); }
#line 2999 "DynareBison.cc" // lalr1.cc:919
    break;

  case 424:
#line 1012 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_diff(yystack_[1].value.as < expr_t > ()); }
#line 3005 "DynareBison.cc" // lalr1.cc:919
    break;

  case 425:
#line 1014 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_adl(yystack_[3].value.as < expr_t > (), yystack_[1].value.as < string > (), "1"); }
#line 3011 "DynareBison.cc" // lalr1.cc:919
    break;

  case 426:
#line 1016 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_adl(yystack_[5].value.as < expr_t > (), yystack_[3].value.as < string > (), yystack_[1].value.as < string > ()); }
#line 3017 "DynareBison.cc" // lalr1.cc:919
    break;

  case 427:
#line 1018 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_adl(yystack_[5].value.as < expr_t > (), yystack_[3].value.as < string > (), yystack_[1].value.as < vector<int> > ()); }
#line 3023 "DynareBison.cc" // lalr1.cc:919
    break;

  case 428:
#line 1020 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_log(yystack_[1].value.as < expr_t > ()); }
#line 3029 "DynareBison.cc" // lalr1.cc:919
    break;

  case 429:
#line 1022 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_log(yystack_[1].value.as < expr_t > ()); }
#line 3035 "DynareBison.cc" // lalr1.cc:919
    break;

  case 430:
#line 1024 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_log10(yystack_[1].value.as < expr_t > ()); }
#line 3041 "DynareBison.cc" // lalr1.cc:919
    break;

  case 431:
#line 1026 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_sin(yystack_[1].value.as < expr_t > ()); }
#line 3047 "DynareBison.cc" // lalr1.cc:919
    break;

  case 432:
#line 1028 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_cos(yystack_[1].value.as < expr_t > ()); }
#line 3053 "DynareBison.cc" // lalr1.cc:919
    break;

  case 433:
#line 1030 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_tan(yystack_[1].value.as < expr_t > ()); }
#line 3059 "DynareBison.cc" // lalr1.cc:919
    break;

  case 434:
#line 1032 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_asin(yystack_[1].value.as < expr_t > ()); }
#line 3065 "DynareBison.cc" // lalr1.cc:919
    break;

  case 435:
#line 1034 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_acos(yystack_[1].value.as < expr_t > ()); }
#line 3071 "DynareBison.cc" // lalr1.cc:919
    break;

  case 436:
#line 1036 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_atan(yystack_[1].value.as < expr_t > ()); }
#line 3077 "DynareBison.cc" // lalr1.cc:919
    break;

  case 437:
#line 1038 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_sqrt(yystack_[1].value.as < expr_t > ()); }
#line 3083 "DynareBison.cc" // lalr1.cc:919
    break;

  case 438:
#line 1040 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_cbrt(yystack_[1].value.as < expr_t > ()); }
#line 3089 "DynareBison.cc" // lalr1.cc:919
    break;

  case 439:
#line 1042 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_abs(yystack_[1].value.as < expr_t > ()); }
#line 3095 "DynareBison.cc" // lalr1.cc:919
    break;

  case 440:
#line 1044 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_sign(yystack_[1].value.as < expr_t > ()); }
#line 3101 "DynareBison.cc" // lalr1.cc:919
    break;

  case 441:
#line 1046 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_max(yystack_[3].value.as < expr_t > (), yystack_[1].value.as < expr_t > ()); }
#line 3107 "DynareBison.cc" // lalr1.cc:919
    break;

  case 442:
#line 1048 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_min(yystack_[3].value.as < expr_t > (), yystack_[1].value.as < expr_t > ()); }
#line 3113 "DynareBison.cc" // lalr1.cc:919
    break;

  case 443:
#line 1049 "DynareBison.yy" // lalr1.cc:919
    { driver.push_external_function_arg_vector_onto_stack(); }
#line 3119 "DynareBison.cc" // lalr1.cc:919
    break;

  case 444:
#line 1050 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_model_var_or_external_function(yystack_[4].value.as < string > (), true); }
#line 3125 "DynareBison.cc" // lalr1.cc:919
    break;

  case 445:
#line 1052 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_normcdf(yystack_[5].value.as < expr_t > (), yystack_[3].value.as < expr_t > (), yystack_[1].value.as < expr_t > ()); }
#line 3131 "DynareBison.cc" // lalr1.cc:919
    break;

  case 446:
#line 1054 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_normcdf(yystack_[1].value.as < expr_t > ()); }
#line 3137 "DynareBison.cc" // lalr1.cc:919
    break;

  case 447:
#line 1056 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_normpdf(yystack_[5].value.as < expr_t > (), yystack_[3].value.as < expr_t > (), yystack_[1].value.as < expr_t > ()); }
#line 3143 "DynareBison.cc" // lalr1.cc:919
    break;

  case 448:
#line 1058 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_normpdf(yystack_[1].value.as < expr_t > ()); }
#line 3149 "DynareBison.cc" // lalr1.cc:919
    break;

  case 449:
#line 1060 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_erf(yystack_[1].value.as < expr_t > ()); }
#line 3155 "DynareBison.cc" // lalr1.cc:919
    break;

  case 450:
#line 1062 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_steady_state(yystack_[1].value.as < expr_t > ()); }
#line 3161 "DynareBison.cc" // lalr1.cc:919
    break;

  case 451:
#line 1066 "DynareBison.yy" // lalr1.cc:919
    { driver.add_external_function_arg(yystack_[0].value.as < expr_t > ()); }
#line 3167 "DynareBison.cc" // lalr1.cc:919
    break;

  case 452:
#line 1068 "DynareBison.yy" // lalr1.cc:919
    { driver.add_external_function_arg(yystack_[0].value.as < expr_t > ()); }
#line 3173 "DynareBison.cc" // lalr1.cc:919
    break;

  case 453:
#line 1072 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_and_init_model_local_variable(yystack_[3].value.as < string > (), yystack_[1].value.as < expr_t > ()); }
#line 3179 "DynareBison.cc" // lalr1.cc:919
    break;

  case 454:
#line 1074 "DynareBison.yy" // lalr1.cc:919
    { driver.end_shocks(false); }
#line 3185 "DynareBison.cc" // lalr1.cc:919
    break;

  case 455:
#line 1075 "DynareBison.yy" // lalr1.cc:919
    { driver.end_shocks(true); }
#line 3191 "DynareBison.cc" // lalr1.cc:919
    break;

  case 459:
#line 1084 "DynareBison.yy" // lalr1.cc:919
    { driver.add_stderr_shock(yystack_[4].value.as < string > (), yystack_[1].value.as < expr_t > ()); }
#line 3197 "DynareBison.cc" // lalr1.cc:919
    break;

  case 460:
#line 1086 "DynareBison.yy" // lalr1.cc:919
    { driver.add_var_shock(yystack_[3].value.as < string > (), yystack_[1].value.as < expr_t > ()); }
#line 3203 "DynareBison.cc" // lalr1.cc:919
    break;

  case 461:
#line 1088 "DynareBison.yy" // lalr1.cc:919
    { driver.add_covar_shock(yystack_[5].value.as < string > (), yystack_[3].value.as < string > (), yystack_[1].value.as < expr_t > ()); }
#line 3209 "DynareBison.cc" // lalr1.cc:919
    break;

  case 462:
#line 1090 "DynareBison.yy" // lalr1.cc:919
    { driver.add_correl_shock(yystack_[5].value.as < string > (), yystack_[3].value.as < string > (), yystack_[1].value.as < expr_t > ()); }
#line 3215 "DynareBison.cc" // lalr1.cc:919
    break;

  case 463:
#line 1094 "DynareBison.yy" // lalr1.cc:919
    { driver.add_det_shock(yystack_[7].value.as < string > (), false); }
#line 3221 "DynareBison.cc" // lalr1.cc:919
    break;

  case 464:
#line 1097 "DynareBison.yy" // lalr1.cc:919
    {driver.begin_svar_identification();}
#line 3227 "DynareBison.cc" // lalr1.cc:919
    break;

  case 465:
#line 1098 "DynareBison.yy" // lalr1.cc:919
    { driver.end_svar_identification(); }
#line 3233 "DynareBison.cc" // lalr1.cc:919
    break;

  case 468:
#line 1106 "DynareBison.yy" // lalr1.cc:919
    { driver.combine_lag_and_restriction(yystack_[2].value.as < string > ()); }
#line 3239 "DynareBison.cc" // lalr1.cc:919
    break;

  case 469:
#line 1108 "DynareBison.yy" // lalr1.cc:919
    { driver.add_constants_exclusion(); }
#line 3245 "DynareBison.cc" // lalr1.cc:919
    break;

  case 470:
#line 1110 "DynareBison.yy" // lalr1.cc:919
    { driver.add_restriction_equation_nbr(yystack_[1].value.as < string > ());}
#line 3251 "DynareBison.cc" // lalr1.cc:919
    break;

  case 471:
#line 1112 "DynareBison.yy" // lalr1.cc:919
    {driver.add_restriction_equal();}
#line 3257 "DynareBison.cc" // lalr1.cc:919
    break;

  case 473:
#line 1115 "DynareBison.yy" // lalr1.cc:919
    { driver.add_upper_cholesky(); }
#line 3263 "DynareBison.cc" // lalr1.cc:919
    break;

  case 474:
#line 1117 "DynareBison.yy" // lalr1.cc:919
    { driver.add_lower_cholesky(); }
#line 3269 "DynareBison.cc" // lalr1.cc:919
    break;

  case 475:
#line 1121 "DynareBison.yy" // lalr1.cc:919
    { driver.add_restriction_in_equation(yystack_[3].value.as < string > ()); }
#line 3275 "DynareBison.cc" // lalr1.cc:919
    break;

  case 476:
#line 1123 "DynareBison.yy" // lalr1.cc:919
    { driver.add_restriction_in_equation(yystack_[3].value.as < string > ()); }
#line 3281 "DynareBison.cc" // lalr1.cc:919
    break;

  case 477:
#line 1127 "DynareBison.yy" // lalr1.cc:919
    { driver.add_in_svar_restriction_symbols(yystack_[0].value.as < string > ()); }
#line 3287 "DynareBison.cc" // lalr1.cc:919
    break;

  case 478:
#line 1129 "DynareBison.yy" // lalr1.cc:919
    { driver.add_in_svar_restriction_symbols(yystack_[0].value.as < string > ()); }
#line 3293 "DynareBison.cc" // lalr1.cc:919
    break;

  case 479:
#line 1132 "DynareBison.yy" // lalr1.cc:919
    {driver.check_restriction_expression_constant(yystack_[0].value.as < expr_t > ());}
#line 3299 "DynareBison.cc" // lalr1.cc:919
    break;

  case 483:
#line 1141 "DynareBison.yy" // lalr1.cc:919
    { driver.add_positive_restriction_element(yystack_[3].value.as < string > (),yystack_[1].value.as < string > ());}
#line 3305 "DynareBison.cc" // lalr1.cc:919
    break;

  case 484:
#line 1143 "DynareBison.yy" // lalr1.cc:919
    { driver.add_positive_restriction_element(yystack_[3].value.as < string > (),yystack_[1].value.as < string > ());}
#line 3311 "DynareBison.cc" // lalr1.cc:919
    break;

  case 485:
#line 1145 "DynareBison.yy" // lalr1.cc:919
    { driver.add_negative_restriction_element(yystack_[3].value.as < string > (),yystack_[1].value.as < string > ());}
#line 3317 "DynareBison.cc" // lalr1.cc:919
    break;

  case 486:
#line 1147 "DynareBison.yy" // lalr1.cc:919
    { driver.add_positive_restriction_element(yystack_[7].value.as < expr_t > (),yystack_[3].value.as < string > (),yystack_[1].value.as < string > ());}
#line 3323 "DynareBison.cc" // lalr1.cc:919
    break;

  case 487:
#line 1151 "DynareBison.yy" // lalr1.cc:919
    { driver.add_svar_global_identification_check(); }
#line 3329 "DynareBison.cc" // lalr1.cc:919
    break;

  case 488:
#line 1155 "DynareBison.yy" // lalr1.cc:919
    { driver.markov_switching(); }
#line 3335 "DynareBison.cc" // lalr1.cc:919
    break;

  case 497:
#line 1171 "DynareBison.yy" // lalr1.cc:919
    { driver.svar(); }
#line 3341 "DynareBison.cc" // lalr1.cc:919
    break;

  case 504:
#line 1184 "DynareBison.yy" // lalr1.cc:919
    { driver.end_mshocks(false); }
#line 3347 "DynareBison.cc" // lalr1.cc:919
    break;

  case 505:
#line 1185 "DynareBison.yy" // lalr1.cc:919
    { driver.end_mshocks(true); }
#line 3353 "DynareBison.cc" // lalr1.cc:919
    break;

  case 508:
#line 1193 "DynareBison.yy" // lalr1.cc:919
    { driver.add_period(yystack_[0].value.as < string > ()); }
#line 3359 "DynareBison.cc" // lalr1.cc:919
    break;

  case 509:
#line 1195 "DynareBison.yy" // lalr1.cc:919
    { driver.add_period(yystack_[0].value.as < string > ()); }
#line 3365 "DynareBison.cc" // lalr1.cc:919
    break;

  case 510:
#line 1197 "DynareBison.yy" // lalr1.cc:919
    { driver.add_period(yystack_[2].value.as < string > (), yystack_[0].value.as < string > ()); }
#line 3371 "DynareBison.cc" // lalr1.cc:919
    break;

  case 511:
#line 1199 "DynareBison.yy" // lalr1.cc:919
    { driver.add_period(yystack_[2].value.as < string > (), yystack_[0].value.as < string > ()); }
#line 3377 "DynareBison.cc" // lalr1.cc:919
    break;

  case 512:
#line 1201 "DynareBison.yy" // lalr1.cc:919
    { driver.add_period(yystack_[2].value.as < string > (), yystack_[0].value.as < string > ()); }
#line 3383 "DynareBison.cc" // lalr1.cc:919
    break;

  case 513:
#line 1203 "DynareBison.yy" // lalr1.cc:919
    { driver.add_period(yystack_[0].value.as < string > ()); }
#line 3389 "DynareBison.cc" // lalr1.cc:919
    break;

  case 514:
#line 1206 "DynareBison.yy" // lalr1.cc:919
    { driver.do_sigma_e(); }
#line 3395 "DynareBison.cc" // lalr1.cc:919
    break;

  case 515:
#line 1209 "DynareBison.yy" // lalr1.cc:919
    { driver.add_value(yystack_[1].value.as < expr_t > ()); }
#line 3401 "DynareBison.cc" // lalr1.cc:919
    break;

  case 516:
#line 1211 "DynareBison.yy" // lalr1.cc:919
    { driver.add_value(yystack_[1].value.as < expr_t > ()); }
#line 3407 "DynareBison.cc" // lalr1.cc:919
    break;

  case 517:
#line 1213 "DynareBison.yy" // lalr1.cc:919
    { driver.add_value(yystack_[1].value.as < expr_t > ()); }
#line 3413 "DynareBison.cc" // lalr1.cc:919
    break;

  case 518:
#line 1215 "DynareBison.yy" // lalr1.cc:919
    { driver.add_value(yystack_[0].value.as < string > ()); }
#line 3419 "DynareBison.cc" // lalr1.cc:919
    break;

  case 519:
#line 1217 "DynareBison.yy" // lalr1.cc:919
    { driver.add_value(yystack_[0].value.as < string > ()); }
#line 3425 "DynareBison.cc" // lalr1.cc:919
    break;

  case 520:
#line 1219 "DynareBison.yy" // lalr1.cc:919
    { driver.add_value(yystack_[0].value.as < string > ()); }
#line 3431 "DynareBison.cc" // lalr1.cc:919
    break;

  case 521:
#line 1223 "DynareBison.yy" // lalr1.cc:919
    { driver.end_of_row(); }
#line 3437 "DynareBison.cc" // lalr1.cc:919
    break;

  case 522:
#line 1225 "DynareBison.yy" // lalr1.cc:919
    { driver.end_of_row(); }
#line 3443 "DynareBison.cc" // lalr1.cc:919
    break;

  case 523:
#line 1229 "DynareBison.yy" // lalr1.cc:919
    { driver.add_to_row(yystack_[1].value.as < expr_t > ()); }
#line 3449 "DynareBison.cc" // lalr1.cc:919
    break;

  case 524:
#line 1231 "DynareBison.yy" // lalr1.cc:919
    { driver.add_to_row_const(yystack_[0].value.as < string > ()); }
#line 3455 "DynareBison.cc" // lalr1.cc:919
    break;

  case 525:
#line 1233 "DynareBison.yy" // lalr1.cc:919
    { driver.add_to_row(yystack_[1].value.as < expr_t > ()); }
#line 3461 "DynareBison.cc" // lalr1.cc:919
    break;

  case 526:
#line 1235 "DynareBison.yy" // lalr1.cc:919
    { driver.add_to_row_const(yystack_[0].value.as < string > ()); }
#line 3467 "DynareBison.cc" // lalr1.cc:919
    break;

  case 527:
#line 1237 "DynareBison.yy" // lalr1.cc:919
    { driver.add_to_row(yystack_[1].value.as < expr_t > ()); }
#line 3473 "DynareBison.cc" // lalr1.cc:919
    break;

  case 528:
#line 1239 "DynareBison.yy" // lalr1.cc:919
    { driver.add_to_row_const(yystack_[0].value.as < string > ()); }
#line 3479 "DynareBison.cc" // lalr1.cc:919
    break;

  case 529:
#line 1243 "DynareBison.yy" // lalr1.cc:919
    { driver.steady(); }
#line 3485 "DynareBison.cc" // lalr1.cc:919
    break;

  case 530:
#line 1245 "DynareBison.yy" // lalr1.cc:919
    { driver.steady(); }
#line 3491 "DynareBison.cc" // lalr1.cc:919
    break;

  case 541:
#line 1263 "DynareBison.yy" // lalr1.cc:919
    { driver.check(); }
#line 3497 "DynareBison.cc" // lalr1.cc:919
    break;

  case 542:
#line 1265 "DynareBison.yy" // lalr1.cc:919
    { driver.check(); }
#line 3503 "DynareBison.cc" // lalr1.cc:919
    break;

  case 547:
#line 1277 "DynareBison.yy" // lalr1.cc:919
    { driver.model_info(); }
#line 3509 "DynareBison.cc" // lalr1.cc:919
    break;

  case 548:
#line 1279 "DynareBison.yy" // lalr1.cc:919
    { driver.model_info(); }
#line 3515 "DynareBison.cc" // lalr1.cc:919
    break;

  case 552:
#line 1288 "DynareBison.yy" // lalr1.cc:919
    { driver.perfect_foresight_setup(); }
#line 3521 "DynareBison.cc" // lalr1.cc:919
    break;

  case 553:
#line 1290 "DynareBison.yy" // lalr1.cc:919
    { driver.perfect_foresight_setup(); }
#line 3527 "DynareBison.cc" // lalr1.cc:919
    break;

  case 558:
#line 1302 "DynareBison.yy" // lalr1.cc:919
    { driver.perfect_foresight_solver(); }
#line 3533 "DynareBison.cc" // lalr1.cc:919
    break;

  case 559:
#line 1304 "DynareBison.yy" // lalr1.cc:919
    { driver.perfect_foresight_solver(); }
#line 3539 "DynareBison.cc" // lalr1.cc:919
    break;

  case 623:
#line 1377 "DynareBison.yy" // lalr1.cc:919
    { driver.gmm_estimation(); }
#line 3545 "DynareBison.cc" // lalr1.cc:919
    break;

  case 624:
#line 1379 "DynareBison.yy" // lalr1.cc:919
    { driver.gmm_estimation(); }
#line 3551 "DynareBison.cc" // lalr1.cc:919
    break;

  case 636:
#line 1398 "DynareBison.yy" // lalr1.cc:919
    { driver.smm_estimation(); }
#line 3557 "DynareBison.cc" // lalr1.cc:919
    break;

  case 637:
#line 1400 "DynareBison.yy" // lalr1.cc:919
    { driver.smm_estimation(); }
#line 3563 "DynareBison.cc" // lalr1.cc:919
    break;

  case 653:
#line 1423 "DynareBison.yy" // lalr1.cc:919
    { driver.prior_posterior_function(true); }
#line 3569 "DynareBison.cc" // lalr1.cc:919
    break;

  case 654:
#line 1427 "DynareBison.yy" // lalr1.cc:919
    { driver.prior_posterior_function(false); }
#line 3575 "DynareBison.cc" // lalr1.cc:919
    break;

  case 659:
#line 1439 "DynareBison.yy" // lalr1.cc:919
    { driver.simul(); }
#line 3581 "DynareBison.cc" // lalr1.cc:919
    break;

  case 660:
#line 1441 "DynareBison.yy" // lalr1.cc:919
    { driver.simul(); }
#line 3587 "DynareBison.cc" // lalr1.cc:919
    break;

  case 665:
#line 1453 "DynareBison.yy" // lalr1.cc:919
    { driver.external_function(); }
#line 3593 "DynareBison.cc" // lalr1.cc:919
    break;

  case 672:
#line 1467 "DynareBison.yy" // lalr1.cc:919
    { driver.stoch_simul(); }
#line 3599 "DynareBison.cc" // lalr1.cc:919
    break;

  case 673:
#line 1469 "DynareBison.yy" // lalr1.cc:919
    { driver.stoch_simul(); }
#line 3605 "DynareBison.cc" // lalr1.cc:919
    break;

  case 674:
#line 1471 "DynareBison.yy" // lalr1.cc:919
    { driver.stoch_simul(); }
#line 3611 "DynareBison.cc" // lalr1.cc:919
    break;

  case 675:
#line 1473 "DynareBison.yy" // lalr1.cc:919
    { driver.stoch_simul(); }
#line 3617 "DynareBison.cc" // lalr1.cc:919
    break;

  case 734:
#line 1541 "DynareBison.yy" // lalr1.cc:919
    { driver.add_in_symbol_list(yystack_[0].value.as < string > ()); }
#line 3623 "DynareBison.cc" // lalr1.cc:919
    break;

  case 735:
#line 1543 "DynareBison.yy" // lalr1.cc:919
    { driver.add_in_symbol_list(yystack_[0].value.as < string > ()); }
#line 3629 "DynareBison.cc" // lalr1.cc:919
    break;

  case 736:
#line 1545 "DynareBison.yy" // lalr1.cc:919
    { driver.add_in_symbol_list(yystack_[0].value.as < string > ()); }
#line 3635 "DynareBison.cc" // lalr1.cc:919
    break;

  case 738:
#line 1550 "DynareBison.yy" // lalr1.cc:919
    { driver.add_in_symbol_list(":"); }
#line 3641 "DynareBison.cc" // lalr1.cc:919
    break;

  case 739:
#line 1554 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 3647 "DynareBison.cc" // lalr1.cc:919
    break;

  case 740:
#line 1556 "DynareBison.yy" // lalr1.cc:919
    {
                   yylhs.value.as < string > () = yystack_[0].value.as < string > ();
                   yylhs.value.as < string > ().insert(0, "-");
                 }
#line 3656 "DynareBison.cc" // lalr1.cc:919
    break;

  case 741:
#line 1560 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 3662 "DynareBison.cc" // lalr1.cc:919
    break;

  case 742:
#line 1563 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 3668 "DynareBison.cc" // lalr1.cc:919
    break;

  case 743:
#line 1564 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 3674 "DynareBison.cc" // lalr1.cc:919
    break;

  case 744:
#line 1568 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 3680 "DynareBison.cc" // lalr1.cc:919
    break;

  case 745:
#line 1570 "DynareBison.yy" // lalr1.cc:919
    {
                 yylhs.value.as < string > () = yystack_[0].value.as < string > ();
                 yylhs.value.as < string > ().insert(0, "-");
               }
#line 3689 "DynareBison.cc" // lalr1.cc:919
    break;

  case 746:
#line 1574 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 3695 "DynareBison.cc" // lalr1.cc:919
    break;

  case 747:
#line 1578 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = "Inf"; }
#line 3701 "DynareBison.cc" // lalr1.cc:919
    break;

  case 748:
#line 1580 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = "-Inf"; }
#line 3707 "DynareBison.cc" // lalr1.cc:919
    break;

  case 749:
#line 1582 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = "Inf"; }
#line 3713 "DynareBison.cc" // lalr1.cc:919
    break;

  case 750:
#line 1585 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 3719 "DynareBison.cc" // lalr1.cc:919
    break;

  case 751:
#line 1586 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 3725 "DynareBison.cc" // lalr1.cc:919
    break;

  case 752:
#line 1589 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 3731 "DynareBison.cc" // lalr1.cc:919
    break;

  case 753:
#line 1590 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 3737 "DynareBison.cc" // lalr1.cc:919
    break;

  case 754:
#line 1593 "DynareBison.yy" // lalr1.cc:919
    { driver.estimated_params(); }
#line 3743 "DynareBison.cc" // lalr1.cc:919
    break;

  case 755:
#line 1596 "DynareBison.yy" // lalr1.cc:919
    { driver.add_estimated_params_element(); }
#line 3749 "DynareBison.cc" // lalr1.cc:919
    break;

  case 756:
#line 1598 "DynareBison.yy" // lalr1.cc:919
    { driver.add_estimated_params_element(); }
#line 3755 "DynareBison.cc" // lalr1.cc:919
    break;

  case 759:
#line 1605 "DynareBison.yy" // lalr1.cc:919
    {
                    driver.estim_params.type = 1;
                    driver.estim_params.name = yystack_[0].value.as < string > ();
                  }
#line 3764 "DynareBison.cc" // lalr1.cc:919
    break;

  case 760:
#line 1610 "DynareBison.yy" // lalr1.cc:919
    {
                    driver.estim_params.type = 2;
                    driver.estim_params.name = yystack_[0].value.as < string > ();
                  }
#line 3773 "DynareBison.cc" // lalr1.cc:919
    break;

  case 761:
#line 1615 "DynareBison.yy" // lalr1.cc:919
    {
                    driver.estim_params.type = 3;
                    driver.estim_params.name = yystack_[2].value.as < string > ();
                    driver.estim_params.name2 = yystack_[0].value.as < string > ();
                  }
#line 3783 "DynareBison.cc" // lalr1.cc:919
    break;

  case 762:
#line 1621 "DynareBison.yy" // lalr1.cc:919
    {
                    driver.estim_params.type = 2;
                    driver.estim_params.name = "dsge_prior_weight";
                  }
#line 3792 "DynareBison.cc" // lalr1.cc:919
    break;

  case 763:
#line 1628 "DynareBison.yy" // lalr1.cc:919
    {
                    driver.estim_params.prior = yystack_[2].value.as < PriorDistributions > ();
                  }
#line 3800 "DynareBison.cc" // lalr1.cc:919
    break;

  case 764:
#line 1632 "DynareBison.yy" // lalr1.cc:919
    {
                    driver.estim_params.init_val = yystack_[4].value.as < expr_t > ();
                    driver.estim_params.prior = yystack_[2].value.as < PriorDistributions > ();
                  }
#line 3809 "DynareBison.cc" // lalr1.cc:919
    break;

  case 765:
#line 1637 "DynareBison.yy" // lalr1.cc:919
    {
                    driver.estim_params.init_val = yystack_[8].value.as < expr_t > ();
                    driver.estim_params.low_bound = yystack_[6].value.as < expr_t > ();
                    driver.estim_params.up_bound = yystack_[4].value.as < expr_t > ();
                    driver.estim_params.prior = yystack_[2].value.as < PriorDistributions > ();
                  }
#line 3820 "DynareBison.cc" // lalr1.cc:919
    break;

  case 766:
#line 1644 "DynareBison.yy" // lalr1.cc:919
    {
                    driver.estim_params.init_val = yystack_[0].value.as < expr_t > ();
                  }
#line 3828 "DynareBison.cc" // lalr1.cc:919
    break;

  case 767:
#line 1648 "DynareBison.yy" // lalr1.cc:919
    {
                    driver.estim_params.init_val = yystack_[4].value.as < expr_t > ();
                    driver.estim_params.low_bound = yystack_[2].value.as < expr_t > ();
                    driver.estim_params.up_bound = yystack_[0].value.as < expr_t > ();
                  }
#line 3838 "DynareBison.cc" // lalr1.cc:919
    break;

  case 768:
#line 1656 "DynareBison.yy" // lalr1.cc:919
    {
                    driver.estim_params.mean = yystack_[2].value.as < expr_t > ();
                    driver.estim_params.std = yystack_[0].value.as < expr_t > ();
                  }
#line 3847 "DynareBison.cc" // lalr1.cc:919
    break;

  case 769:
#line 1661 "DynareBison.yy" // lalr1.cc:919
    {
                    driver.estim_params.mean = yystack_[4].value.as < expr_t > ();
                    driver.estim_params.std = yystack_[2].value.as < expr_t > ();
                    driver.estim_params.p3 = yystack_[0].value.as < expr_t > ();
                  }
#line 3857 "DynareBison.cc" // lalr1.cc:919
    break;

  case 770:
#line 1667 "DynareBison.yy" // lalr1.cc:919
    {
                    driver.estim_params.mean = yystack_[6].value.as < expr_t > ();
                    driver.estim_params.std = yystack_[4].value.as < expr_t > ();
                    driver.estim_params.p3 = yystack_[2].value.as < expr_t > ();
                    driver.estim_params.p4 = yystack_[0].value.as < expr_t > ();
                  }
#line 3868 "DynareBison.cc" // lalr1.cc:919
    break;

  case 771:
#line 1674 "DynareBison.yy" // lalr1.cc:919
    {
                    driver.estim_params.mean = yystack_[8].value.as < expr_t > ();
                    driver.estim_params.std = yystack_[6].value.as < expr_t > ();
                    driver.estim_params.p3 = yystack_[4].value.as < expr_t > ();
                    driver.estim_params.p4 = yystack_[2].value.as < expr_t > ();
                    driver.estim_params.jscale = yystack_[0].value.as < expr_t > ();
                  }
#line 3880 "DynareBison.cc" // lalr1.cc:919
    break;

  case 772:
#line 1684 "DynareBison.yy" // lalr1.cc:919
    { driver.estimated_params_init(); }
#line 3886 "DynareBison.cc" // lalr1.cc:919
    break;

  case 773:
#line 1686 "DynareBison.yy" // lalr1.cc:919
    { driver.estimated_params_init(true); }
#line 3892 "DynareBison.cc" // lalr1.cc:919
    break;

  case 774:
#line 1688 "DynareBison.yy" // lalr1.cc:919
    { driver.estimated_params_init(true); }
#line 3898 "DynareBison.cc" // lalr1.cc:919
    break;

  case 775:
#line 1692 "DynareBison.yy" // lalr1.cc:919
    { driver.add_estimated_params_element(); }
#line 3904 "DynareBison.cc" // lalr1.cc:919
    break;

  case 776:
#line 1694 "DynareBison.yy" // lalr1.cc:919
    { driver.add_estimated_params_element(); }
#line 3910 "DynareBison.cc" // lalr1.cc:919
    break;

  case 777:
#line 1698 "DynareBison.yy" // lalr1.cc:919
    {
                        driver.estim_params.type = 1;
                        driver.estim_params.name = yystack_[3].value.as < string > ();
                        driver.estim_params.init_val = yystack_[1].value.as < expr_t > ();
                      }
#line 3920 "DynareBison.cc" // lalr1.cc:919
    break;

  case 778:
#line 1704 "DynareBison.yy" // lalr1.cc:919
    {
                        driver.estim_params.type = 3;
                        driver.estim_params.name = yystack_[5].value.as < string > ();
                        driver.estim_params.name2 = yystack_[3].value.as < string > ();
                        driver.estim_params.init_val = yystack_[1].value.as < expr_t > ();
                      }
#line 3931 "DynareBison.cc" // lalr1.cc:919
    break;

  case 779:
#line 1711 "DynareBison.yy" // lalr1.cc:919
    {
                        driver.estim_params.type = 2;
                        driver.estim_params.name = yystack_[3].value.as < string > ();
                        driver.estim_params.init_val = yystack_[1].value.as < expr_t > ();
                      }
#line 3941 "DynareBison.cc" // lalr1.cc:919
    break;

  case 780:
#line 1719 "DynareBison.yy" // lalr1.cc:919
    { driver.estimated_params_bounds(); }
#line 3947 "DynareBison.cc" // lalr1.cc:919
    break;

  case 781:
#line 1722 "DynareBison.yy" // lalr1.cc:919
    { driver.add_estimated_params_element(); }
#line 3953 "DynareBison.cc" // lalr1.cc:919
    break;

  case 782:
#line 1724 "DynareBison.yy" // lalr1.cc:919
    { driver.add_estimated_params_element(); }
#line 3959 "DynareBison.cc" // lalr1.cc:919
    break;

  case 783:
#line 1728 "DynareBison.yy" // lalr1.cc:919
    {
                          driver.estim_params.type = 1;
                          driver.estim_params.name = yystack_[5].value.as < string > ();
                          driver.estim_params.low_bound = yystack_[3].value.as < expr_t > ();
                          driver.estim_params.up_bound = yystack_[1].value.as < expr_t > ();
                        }
#line 3970 "DynareBison.cc" // lalr1.cc:919
    break;

  case 784:
#line 1735 "DynareBison.yy" // lalr1.cc:919
    {
                          driver.estim_params.type = 3;
                          driver.estim_params.name = yystack_[7].value.as < string > ();
                          driver.estim_params.name2 = yystack_[5].value.as < string > ();
                          driver.estim_params.low_bound = yystack_[3].value.as < expr_t > ();
                          driver.estim_params.up_bound = yystack_[1].value.as < expr_t > ();
                        }
#line 3982 "DynareBison.cc" // lalr1.cc:919
    break;

  case 785:
#line 1743 "DynareBison.yy" // lalr1.cc:919
    {
                          driver.estim_params.type = 2;
                          driver.estim_params.name = yystack_[5].value.as < string > ();
                          driver.estim_params.low_bound = yystack_[3].value.as < expr_t > ();
                          driver.estim_params.up_bound = yystack_[1].value.as < expr_t > ();
                        }
#line 3993 "DynareBison.cc" // lalr1.cc:919
    break;

  case 786:
#line 1752 "DynareBison.yy" // lalr1.cc:919
    { driver.osr_params_bounds(); }
#line 3999 "DynareBison.cc" // lalr1.cc:919
    break;

  case 787:
#line 1755 "DynareBison.yy" // lalr1.cc:919
    { driver.add_osr_params_element(); }
#line 4005 "DynareBison.cc" // lalr1.cc:919
    break;

  case 788:
#line 1757 "DynareBison.yy" // lalr1.cc:919
    { driver.add_osr_params_element(); }
#line 4011 "DynareBison.cc" // lalr1.cc:919
    break;

  case 789:
#line 1761 "DynareBison.yy" // lalr1.cc:919
    {
                    driver.osr_params.name = yystack_[5].value.as < string > ();
                    driver.osr_params.low_bound = yystack_[3].value.as < expr_t > ();
                    driver.osr_params.up_bound = yystack_[1].value.as < expr_t > ();
                  }
#line 4021 "DynareBison.cc" // lalr1.cc:919
    break;

  case 790:
#line 1769 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < PriorDistributions > () = PriorDistributions::beta; }
#line 4027 "DynareBison.cc" // lalr1.cc:919
    break;

  case 791:
#line 1771 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < PriorDistributions > () = PriorDistributions::gamma; }
#line 4033 "DynareBison.cc" // lalr1.cc:919
    break;

  case 792:
#line 1773 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < PriorDistributions > () = PriorDistributions::normal; }
#line 4039 "DynareBison.cc" // lalr1.cc:919
    break;

  case 793:
#line 1775 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < PriorDistributions > () = PriorDistributions::invGamma; }
#line 4045 "DynareBison.cc" // lalr1.cc:919
    break;

  case 794:
#line 1777 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < PriorDistributions > () = PriorDistributions::invGamma1; }
#line 4051 "DynareBison.cc" // lalr1.cc:919
    break;

  case 795:
#line 1779 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < PriorDistributions > () = PriorDistributions::uniform; }
#line 4057 "DynareBison.cc" // lalr1.cc:919
    break;

  case 796:
#line 1781 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < PriorDistributions > () = PriorDistributions::invGamma2; }
#line 4063 "DynareBison.cc" // lalr1.cc:919
    break;

  case 797:
#line 1783 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < PriorDistributions > () = PriorDistributions::dirichlet; }
#line 4069 "DynareBison.cc" // lalr1.cc:919
    break;

  case 798:
#line 1785 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < PriorDistributions > () = PriorDistributions::weibull; }
#line 4075 "DynareBison.cc" // lalr1.cc:919
    break;

  case 799:
#line 1789 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < PriorDistributions > () = PriorDistributions::beta; }
#line 4081 "DynareBison.cc" // lalr1.cc:919
    break;

  case 800:
#line 1791 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < PriorDistributions > () = PriorDistributions::gamma; }
#line 4087 "DynareBison.cc" // lalr1.cc:919
    break;

  case 801:
#line 1793 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < PriorDistributions > () = PriorDistributions::normal; }
#line 4093 "DynareBison.cc" // lalr1.cc:919
    break;

  case 802:
#line 1795 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < PriorDistributions > () = PriorDistributions::invGamma; }
#line 4099 "DynareBison.cc" // lalr1.cc:919
    break;

  case 803:
#line 1797 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < PriorDistributions > () = PriorDistributions::invGamma1; }
#line 4105 "DynareBison.cc" // lalr1.cc:919
    break;

  case 804:
#line 1799 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < PriorDistributions > () = PriorDistributions::uniform; }
#line 4111 "DynareBison.cc" // lalr1.cc:919
    break;

  case 805:
#line 1801 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < PriorDistributions > () = PriorDistributions::invGamma2; }
#line 4117 "DynareBison.cc" // lalr1.cc:919
    break;

  case 806:
#line 1803 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < PriorDistributions > () = PriorDistributions::weibull; }
#line 4123 "DynareBison.cc" // lalr1.cc:919
    break;

  case 807:
#line 1806 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 4129 "DynareBison.cc" // lalr1.cc:919
    break;

  case 808:
#line 1808 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 4135 "DynareBison.cc" // lalr1.cc:919
    break;

  case 809:
#line 1810 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = yystack_[2].value.as < string > () + '+' + yystack_[0].value.as < string > (); }
#line 4141 "DynareBison.cc" // lalr1.cc:919
    break;

  case 810:
#line 1814 "DynareBison.yy" // lalr1.cc:919
    { driver.set_time(yystack_[2].value.as < string > ()); }
#line 4147 "DynareBison.cc" // lalr1.cc:919
    break;

  case 811:
#line 1818 "DynareBison.yy" // lalr1.cc:919
    { driver.estimation_data(); }
#line 4153 "DynareBison.cc" // lalr1.cc:919
    break;

  case 821:
#line 1835 "DynareBison.yy" // lalr1.cc:919
    { driver.set_subsamples(yystack_[4].value.as < pair<string,string> > ().first, yystack_[4].value.as < pair<string,string> > ().second); }
#line 4159 "DynareBison.cc" // lalr1.cc:919
    break;

  case 822:
#line 1839 "DynareBison.yy" // lalr1.cc:919
    { driver.copy_subsamples(yystack_[3].value.as < pair<string,string> > ().first, yystack_[3].value.as < pair<string,string> > ().second, yystack_[1].value.as < pair<string,string> > ().first, yystack_[1].value.as < pair<string,string> > ().second); }
#line 4165 "DynareBison.cc" // lalr1.cc:919
    break;

  case 823:
#line 1843 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < pair<string,string> > () = { yystack_[2].value.as < string > (), "" }; }
#line 4171 "DynareBison.cc" // lalr1.cc:919
    break;

  case 824:
#line 1845 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < pair<string,string> > () = { yystack_[3].value.as < string > (), "" }; }
#line 4177 "DynareBison.cc" // lalr1.cc:919
    break;

  case 825:
#line 1847 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < pair<string,string> > () = { yystack_[5].value.as < string > (), yystack_[3].value.as < string > () }; }
#line 4183 "DynareBison.cc" // lalr1.cc:919
    break;

  case 828:
#line 1854 "DynareBison.yy" // lalr1.cc:919
    { driver.set_prior_variance(); driver.prior_shape = PriorDistributions::noShape; }
#line 4189 "DynareBison.cc" // lalr1.cc:919
    break;

  case 829:
#line 1855 "DynareBison.yy" // lalr1.cc:919
    { driver.set_prior(yystack_[7].value.as < string > (), ""); }
#line 4195 "DynareBison.cc" // lalr1.cc:919
    break;

  case 830:
#line 1856 "DynareBison.yy" // lalr1.cc:919
    { driver.set_prior_variance(); driver.prior_shape = PriorDistributions::noShape; }
#line 4201 "DynareBison.cc" // lalr1.cc:919
    break;

  case 831:
#line 1857 "DynareBison.yy" // lalr1.cc:919
    { driver.set_prior(yystack_[9].value.as < string > (), yystack_[7].value.as < string > ()); }
#line 4207 "DynareBison.cc" // lalr1.cc:919
    break;

  case 832:
#line 1858 "DynareBison.yy" // lalr1.cc:919
    { driver.set_prior_variance(); driver.prior_shape = PriorDistributions::noShape; }
#line 4213 "DynareBison.cc" // lalr1.cc:919
    break;

  case 833:
#line 1859 "DynareBison.yy" // lalr1.cc:919
    { driver.set_joint_prior(yystack_[7].value.as < vector<string> > ()); }
#line 4219 "DynareBison.cc" // lalr1.cc:919
    break;

  case 834:
#line 1860 "DynareBison.yy" // lalr1.cc:919
    { driver.set_prior_variance(); driver.prior_shape = PriorDistributions::noShape; }
#line 4225 "DynareBison.cc" // lalr1.cc:919
    break;

  case 835:
#line 1861 "DynareBison.yy" // lalr1.cc:919
    { driver.set_std_prior(yystack_[8].value.as < string > (), ""); }
#line 4231 "DynareBison.cc" // lalr1.cc:919
    break;

  case 836:
#line 1862 "DynareBison.yy" // lalr1.cc:919
    { driver.set_prior_variance(); driver.prior_shape = PriorDistributions::noShape; }
#line 4237 "DynareBison.cc" // lalr1.cc:919
    break;

  case 837:
#line 1863 "DynareBison.yy" // lalr1.cc:919
    { driver.set_std_prior(yystack_[10].value.as < string > (), yystack_[7].value.as < string > ()); }
#line 4243 "DynareBison.cc" // lalr1.cc:919
    break;

  case 838:
#line 1864 "DynareBison.yy" // lalr1.cc:919
    { driver.set_prior_variance(); driver.prior_shape = PriorDistributions::noShape; }
#line 4249 "DynareBison.cc" // lalr1.cc:919
    break;

  case 839:
#line 1865 "DynareBison.yy" // lalr1.cc:919
    { driver.set_corr_prior(yystack_[10].value.as < string > (), yystack_[8].value.as < string > (), ""); }
#line 4255 "DynareBison.cc" // lalr1.cc:919
    break;

  case 840:
#line 1866 "DynareBison.yy" // lalr1.cc:919
    { driver.set_prior_variance(); driver.prior_shape = PriorDistributions::noShape; }
#line 4261 "DynareBison.cc" // lalr1.cc:919
    break;

  case 841:
#line 1867 "DynareBison.yy" // lalr1.cc:919
    { driver.set_corr_prior(yystack_[12].value.as < string > (), yystack_[10].value.as < string > (), yystack_[7].value.as < string > ()); }
#line 4267 "DynareBison.cc" // lalr1.cc:919
    break;

  case 866:
#line 1903 "DynareBison.yy" // lalr1.cc:919
    { driver.copy_prior(get<0>(yystack_[3].value.as < tuple<string,string,string,string> > ()), get<1>(yystack_[3].value.as < tuple<string,string,string,string> > ()), get<2>(yystack_[3].value.as < tuple<string,string,string,string> > ()), get<3>(yystack_[3].value.as < tuple<string,string,string,string> > ()),
                               get<0>(yystack_[1].value.as < tuple<string,string,string,string> > ()), get<1>(yystack_[1].value.as < tuple<string,string,string,string> > ()), get<2>(yystack_[1].value.as < tuple<string,string,string,string> > ()), get<3>(yystack_[1].value.as < tuple<string,string,string,string> > ())); }
#line 4274 "DynareBison.cc" // lalr1.cc:919
    break;

  case 867:
#line 1908 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < tuple<string,string,string,string> > () = { "par", yystack_[2].value.as < string > (), "", "" }; }
#line 4280 "DynareBison.cc" // lalr1.cc:919
    break;

  case 868:
#line 1910 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < tuple<string,string,string,string> > () = { "par", yystack_[4].value.as < string > (), "", yystack_[2].value.as < string > () }; }
#line 4286 "DynareBison.cc" // lalr1.cc:919
    break;

  case 869:
#line 1912 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < tuple<string,string,string,string> > () = { "std", yystack_[3].value.as < string > (), "", "" }; }
#line 4292 "DynareBison.cc" // lalr1.cc:919
    break;

  case 870:
#line 1914 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < tuple<string,string,string,string> > () = { "std", yystack_[5].value.as < string > (), "", yystack_[2].value.as < string > () }; }
#line 4298 "DynareBison.cc" // lalr1.cc:919
    break;

  case 871:
#line 1916 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < tuple<string,string,string,string> > () = { "corr", yystack_[5].value.as < string > (), yystack_[3].value.as < string > (), "" }; }
#line 4304 "DynareBison.cc" // lalr1.cc:919
    break;

  case 872:
#line 1918 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < tuple<string,string,string,string> > () = { "corr", yystack_[7].value.as < string > (), yystack_[5].value.as < string > (), yystack_[2].value.as < string > () }; }
#line 4310 "DynareBison.cc" // lalr1.cc:919
    break;

  case 873:
#line 1922 "DynareBison.yy" // lalr1.cc:919
    { driver.set_options(yystack_[6].value.as < string > (), ""); }
#line 4316 "DynareBison.cc" // lalr1.cc:919
    break;

  case 874:
#line 1924 "DynareBison.yy" // lalr1.cc:919
    { driver.set_options(yystack_[8].value.as < string > (), yystack_[6].value.as < string > ()); }
#line 4322 "DynareBison.cc" // lalr1.cc:919
    break;

  case 875:
#line 1926 "DynareBison.yy" // lalr1.cc:919
    { driver.set_std_options(yystack_[7].value.as < string > (), ""); }
#line 4328 "DynareBison.cc" // lalr1.cc:919
    break;

  case 876:
#line 1928 "DynareBison.yy" // lalr1.cc:919
    { driver.set_std_options(yystack_[9].value.as < string > (), yystack_[6].value.as < string > ()); }
#line 4334 "DynareBison.cc" // lalr1.cc:919
    break;

  case 877:
#line 1930 "DynareBison.yy" // lalr1.cc:919
    { driver.set_corr_options(yystack_[9].value.as < string > (), yystack_[7].value.as < string > (), ""); }
#line 4340 "DynareBison.cc" // lalr1.cc:919
    break;

  case 878:
#line 1932 "DynareBison.yy" // lalr1.cc:919
    { driver.set_corr_options(yystack_[11].value.as < string > (), yystack_[9].value.as < string > (), yystack_[6].value.as < string > ()); }
#line 4346 "DynareBison.cc" // lalr1.cc:919
    break;

  case 884:
#line 1945 "DynareBison.yy" // lalr1.cc:919
    { driver.copy_prior(get<0>(yystack_[3].value.as < tuple<string,string,string,string> > ()), get<1>(yystack_[3].value.as < tuple<string,string,string,string> > ()), get<2>(yystack_[3].value.as < tuple<string,string,string,string> > ()), get<3>(yystack_[3].value.as < tuple<string,string,string,string> > ()),
                                 get<0>(yystack_[1].value.as < tuple<string,string,string,string> > ()), get<1>(yystack_[1].value.as < tuple<string,string,string,string> > ()), get<2>(yystack_[1].value.as < tuple<string,string,string,string> > ()), get<3>(yystack_[1].value.as < tuple<string,string,string,string> > ())); }
#line 4353 "DynareBison.cc" // lalr1.cc:919
    break;

  case 885:
#line 1950 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < tuple<string,string,string,string> > () = { "par", yystack_[2].value.as < string > (), "", "" }; }
#line 4359 "DynareBison.cc" // lalr1.cc:919
    break;

  case 886:
#line 1952 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < tuple<string,string,string,string> > () = { "par", yystack_[4].value.as < string > (), "", yystack_[2].value.as < string > () }; }
#line 4365 "DynareBison.cc" // lalr1.cc:919
    break;

  case 887:
#line 1954 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < tuple<string,string,string,string> > () = { "std", yystack_[3].value.as < string > (), "", "" }; }
#line 4371 "DynareBison.cc" // lalr1.cc:919
    break;

  case 888:
#line 1956 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < tuple<string,string,string,string> > () = { "std", yystack_[5].value.as < string > (), "", yystack_[2].value.as < string > () }; }
#line 4377 "DynareBison.cc" // lalr1.cc:919
    break;

  case 889:
#line 1958 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < tuple<string,string,string,string> > () = { "corr", yystack_[5].value.as < string > (), yystack_[3].value.as < string > (), "" }; }
#line 4383 "DynareBison.cc" // lalr1.cc:919
    break;

  case 890:
#line 1960 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < tuple<string,string,string,string> > () = { "corr", yystack_[7].value.as < string > (), yystack_[5].value.as < string > (), yystack_[2].value.as < string > () }; }
#line 4389 "DynareBison.cc" // lalr1.cc:919
    break;

  case 891:
#line 1964 "DynareBison.yy" // lalr1.cc:919
    { driver.run_estimation(); }
#line 4395 "DynareBison.cc" // lalr1.cc:919
    break;

  case 892:
#line 1966 "DynareBison.yy" // lalr1.cc:919
    { driver.run_estimation(); }
#line 4401 "DynareBison.cc" // lalr1.cc:919
    break;

  case 893:
#line 1968 "DynareBison.yy" // lalr1.cc:919
    { driver.run_estimation(); }
#line 4407 "DynareBison.cc" // lalr1.cc:919
    break;

  case 894:
#line 1970 "DynareBison.yy" // lalr1.cc:919
    { driver.run_estimation(); }
#line 4413 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1016:
#line 2099 "DynareBison.yy" // lalr1.cc:919
    { driver.optim_options_string(yystack_[2].value.as < string > (), yystack_[0].value.as < string > ()); }
#line 4419 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1017:
#line 2101 "DynareBison.yy" // lalr1.cc:919
    { driver.optim_options_num(yystack_[2].value.as < string > (), yystack_[0].value.as < string > ()); }
#line 4425 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1018:
#line 2103 "DynareBison.yy" // lalr1.cc:919
    { driver.optim_options_num(yystack_[2].value.as < string > (), yystack_[0].value.as < string > ()); }
#line 4431 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1021:
#line 2111 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = "''" + yystack_[2].value.as < string > () + "'', ''" + yystack_[0].value.as < string > () + "''"; }
#line 4437 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1022:
#line 2113 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = "''" + yystack_[2].value.as < string > () + "''," + yystack_[0].value.as < string > (); }
#line 4443 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1023:
#line 2116 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 4449 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1024:
#line 2118 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = yystack_[2].value.as < string > () + ',' + yystack_[0].value.as < string > (); }
#line 4455 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1025:
#line 2122 "DynareBison.yy" // lalr1.cc:919
    { driver.sampling_options_string(yystack_[2].value.as < string > (), yystack_[0].value.as < string > ()); }
#line 4461 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1026:
#line 2124 "DynareBison.yy" // lalr1.cc:919
    { driver.sampling_options_num(yystack_[2].value.as < string > (), yystack_[0].value.as < string > ()); }
#line 4467 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1027:
#line 2126 "DynareBison.yy" // lalr1.cc:919
    { driver.sampling_options_vec_str(yystack_[2].value.as < string > (), yystack_[0].value.as < vector<string> > ()); }
#line 4473 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1028:
#line 2128 "DynareBison.yy" // lalr1.cc:919
    { driver.sampling_options_string(yystack_[4].value.as < string > (), '(' + yystack_[1].value.as < string > () + ')'); }
#line 4479 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1031:
#line 2135 "DynareBison.yy" // lalr1.cc:919
    { driver.check_varobs(); }
#line 4485 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1033:
#line 2138 "DynareBison.yy" // lalr1.cc:919
    { driver.add_varobs(yystack_[0].value.as < string > ()); }
#line 4491 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1034:
#line 2140 "DynareBison.yy" // lalr1.cc:919
    { driver.add_varobs(yystack_[0].value.as < string > ()); }
#line 4497 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1035:
#line 2142 "DynareBison.yy" // lalr1.cc:919
    { driver.add_varobs(yystack_[0].value.as < string > ()); }
#line 4503 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1036:
#line 2145 "DynareBison.yy" // lalr1.cc:919
    { driver.check_varexobs(); }
#line 4509 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1038:
#line 2148 "DynareBison.yy" // lalr1.cc:919
    { driver.add_varexobs(yystack_[0].value.as < string > ()); }
#line 4515 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1039:
#line 2150 "DynareBison.yy" // lalr1.cc:919
    { driver.add_varexobs(yystack_[0].value.as < string > ()); }
#line 4521 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1040:
#line 2152 "DynareBison.yy" // lalr1.cc:919
    { driver.add_varexobs(yystack_[0].value.as < string > ()); }
#line 4527 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1041:
#line 2155 "DynareBison.yy" // lalr1.cc:919
    { driver.set_trends(); }
#line 4533 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1044:
#line 2161 "DynareBison.yy" // lalr1.cc:919
    { driver.set_trend_element(yystack_[4].value.as < string > (), yystack_[2].value.as < expr_t > ()); }
#line 4539 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1045:
#line 2163 "DynareBison.yy" // lalr1.cc:919
    { driver.set_unit_root_vars(); }
#line 4545 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1046:
#line 2165 "DynareBison.yy" // lalr1.cc:919
    { driver.optim_weights(); }
#line 4551 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1047:
#line 2168 "DynareBison.yy" // lalr1.cc:919
    { driver.set_optim_weights(yystack_[2].value.as < string > (), yystack_[1].value.as < expr_t > ()); }
#line 4557 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1048:
#line 2170 "DynareBison.yy" // lalr1.cc:919
    { driver.set_optim_weights(yystack_[4].value.as < string > (), yystack_[2].value.as < string > (), yystack_[1].value.as < expr_t > ()); }
#line 4563 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1049:
#line 2172 "DynareBison.yy" // lalr1.cc:919
    { driver.set_optim_weights(yystack_[2].value.as < string > (), yystack_[1].value.as < expr_t > ()); }
#line 4569 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1050:
#line 2174 "DynareBison.yy" // lalr1.cc:919
    { driver.set_optim_weights(yystack_[4].value.as < string > (), yystack_[2].value.as < string > (), yystack_[1].value.as < expr_t > ()); }
#line 4575 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1051:
#line 2177 "DynareBison.yy" // lalr1.cc:919
    { driver.set_osr_params(); }
#line 4581 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1061:
#line 2194 "DynareBison.yy" // lalr1.cc:919
    { driver.run_osr(); }
#line 4587 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1062:
#line 2196 "DynareBison.yy" // lalr1.cc:919
    { driver.run_osr(); }
#line 4593 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1063:
#line 2198 "DynareBison.yy" // lalr1.cc:919
    { driver.run_osr(); }
#line 4599 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1064:
#line 2200 "DynareBison.yy" // lalr1.cc:919
    {driver.run_osr(); }
#line 4605 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1065:
#line 2204 "DynareBison.yy" // lalr1.cc:919
    { driver.run_dynatype(yystack_[2].value.as < string > ()); }
#line 4611 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1066:
#line 2206 "DynareBison.yy" // lalr1.cc:919
    { driver.run_dynatype(yystack_[3].value.as < string > ()); }
#line 4617 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1067:
#line 2210 "DynareBison.yy" // lalr1.cc:919
    { driver.run_dynasave(yystack_[2].value.as < string > ()); }
#line 4623 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1068:
#line 2212 "DynareBison.yy" // lalr1.cc:919
    { driver.run_dynasave(yystack_[3].value.as < string > ()); }
#line 4629 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1069:
#line 2216 "DynareBison.yy" // lalr1.cc:919
    { driver.run_load_params_and_steady_state(yystack_[2].value.as < string > ()); }
#line 4635 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1070:
#line 2220 "DynareBison.yy" // lalr1.cc:919
    { driver.run_save_params_and_steady_state(yystack_[2].value.as < string > ()); }
#line 4641 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1071:
#line 2224 "DynareBison.yy" // lalr1.cc:919
    { driver.run_identification(); }
#line 4647 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1072:
#line 2226 "DynareBison.yy" // lalr1.cc:919
    { driver.run_identification(); }
#line 4653 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1109:
#line 2270 "DynareBison.yy" // lalr1.cc:919
    { driver.run_model_comparison(); }
#line 4659 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1110:
#line 2272 "DynareBison.yy" // lalr1.cc:919
    { driver.run_model_comparison(); }
#line 4665 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1111:
#line 2275 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 4671 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1112:
#line 2276 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 4677 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1113:
#line 2279 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 4683 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1114:
#line 2281 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = yystack_[2].value.as < string > () + "." + yystack_[0].value.as < string > (); }
#line 4689 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1115:
#line 2284 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 4695 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1116:
#line 2285 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 4701 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1117:
#line 2289 "DynareBison.yy" // lalr1.cc:919
    { driver.add_parallel_local_file(yystack_[0].value.as < string > ()); }
#line 4707 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1118:
#line 2291 "DynareBison.yy" // lalr1.cc:919
    { driver.add_parallel_local_file(yystack_[0].value.as < string > ()); }
#line 4713 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1119:
#line 2295 "DynareBison.yy" // lalr1.cc:919
    { driver.add_mc_filename(yystack_[0].value.as < string > ()); }
#line 4719 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1120:
#line 2297 "DynareBison.yy" // lalr1.cc:919
    { driver.add_mc_filename(yystack_[3].value.as < string > (), yystack_[1].value.as < string > ()); }
#line 4725 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1121:
#line 2299 "DynareBison.yy" // lalr1.cc:919
    { driver.add_mc_filename(yystack_[0].value.as < string > ()); }
#line 4731 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1122:
#line 2301 "DynareBison.yy" // lalr1.cc:919
    { driver.add_mc_filename(yystack_[3].value.as < string > (), yystack_[1].value.as < string > ()); }
#line 4737 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1123:
#line 2303 "DynareBison.yy" // lalr1.cc:919
    { driver.add_mc_filename(yystack_[0].value.as < string > ()); }
#line 4743 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1124:
#line 2305 "DynareBison.yy" // lalr1.cc:919
    { driver.add_mc_filename(yystack_[3].value.as < string > (), yystack_[1].value.as < string > ()); }
#line 4749 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1125:
#line 2308 "DynareBison.yy" // lalr1.cc:919
    { driver.begin_planner_objective(); }
#line 4755 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1126:
#line 2309 "DynareBison.yy" // lalr1.cc:919
    { driver.end_planner_objective(yystack_[0].value.as < expr_t > ()); }
#line 4761 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1128:
#line 2312 "DynareBison.yy" // lalr1.cc:919
    { driver.ramsey_model(); }
#line 4767 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1129:
#line 2314 "DynareBison.yy" // lalr1.cc:919
    { driver.ramsey_model(); }
#line 4773 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1130:
#line 2318 "DynareBison.yy" // lalr1.cc:919
    { driver.ramsey_policy(); }
#line 4779 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1131:
#line 2320 "DynareBison.yy" // lalr1.cc:919
    { driver.ramsey_policy(); }
#line 4785 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1132:
#line 2322 "DynareBison.yy" // lalr1.cc:919
    { driver.ramsey_policy(); }
#line 4791 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1133:
#line 2324 "DynareBison.yy" // lalr1.cc:919
    { driver.ramsey_policy(); }
#line 4797 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1134:
#line 2328 "DynareBison.yy" // lalr1.cc:919
    { driver.add_ramsey_constraints_statement(); }
#line 4803 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1137:
#line 2336 "DynareBison.yy" // lalr1.cc:919
    { driver.ramsey_constraint_add_less(yystack_[3].value.as < string > (),yystack_[1].value.as < expr_t > ()); }
#line 4809 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1138:
#line 2338 "DynareBison.yy" // lalr1.cc:919
    { driver.ramsey_constraint_add_greater(yystack_[3].value.as < string > (),yystack_[1].value.as < expr_t > ()); }
#line 4815 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1139:
#line 2340 "DynareBison.yy" // lalr1.cc:919
    { driver.ramsey_constraint_add_less_equal(yystack_[3].value.as < string > (),yystack_[1].value.as < expr_t > ()); }
#line 4821 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1140:
#line 2342 "DynareBison.yy" // lalr1.cc:919
    { driver.ramsey_constraint_add_greater_equal(yystack_[3].value.as < string > (),yystack_[1].value.as < expr_t > ()); }
#line 4827 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1141:
#line 2346 "DynareBison.yy" // lalr1.cc:919
    { driver.evaluate_planner_objective(); }
#line 4833 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1142:
#line 2350 "DynareBison.yy" // lalr1.cc:919
    { driver.discretionary_policy(); }
#line 4839 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1143:
#line 2352 "DynareBison.yy" // lalr1.cc:919
    { driver.discretionary_policy(); }
#line 4845 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1144:
#line 2354 "DynareBison.yy" // lalr1.cc:919
    { driver.discretionary_policy(); }
#line 4851 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1145:
#line 2356 "DynareBison.yy" // lalr1.cc:919
    { driver.discretionary_policy(); }
#line 4857 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1161:
#line 2387 "DynareBison.yy" // lalr1.cc:919
    { driver.write_latex_dynamic_model(false); }
#line 4863 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1162:
#line 2389 "DynareBison.yy" // lalr1.cc:919
    { driver.write_latex_dynamic_model(true); }
#line 4869 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1163:
#line 2393 "DynareBison.yy" // lalr1.cc:919
    { driver.write_latex_static_model(false); }
#line 4875 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1164:
#line 2395 "DynareBison.yy" // lalr1.cc:919
    { driver.write_latex_static_model(true); }
#line 4881 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1165:
#line 2399 "DynareBison.yy" // lalr1.cc:919
    { driver.write_latex_original_model(false); }
#line 4887 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1166:
#line 2401 "DynareBison.yy" // lalr1.cc:919
    { driver.write_latex_original_model(true); }
#line 4893 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1167:
#line 2405 "DynareBison.yy" // lalr1.cc:919
    { driver.write_latex_steady_state_model(); }
#line 4899 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1168:
#line 2409 "DynareBison.yy" // lalr1.cc:919
    {driver.shock_decomposition(); }
#line 4905 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1169:
#line 2411 "DynareBison.yy" // lalr1.cc:919
    { driver.shock_decomposition(); }
#line 4911 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1170:
#line 2413 "DynareBison.yy" // lalr1.cc:919
    { driver.shock_decomposition(); }
#line 4917 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1171:
#line 2415 "DynareBison.yy" // lalr1.cc:919
    { driver.shock_decomposition(); }
#line 4923 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1172:
#line 2419 "DynareBison.yy" // lalr1.cc:919
    {driver.realtime_shock_decomposition(); }
#line 4929 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1173:
#line 2421 "DynareBison.yy" // lalr1.cc:919
    { driver.realtime_shock_decomposition(); }
#line 4935 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1174:
#line 2423 "DynareBison.yy" // lalr1.cc:919
    { driver.realtime_shock_decomposition(); }
#line 4941 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1175:
#line 2425 "DynareBison.yy" // lalr1.cc:919
    { driver.realtime_shock_decomposition(); }
#line 4947 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1176:
#line 2429 "DynareBison.yy" // lalr1.cc:919
    {driver.plot_shock_decomposition(); }
#line 4953 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1177:
#line 2431 "DynareBison.yy" // lalr1.cc:919
    { driver.plot_shock_decomposition(); }
#line 4959 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1178:
#line 2433 "DynareBison.yy" // lalr1.cc:919
    { driver.plot_shock_decomposition(); }
#line 4965 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1179:
#line 2435 "DynareBison.yy" // lalr1.cc:919
    { driver.plot_shock_decomposition(); }
#line 4971 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1180:
#line 2439 "DynareBison.yy" // lalr1.cc:919
    {driver.initial_condition_decomposition(); }
#line 4977 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1181:
#line 2441 "DynareBison.yy" // lalr1.cc:919
    { driver.initial_condition_decomposition(); }
#line 4983 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1182:
#line 2443 "DynareBison.yy" // lalr1.cc:919
    { driver.initial_condition_decomposition(); }
#line 4989 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1183:
#line 2445 "DynareBison.yy" // lalr1.cc:919
    { driver.initial_condition_decomposition(); }
#line 4995 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1184:
#line 2449 "DynareBison.yy" // lalr1.cc:919
    { driver.squeeze_shock_decomposition(); }
#line 5001 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1185:
#line 2451 "DynareBison.yy" // lalr1.cc:919
    { driver.squeeze_shock_decomposition(); }
#line 5007 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1205:
#line 2480 "DynareBison.yy" // lalr1.cc:919
    { driver.bvar_density(yystack_[1].value.as < string > ()); }
#line 5013 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1206:
#line 2482 "DynareBison.yy" // lalr1.cc:919
    { driver.bvar_density(yystack_[1].value.as < string > ()); }
#line 5019 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1213:
#line 2496 "DynareBison.yy" // lalr1.cc:919
    { driver.bvar_forecast(yystack_[1].value.as < string > ()); }
#line 5025 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1214:
#line 2498 "DynareBison.yy" // lalr1.cc:919
    { driver.bvar_forecast(yystack_[1].value.as < string > ()); }
#line 5031 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1265:
#line 2556 "DynareBison.yy" // lalr1.cc:919
    { driver.sbvar(); }
#line 5037 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1266:
#line 2558 "DynareBison.yy" // lalr1.cc:919
    { driver.sbvar(); }
#line 5043 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1283:
#line 2582 "DynareBison.yy" // lalr1.cc:919
    { driver.ms_variance_decomposition(); }
#line 5049 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1284:
#line 2584 "DynareBison.yy" // lalr1.cc:919
    { driver.ms_variance_decomposition(); }
#line 5055 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1301:
#line 2608 "DynareBison.yy" // lalr1.cc:919
    { driver.ms_forecast(); }
#line 5061 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1302:
#line 2610 "DynareBison.yy" // lalr1.cc:919
    { driver.ms_forecast(); }
#line 5067 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1319:
#line 2634 "DynareBison.yy" // lalr1.cc:919
    { driver.ms_irf(); }
#line 5073 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1320:
#line 2636 "DynareBison.yy" // lalr1.cc:919
    { driver.ms_irf(); }
#line 5079 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1321:
#line 2638 "DynareBison.yy" // lalr1.cc:919
    { driver.ms_irf(); }
#line 5085 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1322:
#line 2640 "DynareBison.yy" // lalr1.cc:919
    { driver.ms_irf(); }
#line 5091 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1329:
#line 2654 "DynareBison.yy" // lalr1.cc:919
    { driver.ms_compute_probabilities(); }
#line 5097 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1330:
#line 2656 "DynareBison.yy" // lalr1.cc:919
    { driver.ms_compute_probabilities(); }
#line 5103 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1341:
#line 2674 "DynareBison.yy" // lalr1.cc:919
    { driver.ms_compute_mdd(); }
#line 5109 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1342:
#line 2676 "DynareBison.yy" // lalr1.cc:919
    { driver.ms_compute_mdd(); }
#line 5115 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1352:
#line 2693 "DynareBison.yy" // lalr1.cc:919
    { driver.ms_simulation(); }
#line 5121 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1353:
#line 2695 "DynareBison.yy" // lalr1.cc:919
    { driver.ms_simulation(); }
#line 5127 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1391:
#line 2740 "DynareBison.yy" // lalr1.cc:919
    { driver.ms_estimation(); }
#line 5133 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1392:
#line 2742 "DynareBison.yy" // lalr1.cc:919
    { driver.ms_estimation(); }
#line 5139 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1393:
#line 2746 "DynareBison.yy" // lalr1.cc:919
    { driver.dynare_sensitivity(); }
#line 5145 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1394:
#line 2748 "DynareBison.yy" // lalr1.cc:919
    { driver.dynare_sensitivity(); }
#line 5151 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1519:
#line 2896 "DynareBison.yy" // lalr1.cc:919
    { driver.end_homotopy();}
#line 5157 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1522:
#line 2903 "DynareBison.yy" // lalr1.cc:919
    { driver.homotopy_val(yystack_[5].value.as < string > (), yystack_[3].value.as < expr_t > (), yystack_[1].value.as < expr_t > ());}
#line 5163 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1523:
#line 2905 "DynareBison.yy" // lalr1.cc:919
    { driver.homotopy_val(yystack_[3].value.as < string > (), nullptr, yystack_[1].value.as < expr_t > ());}
#line 5169 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1524:
#line 2908 "DynareBison.yy" // lalr1.cc:919
    {driver.forecast();}
#line 5175 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1525:
#line 2909 "DynareBison.yy" // lalr1.cc:919
    {driver.forecast();}
#line 5181 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1526:
#line 2910 "DynareBison.yy" // lalr1.cc:919
    {driver.forecast();}
#line 5187 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1527:
#line 2911 "DynareBison.yy" // lalr1.cc:919
    {driver.forecast();}
#line 5193 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1535:
#line 2926 "DynareBison.yy" // lalr1.cc:919
    { driver.conditional_forecast(); }
#line 5199 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1543:
#line 2941 "DynareBison.yy" // lalr1.cc:919
    { driver.plot_conditional_forecast(); }
#line 5205 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1544:
#line 2943 "DynareBison.yy" // lalr1.cc:919
    { driver.plot_conditional_forecast(yystack_[3].value.as < string > ()); }
#line 5211 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1545:
#line 2947 "DynareBison.yy" // lalr1.cc:919
    { driver.conditional_forecast_paths(); }
#line 5217 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1548:
#line 2955 "DynareBison.yy" // lalr1.cc:919
    { driver.add_det_shock(yystack_[7].value.as < string > (), true); }
#line 5223 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1549:
#line 2958 "DynareBison.yy" // lalr1.cc:919
    { driver.begin_steady_state_model(); }
#line 5229 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1550:
#line 2959 "DynareBison.yy" // lalr1.cc:919
    { driver.reset_data_tree(); }
#line 5235 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1553:
#line 2967 "DynareBison.yy" // lalr1.cc:919
    { driver.add_steady_state_model_equal(yystack_[3].value.as < string > (), yystack_[1].value.as < expr_t > ()); }
#line 5241 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1554:
#line 2969 "DynareBison.yy" // lalr1.cc:919
    { driver.add_steady_state_model_equal_multiple(yystack_[1].value.as < expr_t > ()); }
#line 5247 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1555:
#line 2973 "DynareBison.yy" // lalr1.cc:919
    { driver.calib_smoother(); }
#line 5253 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1556:
#line 2975 "DynareBison.yy" // lalr1.cc:919
    { driver.calib_smoother(); }
#line 5259 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1557:
#line 2977 "DynareBison.yy" // lalr1.cc:919
    { driver.calib_smoother(); }
#line 5265 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1558:
#line 2979 "DynareBison.yy" // lalr1.cc:919
    { driver.calib_smoother(); }
#line 5271 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1574:
#line 3002 "DynareBison.yy" // lalr1.cc:919
    { driver.end_generate_irfs(); }
#line 5277 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1575:
#line 3004 "DynareBison.yy" // lalr1.cc:919
    { driver.end_generate_irfs(); }
#line 5283 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1576:
#line 3006 "DynareBison.yy" // lalr1.cc:919
    { driver.end_generate_irfs(); }
#line 5289 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1577:
#line 3008 "DynareBison.yy" // lalr1.cc:919
    { driver.end_generate_irfs(); }
#line 5295 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1584:
#line 3024 "DynareBison.yy" // lalr1.cc:919
    { driver.add_generate_irfs_element(yystack_[3].value.as < string > ()); }
#line 5301 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1585:
#line 3028 "DynareBison.yy" // lalr1.cc:919
    { driver.add_generate_irfs_exog_element(yystack_[2].value.as < string > (), yystack_[0].value.as < string > ()); }
#line 5307 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1586:
#line 3030 "DynareBison.yy" // lalr1.cc:919
    { driver.add_generate_irfs_exog_element(yystack_[2].value.as < string > (), yystack_[0].value.as < string > ()); }
#line 5313 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1587:
#line 3034 "DynareBison.yy" // lalr1.cc:919
    { driver.extended_path(); }
#line 5319 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1588:
#line 3036 "DynareBison.yy" // lalr1.cc:919
    { driver.extended_path(); }
#line 5325 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1597:
#line 3052 "DynareBison.yy" // lalr1.cc:919
    { driver.model_diagnostics(); }
#line 5331 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1598:
#line 3056 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < pair<expr_t,expr_t> > () = { yystack_[3].value.as < expr_t > (), yystack_[1].value.as < expr_t > () }; }
#line 5337 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1599:
#line 3058 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < pair<expr_t,expr_t> > () = { driver.add_non_negative_constant("0"), driver.add_inf_constant() }; }
#line 5343 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1600:
#line 3060 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < pair<expr_t,expr_t> > () = { driver.add_uminus(driver.add_inf_constant()), driver.add_non_negative_constant("0") }; }
#line 5349 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1601:
#line 3064 "DynareBison.yy" // lalr1.cc:919
    { driver.end_moment_calibration(); }
#line 5355 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1604:
#line 3072 "DynareBison.yy" // lalr1.cc:919
    { driver.add_moment_calibration_item(yystack_[5].value.as < string > (), yystack_[3].value.as < string > (), "0", yystack_[1].value.as < pair<expr_t,expr_t> > ()); }
#line 5361 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1605:
#line 3074 "DynareBison.yy" // lalr1.cc:919
    { driver.add_moment_calibration_item(yystack_[8].value.as < string > (), yystack_[6].value.as < string > (), yystack_[4].value.as < string > (), yystack_[1].value.as < pair<expr_t,expr_t> > ()); }
#line 5367 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1606:
#line 3076 "DynareBison.yy" // lalr1.cc:919
    { driver.add_moment_calibration_item(yystack_[8].value.as < string > (), yystack_[6].value.as < string > (), yystack_[4].value.as < string > (), yystack_[1].value.as < pair<expr_t,expr_t> > ()); }
#line 5373 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1607:
#line 3080 "DynareBison.yy" // lalr1.cc:919
    { driver.end_irf_calibration(); }
#line 5379 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1608:
#line 3082 "DynareBison.yy" // lalr1.cc:919
    { driver.end_irf_calibration(); }
#line 5385 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1611:
#line 3090 "DynareBison.yy" // lalr1.cc:919
    { driver.add_irf_calibration_item(yystack_[5].value.as < string > (), "1", yystack_[3].value.as < string > (), yystack_[1].value.as < pair<expr_t,expr_t> > ()); }
#line 5391 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1612:
#line 3092 "DynareBison.yy" // lalr1.cc:919
    { driver.add_irf_calibration_item(yystack_[8].value.as < string > (), yystack_[6].value.as < string > (), yystack_[3].value.as < string > (), yystack_[1].value.as < pair<expr_t,expr_t> > ()); }
#line 5397 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1613:
#line 3094 "DynareBison.yy" // lalr1.cc:919
    { driver.add_irf_calibration_item(yystack_[8].value.as < string > (), yystack_[6].value.as < string > (), yystack_[3].value.as < string > (), yystack_[1].value.as < pair<expr_t,expr_t> > ()); }
#line 5403 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1614:
#line 3098 "DynareBison.yy" // lalr1.cc:919
    { driver.smoother2histval(); }
#line 5409 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1615:
#line 3100 "DynareBison.yy" // lalr1.cc:919
    { driver.smoother2histval(); }
#line 5415 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1623:
#line 3115 "DynareBison.yy" // lalr1.cc:919
    { driver.end_shock_groups("default"); }
#line 5421 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1624:
#line 3117 "DynareBison.yy" // lalr1.cc:919
    {driver.end_shock_groups(yystack_[5].value.as < string > ());}
#line 5427 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1627:
#line 3124 "DynareBison.yy" // lalr1.cc:919
    { driver.add_shock_group(yystack_[3].value.as < string > ()); }
#line 5433 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1628:
#line 3125 "DynareBison.yy" // lalr1.cc:919
    { driver.add_shock_group(yystack_[3].value.as < string > ()); }
#line 5439 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1629:
#line 3128 "DynareBison.yy" // lalr1.cc:919
    {driver.add_shock_group_element(yystack_[0].value.as < string > ());}
#line 5445 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1630:
#line 3129 "DynareBison.yy" // lalr1.cc:919
    {driver.add_shock_group_element(yystack_[0].value.as < string > ());}
#line 5451 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1631:
#line 3130 "DynareBison.yy" // lalr1.cc:919
    {driver.add_shock_group_element(yystack_[0].value.as < string > ());}
#line 5457 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1632:
#line 3134 "DynareBison.yy" // lalr1.cc:919
    { driver.end_init2shocks("default"); }
#line 5463 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1633:
#line 3136 "DynareBison.yy" // lalr1.cc:919
    {driver.end_init2shocks(yystack_[5].value.as < string > ());}
#line 5469 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1636:
#line 3143 "DynareBison.yy" // lalr1.cc:919
    { driver.add_init2shocks(yystack_[2].value.as < string > (), yystack_[1].value.as < string > ()); }
#line 5475 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1637:
#line 3144 "DynareBison.yy" // lalr1.cc:919
    { driver.add_init2shocks(yystack_[3].value.as < string > (), yystack_[1].value.as < string > ()); }
#line 5481 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1638:
#line 3147 "DynareBison.yy" // lalr1.cc:919
    {
                                       if (yystack_[0].value.as < string > () == "0")
                                         driver.warning("dr_algo option is now deprecated, and may be removed in a future version of Dynare");
                                       else
                                         driver.error("dr_algo=1 option is no longer supported");
                                     }
#line 5492 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1639:
#line 3153 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("solve_algo", yystack_[0].value.as < string > ()); }
#line 5498 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1640:
#line 3154 "DynareBison.yy" // lalr1.cc:919
    {
                                             if (yystack_[0].value.as < string > () == "0")
                                               driver.warning("simul_algo option is now deprecated, and may be removed in a future version of Dynare");
                                             else
                                               driver.error("simul_algo=1 option is no longer supported");
                                           }
#line 5509 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1641:
#line 3160 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("stack_solve_algo", yystack_[0].value.as < string > ()); }
#line 5515 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1642:
#line 3161 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("simul.robust_lin_solve", "true"); }
#line 5521 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1643:
#line 3162 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("endogenous_terminal_period", "true"); }
#line 5527 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1644:
#line 3163 "DynareBison.yy" // lalr1.cc:919
    { driver.linear(); }
#line 5533 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1645:
#line 3164 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("order", yystack_[0].value.as < string > ()); }
#line 5539 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1646:
#line 3165 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("replic", yystack_[0].value.as < string > ()); }
#line 5545 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1647:
#line 3166 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("drop", yystack_[0].value.as < string > ()); }
#line 5551 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1648:
#line 3167 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("ar", yystack_[0].value.as < string > ()); }
#line 5557 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1649:
#line 3168 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("nocorr", "true"); }
#line 5563 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1650:
#line 3169 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("nofunctions", "true"); }
#line 5569 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1651:
#line 3170 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("nomoments", "true"); }
#line 5575 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1652:
#line 3171 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("irf", yystack_[0].value.as < string > ()); }
#line 5581 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1653:
#line 3172 "DynareBison.yy" // lalr1.cc:919
    { driver.option_symbol_list("irf_shocks"); }
#line 5587 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1654:
#line 3173 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("hp_filter", yystack_[0].value.as < string > ()); }
#line 5593 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1655:
#line 3174 "DynareBison.yy" // lalr1.cc:919
    {
                                         driver.warning("The 'hp_ngrid' option is deprecated. It has been superseded by the 'filtered_theoretical_moments_grid' option.");
                                         driver.option_num("filtered_theoretical_moments_grid", yystack_[0].value.as < string > ());
                                       }
#line 5602 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1656:
#line 3178 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("filtered_theoretical_moments_grid", yystack_[0].value.as < string > ()); }
#line 5608 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1657:
#line 3179 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("one_sided_hp_filter", yystack_[0].value.as < string > ()); }
#line 5614 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1658:
#line 3180 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("periods", yystack_[0].value.as < string > ()); }
#line 5620 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1659:
#line 3181 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("ep.periods", yystack_[0].value.as < string > ()); }
#line 5626 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1660:
#line 3182 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("ep.stochastic.order", yystack_[0].value.as < string > ()); }
#line 5632 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1661:
#line 3183 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("ep.stochastic.hybrid_order", "2"); }
#line 5638 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1662:
#line 3184 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("steady.maxit", yystack_[0].value.as < string > ()); }
#line 5644 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1663:
#line 3185 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("simul.maxit", yystack_[0].value.as < string > ()); }
#line 5650 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1664:
#line 3186 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("bandpass.indicator", "true"); }
#line 5656 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1665:
#line 3188 "DynareBison.yy" // lalr1.cc:919
    {
                      driver.option_num("bandpass.indicator", "true");
                      driver.option_vec_int("bandpass.passband", yystack_[0].value.as < vector<int> > ());
                    }
#line 5665 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1666:
#line 3193 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("dp.maxit", yystack_[0].value.as < string > ()); }
#line 5671 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1667:
#line 3194 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("osr.maxit", yystack_[0].value.as < string > ()); }
#line 5677 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1668:
#line 3195 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("osr.tolf", yystack_[0].value.as < string > ()); }
#line 5683 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1669:
#line 3196 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("dynatol.f", yystack_[0].value.as < string > ()); }
#line 5689 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1670:
#line 3197 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("dynatol.x", yystack_[0].value.as < string > ()); }
#line 5695 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1671:
#line 3198 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("solve_tolf", yystack_[0].value.as < string > ()); }
#line 5701 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1672:
#line 3199 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("osr.opt_algo", yystack_[0].value.as < string > ()); }
#line 5707 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1673:
#line 3200 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("osr.opt_algo", yystack_[0].value.as < string > ()); }
#line 5713 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1674:
#line 3202 "DynareBison.yy" // lalr1.cc:919
    { driver.cutoff(yystack_[0].value.as < string > ()); }
#line 5719 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1675:
#line 3203 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("markowitz", yystack_[0].value.as < string > ()); }
#line 5725 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1676:
#line 3204 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("minimal_solving_periods", yystack_[0].value.as < string > ()); }
#line 5731 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1677:
#line 3205 "DynareBison.yy" // lalr1.cc:919
    { driver.mfs(yystack_[0].value.as < string > ()); }
#line 5737 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1679:
#line 3207 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("simul_replic", yystack_[0].value.as < string > ()); }
#line 5743 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1680:
#line 3208 "DynareBison.yy" // lalr1.cc:919
    { driver.error("'simul_seed' option is no longer supported; use 'set_dynare_seed' command instead"); }
#line 5749 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1681:
#line 3209 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("qz_criterium", yystack_[0].value.as < string > ()); }
#line 5755 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1682:
#line 3210 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("qz_zero_threshold", yystack_[0].value.as < string > ()); }
#line 5761 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1683:
#line 3211 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("file", yystack_[0].value.as < string > ()); }
#line 5767 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1684:
#line 3212 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("pac.model_name", yystack_[0].value.as < string > ()); }
#line 5773 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1685:
#line 3213 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("pac.aux_model_name", yystack_[0].value.as < string > ()); }
#line 5779 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1686:
#line 3214 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("pac.discount", yystack_[0].value.as < string > ()); }
#line 5785 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1687:
#line 3215 "DynareBison.yy" // lalr1.cc:919
    { driver.begin_pac_growth(); }
#line 5791 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1688:
#line 3215 "DynareBison.yy" // lalr1.cc:919
    { driver.set_pac_growth(yystack_[0].value.as < expr_t > ()); }
#line 5797 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1689:
#line 3216 "DynareBison.yy" // lalr1.cc:919
    { driver.set_pac_steady_state_growth(yystack_[0].value.as < string > ()); }
#line 5803 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1690:
#line 3217 "DynareBison.yy" // lalr1.cc:919
    { driver.set_pac_steady_state_growth(yystack_[0].value.as < string > ()); }
#line 5809 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1691:
#line 3219 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("var.model_name", yystack_[0].value.as < string > ()); }
#line 5815 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1692:
#line 3220 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("var.order", yystack_[0].value.as < string > ()); }
#line 5821 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1693:
#line 3221 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("series", yystack_[0].value.as < string > ()); }
#line 5827 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1694:
#line 3222 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("datafile", yystack_[0].value.as < string > ()); }
#line 5833 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1695:
#line 3223 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("var_estimation.datafile", yystack_[0].value.as < string > ()); }
#line 5839 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1696:
#line 3224 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("var_estimation.model_name", yystack_[0].value.as < string > ()); }
#line 5845 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1697:
#line 3225 "DynareBison.yy" // lalr1.cc:919
    { driver.option_vec_str("var.eqtags", yystack_[0].value.as < vector<string> > ()); }
#line 5851 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1698:
#line 3226 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("dirname", yystack_[0].value.as < string > ()); }
#line 5857 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1699:
#line 3227 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("huge_number", yystack_[0].value.as < string > ()); }
#line 5863 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1700:
#line 3229 "DynareBison.yy" // lalr1.cc:919
    { driver.option_vec_int("nobs", yystack_[0].value.as < vector<int> > ()); }
#line 5869 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1701:
#line 3231 "DynareBison.yy" // lalr1.cc:919
    { driver.option_vec_int("nobs", yystack_[0].value.as < vector<int> > ()); }
#line 5875 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1702:
#line 3233 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("trend_component.name", yystack_[0].value.as < string > ()); }
#line 5881 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1703:
#line 3234 "DynareBison.yy" // lalr1.cc:919
    { driver.option_vec_str("trend_component.targets", yystack_[0].value.as < vector<string> > ()); }
#line 5887 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1704:
#line 3235 "DynareBison.yy" // lalr1.cc:919
    { driver.option_vec_str("trend_component.eqtags", yystack_[0].value.as < vector<string> > ()); }
#line 5893 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1705:
#line 3237 "DynareBison.yy" // lalr1.cc:919
    { driver.option_vec_int("conditional_variance_decomposition", yystack_[0].value.as < vector<int> > ()); }
#line 5899 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1706:
#line 3239 "DynareBison.yy" // lalr1.cc:919
    { driver.option_vec_int("conditional_variance_decomposition", yystack_[0].value.as < vector<int> > ()); }
#line 5905 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1707:
#line 3242 "DynareBison.yy" // lalr1.cc:919
    { driver.option_vec_int("first_obs", yystack_[0].value.as < vector<int> > ()); }
#line 5911 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1708:
#line 3244 "DynareBison.yy" // lalr1.cc:919
    { driver.option_vec_int("first_obs", yystack_[0].value.as < vector<int> > ()); }
#line 5917 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1709:
#line 3247 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("posterior_sampler_options.posterior_sampling_method", yystack_[0].value.as < string > ()); }
#line 5923 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1710:
#line 3248 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("first_obs", yystack_[0].value.as < string > ()); }
#line 5929 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1711:
#line 3249 "DynareBison.yy" // lalr1.cc:919
    { driver.option_date("firstobs", yystack_[0].value.as < string > ()); }
#line 5935 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1712:
#line 3250 "DynareBison.yy" // lalr1.cc:919
    { driver.option_date("lastobs", yystack_[0].value.as < string > ()); }
#line 5941 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1713:
#line 3251 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("kalman.keep_kalman_algo_if_singularity_is_detected", "true"); }
#line 5947 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1714:
#line 3252 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("nobs", yystack_[0].value.as < string > ()); }
#line 5953 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1715:
#line 3253 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("shift", yystack_[0].value.as < string > ()); }
#line 5959 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1716:
#line 3254 "DynareBison.yy" // lalr1.cc:919
    { driver.prior_shape = yystack_[0].value.as < PriorDistributions > (); }
#line 5965 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1717:
#line 3255 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("mode", yystack_[0].value.as < string > ()); }
#line 5971 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1718:
#line 3256 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("mean", yystack_[0].value.as < string > ()); }
#line 5977 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1719:
#line 3257 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("mean", yystack_[0].value.as < string > ()); }
#line 5983 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1720:
#line 3258 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("truncate", yystack_[0].value.as < string > ()); }
#line 5989 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1721:
#line 3259 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("stdev", yystack_[0].value.as < string > ()); }
#line 5995 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1722:
#line 3260 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("jscale", yystack_[0].value.as < string > ()); }
#line 6001 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1723:
#line 3261 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("init", yystack_[0].value.as < string > ()); }
#line 6007 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1724:
#line 3262 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("bounds", yystack_[0].value.as < string > ()); }
#line 6013 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1725:
#line 3263 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("domain", yystack_[0].value.as < string > ()); }
#line 6019 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1726:
#line 3264 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("interval", yystack_[0].value.as < string > ()); }
#line 6025 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1727:
#line 3265 "DynareBison.yy" // lalr1.cc:919
    { driver.set_prior_variance(yystack_[0].value.as < expr_t > ()); }
#line 6031 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1728:
#line 3266 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("variance",yystack_[0].value.as < string > ()); }
#line 6037 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1729:
#line 3267 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("prefilter", yystack_[0].value.as < string > ()); }
#line 6043 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1730:
#line 3268 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("presample", yystack_[0].value.as < string > ()); }
#line 6049 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1731:
#line 3269 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("lik_algo", yystack_[0].value.as < string > ()); }
#line 6055 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1732:
#line 3270 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("lik_init", yystack_[0].value.as < string > ()); }
#line 6061 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1733:
#line 3272 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("nograph", "true"); }
#line 6067 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1734:
#line 3274 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("nograph", "false"); }
#line 6073 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1735:
#line 3277 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("no_graph.posterior", "true"); }
#line 6079 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1736:
#line 3279 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("no_graph.posterior", "false"); }
#line 6085 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1737:
#line 3281 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("no_graph.plot_shock_decomposition", "true"); }
#line 6091 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1738:
#line 3282 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("no_graph.shock_decomposition", "true"); }
#line 6097 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1739:
#line 3283 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("shock_decomp.init_state", yystack_[0].value.as < string > ()); }
#line 6103 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1740:
#line 3285 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("shock_decomp.forecast_type", "unconditional"); }
#line 6109 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1741:
#line 3287 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("shock_decomp.forecast_type", "conditional"); }
#line 6115 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1742:
#line 3288 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("shock_decomp.presample", yystack_[0].value.as < string > ()); }
#line 6121 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1743:
#line 3289 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("shock_decomp.forecast", yystack_[0].value.as < string > ()); }
#line 6127 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1744:
#line 3290 "DynareBison.yy" // lalr1.cc:919
    { driver.option_vec_int("shock_decomp.save_realtime", yystack_[0].value.as < vector<int> > ()); }
#line 6133 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1745:
#line 3291 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("shock_decomp.fast_realtime", yystack_[0].value.as < string > ()); }
#line 6139 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1746:
#line 3292 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("nodisplay", "true"); }
#line 6145 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1747:
#line 3293 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("initial_condition_decomp.nodisplay", "true"); }
#line 6151 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1748:
#line 3294 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("plot_shock_decomp.nodisplay", "true"); }
#line 6157 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1749:
#line 3295 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("plot_shock_decomp.init2shocks", "default"); }
#line 6163 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1750:
#line 3296 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("plot_shock_decomp.init2shocks", yystack_[0].value.as < string > ()); }
#line 6169 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1751:
#line 3298 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("initial_condition_decomp.max_nrows", yystack_[0].value.as < string > ()); }
#line 6175 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1752:
#line 3299 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("plot_shock_decomp.max_nrows", yystack_[0].value.as < string > ()); }
#line 6181 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1753:
#line 3301 "DynareBison.yy" // lalr1.cc:919
    { driver.process_graph_format_option(); }
#line 6187 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1754:
#line 3303 "DynareBison.yy" // lalr1.cc:919
    { driver.process_graph_format_option(); }
#line 6193 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1755:
#line 3306 "DynareBison.yy" // lalr1.cc:919
    { driver.initial_condition_decomp_process_graph_format_option(); }
#line 6199 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1756:
#line 3308 "DynareBison.yy" // lalr1.cc:919
    { driver.initial_condition_decomp_process_graph_format_option(); }
#line 6205 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1757:
#line 3311 "DynareBison.yy" // lalr1.cc:919
    { driver.plot_shock_decomp_process_graph_format_option(); }
#line 6211 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1758:
#line 3313 "DynareBison.yy" // lalr1.cc:919
    { driver.plot_shock_decomp_process_graph_format_option(); }
#line 6217 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1759:
#line 3315 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("shock_decomp.with_epilogue", "true"); }
#line 6223 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1760:
#line 3316 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("initial_condition_decomp.with_epilogue", "true"); }
#line 6229 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1761:
#line 3318 "DynareBison.yy" // lalr1.cc:919
    { driver.add_graph_format("eps"); }
#line 6235 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1762:
#line 3320 "DynareBison.yy" // lalr1.cc:919
    { driver.add_graph_format("fig"); }
#line 6241 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1763:
#line 3322 "DynareBison.yy" // lalr1.cc:919
    { driver.add_graph_format("pdf"); }
#line 6247 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1764:
#line 3324 "DynareBison.yy" // lalr1.cc:919
    { driver.add_graph_format("none"); }
#line 6253 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1767:
#line 3331 "DynareBison.yy" // lalr1.cc:919
    { driver.set_subsample_name_equal_to_date_range(yystack_[4].value.as < string > (), yystack_[2].value.as < string > (), yystack_[0].value.as < string > ()); }
#line 6259 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1768:
#line 3333 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("bvar.conf_sig", yystack_[0].value.as < string > ()); }
#line 6265 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1769:
#line 3334 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("forecasts.conf_sig", yystack_[0].value.as < string > ()); }
#line 6271 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1770:
#line 3335 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("conditional_forecast.conf_sig", yystack_[0].value.as < string > ()); }
#line 6277 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1771:
#line 3336 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("mh_conf_sig", yystack_[0].value.as < string > ()); }
#line 6283 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1772:
#line 3337 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("mh_replic", yystack_[0].value.as < string > ()); }
#line 6289 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1773:
#line 3338 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("posterior_max_subsample_draws", yystack_[0].value.as < string > ()); }
#line 6295 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1774:
#line 3339 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("mh_drop", yystack_[0].value.as < string > ()); }
#line 6301 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1775:
#line 3340 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("mh_jscale", yystack_[0].value.as < string > ()); }
#line 6307 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1776:
#line 3342 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("mh_tune_jscale.target", yystack_[0].value.as < string > ()); driver.option_num("mh_tune_jscale.status", "true");}
#line 6313 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1777:
#line 3343 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("mh_tune_jscale.status", "true");}
#line 6319 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1780:
#line 3346 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("posterior_sampler_options.posterior_sampling_method.proposal_distribution", yystack_[0].value.as < string > ()); }
#line 6325 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1781:
#line 3348 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("estimation.moments_posterior_density.indicator", "false"); }
#line 6331 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1782:
#line 3350 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("mh_init_scale", yystack_[0].value.as < string > ()); }
#line 6337 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1783:
#line 3351 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("mode_file", yystack_[0].value.as < string > ()); }
#line 6343 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1784:
#line 3352 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("mode_compute", yystack_[0].value.as < string > ()); }
#line 6349 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1785:
#line 3353 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("mode_compute", yystack_[0].value.as < string > ()); }
#line 6355 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1786:
#line 3354 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("mode_check.status", "true"); }
#line 6361 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1787:
#line 3355 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("mode_check.neighbourhood_size", yystack_[0].value.as < string > ()); }
#line 6367 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1788:
#line 3356 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("mode_check.number_of_points", yystack_[0].value.as < string > ()); }
#line 6373 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1789:
#line 3357 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("mode_check.symmetric_plots", yystack_[0].value.as < string > ()); }
#line 6379 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1790:
#line 3358 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("prior_trunc", yystack_[0].value.as < string > ()); }
#line 6385 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1791:
#line 3359 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("mh_mode", yystack_[0].value.as < string > ()); }
#line 6391 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1792:
#line 3360 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("mh_nblck", yystack_[0].value.as < string > ()); }
#line 6397 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1793:
#line 3361 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("load_mh_file", "true"); }
#line 6403 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1794:
#line 3362 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("load_results_after_load_mh", "true"); }
#line 6409 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1795:
#line 3363 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("loglinear", "true"); }
#line 6415 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1796:
#line 3364 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("linear_approximation", "true"); }
#line 6421 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1797:
#line 3365 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("logdata", "true"); }
#line 6427 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1798:
#line 3366 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("nodiagnostic", "true"); }
#line 6433 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1799:
#line 3367 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("bayesian_irf", "true"); }
#line 6439 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1800:
#line 3369 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("dsge_var", yystack_[0].value.as < string > ()); }
#line 6445 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1801:
#line 3371 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("dsge_var", "Inf"); }
#line 6451 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1802:
#line 3373 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("dsge_var", "NaN"); }
#line 6457 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1803:
#line 3375 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("dsge_varlag", yystack_[0].value.as < string > ()); }
#line 6463 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1804:
#line 3376 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("TeX", "true"); }
#line 6469 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1805:
#line 3377 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("forecast", yystack_[0].value.as < string > ()); }
#line 6475 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1806:
#line 3378 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("smoother", "true"); }
#line 6481 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1807:
#line 3379 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("moments_varendo", "true"); }
#line 6487 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1808:
#line 3380 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("contemporaneous_correlation", "true"); }
#line 6493 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1809:
#line 3381 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("filtered_vars", "true"); }
#line 6499 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1810:
#line 3382 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("relative_irf", "true"); }
#line 6505 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1811:
#line 3383 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("fast_kalman_filter", "true"); }
#line 6511 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1812:
#line 3384 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("kalman_algo", yystack_[0].value.as < string > ()); }
#line 6517 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1813:
#line 3385 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("kalman_tol", yystack_[0].value.as < string > ()); }
#line 6523 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1814:
#line 3386 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("diffuse_kalman_tol", yystack_[0].value.as < string > ()); }
#line 6529 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1815:
#line 3388 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("mc_marginal_density", "laplace"); }
#line 6535 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1816:
#line 3390 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("mc_marginal_density", "modifiedharmonicmean"); }
#line 6541 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1817:
#line 3392 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("noprint", "false"); }
#line 6547 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1818:
#line 3393 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("noprint", "true"); }
#line 6553 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1819:
#line 3394 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("xls_sheet", yystack_[0].value.as < string > ()); }
#line 6559 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1820:
#line 3395 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("xls_range", yystack_[0].value.as < string > ()); }
#line 6565 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1821:
#line 3396 "DynareBison.yy" // lalr1.cc:919
    { driver.option_vec_int("filter_step_ahead", yystack_[0].value.as < vector<int> > ()); }
#line 6571 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1822:
#line 3397 "DynareBison.yy" // lalr1.cc:919
    { driver.option_vec_int("convergence.geweke.taper_steps", yystack_[0].value.as < vector<int> > ()); }
#line 6577 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1823:
#line 3398 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("convergence.geweke.geweke_interval",yystack_[0].value.as < string > ()); }
#line 6583 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1824:
#line 3399 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("convergence.rafterylewis.indicator", "true"); }
#line 6589 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1825:
#line 3400 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("convergence.rafterylewis.qrs",yystack_[0].value.as < string > ()); }
#line 6595 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1826:
#line 3401 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("noconstant", "false"); }
#line 6601 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1827:
#line 3402 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("noconstant", "true"); }
#line 6607 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1828:
#line 3403 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("mh_recover", "true"); }
#line 6613 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1829:
#line 3404 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("diffuse_filter", "true"); }
#line 6619 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1830:
#line 3405 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("plot_priors", yystack_[0].value.as < string > ()); }
#line 6625 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1831:
#line 3406 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("aim_solver", "true"); }
#line 6631 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1832:
#line 3407 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("partial_information", "true"); }
#line 6637 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1833:
#line 3408 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("sub_draws",yystack_[0].value.as < string > ());}
#line 6643 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1834:
#line 3409 "DynareBison.yy" // lalr1.cc:919
    { driver.set_planner_discount(yystack_[0].value.as < expr_t > ()); }
#line 6649 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1835:
#line 3410 "DynareBison.yy" // lalr1.cc:919
    { driver.set_planner_discount_latex_name(yystack_[0].value.as < string > ()); }
#line 6655 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1836:
#line 3411 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("sylvester_fp", "true"); }
#line 6661 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1837:
#line 3412 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("sylvester_fp", "false"); }
#line 6667 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1838:
#line 3413 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("sylvester_fixed_point_tol",yystack_[0].value.as < string > ());}
#line 6673 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1839:
#line 3414 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("lyapunov_fp", "true"); }
#line 6679 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1840:
#line 3415 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("lyapunov_db", "true"); }
#line 6685 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1841:
#line 3416 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("lyapunov_srs", "true"); }
#line 6691 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1842:
#line 3417 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("lyapunov_fp", "false"); driver.option_num("lyapunov_db", "false"); driver.option_num("lyapunov_srs", "false");}
#line 6697 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1843:
#line 3418 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("lyapunov_fixed_point_tol",yystack_[0].value.as < string > ());}
#line 6703 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1844:
#line 3419 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("lyapunov_doubling_tol",yystack_[0].value.as < string > ());}
#line 6709 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1845:
#line 3420 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("dr_cycle_reduction", "true"); }
#line 6715 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1846:
#line 3421 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("dr_logarithmic_reduction", "true"); }
#line 6721 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1847:
#line 3422 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("dr_cycle_reduction", "false"); driver.option_num("dr_logarithmic_reduction", "false");}
#line 6727 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1848:
#line 3423 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("dr_cycle_reduction_tol",yystack_[0].value.as < string > ());}
#line 6733 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1849:
#line 3424 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("dr_logarithmic_reduction_tol",yystack_[0].value.as < string > ());}
#line 6739 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1850:
#line 3425 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("dr_logarithmic_reduction_maxiter",yystack_[0].value.as < string > ());}
#line 6745 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1851:
#line 3426 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("plot_shock_decomp.detail_plot", "true"); }
#line 6751 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1852:
#line 3427 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("initial_condition_decomp.detail_plot", "true"); }
#line 6757 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1853:
#line 3428 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("plot_shock_decomp.interactive", "true"); }
#line 6763 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1854:
#line 3429 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("plot_shock_decomp.screen_shocks", "true"); }
#line 6769 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1855:
#line 3430 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("plot_shock_decomp.steadystate", "true"); }
#line 6775 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1856:
#line 3431 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("initial_condition_decomp.steadystate", "true"); }
#line 6781 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1857:
#line 3432 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("initial_condition_decomp.fig_name", yystack_[0].value.as < string > ()); }
#line 6787 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1858:
#line 3433 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("plot_shock_decomp.fig_name", yystack_[0].value.as < string > ()); }
#line 6793 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1859:
#line 3435 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("plot_shock_decomp.type", "qoq"); }
#line 6799 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1860:
#line 3437 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("plot_shock_decomp.type", "yoy"); }
#line 6805 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1861:
#line 3439 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("plot_shock_decomp.type", "aoa"); }
#line 6811 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1862:
#line 3442 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("initial_condition_decomp.type", "qoq"); }
#line 6817 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1863:
#line 3444 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("initial_condition_decomp.type", "yoy"); }
#line 6823 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1864:
#line 3446 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("initial_condition_decomp.type", "aoa"); }
#line 6829 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1865:
#line 3448 "DynareBison.yy" // lalr1.cc:919
    { driver.option_date("initial_condition_decomp.plot_init_date", yystack_[0].value.as < string > ()); }
#line 6835 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1866:
#line 3449 "DynareBison.yy" // lalr1.cc:919
    { driver.option_date("initial_condition_decomp.plot_end_date", yystack_[0].value.as < string > ()); }
#line 6841 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1867:
#line 3450 "DynareBison.yy" // lalr1.cc:919
    { driver.option_date("plot_shock_decomp.plot_init_date", yystack_[0].value.as < string > ()); }
#line 6847 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1868:
#line 3451 "DynareBison.yy" // lalr1.cc:919
    { driver.option_date("plot_shock_decomp.plot_end_date", yystack_[0].value.as < string > ()); }
#line 6853 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1869:
#line 3452 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("initial_condition_decomp.write_xls", "true"); }
#line 6859 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1870:
#line 3453 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("plot_shock_decomp.write_xls", "true"); }
#line 6865 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1871:
#line 3454 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("plot_shock_decomp.realtime", yystack_[0].value.as < string > ()); }
#line 6871 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1872:
#line 3455 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("plot_shock_decomp.vintage", yystack_[0].value.as < string > ()); }
#line 6877 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1873:
#line 3456 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("plot_shock_decomp.diff", "true"); }
#line 6883 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1874:
#line 3457 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("initial_condition_decomp.diff", "true"); }
#line 6889 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1875:
#line 3458 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("plot_shock_decomp.flip", "true"); }
#line 6895 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1876:
#line 3459 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("initial_condition_decomp.flip", "true"); }
#line 6901 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1877:
#line 3460 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("bvar_prior_tau", yystack_[0].value.as < string > ()); }
#line 6907 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1878:
#line 3461 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("bvar_prior_decay", yystack_[0].value.as < string > ()); }
#line 6913 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1879:
#line 3462 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("bvar_prior_lambda", yystack_[0].value.as < string > ()); }
#line 6919 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1880:
#line 3463 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("bvar_prior_mu", yystack_[0].value.as < string > ()); }
#line 6925 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1881:
#line 3464 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("bvar_prior_omega", yystack_[0].value.as < string > ()); }
#line 6931 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1882:
#line 3465 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("bvar_prior_flat", "true"); }
#line 6937 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1883:
#line 3466 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("bvar_prior_train", yystack_[0].value.as < string > ()); }
#line 6943 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1884:
#line 3467 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("bvar_replic", yystack_[0].value.as < string > ()); }
#line 6949 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1885:
#line 3468 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("irf_opt.stderr_multiples", "true"); }
#line 6955 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1886:
#line 3469 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("irf_opt.diagonal_only", "true"); }
#line 6961 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1887:
#line 3470 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("particle.number_of_particles", yystack_[0].value.as < string > ()); }
#line 6967 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1889:
#line 3472 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("particle.resampling.status.systematic", "false"); driver.option_num("particle.resampling.status.none", "true"); }
#line 6973 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1890:
#line 3473 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("particle.resampling.status.systematic", "false"); driver.option_num("particle.resampling.status.generic", "true"); }
#line 6979 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1891:
#line 3474 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("particle.resampling.threshold", yystack_[0].value.as < string > ()); }
#line 6985 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1892:
#line 3475 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("particle.resampling.method.kitagawa", "true"); driver.option_num("particle.resampling.method.smooth", "false"); driver.option_num("particle.resampling.smethod.stratified", "false"); }
#line 6991 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1893:
#line 3476 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("particle.resampling.method.kitagawa", "false"); driver.option_num("particle.resampling.method.smooth", "true"); driver.option_num("particle.resampling.smethod.stratified", "false"); }
#line 6997 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1894:
#line 3477 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("particle.resampling.method.kitagawa", "false"); driver.option_num("particle.resampling.method.smooth", "false"); driver.option_num("particle.resampling.method.stratified", "true"); }
#line 7003 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1895:
#line 3478 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("particle.cpf_weights_method.amisanotristani", "true"); driver.option_num("particle.cpf_weights_method.murrayjonesparslow", "false"); }
#line 7009 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1896:
#line 3479 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("particle.cpf_weights_method.amisanotristani", "false"); driver.option_num("particle.cpf_weights_method.murrayjonesparslow", "true"); }
#line 7015 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1897:
#line 3480 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("particle.filter_algorithm", yystack_[0].value.as < string > ()); }
#line 7021 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1898:
#line 3481 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("particle.initialization", yystack_[0].value.as < string > ()); }
#line 7027 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1899:
#line 3482 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("particle.proposal_approximation.cubature", "true"); driver.option_num("particle.proposal_approximation.unscented", "false"); driver.option_num("particle.proposal_approximation.montecarlo", "false");}
#line 7033 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1900:
#line 3483 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("particle.proposal_approximation.cubature", "false"); driver.option_num("particle.proposal_approximation.unscented", "true"); driver.option_num("particle.proposal_approximation.montecarlo", "false");}
#line 7039 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1901:
#line 3484 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("particle.proposal_approximation.cubature", "false"); driver.option_num("particle.proposal_approximation.unscented", "false"); driver.option_num("particle.proposal_approximation.montecarlo", "true");}
#line 7045 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1902:
#line 3485 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("particle.distribution_approximation.cubature", "true"); driver.option_num("particle.distribution_approximation.unscented", "false"); driver.option_num("particle.distribution_approximation.montecarlo", "false");}
#line 7051 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1903:
#line 3486 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("particle.distribution_approximation.cubature", "false"); driver.option_num("particle.distribution_approximation.unscented", "true"); driver.option_num("particle.distribution_approximation.montecarlo", "false");}
#line 7057 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1904:
#line 3487 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("particle.distribution_approximation.cubature", "false"); driver.option_num("particle.distribution_approximation.unscented", "false"); driver.option_num("particle.distribution_approximation.montecarlo", "true");}
#line 7063 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1905:
#line 3490 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("identification", yystack_[0].value.as < string > ()); }
#line 7069 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1906:
#line 3491 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("morris", yystack_[0].value.as < string > ()); }
#line 7075 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1907:
#line 3492 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("stab", yystack_[0].value.as < string > ()); }
#line 7081 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1908:
#line 3493 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("redform", yystack_[0].value.as < string > ()); }
#line 7087 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1909:
#line 3494 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("pprior", yystack_[0].value.as < string > ()); }
#line 7093 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1910:
#line 3495 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("prior_range", yystack_[0].value.as < string > ()); }
#line 7099 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1911:
#line 3496 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("ppost", yystack_[0].value.as < string > ()); }
#line 7105 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1912:
#line 3497 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("ilptau", yystack_[0].value.as < string > ()); }
#line 7111 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1913:
#line 3498 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("morris_nliv", yystack_[0].value.as < string > ()); }
#line 7117 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1914:
#line 3499 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("morris_ntra", yystack_[0].value.as < string > ()); }
#line 7123 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1915:
#line 3500 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("Nsam", yystack_[0].value.as < string > ()); }
#line 7129 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1916:
#line 3501 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("load_redform", yystack_[0].value.as < string > ()); }
#line 7135 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1917:
#line 3502 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("load_rmse", yystack_[0].value.as < string > ()); }
#line 7141 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1918:
#line 3503 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("load_stab", yystack_[0].value.as < string > ()); }
#line 7147 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1919:
#line 3504 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("alpha2_stab", yystack_[0].value.as < string > ()); }
#line 7153 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1920:
#line 3505 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("logtrans_redform", yystack_[0].value.as < string > ()); }
#line 7159 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1921:
#line 3506 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("threshold_redform",yystack_[0].value.as < string > ()); }
#line 7165 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1922:
#line 3507 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("ksstat_redform", yystack_[0].value.as < string > ()); }
#line 7171 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1923:
#line 3508 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("alpha2_redform", yystack_[0].value.as < string > ()); }
#line 7177 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1924:
#line 3509 "DynareBison.yy" // lalr1.cc:919
    { driver.option_symbol_list("namendo"); }
#line 7183 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1925:
#line 3510 "DynareBison.yy" // lalr1.cc:919
    { driver.option_symbol_list("namlagendo"); }
#line 7189 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1926:
#line 3511 "DynareBison.yy" // lalr1.cc:919
    { driver.option_symbol_list("namexo"); }
#line 7195 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1927:
#line 3512 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("rmse", yystack_[0].value.as < string > ()); }
#line 7201 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1928:
#line 3513 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("lik_only", yystack_[0].value.as < string > ()); }
#line 7207 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1929:
#line 3514 "DynareBison.yy" // lalr1.cc:919
    { driver.option_symbol_list("var_rmse"); }
#line 7213 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1930:
#line 3515 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("pfilt_rmse", yystack_[0].value.as < string > ()); }
#line 7219 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1931:
#line 3516 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("istart_rmse", yystack_[0].value.as < string > ()); }
#line 7225 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1932:
#line 3517 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("alpha_rmse", yystack_[0].value.as < string > ()); }
#line 7231 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1933:
#line 3518 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("alpha2_rmse", yystack_[0].value.as < string > ()); }
#line 7237 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1934:
#line 3520 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("gsa_sample_file", yystack_[0].value.as < string > ()); }
#line 7243 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1935:
#line 3522 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("gsa_sample_file", yystack_[0].value.as < string > ()); }
#line 7249 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1936:
#line 3524 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("neighborhood_width", yystack_[0].value.as < string > ()); }
#line 7255 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1937:
#line 3525 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("pvalue_ks", yystack_[0].value.as < string > ()); }
#line 7261 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1938:
#line 3526 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("pvalue_corr", yystack_[0].value.as < string > ()); }
#line 7267 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1939:
#line 3527 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("load_ident_files", yystack_[0].value.as < string > ()); }
#line 7273 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1940:
#line 3528 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("useautocorr", yystack_[0].value.as < string > ()); }
#line 7279 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1941:
#line 3529 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("prior_mc", yystack_[0].value.as < string > ()); }
#line 7285 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1942:
#line 3530 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("advanced", yystack_[0].value.as < string > ()); }
#line 7291 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1943:
#line 3531 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("max_dim_cova_group", yystack_[0].value.as < string > ()); }
#line 7297 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1944:
#line 3533 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("homotopy_mode",yystack_[0].value.as < string > ()); }
#line 7303 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1945:
#line 3534 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("homotopy_steps",yystack_[0].value.as < string > ()); }
#line 7309 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1946:
#line 3535 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("homotopy_force_continue",yystack_[0].value.as < string > ()); }
#line 7315 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1947:
#line 3536 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("steadystate.nocheck","true"); }
#line 7321 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1948:
#line 3538 "DynareBison.yy" // lalr1.cc:919
    { driver.option_symbol_list("controlled_varexo"); }
#line 7327 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1949:
#line 3540 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("parameter_set", "prior_mode"); }
#line 7333 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1950:
#line 3542 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("parameter_set", "prior_mean"); }
#line 7339 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1951:
#line 3544 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("parameter_set", "posterior_mean"); }
#line 7345 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1952:
#line 3546 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("parameter_set", "posterior_mode"); }
#line 7351 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1953:
#line 3548 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("parameter_set", "posterior_median"); }
#line 7357 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1954:
#line 3550 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("parameter_set", "mle_mode"); }
#line 7363 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1955:
#line 3552 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("parameter_set", "calibration"); }
#line 7369 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1956:
#line 3554 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("nodecomposition", "true"); }
#line 7375 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1957:
#line 3555 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("SpectralDensity.trigger", "true"); }
#line 7381 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1958:
#line 3556 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("ms.drop", yystack_[0].value.as < string > ()); }
#line 7387 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1959:
#line 3557 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("ms.mh_replic", yystack_[0].value.as < string > ()); }
#line 7393 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1960:
#line 3559 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("ms.freq",yystack_[0].value.as < string > ()); }
#line 7399 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1961:
#line 3561 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("ms.freq","12"); }
#line 7405 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1962:
#line 3563 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("ms.freq","4"); }
#line 7411 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1963:
#line 3565 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("ms.initial_year",yystack_[0].value.as < string > ()); }
#line 7417 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1964:
#line 3566 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("ms.initial_subperiod",yystack_[0].value.as < string > ()); }
#line 7423 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1965:
#line 3567 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("ms.final_year",yystack_[0].value.as < string > ()); }
#line 7429 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1966:
#line 3568 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("ms.final_subperiod",yystack_[0].value.as < string > ()); }
#line 7435 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1967:
#line 3569 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("ms.data", yystack_[0].value.as < string > ()); }
#line 7441 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1968:
#line 3570 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("ms.vlist",yystack_[0].value.as < string > ()); }
#line 7447 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1969:
#line 3571 "DynareBison.yy" // lalr1.cc:919
    {driver.option_symbol_list("ms.vlistlog"); }
#line 7453 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1970:
#line 3572 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("ms.vlistper",yystack_[0].value.as < string > ()); }
#line 7459 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1971:
#line 3574 "DynareBison.yy" // lalr1.cc:919
    {
                        driver.warning("restriction_fname is now deprecated, and may be removed in a future version of Dynare. Use svar_identification instead.");
                        driver.option_str("ms.restriction_fname",yystack_[0].value.as < string > ());
                      }
#line 7468 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1972:
#line 3579 "DynareBison.yy" // lalr1.cc:919
    {
                        driver.warning("restriction_fname is now deprecated, and may be removed in a future version of Dynare. Use svar_identification instead.");
                        driver.option_str("ms.restriction_fname","upper_cholesky");
                      }
#line 7477 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1973:
#line 3584 "DynareBison.yy" // lalr1.cc:919
    {
                        driver.warning("restriction_fname is now deprecated, and may be removed in a future version of Dynare. Use svar_identification instead.");
                        driver.option_str("ms.restriction_fname","lower_cholesky");
                      }
#line 7486 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1974:
#line 3589 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("ms.nlags",yystack_[0].value.as < string > ()); }
#line 7492 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1975:
#line 3590 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("ms.cross_restrictions","true"); }
#line 7498 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1976:
#line 3591 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("ms.contemp_reduced_form","true"); }
#line 7504 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1977:
#line 3592 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("ms.real_pseudo_forecast",yystack_[0].value.as < string > ()); }
#line 7510 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1978:
#line 3593 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("ms.bayesian_prior","false"); }
#line 7516 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1979:
#line 3594 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("ms.dummy_obs",yystack_[0].value.as < string > ()); }
#line 7522 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1980:
#line 3595 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("ms.nstates",yystack_[0].value.as < string > ()); }
#line 7528 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1981:
#line 3596 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("ms.indxscalesstates",yystack_[0].value.as < string > ()); }
#line 7534 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1982:
#line 3597 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("ms.alpha",yystack_[0].value.as < string > ()); }
#line 7540 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1983:
#line 3598 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("ms.beta",yystack_[0].value.as < string > ()); }
#line 7546 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1984:
#line 3599 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("ms.gsig2_lmdm",yystack_[0].value.as < string > ()); }
#line 7552 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1985:
#line 3601 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("ms.specification","1"); }
#line 7558 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1986:
#line 3603 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("ms.specification","0"); }
#line 7564 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1987:
#line 3605 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("ms.q_diag",yystack_[0].value.as < string > ()); }
#line 7570 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1988:
#line 3606 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("ms.flat_prior",yystack_[0].value.as < string > ()); }
#line 7576 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1989:
#line 3607 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("ms.ncsk",yystack_[0].value.as < string > ()); }
#line 7582 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1990:
#line 3608 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("ms.nstd",yystack_[0].value.as < string > ()); }
#line 7588 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1991:
#line 3609 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("ms.ninv",yystack_[0].value.as < string > ()); }
#line 7594 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1992:
#line 3610 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("ms.indxparr",yystack_[0].value.as < string > ()); }
#line 7600 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1993:
#line 3611 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("ms.indxovr",yystack_[0].value.as < string > ()); }
#line 7606 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1994:
#line 3612 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("ms.aband",yystack_[0].value.as < string > ()); }
#line 7612 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1995:
#line 3613 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("ms.indxap",yystack_[0].value.as < string > ()); }
#line 7618 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1996:
#line 3614 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("ms.apband",yystack_[0].value.as < string > ()); }
#line 7624 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1997:
#line 3615 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("ms.indximf",yystack_[0].value.as < string > ()); }
#line 7630 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1998:
#line 3616 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("ms.indxfore",yystack_[0].value.as < string > ()); }
#line 7636 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1999:
#line 3617 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("ms.foreband",yystack_[0].value.as < string > ()); }
#line 7642 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2000:
#line 3618 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("ms.indxgforehat",yystack_[0].value.as < string > ()); }
#line 7648 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2001:
#line 3619 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("ms.indxgimfhat",yystack_[0].value.as < string > ()); }
#line 7654 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2002:
#line 3620 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("ms.indxestima",yystack_[0].value.as < string > ()); }
#line 7660 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2003:
#line 3621 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("ms.indxgdls",yystack_[0].value.as < string > ()); }
#line 7666 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2004:
#line 3622 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("ms.eq_ms",yystack_[0].value.as < string > ()); }
#line 7672 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2005:
#line 3623 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("ms.cms",yystack_[0].value.as < string > ()); }
#line 7678 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2006:
#line 3624 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("ms.ncms",yystack_[0].value.as < string > ()); }
#line 7684 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2007:
#line 3625 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("ms.eq_cms",yystack_[0].value.as < string > ()); }
#line 7690 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2008:
#line 3626 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("ms.tlindx",yystack_[0].value.as < string > ()); }
#line 7696 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2009:
#line 3627 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("ms.tlnumber",yystack_[0].value.as < string > ()); }
#line 7702 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2010:
#line 3628 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("ms.cnum",yystack_[0].value.as < string > ()); }
#line 7708 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2011:
#line 3629 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("k_order_solver","true"); }
#line 7714 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2012:
#line 3630 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("pruning", "true"); }
#line 7720 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2013:
#line 3631 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("ms.chain",yystack_[0].value.as < string > ()); }
#line 7726 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2014:
#line 3633 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("ms.restrictions",yystack_[0].value.as < string > ()); }
#line 7732 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2015:
#line 3636 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("ms.duration",yystack_[0].value.as < string > ()); }
#line 7738 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2016:
#line 3638 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("ms.duration",yystack_[0].value.as < string > ()); }
#line 7744 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2017:
#line 3640 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("ms.number_of_regimes",yystack_[0].value.as < string > ()); }
#line 7750 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2018:
#line 3641 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("ms.number_of_lags",yystack_[0].value.as < string > ()); }
#line 7756 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2019:
#line 3642 "DynareBison.yy" // lalr1.cc:919
    { driver.option_symbol_list("ms.parameters"); }
#line 7762 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2020:
#line 3643 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("ms.coefficients","svar_coefficients"); }
#line 7768 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2021:
#line 3644 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("ms.variances","svar_variances"); }
#line 7774 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2022:
#line 3646 "DynareBison.yy" // lalr1.cc:919
    { driver.option_vec_int("ms.equations",yystack_[0].value.as < vector<int> > ()); }
#line 7780 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2023:
#line 3648 "DynareBison.yy" // lalr1.cc:919
    { driver.option_vec_int("ms.equations",yystack_[0].value.as < vector<int> > ()); }
#line 7786 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2024:
#line 3650 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("silent_optimizer", "true"); }
#line 7792 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2025:
#line 3651 "DynareBison.yy" // lalr1.cc:919
    {driver.option_symbol_list("instruments"); }
#line 7798 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2026:
#line 3653 "DynareBison.yy" // lalr1.cc:919
    { driver.external_function_option("name", yystack_[0].value.as < string > ()); }
#line 7804 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2027:
#line 3654 "DynareBison.yy" // lalr1.cc:919
    { driver.external_function_option("nargs",yystack_[0].value.as < string > ()); }
#line 7810 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2028:
#line 3656 "DynareBison.yy" // lalr1.cc:919
    { driver.external_function_option("first_deriv_provided", yystack_[0].value.as < string > ()); }
#line 7816 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2029:
#line 3658 "DynareBison.yy" // lalr1.cc:919
    { driver.external_function_option("first_deriv_provided", ""); }
#line 7822 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2030:
#line 3661 "DynareBison.yy" // lalr1.cc:919
    { driver.external_function_option("second_deriv_provided", yystack_[0].value.as < string > ()); }
#line 7828 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2031:
#line 3663 "DynareBison.yy" // lalr1.cc:919
    { driver.external_function_option("second_deriv_provided", ""); }
#line 7834 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2032:
#line 3666 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("filter_covariance","true");}
#line 7840 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2033:
#line 3669 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("filter_decomposition","true");}
#line 7846 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2034:
#line 3672 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("smoothed_state_uncertainty","true");}
#line 7852 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2035:
#line 3675 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("selected_variables_only","true");}
#line 7858 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2036:
#line 3678 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("cova_compute",yystack_[0].value.as < string > ());}
#line 7864 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2037:
#line 3680 "DynareBison.yy" // lalr1.cc:919
    {driver.option_str("ms.output_file_tag", yystack_[0].value.as < string > ()); }
#line 7870 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2038:
#line 3681 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("ms.file_tag", yystack_[0].value.as < string > ()); }
#line 7876 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2039:
#line 3682 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("ms.create_init", "false"); }
#line 7882 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2040:
#line 3683 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("ms.simulation_file_tag", yystack_[0].value.as < string > ()); }
#line 7888 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2041:
#line 3685 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("ms.coefficients_prior_hyperparameters",yystack_[0].value.as < string > ()); }
#line 7894 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2042:
#line 3687 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("ms.convergence_starting_value",yystack_[0].value.as < string > ()); }
#line 7900 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2043:
#line 3689 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("ms.convergence_ending_value",yystack_[0].value.as < string > ()); }
#line 7906 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2044:
#line 3691 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("ms.convergence_increment_value",yystack_[0].value.as < string > ()); }
#line 7912 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2045:
#line 3693 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("ms.max_iterations_starting_value",yystack_[0].value.as < string > ()); }
#line 7918 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2046:
#line 3695 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("ms.max_iterations_increment_value",yystack_[0].value.as < string > ()); }
#line 7924 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2047:
#line 3697 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("ms.max_block_iterations",yystack_[0].value.as < string > ()); }
#line 7930 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2048:
#line 3699 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("ms.max_repeated_optimization_runs",yystack_[0].value.as < string > ()); }
#line 7936 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2049:
#line 3701 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("ms.function_convergence_criterion",yystack_[0].value.as < string > ()); }
#line 7942 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2050:
#line 3703 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("ms.parameter_convergence_criterion",yystack_[0].value.as < string > ()); }
#line 7948 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2051:
#line 3705 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("ms.number_of_large_perturbations",yystack_[0].value.as < string > ()); }
#line 7954 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2052:
#line 3707 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("ms.number_of_small_perturbations",yystack_[0].value.as < string > ()); }
#line 7960 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2053:
#line 3709 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("ms.number_of_posterior_draws_after_perturbation",yystack_[0].value.as < string > ()); }
#line 7966 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2054:
#line 3711 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("ms.max_number_of_stages",yystack_[0].value.as < string > ()); }
#line 7972 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2055:
#line 3713 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("ms.random_function_convergence_criterion",yystack_[0].value.as < string > ()); }
#line 7978 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2056:
#line 3715 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("ms.random_parameter_convergence_criterion",yystack_[0].value.as < string > ()); }
#line 7984 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2057:
#line 3716 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("ms.thinning_factor",yystack_[0].value.as < string > ()); }
#line 7990 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2058:
#line 3717 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("ms.adaptive_mh_draws",yystack_[0].value.as < string > ()); }
#line 7996 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2059:
#line 3718 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("ms.save_draws","true"); }
#line 8002 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2060:
#line 3719 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("ms.proposal_draws",yystack_[0].value.as < string > ()); }
#line 8008 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2061:
#line 3720 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("ms.use_mean_center","true"); }
#line 8014 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2062:
#line 3721 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("ms.proposal_type",yystack_[0].value.as < string > ()); }
#line 8020 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2063:
#line 3722 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("ms.proposal_lower_bound",yystack_[0].value.as < string > ()); }
#line 8026 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2064:
#line 3723 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("ms.proposal_upper_bound",yystack_[0].value.as < string > ()); }
#line 8032 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2065:
#line 3724 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("ms.parameter_uncertainty","true"); }
#line 8038 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2066:
#line 3725 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("ms.horizon",yystack_[0].value.as < string > ()); }
#line 8044 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2067:
#line 3726 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("ms.filtered_probabilities","true"); }
#line 8050 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2068:
#line 3727 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("ms.real_time_smoothed_probabilities","true"); }
#line 8056 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2069:
#line 3728 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("ms.error_bands","false"); }
#line 8062 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2070:
#line 3729 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("ms.percentiles",yystack_[0].value.as < string > ()); }
#line 8068 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2071:
#line 3730 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("ms.shock_draws",yystack_[0].value.as < string > ()); }
#line 8074 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2072:
#line 3731 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("ms.shocks_per_parameter",yystack_[0].value.as < string > ()); }
#line 8080 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2073:
#line 3732 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("ms.free_parameters",yystack_[0].value.as < string > ()); }
#line 8086 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2074:
#line 3733 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("ms.median","1"); }
#line 8092 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2075:
#line 3734 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("median", yystack_[0].value.as < string > ()); }
#line 8098 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2076:
#line 3735 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("ms.regimes","true"); }
#line 8104 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2077:
#line 3736 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("ms.regime",yystack_[0].value.as < string > ()); }
#line 8110 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2078:
#line 3737 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("ms.forecast_data_obs",yystack_[0].value.as < string > ()); }
#line 8116 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2079:
#line 3738 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("discretionary_tol",yystack_[0].value.as < string > ()); }
#line 8122 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2080:
#line 3739 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("analytic_derivation", "1"); }
#line 8128 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2081:
#line 3740 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("analytic_derivation_mode", yystack_[0].value.as < string > ()); }
#line 8134 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2082:
#line 3741 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("endogenous_prior", "true"); }
#line 8140 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2083:
#line 3742 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("use_univariate_filters_if_singularity_is_detected", yystack_[0].value.as < string > ()); }
#line 8146 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2084:
#line 3744 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("MCMC_jumping_covariance", yystack_[0].value.as < string > ()); }
#line 8152 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2085:
#line 3745 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("MCMC_jumping_covariance", yystack_[0].value.as < string > ()); }
#line 8158 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2086:
#line 3747 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("MCMC_jumping_covariance", yystack_[0].value.as < string > ()); }
#line 8164 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2087:
#line 3749 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("MCMC_jumping_covariance", yystack_[0].value.as < string > ()); }
#line 8170 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2088:
#line 3751 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("rescale_prediction_error_covariance", "true"); }
#line 8176 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2089:
#line 3752 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("hessian.use_penalized_objective","true"); }
#line 8182 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2090:
#line 3753 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("impulse_responses.plot_threshold", yystack_[0].value.as < string > ()); }
#line 8188 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2091:
#line 3754 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("dr_display_tol", yystack_[0].value.as < string > ()); }
#line 8194 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2092:
#line 3755 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("endo_vars_for_moment_computations_in_estimation", "all_endogenous_variables"); }
#line 8200 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2093:
#line 3756 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("endo_vars_for_moment_computations_in_estimation", "only_observed_variables"); }
#line 8206 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2094:
#line 3757 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("no_homotopy", "true"); }
#line 8212 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2095:
#line 3759 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("infile", yystack_[0].value.as < string > ()); }
#line 8218 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2096:
#line 3760 "DynareBison.yy" // lalr1.cc:919
    { driver.option_symbol_list("invars"); }
#line 8224 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2097:
#line 3761 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("period", yystack_[0].value.as < string > ()); }
#line 8230 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2098:
#line 3762 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("outfile", yystack_[0].value.as < string > ()); }
#line 8236 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2099:
#line 3763 "DynareBison.yy" // lalr1.cc:919
    { driver.option_symbol_list("outvars"); }
#line 8242 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2100:
#line 3764 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("lmmcp.status", "true"); }
#line 8248 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2101:
#line 3765 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("occbin", "true"); }
#line 8254 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2102:
#line 3766 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("function", yystack_[0].value.as < string > ()); }
#line 8260 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2103:
#line 3767 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("sampling_draws",yystack_[0].value.as < string > ()); }
#line 8266 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2104:
#line 3768 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("plot_shock_decomp.use_shock_groups","default"); }
#line 8272 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2105:
#line 3769 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("plot_shock_decomp.use_shock_groups", yystack_[0].value.as < string > ()); }
#line 8278 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2106:
#line 3771 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("plot_shock_decomp.colormap",yystack_[0].value.as < string > ()); }
#line 8284 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2107:
#line 3772 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("initial_condition_decomp.colormap",yystack_[0].value.as < string > ()); }
#line 8290 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2108:
#line 3774 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("gmm.order", yystack_[0].value.as < string > ()); }
#line 8296 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2109:
#line 3775 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("smm.order", yystack_[0].value.as < string > ()); }
#line 8302 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2110:
#line 3776 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("gmm.centered_moments", "true"); }
#line 8308 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2111:
#line 3777 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("smm.centered_moments", "true"); }
#line 8314 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2112:
#line 3779 "DynareBison.yy" // lalr1.cc:919
    { driver.option_vec_int("gmm.autolag", yystack_[0].value.as < vector<int> > ()); }
#line 8320 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2113:
#line 3781 "DynareBison.yy" // lalr1.cc:919
    { driver.option_vec_int("gmm.autolag", yystack_[0].value.as < vector<int> > ()); }
#line 8326 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2114:
#line 3784 "DynareBison.yy" // lalr1.cc:919
    { driver.option_vec_int("smm.autolag", yystack_[0].value.as < vector<int> > ()); }
#line 8332 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2115:
#line 3786 "DynareBison.yy" // lalr1.cc:919
    { driver.option_vec_int("smm.autolag", yystack_[0].value.as < vector<int> > ()); }
#line 8338 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2116:
#line 3788 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("gmm.recursive_estimation", "true"); }
#line 8344 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2117:
#line 3789 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("smm.recursive_estimation", "true"); }
#line 8350 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2118:
#line 3790 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("gmm.qLag", yystack_[0].value.as < string > ()); }
#line 8356 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2119:
#line 3791 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("smm.qLag", yystack_[0].value.as < string > ()); }
#line 8362 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2120:
#line 3793 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("gmm.weighting_matrix", yystack_[0].value.as < string > ()); }
#line 8368 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2121:
#line 3795 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("gmm.weighting_matrix", yystack_[0].value.as < string > ()); }
#line 8374 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2122:
#line 3797 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("gmm.weighting_matrix", yystack_[0].value.as < string > ()); }
#line 8380 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2123:
#line 3799 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("gmm.weighting_matrix", yystack_[0].value.as < string > ()); }
#line 8386 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2124:
#line 3802 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("smm.weighting_matrix", yystack_[0].value.as < string > ()); }
#line 8392 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2125:
#line 3804 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("smm.weighting_matrix", yystack_[0].value.as < string > ()); }
#line 8398 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2126:
#line 3806 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("smm.weighting_matrix", yystack_[0].value.as < string > ()); }
#line 8404 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2127:
#line 3808 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("smm.weighting_matrix", yystack_[0].value.as < string > ()); }
#line 8410 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2128:
#line 3810 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("gmm.penalized_estimator", "true"); }
#line 8416 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2129:
#line 3811 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("smm.penalized_estimator", "true"); }
#line 8422 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2130:
#line 3812 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("gmm.verbose", "true"); }
#line 8428 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2131:
#line 3813 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("smm.verbose", "true"); }
#line 8434 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2132:
#line 3815 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("smm.simulation_multiple", yystack_[0].value.as < string > ()); }
#line 8440 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2133:
#line 3816 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("smm.drop", yystack_[0].value.as < string > ()); }
#line 8446 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2134:
#line 3817 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("smm.seed", yystack_[0].value.as < string > ()); }
#line 8452 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2135:
#line 3818 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("smm.bounded_support", "true"); }
#line 8458 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2136:
#line 3820 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("irf_opt.analytical_GIRF", "true"); }
#line 8464 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2137:
#line 3821 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("irf_opt.percent", "true"); }
#line 8470 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2138:
#line 3822 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("irf_opt.ergodic_mean_irf", "true"); }
#line 8476 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2139:
#line 3823 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("irf_opt.EM.drop", yystack_[0].value.as < string > ()); }
#line 8482 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2140:
#line 3824 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("irf_opt.EM.tolf", yystack_[0].value.as < string > ()); }
#line 8488 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2141:
#line 3825 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("irf_opt.EM.iter", yystack_[0].value.as < string > ()); }
#line 8494 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2142:
#line 3828 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("no_identification_strength", "true"); }
#line 8500 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2143:
#line 3829 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("no_identification_reducedform", "true"); }
#line 8506 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2144:
#line 3830 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("no_identification_moments", "true"); }
#line 8512 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2145:
#line 3831 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("no_identification_minimal", "true"); }
#line 8518 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2146:
#line 3832 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("no_identification_spectrum", "true"); }
#line 8524 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2147:
#line 3833 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("normalize_jacobians", yystack_[0].value.as < string > ()); }
#line 8530 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2148:
#line 3834 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("grid_nbr", yystack_[0].value.as < string > ()); }
#line 8536 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2149:
#line 3835 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("tol_rank", yystack_[0].value.as < string > ()); }
#line 8542 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2150:
#line 3836 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("tol_deriv", yystack_[0].value.as < string > ()); }
#line 8548 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2151:
#line 3837 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("tol_sv", yystack_[0].value.as < string > ()); }
#line 8554 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2152:
#line 3838 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("checks_via_subsets", yystack_[0].value.as < string > ()); }
#line 8560 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2153:
#line 3839 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("max_dim_subsets_groups", yystack_[0].value.as < string > ()); }
#line 8566 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2154:
#line 3842 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = yystack_[2].value.as < string > () + ':' + yystack_[0].value.as < string > (); }
#line 8572 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2155:
#line 3845 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = yystack_[2].value.as < string > () + ':' + yystack_[0].value.as < string > (); }
#line 8578 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2156:
#line 3848 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < pair<string,string> > () = { yystack_[2].value.as < string > (), yystack_[0].value.as < string > () }; }
#line 8584 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2157:
#line 3850 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < pair<string,string> > () = { yystack_[2].value.as < string > (), "Inf" }; }
#line 8590 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2158:
#line 3854 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = yystack_[2].value.as < string > () + ':' + yystack_[0].value.as < string > (); }
#line 8596 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2159:
#line 3856 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = "-(" + yystack_[3].value.as < string > () + ':' + yystack_[1].value.as < string > () + ")"; }
#line 8602 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2160:
#line 3859 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < vector<int> > () = vector<int>{stoi(yystack_[0].value.as < string > ())}; }
#line 8608 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2161:
#line 3862 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < vector<int> > () = yystack_[0].value.as < vector<int> > (); }
#line 8614 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2162:
#line 3864 "DynareBison.yy" // lalr1.cc:919
    {
                 yylhs.value.as < vector<int> > () = vector<int>{};
                 for (int i = stoi(yystack_[2].value.as < string > ()); i <= stoi(yystack_[0].value.as < string > ()); i++)
                   yylhs.value.as < vector<int> > ().push_back(i);
               }
#line 8624 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2163:
#line 3872 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < vector<int> > () = yystack_[0].value.as < vector<int> > ();}
#line 8630 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2164:
#line 3874 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < vector<int> > () = yystack_[0].value.as < vector<int> > ();}
#line 8636 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2165:
#line 3876 "DynareBison.yy" // lalr1.cc:919
    {
              yylhs.value.as < vector<int> > () = yystack_[1].value.as < vector<int> > ();
              yylhs.value.as < vector<int> > ().insert(yylhs.value.as < vector<int> > ().end(), yystack_[0].value.as < vector<int> > ().begin(), yystack_[0].value.as < vector<int> > ().end());
            }
#line 8645 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2166:
#line 3881 "DynareBison.yy" // lalr1.cc:919
    {
              yylhs.value.as < vector<int> > () = yystack_[2].value.as < vector<int> > ();
              yylhs.value.as < vector<int> > ().insert(yylhs.value.as < vector<int> > ().end(), yystack_[0].value.as < vector<int> > ().begin(), yystack_[0].value.as < vector<int> > ().end());
            }
#line 8654 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2167:
#line 3887 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < vector<int> > () = yystack_[1].value.as < vector<int> > (); }
#line 8660 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2168:
#line 3888 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < vector<int> > () = yystack_[2].value.as < vector<int> > (); }
#line 8666 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2169:
#line 3892 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < vector<string> > () = vector<string>{yystack_[0].value.as < string > ()}; }
#line 8672 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2170:
#line 3894 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < vector<string> > () = vector<string>{yystack_[0].value.as < string > ()}; }
#line 8678 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2171:
#line 3896 "DynareBison.yy" // lalr1.cc:919
    {
              yylhs.value.as < vector<string> > () = yystack_[1].value.as < vector<string> > ();
              yylhs.value.as < vector<string> > ().push_back(yystack_[0].value.as < string > ());
            }
#line 8687 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2172:
#line 3901 "DynareBison.yy" // lalr1.cc:919
    {
              yylhs.value.as < vector<string> > () = yystack_[2].value.as < vector<string> > ();
              yylhs.value.as < vector<string> > ().push_back(yystack_[0].value.as < string > ());
            }
#line 8696 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2173:
#line 3907 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < vector<string> > () = yystack_[1].value.as < vector<string> > (); }
#line 8702 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2174:
#line 3908 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < vector<string> > () = yystack_[2].value.as < vector<string> > (); }
#line 8708 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2175:
#line 3912 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = '[' + yystack_[0].value.as < string > (); }
#line 8714 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2176:
#line 3914 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = '[' + yystack_[0].value.as < string > (); }
#line 8720 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2177:
#line 3916 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = yystack_[1].value.as < string > () + ' ' + yystack_[0].value.as < string > (); }
#line 8726 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2178:
#line 3918 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = yystack_[2].value.as < string > () + ' ' + yystack_[0].value.as < string > (); }
#line 8732 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2179:
#line 3922 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = yystack_[1].value.as < string > () + ']'; }
#line 8738 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2180:
#line 3924 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = yystack_[2].value.as < string > () + ']'; }
#line 8744 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2181:
#line 3928 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = yystack_[2].value.as < string > () + ',' + yystack_[0].value.as < string > (); }
#line 8750 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2182:
#line 3929 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 8756 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2183:
#line 3933 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = yystack_[1].value.as < string > (); }
#line 8762 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2184:
#line 3934 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 8768 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2185:
#line 3938 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = '[' + yystack_[0].value.as < string > (); }
#line 8774 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2186:
#line 3940 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = yystack_[1].value.as < string > () + ' ' + yystack_[0].value.as < string > (); }
#line 8780 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2187:
#line 3944 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = yystack_[1].value.as < string > () + ']'; }
#line 8786 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2188:
#line 3946 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 8792 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2189:
#line 3947 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 8798 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2190:
#line 3948 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 8804 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2191:
#line 3949 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 8810 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2192:
#line 3950 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 8816 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2193:
#line 3951 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 8822 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2194:
#line 3952 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 8828 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2195:
#line 3953 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 8834 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2196:
#line 3954 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 8840 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2197:
#line 3955 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 8846 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2198:
#line 3956 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 8852 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2199:
#line 3957 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 8858 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2200:
#line 3958 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 8864 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2201:
#line 3959 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 8870 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2202:
#line 3960 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 8876 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2203:
#line 3961 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 8882 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2204:
#line 3962 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 8888 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2205:
#line 3963 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 8894 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2206:
#line 3964 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 8900 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2207:
#line 3965 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 8906 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2208:
#line 3966 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 8912 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2209:
#line 3967 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 8918 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2210:
#line 3971 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 8924 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2211:
#line 3972 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 8930 "DynareBison.cc" // lalr1.cc:919
    break;


#line 8934 "DynareBison.cc" // lalr1.cc:919
            default:
              break;
            }
        }
#if YY_EXCEPTIONS
      catch (const syntax_error& yyexc)
        {
          YYCDEBUG << "Caught exception: " << yyexc.what() << '\n';
          error (yyexc);
          YYERROR;
        }
#endif // YY_EXCEPTIONS
      YY_SYMBOL_PRINT ("-> $$ =", yylhs);
      yypop_ (yylen);
      yylen = 0;
      YY_STACK_PRINT ();

      // Shift the result of the reduction.
      yypush_ (YY_NULLPTR, YY_MOVE (yylhs));
    }
    goto yynewstate;


  /*--------------------------------------.
  | yyerrlab -- here on detecting error.  |
  `--------------------------------------*/
  yyerrlab:
    // If not already recovering from an error, report this error.
    if (!yyerrstatus_)
      {
        ++yynerrs_;
        error (yyla.location, yysyntax_error_ (yystack_[0].state, yyla));
      }


    yyerror_range[1].location = yyla.location;
    if (yyerrstatus_ == 3)
      {
        /* If just tried and failed to reuse lookahead token after an
           error, discard it.  */

        // Return failure if at end of input.
        if (yyla.type_get () == yyeof_)
          YYABORT;
        else if (!yyla.empty ())
          {
            yy_destroy_ ("Error: discarding", yyla);
            yyla.clear ();
          }
      }

    // Else will try to reuse lookahead token after shifting the error token.
    goto yyerrlab1;


  /*---------------------------------------------------.
  | yyerrorlab -- error raised explicitly by YYERROR.  |
  `---------------------------------------------------*/
  yyerrorlab:
    /* Pacify compilers when the user code never invokes YYERROR and
       the label yyerrorlab therefore never appears in user code.  */
    if (false)
      YYERROR;

    /* Do not reclaim the symbols of the rule whose action triggered
       this YYERROR.  */
    yypop_ (yylen);
    yylen = 0;
    goto yyerrlab1;


  /*-------------------------------------------------------------.
  | yyerrlab1 -- common code for both syntax error and YYERROR.  |
  `-------------------------------------------------------------*/
  yyerrlab1:
    yyerrstatus_ = 3;   // Each real token shifted decrements this.
    {
      stack_symbol_type error_token;
      for (;;)
        {
          yyn = yypact_[yystack_[0].state];
          if (!yy_pact_value_is_default_ (yyn))
            {
              yyn += yyterror_;
              if (0 <= yyn && yyn <= yylast_ && yycheck_[yyn] == yyterror_)
                {
                  yyn = yytable_[yyn];
                  if (0 < yyn)
                    break;
                }
            }

          // Pop the current state because it cannot handle the error token.
          if (yystack_.size () == 1)
            YYABORT;

          yyerror_range[1].location = yystack_[0].location;
          yy_destroy_ ("Error: popping", yystack_[0]);
          yypop_ ();
          YY_STACK_PRINT ();
        }

      yyerror_range[2].location = yyla.location;
      YYLLOC_DEFAULT (error_token.location, yyerror_range, 2);

      // Shift the error token.
      error_token.state = yyn;
      yypush_ ("Shifting", YY_MOVE (error_token));
    }
    goto yynewstate;


  /*-------------------------------------.
  | yyacceptlab -- YYACCEPT comes here.  |
  `-------------------------------------*/
  yyacceptlab:
    yyresult = 0;
    goto yyreturn;


  /*-----------------------------------.
  | yyabortlab -- YYABORT comes here.  |
  `-----------------------------------*/
  yyabortlab:
    yyresult = 1;
    goto yyreturn;


  /*-----------------------------------------------------.
  | yyreturn -- parsing is finished, return the result.  |
  `-----------------------------------------------------*/
  yyreturn:
    if (!yyla.empty ())
      yy_destroy_ ("Cleanup: discarding lookahead", yyla);

    /* Do not reclaim the symbols of the rule whose action triggered
       this YYABORT or YYACCEPT.  */
    yypop_ (yylen);
    while (1 < yystack_.size ())
      {
        yy_destroy_ ("Cleanup: popping", yystack_[0]);
        yypop_ ();
      }

    return yyresult;
  }
#if YY_EXCEPTIONS
    catch (...)
      {
        YYCDEBUG << "Exception caught: cleaning lookahead and stack\n";
        // Do not try to display the values of the reclaimed symbols,
        // as their printers might throw an exception.
        if (!yyla.empty ())
          yy_destroy_ (YY_NULLPTR, yyla);

        while (1 < yystack_.size ())
          {
            yy_destroy_ (YY_NULLPTR, yystack_[0]);
            yypop_ ();
          }
        throw;
      }
#endif // YY_EXCEPTIONS
  }

  void
  parser::error (const syntax_error& yyexc)
  {
    error (yyexc.location, yyexc.what ());
  }

  // Generate an error message.
  std::string
  parser::yysyntax_error_ (state_type yystate, const symbol_type& yyla) const
  {
    // Number of reported tokens (one for the "unexpected", one per
    // "expected").
    size_t yycount = 0;
    // Its maximum.
    enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
    // Arguments of yyformat.
    char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];

    /* There are many possibilities here to consider:
       - If this state is a consistent state with a default action, then
         the only way this function was invoked is if the default action
         is an error action.  In that case, don't check for expected
         tokens because there are none.
       - The only way there can be no lookahead present (in yyla) is
         if this state is a consistent state with a default action.
         Thus, detecting the absence of a lookahead is sufficient to
         determine that there is no unexpected or expected token to
         report.  In that case, just report a simple "syntax error".
       - Don't assume there isn't a lookahead just because this state is
         a consistent state with a default action.  There might have
         been a previous inconsistent state, consistent state with a
         non-default action, or user semantic action that manipulated
         yyla.  (However, yyla is currently not documented for users.)
       - Of course, the expected token list depends on states to have
         correct lookahead information, and it depends on the parser not
         to perform extra reductions after fetching a lookahead from the
         scanner and before detecting a syntax error.  Thus, state
         merging (from LALR or IELR) and default reductions corrupt the
         expected token list.  However, the list is correct for
         canonical LR with one exception: it will still contain any
         token that will not be accepted due to an error action in a
         later state.
    */
    if (!yyla.empty ())
      {
        int yytoken = yyla.type_get ();
        yyarg[yycount++] = yytname_[yytoken];
        int yyn = yypact_[yystate];
        if (!yy_pact_value_is_default_ (yyn))
          {
            /* Start YYX at -YYN if negative to avoid negative indexes in
               YYCHECK.  In other words, skip the first -YYN actions for
               this state because they are default actions.  */
            int yyxbegin = yyn < 0 ? -yyn : 0;
            // Stay within bounds of both yycheck and yytname.
            int yychecklim = yylast_ - yyn + 1;
            int yyxend = yychecklim < yyntokens_ ? yychecklim : yyntokens_;
            for (int yyx = yyxbegin; yyx < yyxend; ++yyx)
              if (yycheck_[yyx + yyn] == yyx && yyx != yyterror_
                  && !yy_table_value_is_error_ (yytable_[yyx + yyn]))
                {
                  if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                    {
                      yycount = 1;
                      break;
                    }
                  else
                    yyarg[yycount++] = yytname_[yyx];
                }
          }
      }

    char const* yyformat = YY_NULLPTR;
    switch (yycount)
      {
#define YYCASE_(N, S)                         \
        case N:                               \
          yyformat = S;                       \
        break
      default: // Avoid compiler warnings.
        YYCASE_ (0, YY_("syntax error"));
        YYCASE_ (1, YY_("syntax error, unexpected %s"));
        YYCASE_ (2, YY_("syntax error, unexpected %s, expecting %s"));
        YYCASE_ (3, YY_("syntax error, unexpected %s, expecting %s or %s"));
        YYCASE_ (4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
        YYCASE_ (5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
#undef YYCASE_
      }

    std::string yyres;
    // Argument number.
    size_t yyi = 0;
    for (char const* yyp = yyformat; *yyp; ++yyp)
      if (yyp[0] == '%' && yyp[1] == 's' && yyi < yycount)
        {
          yyres += yytnamerr_ (yyarg[yyi++]);
          ++yyp;
        }
      else
        yyres += *yyp;
    return yyres;
  }


  const short parser::yypact_ninf_ = -3403;

  const short parser::yytable_ninf_ = -2208;

  const short
  parser::yypact_[] =
  {
    5536,   219,   309,  8603,  -182,   111,   -95,  -167,   -29,  9098,
     419,    -8,     3,   512,  9362,    -5,     6,   539,   569,     8,
      33, -3403,    35,  9410,    37,   712,    43,    47,   717,   720,
      48,   723,    62,    65,   997, 10086,  1045,  1059,    88,    97,
   -3403,  1093,   103,   106, 10496, 13626, 13626,   492, -3403, 10788,
    1096,  1098, 13626,    84,  1109, 10530,  1111,   549,  1115,  1119,
     128,  1121, 10565, 10604,  1128, 10638,   135, 10678,   145, -3403,
   13626, 10823, 13626, 13626, -3403, -3403, 13626,   147, 10711, 13626,
    1132,  1142,  1144,   153,   203,   330,   346,   377,  1146,   496,
    1159, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403,
   -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403,
     503,  1174,   526, 10755,  1176,  1178,  1190,  1222,  1226,  1229,
   -3403,   534,   229,   536,   376,   553,   560,   563,   565,   576,
   10863,   420,  4973, -3403, -3403, -3403, -3403, -3403, -3403, -3403,
   -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403,
   -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403,
   -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403,
   -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403,
   -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403,   281, -3403,
   -3403,  1008, -3403, -3403,  1014, -3403, -3403, -3403, -3403, -3403,
   -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403,
   -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403,
   -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403,
   -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403,
   -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403,
     284,   445,  2737,   447,  3273, -3403,  2607,  3477, -3403,   311,
   -3403,  2519,  1424,   736, 13626, -3403,   456,  3582,   305, 13458,
   13458, 13626,  1066, -3403,  6395,  3937,  9128, 12007, 12034,  1133,
   -3403,  1420,  1017, 13626,  1375, -3403,  1621,  4262, 13626, 13626,
    1157,  1056, 13626, -3403,   487, 13626,  1161,  1150, 13626,   925,
   13458,  1081, -3403,  3566, -3403,  1094,   625,  2754, -3403, -3403,
   -3403,   899,   996, -3403, 13626,   471,   508, 13626, 13626, -3403,
    4232,  4441,  4889,  5001,   113,  1147,   628,  9938,  1032,  5235,
   -3403,   589, -3403, 14225,  5350, 13458,   414,  1061, -3403,  2626,
    5452, 13665,  1126,   684, -3403,  3945, -3403,  1532, -3403, -3403,
    2264, -3403,  6840,  5493, -3403,   613,  5562, -3403,  1086, -3403,
    7257,  5760,  1160, -3403,  6934,  5821, -3403,  5871,   257,  7195,
     170,  7339,   176,  7368,   192, 13626, 13626,  7429, -3403,   355,
   -3403,   566,  7453,  7485,   985, -3403,  1172, -3403,  1175, -3403,
    1177, -3403,   264, -3403,   274, 12155, -3403,  9828,   497, 13626,
    1195, 13626, -3403, 11750,   938, -3403,  3139,  7517, -3403,  2471,
   -3403, 11575, -3403,  1116, -3403,  1260, -3403,   134, -3403,  2379,
     764,   953, -3403,   633, -3403,  1125,   187,   187,  6728,  3832,
   -3403,  7544,   986, -3403, -3403, 12062, 13626, 12082, 12265, 10450,
   13388, -3403,  1415, -3403,  1417,  1428,  1430,  1440,  1455, -3403,
    1496,  1502,  1504, -3403,  1506,  1510,  1523,  1529, -3403,  1551,
     991, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403,
   -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403,  1538,  1570,
    1593, -3403,  1642,  1047, -3403, -3403, -3403,  1626, -3403,  1628,
   -3403, -3403,  1640, -3403, -3403,  1076,  1680, -3403, -3403, -3403,
   -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403,
   13626, -3403, -3403, -3403, -3403, -3403, -3403,  1085, -3403,  1670,
    1681,  1688,  1723,  1726,  1736,  1740,  1747, -3403,   166, -3403,
   -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403,  1756,
    1760,  1762,  1764,   243, -3403, -3403, -3403, -3403, -3403, -3403,
   13626,   475, -3403,  1695,  1768, -3403, -3403, -3403,  1772, -3403,
    1781,  1783,  1785, -3403,  1790, -3403,  1792, -3403,  1232,  1819,
   -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403,
   -3403, -3403, -3403, -3403, -3403,  1247, -3403,  1255,  1256, 12299,
   -3403,  1836,  1262, -3403, -3403,  1841,  1844, -3403, -3403, -3403,
    1845,  1846,  1849, -3403, -3403,  1852,  1858,  1860, -3403,  1861,
    1863, -3403, -3403,  1864,  1865,  1868,  1873,  1879, -3403,  1882,
    1886,  1891,  1892, -3403, -3403, -3403,  1893,  1896,  1898,  1899,
    1909,  1912,  1915,  1918,  1920,  1923,  1947, -3403,  1949, -3403,
    1950,  1952,  1956,  1958,  1962, -3403, -3403,  1963,  1968,  1969,
    1972, -3403,  1973,  1982,  1983,  1988,  1989,  1992,  2002,  2006,
    2007,  2008, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403,
   -3403,  2012,  2016, -3403,  2017, -3403,  2019,  2022,  2025, -3403,
   -3403,  2031,  2032, -3403,  2036,  2038, -3403,  2040, -3403,  2045,
   -3403, -3403, -3403,  2047,  2048,  2050,   255, -3403, -3403, -3403,
   -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403,
   -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403,
   -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403,
   -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403,
   -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403,
   -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403,
   -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403,
   -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403,
   -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403,
   -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403,
   -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403,
   -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, 13626, -3403,
   13626,  9056, -3403,   273, -3403, 13626, 13626, 11803, -3403,  2071,
   13626, 13626, 11917, -3403,  2073,  1479, -3403,  2063,  2068, -3403,
   -3403,  1500,  2093, -3403, -3403, -3403, -3403, -3403, -3403, -3403,
   -3403,   123, 12649, -3403,  2099,  2080,  2090,  2096,  2104,  2105,
     258, -3403,   259, -3403, -3403, -3403, -3403, -3403, -3403, -3403,
    1516, 12723, -3403,  1549,  1564,  2143, 12748, -3403,  2166,  2150,
    2157,  2158,  2159,  2160,  2164,  2167,  2170, -3403, -3403, -3403,
   -3403, -3403,  2173,  2176,  2177,  2180,  2184,  2185,  2190,  1589,
    2211, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403,
   -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403,
   -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403,
   -3403, -3403, -3403, -3403, -3403, 12768,  1616,  2194, 12791, -3403,
     177,  1627,  1629,  2198,  9742,  2203, -3403, -3403,  2207,  2210,
   -3403, -3403,  2213, -3403,  2214, -3403, -3403,   260, -3403, -3403,
   -3403,  2215,  1645,   499, 13458, -3403,  1641,   261, -3403, 13626,
   -3403,   545,  1647, 12811, -3403,  2257,  1667,  2267,   498, -3403,
    1672,  2270, -3403, -3403, 12831, -3403,  1682, 12865,  7220,  2260,
    2261,  2265,  2269, -3403,  2272,  2273,  2276,  2278,  2279, -3403,
   -3403, -3403, -3403, -3403, -3403,  2280,  2282, -3403,  2285,  2294,
   -3403,   279, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403,
   -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403,
   -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403,
   -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403,
   -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403,
   -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403,
   -3403, 13626, -3403,   197,  1691, 12107,   837, -3403,  1725, -3403,
   -3403, -3403,  1694,  1734,  1735,  1741,  1748,  1749,  9938,  9938,
    1751,  1752,  1753,  1754,  1758,  1759,  1763,  1766,  1771,  1773,
    1775,  1777,  1778,  1780,  1782,  1787,  1788,  1789,  1793,  9938,
    2770, -3403,   -22,   834,  2301, -3403,   285, -3403, -3403, -3403,
    2336,  2338, -3403,  2348,  2357, -3403, -3403,  2359, -3403,   291,
   -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403,
   -3403, -3403, -3403, -3403, -3403, -3403, -3403,  1784, 13626, 13626,
     609, -3403, -3403,  1791,  2373,  2375, -3403,  2376,  2377, -3403,
    1803,  2401, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403,
   -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403,  2383,
   12531, -3403,  2387,  2389,   564, -3403, -3403,   297, -3403,  2390,
    2407,  2408,  2409,  2411,  1824,  2432, -3403, -3403, -3403, -3403,
   -3403,  5794,   298, -3403,  2413,  2414, -3403,   307, -3403, -3403,
   -3403, -3403, -3403, -3403, -3403, -3403,  2415,  2418,  2419,  2420,
    1847,  2442, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403,
   -3403, -3403, -3403, -3403, -3403,  2423,  2425,  2428,   327, -3403,
   -3403, -3403, -3403, -3403,   351, -3403, -3403, -3403, -3403,  1335,
     507, -3403,  2430,  2434,   359, -3403, -3403, -3403, -3403, -3403,
   -3403,  2438,  2439, 13626, -3403,   206,  1691, -3403, 13626, -3403,
     215,  1691, -3403, 13626, -3403,   233,  1691, -3403,  7665, -3403,
    7717, -3403, 13626, -3403, -3403,  2440,  2441,  2444,  2446,  2447,
    2448,   360, -3403,  2453, -3403, -3403, -3403, -3403, -3403,  2454,
    2457,  2459, -3403,  2460,  2461,  2462, -3403, -3403, -3403,  2466,
    2467,  1894,  2490, -3403, -3403, -3403, -3403, -3403, -3403, -3403,
   -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403,
   -3403, -3403, -3403, -3403, 13626, -3403,  2163, -3403,  1895,  1903,
    1916,  2475,  2476,  2486,   361, -3403, -3403, -3403, -3403,   383,
    2494,  2495,  2498,   364, -3403, -3403, -3403, -3403,  2500,   368,
   -3403, -3403, -3403, -3403,  2504,  2507,  2509,  2511,  2512,  2514,
    2515,  2555,  2556,  2558,  2559,  2560,  2562,  2568,  2573,  2575,
    2578,  2579,  2581,  2583,  2584,  2585,  2586,  2588,  2589,  2590,
    2592,  2593,  2594,  2595,  2596,  2021,  2619, -3403, -3403, -3403,
   -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403,
   -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403,
   -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403,
   -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403,
   -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403,  2601,
    2602,  2604,  2605,  2609,   369, -3403, -3403, -3403, -3403, -3403,
   -3403, -3403, -3403, 12910, -3403, 12182,  2612,  2030,  2613,  2614,
    2616,  2621,  2623,  2629,  2631,  2632,  2633,  2634, -3403,  2635,
   -3403,  2636,  2637,  2639,  2640, -3403,  2641,  2642,  2643,  2648,
    2650,  2651,  2652,  2654,  2657,  2658,  2660,  2661,  2663,  2665,
    2666,  2667,  2668,  2670,  2671,  2672,  2673,  2674,  2675,  2676,
    2677,  2681,  2682,  2683,  2646,  2107, -3403, -3403, -3403, -3403,
   -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403,
   -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403,
   -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403,
   -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403,
   -3403, -3403, -3403, -3403,  2686, -3403, -3403,  2690,  2691,  2692,
    2697,  2698,  2699,  2700,  2702,  2703,  2705, -3403,  2706,  2727,
    2137, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403,
   -3403, -3403, -3403, -3403, -3403, -3403, -3403,  2735,  2139, -3403,
   -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403,
   -3403, -3403, -3403,  2718, -3403,  2719,  2722,  2723,  2725,  2729,
    2731,  2733,  2738,  2739,  2740,  2741,  2742,  2744,  2745,  2746,
    2747,  2175, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403,
   -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403,
   -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403,
   -3403, -3403, -3403, -3403, -3403, -3403, -3403,  2753,  2755, -3403,
    2756,  2774,  2182, -3403, -3403, -3403, -3403, -3403, -3403, -3403,
    2760,  2761,  2763,  2772, -3403,  2790,  2196, -3403, -3403, -3403,
   -3403, -3403, -3403, -3403, -3403, -3403,  2794,  2200, -3403, -3403,
   -3403, -3403,  2775,  2801,  2205, -3403, -3403, -3403, -3403, -3403,
   -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403,   120,
    2784,  2785,  2789,  2791,  2793,  2795,   370, -3403, -3403, -3403,
   -3403, -3403, -3403, -3403,  2571, -3403, -3403,  2797,   373, -3403,
   -3403, -3403, -3403, -3403,  2799,  2803,  2804,  2806,   375, -3403,
   -3403, -3403, -3403, -3403,  2808,  2809,   378, -3403, -3403, -3403,
     400,  2811,  2812, -3403,  2813, -3403,  2815,  2816, -3403, -3403,
    2818,  2819, -3403, -3403,  2217,  2821, -3403, -3403, -3403, -3403,
   -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403,
   -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403,
   -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403,
   -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403,
   -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403,
   -3403, -3403, -3403, -3403,  2824, -3403,  2825, -3403,  2827,  2828,
   -3403, -3403, -3403,  2253,  2851, -3403, -3403, -3403, -3403, -3403,
   -3403, -3403, -3403, -3403, -3403,  2256,  2262,  2258,  2255,   426,
   -3403,  2840,  2266,  2268,  2274,  2259,  2271,  2275,  2277,  2263,
   -3403,  2281,  2297,  2298,  2299, -3403, 10450, 10450,  2302,  2305,
    2310,  2311,  2312,  2314,  2315,  2316,  2318,  2319,  2320,  2321,
    2322,  2323,  2325, 10450,  4799, -3403,    36, -3403, -3403,  2326,
     396,  2329,   499,  1129,   499,  2776,  1129,  2781, 13458,  2783,
     275,  2787,  2837, 13626, 13626,  2737,  2841,  2847,   499,  2848,
    3273,  2849,  2343,   499,  1189, 10903,  2607, -3403, 13626,  2856,
    2857,  2858,   499,   499,  2861,   499,  2862,  2519,  2332,   499,
    2358,  2863,  2871,  1424,  2364,  2367,  2369, -3403, 13626, 13458,
     768,  1083,  1017,  1017, 13626,  2878, 10936,   456, -3403, 10971,
   11013,  2371, -3403, 10450,  2378,  2885,  2630,   499, 13626,   499,
     499,   499,  2887, 13458,   275,  1091,   275,  2889,  2382,   499,
    2893,   499,  2894,  2895,   647,   499,   499,   499,   499,   499,
     499,   499,  2896,  2897,  2898,  2900,  1271,  2906,  2912,  8220,
   13458,  2915,  2343,  2405,  2405, 13196,  2917,   328,   499,  1152,
    1283,  2922, 13626,  1322,  1355,  2435,  2924,  2963,   499,   652,
    2965,  1457,   499,  2966,   597,  2463,  2968,  2969,   499,  2971,
    6395, 11046,  3057, -3403,  2465, -3403,   760, -3403,  3061,  3064,
    2470, -3403, 10450,  3066,  3067,  2474, -3403, 10450,  2477,  2984,
    2986,  2482,  1420,  2991,  2484,  2485, -3403, 10450,  2835,  2839,
    2854,  2860,  2874,  1375,  2491,  1621, 11085,  2501,  2510, -3403,
     825,  2526, 13458,  2532, -3403, 10450,  1129,  3015,  3017,   825,
    3041,  3069,  9721,  3070,  3072,  3073,   499,   499,   499,  3074,
    3075,  2549,   487,  2569,  2572, 13458,  2574, -3403, 13626,  3076,
    2576,  2580, -3403,  2982, 13626,  9288, -3403,  1284, -3403,   499,
     499,  2577,  3081,  2600,  3566,  2617,   477, 13458,  2618,  2615,
     499, -3403,  2625,  2627,  2628, -3403,  2638,  2644, -3403, 13626,
   -3403, 13626,  2645, -3403,  2653,   508,  2659, -3403, 10450,  2662,
    7250, 13626,  4828,   499,  3083,  3087, 13407,   499,  3089,  3122,
     499,  3127,   499,  3129,  3131,  3134,  4232, 11121,   246,  1691,
   -3403, -3403, 13626, -3403,  3204,  7862, -3403, -3403, -3403,  9938,
    9938,  9938,  9938, 13626, 13626,  2876,  2876,  9938,  9938,  9938,
    9938,  9938,  9938,  9938,  9938,  9938,  9938,  9938,  9938,  9938,
    9938,  9938,  9938,  9938,  9938,   825,  3887,  9938,  9938,  9938,
    9938,  9938,  9938,  9938,  9938,  9938,  9938,  9938,  2664, 13626,
    2669, -3403, -3403, -3403,  3140,   589,  2678,   499,   499,  3141,
     499,  3142, 14225,  2679,  2680,  3230,   490,  2695, -3403,  2708,
    1244,  3144, 13626, 13626, 11161,  2626, 13626,  2709, -3403, 13626,
   13626,   499,   499, 10450,   -18,   584, -3403, -3403,  3945,  2712,
   13458,  2724, 13458,  2726,  3145,  2730,  1532, 13626,  9336, -3403,
    3215,  2264,  2732,   499,  2343,  6840, 11194,  3150,  3154,  3159,
    2343, 11229,   613,  2736, 10450,  2937,  1086,  2734,  7257, 11271,
   10450, 10450, 10450, 10450,  2743, -3403,  3166,   499,  6934, 11311,
   -3403, -3403,   271,  1691, -3403, -3403,   301,  1691, -3403, -3403,
     342,  1691, -3403, -3403, 13626, -3403, -3403, 13626, -3403, -3403,
   -3403, -3403, 13626, 10450, 13626, 13626,  3169,   355,  2748, 13458,
    1212,  3171,  3174,  1104,  1017,  1017, 13626,  3175, 11343,   566,
    2964, -3403,  2752,  2757,  2759, 13626,  3177,  2720,   264, 11379,
    3248,  3250,  3252, -3403,  3256,   429, -3403, -3403, -3403, -3403,
   -3403, -3403, 13626,  2720,  2720,   274,  2764, 13458, 12155,  2788,
    3201,  3214,  3234,  3239,  3241,  3246,  3249,  3253,  3255,  3261,
    3263,  3264,  3271,   499,  3293,  2786,   499,   499,  2792,  2800,
    2802,  3295,  3298,  2814,   499,  3299,   499,   499,   499,   499,
     499,  2798,  9828, 13458, 13626,  1017,  1017,  3300,   497,  2807,
    2822, -3403, 13626,  2823, 13626,  2826,   308,  3302,  3303,  3310,
    3312, 13458,  3317,  2817,  3320,   334,  3321,  3324,  3327,  3332,
    3335,   499,   499,  3336,  3339,  3340,  3343,  3344,  3347,   499,
    3348,  3359,  3361,  3362,  3363,  3364,  3365,  3367,  3370,  3371,
    3373,  3375,  3376,  3377,  3380,  3383,  3384,  3385,  2405, 11750,
    2879, -3403,  3386, 13458,  3388, 13458, 13458,  2405,  3389,  3391,
    2405,  1129,  3394,  3139, 11419,  2471,  2888,   122,   499,   499,
     499,  3395,   499,  3397,  3398,   499,   499,  3410,  3412,  3413,
    3414,   499,   499, 11575,  2907,  3418,  3421,  3422,  1116,  2916,
    3425,  1129,  1129,  3428,  1260,  2921,   134,  2923,  3430,  2379,
    2925,  2844,    79,  2926,  2929,   469, -3403,  2927,  2930,  3432,
     435,  3440,  3442,   953,  2936, -3403,   524, -3403,   275,   633,
    2939, 13720,  3445, 13720, 13720,  1125,  2941, 13458,  3446,   187,
    2945,  2946,  3448,  3455,   275,  3456, 13028,  3457,  3458, 11453,
    6728,  3459,   275,  3460, 13130, 11491,  3832,  2952, 13626, 13626,
   -3403,  3236, 13626,  2972,  1017, 13626, 13626, -3403, 13694, 13626,
   13626, -3403, 13550, 10450, 10450, 10450, 10450,  2990,  2990, 10450,
   10450, 10450, 10450, 10450, 10450, 10450, 10450, 10450, 10450, 10450,
   10450, 10450, 10450, 10450,  4075, 10450, 10450, 10450, 10450, 10450,
   10450, 10450, 10450, 10450, 10450, 10450, -3403,  2973,  1537,  2974,
     294, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403,
     479, -3403,   209, -3403, -3403, -3403, -3403, -3403,  2976, -3403,
    2977, -3403, -3403, -3403, -3403,  2978, -3403, -3403, -3403, -3403,
   -3403, -3403, -3403, -3403, -3403, -3403,  7744, -3403,  7782, -3403,
   -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403,
   -3403, 13626, -3403, -3403, -3403, -3403,  3341, -3403,  2967, -3403,
   -3403, -3403, -3403, -3403, -3403, -3403, -3403,   773, -3403,  3235,
    3235, -3403, -3403, -3403,  7810, -3403, -3403,  7838, -3403,  7895,
   -3403,  5388, 13626, -3403, -3403, -3403, -3403, -3403, -3403, -3403,
   -3403, -3403, -3403, -3403,   773, -3403, -3403, -3403, -3403, 13626,
   -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403,
   -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403,
   -3403,  1068,  1095, -3403, -3403, -3403, -3403, -3403, -3403, -3403,
   -3403, -3403, -3403,  1314,   262, -3403, -3403, -3403, -3403, -3403,
   -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403,
   -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403,  3328,
   -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403,
   -3403, -3403, -3403,  3334, -3403, -3403, -3403, -3403, -3403, -3403,
    7927, 13626, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403,
   -3403,  5609,  3578,  2989,  3581, 13626, 10450, -3403,  1168, 13626,
   10450, -3403,  8069, 11965, -3403, -3403, -3403, -3403, -3403, -3403,
   -3403,  2540, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403,
   -3403,  8013, 13433, -3403, -3403,  3508,  3510,  3003, 13626,  3004,
   -3403,  1240, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403,
   -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403,
   -3403, 13626,  3005, -3403,  3603,    15,  3007, 13626, -3403,  9938,
    3586,   235, -3403,  3589,  3016, -3403, -3403,  9938, -3403, -3403,
   -3403, 13626, -3403, 13458, -3403, -3403, -3403, -3403,  3210, -3403,
     499,  3013, -3403, -3403,  3387, -3403,   899, -3403,   250,   288,
    3593, -3403,   530, -3403, -3403,  4120, -3403, 13626,  9162, 10450,
   -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403,
   -3403, -3403, -3403, -3403, -3403, -3403, -3403,  8040,  1691, -3403,
   -3403, -3403,  3372, -3403, -3403,  2750,  2859,  4258,  4302,  3019,
    3020,  4425,  4568,  4600,  4736,  4869,  4881,  5013,  5556,  5793,
    5936,  5978,  5995,  2940,  6026,  6068,   903,  1064,  6134,  3023,
   -3403,  3247,  3247,   909,   909,   909,   909,   805,   805,  2876,
    2876,  3272, -3403, -3403,  9938,  3025, -3403, -3403, -3403, -3403,
   -3403, -3403, -3403, -3403, -3403, -3403, 13626, 13626, 10450,   296,
   -3403,   414, -3403, -3403, -3403, -3403, -3403, -3403,  8070, -3403,
    8122, -3403, -3403,  8161,  3026, -3403, -3403,  6315,   564,  3029,
     608, 10450, -3403, -3403, -3403, -3403, 13626, -3403, 13626, -3403,
   -3403, -3403,   554,  3030, -3403, 10450, -3403, -3403, -3403, -3403,
   -3403, -3403,  8188, -3403, -3403, -3403, -3403, -3403,  8305, -3403,
   13626,  3149, -3403, -3403, -3403, -3403, -3403,  8337,  9706, 10059,
   10238, 10567, -3403, -3403, -3403, -3403, -3403,  8380,  9938,  9938,
    1691, -3403, -3403,  1691, -3403, -3403,  1691, -3403, -3403, -3403,
   -3403,  9938, -3403,  3149, -3403, -3403,  3027, -3403, -3403, -3403,
   -3403, -3403, -3403, -3403, -3403, -3403,   773, -3403,  3235,  3235,
   -3403, -3403, -3403,  8419, -3403, -3403, -3403, -3403, -3403, -3403,
   -3403,   504,   231, -3403, -3403, -3403,  8455, -3403, 13626, 13626,
   13626,  3606, 13315,   383,  3034, -3403, -3403, -3403, -3403, -3403,
   -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403,
   -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403,  1271,   547,
   -3403, -3403, -3403,  2938,  2938,  2938, -3403, -3403,  2938, -3403,
   -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403,
    3235,  3235, -3403, -3403, -3403, -3403,  3035, -3403,  3055, -3403,
   -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, 13626,
   -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403,
   -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403,
   -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403,
   -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403,  9938,
   -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403,
   -3403, -3403, -3403,  8482, -3403, -3403, -3403, -3403, -3403, -3403,
   -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403,
   -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403,
   -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403,
   -3403,  3544,  3545,  3058, -3403, -3403,  3059, -3403, 13626,   303,
   -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403,  3635,
    3063, -3403, -3403, -3403, -3403, -3403, -3403,  3065, -3403, -3403,
   -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403,
   -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403,
   -3403,  8528, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403,
   -3403, -3403,  8567, -3403,   619,  3665,  3085, -3403, -3403,   148,
    3666,  3099,  3071,  3095,  3671,  3101, -3403,  3097,  2953,  2970,
    6364,  6403,  6424,  6436,  6469,  6484,  6538,  6895,  7365,  7392,
    7658,  7687,  7713,  7785,  8045,  1100,  1123, -3403,  3534,  3534,
    1208,  1208,  1208,  1208,   879,   879,  2990,  2990,  3272, 10450,
    3658,  3680,  3685,   430, -3403, -3403, -3403, -3403,   699,  3110,
    3687,  3621,  3108, -3403, -3403,   234, -3403, -3403, 13626, -3403,
   -3403, -3403, 13626, -3403, -3403,   862,  3623,  3111, -3403,   432,
   -3403, -3403, -3403, -3403, 12982,   433,   902, -3403, -3403,  1129,
   -3403,   440, -3403, -3403,  3712, -3403,   434,  3714, -3403,   438,
   -3403, -3403,   760, -3403, 10450,  3715,  3098, 10450,  3716, 10675,
   -3403,  3123, 11988, 10450, -3403, -3403,  3121,   451,  3119, -3403,
   -3403,  3702, 13089,  3128, 10450, -3403, 13289,  3130,   228,  3724,
    3639,  3727, 13347,  8085,  3482,  2982,  9938,  9938, -3403, 10827,
     937, -3403,   439,  9742, -3403,  3132, -3403,  3623,   607,   228,
     961, 13626, -3403,  1129,  3137,   533,  3158, 10450, -3403, 11086,
   -3403, -3403, -3403,  9938,  9938, -3403, -3403, -3403, -3403, -3403,
   -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403,
   -3403,  3488, -3403, -3403,  9938, -3403,  9938, -3403, -3403,  3160,
    2770,   444, 13626,  3717,  3720, 11344, 10450,   622, -3403, 13626,
   -3403, -3403, -3403,  3163, -3403,   584, -3403, 10450, -3403,  8191,
     959,  1054,  3734, -3403, 11487, -3403, -3403,  1136, -3403, -3403,
   -3403, -3403, -3403, -3403,  8230,  8329, -3403, -3403, -3403,  2770,
     441,   446, -3403,  3489, -3403,   172, -3403, -3403, 13626, -3403,
   -3403, -3403, -3403, -3403,  9938, -3403, -3403, -3403, -3403, -3403,
   -3403, -3403, -3403, 12225,  3162,  3165,  3168,  3182, -3403,  3185,
      77,  1171,  8345, -3403,  3736,  3186, -3403, -3403,   578, -3403,
     242, 10450, -3403, -3403, -3403,  3735,  3740,  3743,  3762,  3763,
    3765,  3768,  3769,  3770,   448, -3403, -3403, -3403, -3403, -3403,
   -3403, -3403, -3403, -3403, -3403, -3403, 13626,  3189,  1017, 13626,
    3190,  3352, 13626,  3193,  3696, 10450, 10450, -3403, -3403, -3403,
   -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403,
   -3403, -3403, 10450, -3403, 10450, -3403,  3149,   454,  2786,   499,
    1129,  1537,  3202,  3778,  3781,   455, -3403, -3403, -3403, -3403,
   -3403, -3403, -3403, -3403, -3403, -3403, -3403,  1537,  3206, -3403,
    3719, -3403, -3403, -3403, -3403, -3403,  3203,   319, 13509,   773,
   -3403,  3208, -3403, -3403, -3403, -3403, -3403,  1675,  3328, -3403,
    1463,  3334, -3403,  3149,  3817,  3819,  3820, -3403, 10450, 10450,
   11694, 10450, -3403, -3403,  3226, 11721,  1537,  3229,   320, 10450,
    3227, -3403, 11909,  3233, -3403, -3403, -3403, 10450,  3237, 13626,
   -3403, 13626,  3240, 13626, -3403, -3403,  1325, 11931, -3403, -3403,
   13458, -3403,  9315, -3403,   340,  3242,  3243,   310,    59,  3257,
    3811, -3403, -3403,  3244, -3403, 11980, -3403,  8452,  8491,   458,
    3213,  3345,  9938,  9938, -3403,  8677, 10450, 10450, -3403, 12030,
    3251, -3403, 13665,  8640, -3403, -3403, -3403, 10450, -3403, -3403,
   13626, 13626, -3403, -3403, -3403, -3403, -3403, -3403, -3403,  2770,
   -3403, -3403, -3403, -3403, 13626,   382,  3351,   384, -3403, -3403,
   13626, -3403,  3354, -3403,  2405, -3403, 12212,  1129,  2405,   499,
    2930,  1129,  2405,  2354,  2405,  2405,   619,  3258,  3259,  3746,
    3235,  3262, 13839, -3403,  3268, 13575, -3403,  8716,  9019,  3403,
    3429, 10450, -3403, -3403, -3403, -3403, -3403, -3403,  1129, 10450,
     699,  3260,   460,   699, -3403,  3760,  3771,  3265,  3560, -3403,
    3276,   488,  3266, -3403, -3403, -3403, -3403, -3403, -3403, -3403,
   -3403, -3403,  3640, -3403, -3403, -3403, 10450, 10450, 10450,  3469,
   12289, -3403, 12330, -3403, -3403,   462,   699,  3291,  3868, 12404,
   -3403, -3403, -3403,  3786, -3403,  3852,  3889, -3403,  8713,  3591,
    9938, -3403, -3403, -3403,  3296,  3585, -3403, -3403,   825,  3893,
     825,  3896,  1129, -3403, -3403, -3403, -3403,   292, -3403,  9938,
    9938,  9233,  2770, -3403, 12429, 12455, -3403, -3403, 12606, -3403,
   12472,  8747,   350,  8786, 13367,  3393,  3323,  3325,  3812,  3331,
   -3403,  8825,  3628,  9890,  3833,  3438, -3403, -3403, -3403, -3403,
   -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403,
   -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403,  3330,  3333,
    3071,  3338,  3342, -3403,  3350, -3403, -3403, 10450, 10450,  3149,
   -3403,  3149, -3403, -3403,  3346,   465, -3403,  3329,  3835,  1194,
    1537,  3337,   372,  3934, -3403,   466,  3936, -3403,  3938, 10450,
   -3403, -3403,  3358,   468,  1537,  3349, -3403, 10450,   228,   228,
   13626, -3403,  3643, -3403, 12497, -3403,  1194,  3353,   228, -3403,
     228, -3403,  3360,  3366,  9357,  9471, -3403, -3403, -3403,  3369,
   -3403, 13626, -3403,   358,  1691, -3403, -3403,  3374,  3382,  3378,
     389,  1372, 13626, 13626,  3390, -3403, 13626, -3403,  3644, -3403,
   10271, 10306,  3392,  4212,  3935,  9890, -3403,  3956,  3871,  3860,
   13884,  3520, 13863,  3862,  9530,  9654, -3403,  3399,  3878, -3403,
   10450,   624, -3403,   481,   699,  3396,  3946,  1071,  3640, -3403,
     639, 10450, 12515, -3403,  3400,   482,   699,  3751,  3401,  3402,
    3668, -3403, -3403,   751,   825,  3404,  3405, -3403, -3403, -3403,
   -3403, -3403,   552,  1691, -3403, -3403, -3403, 13626, -3403,   505,
    3393,  3393, 10450, 10450,  3968,  3406,  3480,  3681, -3403,  3431,
    3433, 13626, 10413, -3403,  4212, -3403, 13626,  3979,  3071,  3379,
   -3403, -3403,  3381, -3403, -3403, -3403, -3403, -3403, 10094,  1612,
   -3403, 10450, -3403,  3407,   483,  1537,  3434, -3403, -3403, -3403,
    3982,  3984, -3403, -3403,  3437,   484, -3403, -3403, -3403, -3403,
   -3403,  3436, -3403, -3403,  1691, -3403, -3403,  3986, -3403, -3403,
   -3403,  3970,  3978,  2076,  2076, 13626,  3496,  3439,  3480, -3403,
   -3403, 13626, 13626,  4025,  3447,  9890,   352, -3403, 13626,  3587,
    3941, -3403, 10450, -3403, 10124, -3403,  3443,   485,   699, 10450,
   10450, -3403,  3453, -3403, -3403, 13626,   505,   505,  3452,  3461,
    3463,   397,  1480, 13626, -3403,  4034,  4051,  3965, 13626,  3464,
   13626, -3403,   405, -3403, -3403, 10201, -3403, -3403,  3465,   486,
   -3403,  4053, -3403,  4054, -3403, -3403,  4036, 13626, -3403,   505,
    3496,  3496, 10450, 10450,  3466,  3977,  3980,  3468,  4066, -3403,
   -3403, -3403, -3403, -3403,  3474, 10450,  3987,   436,  4073, -3403,
    4055,  4057,  2076,  2076, 13626,  3481,  3484, -3403,  3992, -3403,
    3149,  3485, 13626,  3490,  3996,   505,   505,  8864, -3403, -3403,
    3504, -3403,  4086, -3403,  3505, -3403, -3403, -3403, -3403, 13626,
   -3403,  3506,  3511, -3403
  };

  const unsigned short
  parser::yydefact_[] =
  {
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2209,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2188,     0,     0,     0,     0,     0,     0,     0,  1125,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2208,
       0,     0,     0,     0,  1031,  1036,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2189,  2190,  2192,  2191,  2193,  2194,  2195,  2196,  2197,
    2198,  2199,  2200,  2201,  2202,  2203,  2204,  2206,  2205,  2207,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     464,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     2,    47,    48,    90,    92,     5,    33,
      35,    34,   115,    36,    26,     6,     7,     8,     4,     9,
      10,    11,    17,    13,    14,    15,    16,   106,    32,   116,
      12,    18,    84,    85,    86,    87,    19,    20,    21,    22,
      56,   107,   108,   111,   112,   109,   110,    23,    88,    24,
      27,    29,    28,    51,    30,    31,    39,    40,     0,    37,
      38,     0,    41,    42,     0,    25,    43,    45,    44,    46,
      49,    50,    52,    53,    54,    69,    70,    71,    55,    57,
      58,    59,    60,    61,    62,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    63,    64,    65,    99,    97,    98,
      96,    95,    94,    93,    66,    67,    68,    81,    83,    82,
      89,   100,    91,   101,   102,   103,   104,   105,   113,   114,
       0,     0,     0,     0,     0,  1555,     0,     0,   736,     0,
     541,     0,     0,     0,     0,  1180,     0,     0,     0,     0,
       0,     0,     0,   891,     0,     0,     0,     0,     0,     0,
    1587,     0,     0,     0,     0,  1524,     0,     0,     0,     0,
       0,     0,     0,  1071,     0,     0,     0,     0,     0,     0,
       0,     0,   385,     0,  1112,     0,  1119,     0,  1111,   547,
     551,     0,     0,  1597,     0,     0,     0,     0,     0,  1061,
       0,     0,     0,     0,   268,     0,     0,     0,     0,     0,
     552,     0,   558,     0,     0,     0,     0,     0,  1168,     0,
       0,     0,     0,     0,   659,     0,  1614,     0,  1549,   529,
       0,   672,     0,     0,  1172,     0,     0,  1128,     0,  1130,
       0,     0,     0,  1142,     0,     0,  1141,     0,     0,     0,
     232,     0,   244,     0,   256,     0,     0,     0,   280,     0,
    1176,     0,     0,     0,   283,  1161,     0,  1163,     0,  1165,
       0,  1167,     0,   157,     0,     0,  1393,     0,     0,     0,
       0,     0,  1265,     0,     0,  1319,     0,     0,  1283,     0,
    1391,     0,  1352,     0,  1341,     0,  1329,     0,  1301,     0,
       0,     0,   357,     0,   487,     0,     0,     0,     0,     0,
    1184,     0,     0,     1,     3,     0,     0,     0,     0,     0,
       0,  1205,     0,  1882,     0,     0,     0,     0,     0,  1826,
       0,     0,     0,  1827,     0,     0,     0,     0,  1193,  1204,
       0,  1194,  1199,  1197,  1200,  1198,  1195,  1196,  1201,  1202,
    1186,  1187,  1188,  1189,  1190,  1191,  1192,  1213,     0,     0,
       0,  1207,  1212,     0,  1209,  1208,  1210,     0,  1809,     0,
    1795,  1829,     0,  2033,  2034,     0,  1560,  1563,  1566,  1564,
    1565,  1561,  1568,  1572,  1573,  1562,  1569,  1571,  1567,  1570,
       0,  1557,   734,   288,   289,   290,   291,     0,  1947,     0,
       0,     0,     0,     0,     0,     0,     0,   545,     0,   544,
     533,   538,   540,   537,   546,   534,   535,   536,   539,     0,
       0,     0,     0,     0,  1536,  1539,  1538,  1540,  1541,  1542,
       0,     0,  1546,     0,     0,  1869,  1856,  1852,     0,  1876,
       0,     0,     0,  1747,     0,  1874,     0,  1760,     0,  1504,
    1511,  1517,  1512,  1518,  1506,  1507,  1513,  1505,  1509,  1510,
    1508,  1514,  1515,  1516,  1182,     0,   117,     0,     0,     0,
     349,     0,     0,  1831,  2080,     0,     0,  1799,  2024,  1956,
       0,     0,     0,  2092,  2093,     0,     0,     0,  2082,     0,
       0,  1713,  1734,     0,     0,     0,     0,     0,  1811,     0,
       0,     0,     0,  1793,  1794,  1797,     0,     0,     0,     0,
       0,     0,     0,  1777,     0,     0,     0,  1828,     0,  1786,
       0,     0,     0,     0,     0,  1807,  1808,     0,     0,     0,
       0,  1824,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2089,  2088,  1746,  1798,  1733,  1735,  1736,  1885,
    1886,     0,     0,  1832,     0,  1781,     0,  1802,     0,  1810,
    1806,     0,     0,  1804,     0,     0,  2032,     0,  2035,     0,
    2136,  2137,  2138,     0,     0,     0,     0,   896,   949,   955,
     976,   935,   964,   979,   897,   998,   999,   898,   962,   899,
    1003,  1005,   900,   901,   902,   903,   904,   905,   906,   907,
     908,   909,   910,   986,   911,   912,   913,   914,  1004,  1001,
    1002,   915,   916,   917,   918,   919,   921,   920,   922,   923,
     924,   925,   926,   927,   928,   930,   931,   933,   934,   936,
     937,   938,   939,   940,   941,   932,   942,   943,   944,   945,
     946,   947,   948,   980,   981,   983,   982,   950,   951,   952,
     953,   954,   956,   957,   965,   966,   967,   968,   969,   970,
     971,   972,   973,   974,  1014,  1015,   989,   990,   991,   992,
     995,   993,   994,   996,   997,   929,  1000,   958,   959,   960,
     961,   963,   975,   977,   978,   984,  1007,  1006,   985,   987,
     988,  1008,  1009,  1010,  1011,  1012,  1013,   893,     0,   762,
       0,     0,   756,     0,   760,     0,     0,     0,   782,     0,
       0,     0,     0,   776,     0,     0,  1661,     0,     0,  2100,
    2101,     0,  1590,  1591,  1592,  1593,  1594,  1595,  1596,   807,
     808,     0,     0,   788,     0,     0,     0,     0,     0,     0,
       0,   365,     0,  1528,  1530,  1532,  1533,  1534,  1531,  1526,
       0,     0,   354,     0,     0,     0,     0,  1520,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2142,  2143,  2144,
    2145,  2146,     0,     0,     0,     0,     0,     0,     0,     0,
    1074,  1108,  1083,  1075,  1082,  1086,  1088,  1089,  1090,  1092,
    1095,  1087,  1091,  1081,  1084,  1077,  1076,  1078,  1079,  1080,
    1085,  1093,  1094,  1096,  1097,  1098,  1099,  1100,  1101,  1102,
    1103,  1104,  1105,  1106,  1107,     0,     0,     0,     0,  1609,
       0,     0,     0,     0,     0,     0,   371,   374,     0,   377,
    1644,   381,     0,   376,     0,   375,   384,     0,   379,   372,
     373,     0,     0,     0,     0,  1109,  1121,     0,   550,     0,
     507,     0,     0,     0,  1602,     0,     0,     0,     0,  1583,
       0,  1579,  1580,  1581,     0,  1043,     0,     0,     0,     0,
       0,     0,     0,  2011,     0,     0,     0,     0,     0,  1649,
    1650,  1651,  1818,  1817,  2012,     0,     0,  1678,     0,     0,
    1054,     0,  1053,   678,   679,   680,   681,   682,   683,   684,
     685,   687,   688,   692,   693,   703,   704,   705,   706,  1055,
    1056,  1057,   707,   709,   708,   710,   711,  1059,   716,   689,
     690,   691,  1058,   727,   686,   694,   712,   713,   714,   715,
     719,   720,   721,   722,   723,   724,   701,   702,   717,   718,
    1060,   725,   726,   695,   696,   697,   698,   699,   700,  1063,
    1051,     0,   221,   266,   274,     0,     0,   271,     0,   295,
     743,   742,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1126,   406,   402,  1113,     0,  1543,     0,   555,   556,   557,
       0,     0,  1796,     0,     0,  2094,  1643,     0,  1642,     0,
     561,   569,   562,   570,   566,   565,   573,   574,   563,   564,
     567,   576,   575,   568,   571,   572,   119,     0,     0,     0,
       0,   457,   458,     0,     0,     0,  1738,  2104,     0,  1759,
       0,  1450,  1452,  1457,  1456,  1461,  1455,  1458,  1459,  1460,
    1462,  1463,  1465,  1466,  1464,  1451,  1453,  1454,  1170,     0,
       0,  1626,     0,     0,     0,   663,   664,     0,   662,     0,
       0,     0,     0,     0,     0,  1617,  1618,  1619,  1620,  1621,
    1622,     0,     0,   532,     0,  1664,  1957,     0,   728,   677,
     733,   732,   729,   730,   731,   674,     0,     0,     0,     0,
       0,  1468,  1470,  1472,  1471,  1475,  1476,  1477,  1478,  1479,
    1480,  1469,  1473,  1474,  1174,     0,     0,     0,     0,  1152,
    1153,  1154,  1155,  1158,     0,  1157,  1159,  1160,  1132,     0,
       0,  1136,     0,     0,     0,  1147,  1148,  1150,  1149,  1144,
    1045,     0,     0,     0,   136,   230,   238,   235,     0,   218,
     242,   250,   247,     0,   219,   254,   262,   259,     0,  1035,
       0,  1040,     0,   220,   278,     0,     0,     0,     0,     0,
       0,     0,   167,     0,  1870,  1853,  1854,  1855,  1851,     0,
       0,     0,  1875,     0,     0,     0,  1748,  1737,  1873,  1749,
       0,     0,  1482,  1500,  1485,  1501,  1502,  1486,  1487,  1488,
    1489,  1490,  1492,  1491,  1496,  1497,  1493,  1494,  1495,  1498,
    1499,  1483,  1484,  1178,     0,   222,   281,   286,     0,     0,
       0,     0,     0,     0,     0,   147,   148,   149,   150,     0,
       0,     0,     0,     0,   153,   154,   155,   156,     0,     0,
     203,   204,   205,  1696,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1396,  1443,  1429,  1430,
    1431,  1432,  1433,  1445,  1434,  1435,  1436,  1437,  1438,  1440,
    1439,  1444,  1446,  1397,  1398,  1399,  1400,  1401,  1402,  1403,
    1404,  1405,  1406,  1407,  1408,  1409,  1410,  1411,  1412,  1421,
    1413,  1414,  1422,  1424,  1423,  1415,  1416,  1425,  1417,  1418,
    1419,  1420,  1426,  1427,  1428,  1441,  1442,  1447,  1448,     0,
       0,     0,     0,     0,     0,   813,   814,   815,   816,   817,
     818,   819,   820,     0,  1635,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1975,     0,
    1976,     0,     0,     0,     0,  1978,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1264,     0,  1215,  1261,  1216,  1217,
    1218,  1219,  1220,  1221,  1222,  1223,  1224,  1225,  1226,  1227,
    1228,  1229,  1230,  1231,  1232,  1233,  1234,  1235,  1236,  1237,
    1238,  1239,  1240,  1241,  1242,  1243,  1244,  1245,  1246,  1247,
    1248,  1249,  1250,  1251,  1252,  1253,  1254,  1255,  1256,  1257,
    1258,  1259,  1260,  1262,     0,  2065,  2076,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2074,  2067,     0,  1318,
       0,  1303,  1304,  1305,  1312,  1306,  1307,  1308,  1309,  1310,
    1311,  1313,  1314,  1316,  1315,  1321,  2069,  1282,     0,  1267,
    1268,  1269,  1275,  1279,  1280,  1270,  1271,  1272,  1273,  1274,
    1276,  1278,  1277,     0,  2039,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1390,     0,  1360,  1361,  1362,  1355,  1356,  1357,  1358,  1359,
    1363,  1364,  1365,  1366,  1367,  1368,  1369,  1370,  1371,  1372,
    1373,  1354,  1374,  1375,  1376,  1377,  1378,  1379,  1380,  1381,
    1382,  1383,  1384,  1385,  1386,  1387,  1388,     0,     0,  2059,
       0,  1351,     0,  1346,  1345,  1343,  1344,  1347,  1348,  1349,
       0,     0,     0,     0,  2061,  1340,     0,  1331,  1332,  1333,
    1337,  1338,  1334,  1335,  1336,  2068,  1328,     0,  1323,  1324,
    1325,  1326,     0,  1300,     0,  1285,  1286,  1287,  1292,  1297,
    1298,  1289,  1290,  1291,  1293,  1294,  1296,  1295,  1288,     0,
       0,     0,     0,     0,     0,     0,     0,   490,   491,   493,
     492,   494,   495,   496,     0,  2020,  2021,     0,     0,   499,
     503,   500,   501,   502,     0,     0,  2029,  2031,     0,   667,
     668,   669,   670,   671,     0,     0,     0,   656,   657,   658,
       0,     0,     0,  2111,     0,  2117,     0,     0,  2129,  2131,
       0,     0,  2135,   640,     0,   639,   591,   587,   595,   605,
     577,   609,   610,   578,   579,   612,   613,   614,   580,   581,
     582,   583,   584,   585,   588,   586,   589,   590,   592,   593,
     596,   597,   598,   599,   600,   601,   602,   603,   604,   621,
     622,   611,   594,   606,   607,   608,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   615,   616,
     617,   618,   619,   620,     0,  2110,     0,  2116,     0,     0,
    2128,  2130,   627,     0,   626,   628,   629,   630,   631,   632,
     633,   634,   635,  1185,   832,     0,     0,     0,     0,     0,
     827,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     338,     0,     0,     0,     0,   337,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   300,   299,  1113,   823,   885,
     828,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   735,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1547,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   118,     0,
       0,     0,   348,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   759,     0,   755,   341,   758,     0,     0,
       0,   781,     0,     0,     0,     0,   775,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   787,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   353,
       0,     0,     0,     0,  1521,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1610,     0,     0,
       0,     0,   128,     0,     0,     0,   391,     0,   392,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1123,
       0,   551,     0,     0,     0,   506,     0,     0,  1603,     0,
    1574,     0,     0,  1582,     0,     0,     0,  1042,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   267,   272,
     269,   277,     0,   224,     0,     0,   228,   226,   296,     0,
       0,     0,     0,     0,     0,   422,   421,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   403,   404,   405,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   456,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1625,     0,
       0,     0,     0,     0,     0,   522,   746,   528,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1552,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1135,     0,     0,     0,     0,
     139,   137,   231,   236,   233,   241,   243,   248,   245,   253,
     255,   260,   257,   265,     0,  1032,  1033,     0,  1037,  1038,
     279,   170,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     282,   284,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1687,     0,     0,   160,   161,   162,   163,
     164,   165,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1634,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   120,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   467,     0,     0,     0,
       0,     0,     0,     0,     0,   361,     0,   360,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     822,     0,     0,     0,     0,     0,     0,   866,     0,     0,
       0,   884,     0,     0,     0,     0,     0,   313,   312,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   297,     0,     0,     0,
       0,  1878,  1879,  1880,  1881,  1877,  1883,  1694,  1710,  2160,
       0,  1701,     0,  1700,  1729,  1730,  1819,  1820,     0,  1203,
       0,  1884,  1768,  1805,  1211,     0,  1821,  1814,  1955,  1949,
    1950,  1952,  1951,  1953,  1954,  1556,     0,  1559,     0,   292,
    1944,  1945,  1946,  1671,  1675,  1662,  1682,  1639,   543,   542,
    1770,     0,  1658,  1646,  1537,  1535,     0,  1545,     0,  1857,
    1862,  1863,  1864,  1761,  1763,  1762,  1764,     0,  1755,  1865,
    1866,  2107,  1751,  1181,     0,  1503,  1067,     0,  1065,     0,
     346,     0,     0,  1648,  1709,  1699,  1780,  1769,  1848,  1849,
    1850,  1698,  1708,  1707,     0,  1753,  1706,  1705,  1652,     0,
    2090,  1812,  1813,  1731,  1732,  1840,  1842,  1839,  1841,  1843,
    1844,  1771,  1774,  1782,  1775,  1776,  1791,  1792,  1772,  1773,
     749,     0,     0,   751,   750,  1787,  1789,  1788,  1784,  1785,
    1783,  1833,  1822,     0,     0,  1823,  1825,  2085,  2084,  2086,
    2087,  1887,  1888,  1890,  1889,  1891,  1892,  1894,  1893,  1895,
    1896,  1898,  1897,  1899,  1900,  1901,  1902,  1903,  1904,     0,
    1645,  1830,  1790,  1801,  1800,  1803,  1837,  1836,  1838,  2083,
    1845,  1846,  1847,     0,  2036,  2139,  2140,  2141,   895,   892,
       0,     0,   754,   799,   800,   802,   803,   805,   801,   804,
     806,   342,     0,     0,     0,     0,     0,   780,     0,     0,
       0,   772,     0,     0,  1660,  1659,  1588,  1589,   809,   810,
     786,     0,   370,   367,   366,   369,   368,   364,   363,  1529,
    1525,     0,     0,   351,   741,     0,     0,     0,     0,     0,
    1519,     0,  2081,  1939,  1943,  1942,  1941,  1940,  1934,  1935,
    1910,  2147,  2148,  2149,  2150,  2151,  2152,  2153,  1072,  1073,
     343,     0,     0,  1607,     0,     0,     0,     0,  1069,     0,
     400,     0,   398,     0,     0,   389,   390,     0,   394,   382,
    1674,     0,  1677,     0,   383,   387,  1815,  1816,     0,  1120,
       0,     0,   549,   548,     0,   504,     0,  1601,     0,     0,
       0,  1575,     0,  1578,  1041,     0,  1046,     0,     0,     0,
    1049,  2091,  1638,  1647,  1672,  1673,  1654,  1655,  1656,  1668,
    1667,  1681,  1679,  1640,  1680,  1052,  1062,     0,   273,   270,
     275,   225,     0,   229,   227,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     401,   415,   416,   411,   412,   413,   414,   407,   408,   410,
     409,   417,  1127,  1114,     0,     0,   554,   553,  1669,  1670,
    1663,  1676,  1641,   560,   559,  1070,     0,     0,     0,     0,
     454,     0,  1741,  1740,  1739,  2105,  2106,  1169,     0,  1449,
       0,  1631,  1623,     0,     0,   744,   745,     0,     0,     0,
       0,     0,   526,   661,   660,  2095,     0,  2098,     0,  2097,
    1615,  1616,     0,     0,  1551,     0,   531,   530,  1657,  1665,
     676,   673,     0,  1743,  1745,  1742,  1744,  1173,     0,  1467,
       0,  1834,  1835,  1151,  1129,  1156,  1131,     0,     0,     0,
       0,     0,  1134,  1666,  2079,  1146,  1143,     0,     0,     0,
     237,   234,   239,   249,   246,   251,   261,   258,   263,  1034,
    1039,     0,   175,   176,   169,   172,   173,   174,   168,   166,
    1858,  1859,  1860,  1861,  1871,  1872,     0,  1757,  1867,  1868,
    1750,  1752,  1177,     0,  1481,   285,  1162,  1164,  1166,  1691,
    1692,     0,     0,  1697,   146,   141,     0,   145,     0,     0,
       0,     0,     0,     0,     0,  1702,  1703,  1704,   152,   151,
    1695,   202,   201,  1905,  1906,  1907,  1908,  1909,  1911,  1912,
    1913,  1914,  1915,  1916,  1917,  1918,  1919,  1920,     0,     0,
    1921,  1922,  1923,     0,     0,     0,  1927,  1928,     0,  1930,
    1931,  1932,  1933,  1936,  1937,  1938,  1394,  1395,  1683,  1693,
    1711,  1712,  1714,   812,   811,  1632,     0,  1636,     0,   177,
    1960,  1961,  1962,  1963,  1964,  1965,  1966,  1967,  1968,     0,
    1970,  1971,  1972,  1973,  1974,  1977,  1979,  1980,  1981,  1982,
    1983,  1994,  1991,  2005,  2006,  2010,  1984,  1987,  1988,  1989,
    1990,  1992,  1993,  1995,  1996,  1997,  1998,  1999,  2000,  2001,
    2002,  2003,  2004,  2007,  2008,  2009,  2041,  1263,  1266,     0,
    2077,  2037,  2066,  2040,  2038,  2070,  2072,  2071,  2073,  2075,
    2057,  1317,  1320,     0,  1281,  1284,  1985,  1986,  2042,  2043,
    2044,  2045,  2046,  2047,  2048,  2049,  2050,  2051,  2052,  2053,
    2054,  2055,  2056,  1389,  1392,  1958,  1959,  2058,  1350,  1353,
    2062,  2064,  2063,  2060,  1339,  1342,  1327,  1330,  2078,  1299,
    1302,     0,     0,     0,   473,   474,     0,   466,     0,     0,
    2184,  2014,  2013,  2015,  2016,  2017,  2018,   489,   488,     0,
       0,   359,  2023,  2022,   498,   497,  1116,  1115,  2026,  2027,
    2028,  2030,   666,   665,  2102,  2103,   655,   653,   654,  2133,
    2109,  2115,  2114,  2119,  2125,  2126,  2124,  2127,  2132,  2134,
     636,     0,   638,  2108,  2113,  2112,  2118,  2121,  2122,  2120,
    2123,   623,     0,   625,     0,     0,     0,   826,   821,     0,
       0,     0,   867,     0,     0,     0,   885,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   298,   310,   311,
     306,   307,   308,   309,   301,   302,   304,   303,   305,     0,
       0,     0,     0,     0,   880,   881,   882,   883,     0,   886,
     830,     0,  2160,  2161,  2163,     0,  2167,  2165,     0,  1206,
    1214,  1558,     0,   287,   293,     0,     0,     0,  1765,     0,
    1183,  1068,  1066,   350,     0,     0,     0,   747,   748,     0,
    2175,     0,  2179,  2177,     0,  1019,     0,     0,  1029,     0,
     894,   761,   341,   757,   341,     0,     0,     0,     0,     0,
     779,     0,     0,     0,  1527,   824,   887,   834,     0,   739,
     740,     0,     0,     0,     0,  1523,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   386,     0,
       0,  1117,     0,     0,  1110,     0,  1122,     0,     0,     0,
       0,     0,  1584,     0,     0,     0,     0,     0,  1047,     0,
    1064,   276,   223,     0,     0,   439,   440,   419,   420,   423,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   449,
     424,     0,   437,   438,     0,   446,     0,   448,   450,     0,
     451,     0,     0,     0,     0,     0,     0,     0,  1171,     0,
    1628,  1630,  1627,     0,   527,   521,   514,     0,   524,     0,
       0,     0,     0,  1550,     0,   675,  1175,     0,  1133,  1137,
    1138,  1139,  1140,  1145,     0,     0,   240,   252,   264,   171,
       0,     0,  1179,     0,  2169,     0,  2171,  2173,     0,   142,
     143,  1684,  1686,  1685,     0,  1689,  1690,   159,   158,  2185,
    2187,  2186,   738,   737,     0,     0,     0,     0,  1637,     0,
       0,     0,     0,  1322,     0,     0,   469,   465,     0,  2182,
       0,     0,   358,   637,   624,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   855,   856,   864,   862,   857,
     860,   859,   865,   863,   861,   858,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   326,   327,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   336,
     324,   325,     0,   333,     0,   335,   339,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   843,   844,   852,   850,
     845,   848,   847,   853,   851,   849,   846,     0,     0,  2164,
       0,  2168,  2166,  2154,   294,  1948,   513,     0,     0,     0,
    1756,     0,  1754,  1653,  2176,  2180,  2178,     0,     0,  1778,
       0,     0,  1779,   342,     0,     0,     0,   763,     0,     0,
       0,     0,   777,   773,     0,     0,     0,     0,     0,     0,
       0,   356,     0,     0,   345,  1599,  1600,     0,     0,     0,
    2155,     0,     0,     0,   399,   397,     0,     0,   393,   378,
       0,   380,     0,  1124,     0,     0,     0,     0,     0,     0,
       0,  1586,  1576,     0,  1044,     0,  1050,     0,     0,     0,
       0,     0,     0,     0,   444,     0,     0,     0,   460,     0,
       0,  1629,     0,     0,   525,  2096,  2099,     0,  1553,  2025,
       0,     0,  2157,  2156,  1758,  2170,  2172,  2174,   144,  1688,
    1924,  1925,  1926,  1929,     0,     0,     0,     0,   180,  1969,
       0,   470,     0,  2019,     0,  2183,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1767,     0,     0,   868,     0,     0,   886,     0,     0,     0,
       0,     0,   331,  1724,  1722,  1723,   879,   873,     0,     0,
       0,     0,     0,     0,  2162,     0,     0,   509,     0,   825,
     889,   838,     0,  1766,   347,   753,  1016,   752,  1017,  1018,
    1020,  1025,     0,  1026,  1027,  1030,   341,   341,   341,     0,
       0,   785,     0,   774,   789,     0,     0,   888,   836,     0,
     352,  1522,   344,     0,  1611,     0,     0,  1608,     0,   132,
       0,   396,   453,  1118,     0,     0,   505,  1604,     0,     0,
       0,     0,     0,  1577,  1048,   441,   442,     0,   425,     0,
       0,     0,   452,  1544,     0,     0,   459,   455,     0,   523,
       0,     0,   208,     0,     0,     0,     0,     0,     0,     0,
     179,     0,   124,     0,     0,   468,  2181,   362,  1715,  1719,
    1721,  1728,  1717,  1726,   790,   791,   793,   794,   796,   792,
     795,   797,   798,  1716,  1725,  1720,   854,   833,     0,     0,
     869,     0,     0,   887,     0,   328,   329,     0,     0,   340,
    1718,  1727,   842,   829,     0,     0,   512,   508,     0,     0,
       0,     0,     0,     0,  1023,     0,   767,   764,   768,     0,
     783,   778,     0,     0,     0,     0,   355,     0,     0,     0,
       0,   129,   130,   135,     0,   388,     0,     0,     0,  2158,
       0,  1585,     0,     0,     0,     0,   418,   462,   461,     0,
    1554,     0,   140,   206,   214,   211,   138,     0,     0,     0,
       0,     0,     0,     0,     0,   178,     0,   121,   122,   127,
       0,     0,     0,   479,     0,   480,   481,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   874,     0,     0,   511,
       0,     0,   520,     0,     0,   890,   840,     0,     0,  1028,
       0,   341,     0,   875,     0,     0,     0,     0,     0,     0,
     131,   133,   395,     0,     0,     0,     0,   426,   427,   445,
     447,  1624,   207,   212,   209,   217,  1633,     0,   183,     0,
       0,     0,     0,     0,     0,     0,     0,   123,   125,     0,
       0,     0,     0,   471,     0,   482,     0,     0,   871,     0,
     870,   889,     0,   888,   332,   334,   831,   510,     0,     0,
    1548,     0,   519,     0,     0,     0,     0,  1021,  1022,  1024,
       0,   769,   784,   835,     0,     0,  1598,  1612,  1613,   134,
     463,     0,  1605,  1606,   213,   210,   215,     0,  2211,  2210,
     194,     0,     0,   195,   196,     0,     0,     0,   181,   199,
     126,     0,     0,     0,     0,     0,     0,   478,     0,     0,
       0,   517,     0,   518,     0,   877,     0,     0,     0,   341,
     341,   876,     0,  2159,   216,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   198,     0,     0,     0,     0,     0,
       0,   476,     0,   872,   890,     0,   516,   839,     0,     0,
     765,   770,   837,     0,   192,   193,     0,     0,   182,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   472,
     477,   475,   515,   878,     0,     0,     0,     0,     0,   188,
       0,     0,   189,   190,     0,     0,     0,   483,     0,   841,
     771,     0,     0,     0,     0,     0,     0,     0,   484,   485,
       0,   197,     0,   184,     0,   186,   187,   200,   486,     0,
     191,     0,     0,   185
  };

  const short
  parser::yypgoto_[] =
  {
   -3403, -3403,  4024, -3403, -3403, -3403, -3403, -3403, -3403, -3403,
   -3403, -3403, -3403, -3403, -3403, -3403, -3403,  1820, -3403, -3403,
    1804, -3403, -3403, -3403,  1060, -3403, -3403,  1848, -3403, -3403,
   -3403, -3403,   387, -3403, -2338, -3403, -3403, -2206, -3403, -3403,
      29, -3403, -3403,  1806,   398, -3403, -3403, -3403, -3403, -3403,
    -881, -3403,  -355, -3403, -3403, -3403, -3403, -3403, -3403, -3403,
   -3403, -3403, -3403, -3403,   611, -3403, -3403, -2014, -3403, -3403,
   -3403,  -290,  -585, -3403,  1360,  -865, -3403, -3403, -3403, -3403,
    1673, -3403, -3403, -3403,  2127,  2077, -3403, -3403, -3403, -3403,
     729, -2019, -3403,   740,   887, -3403, -3403, -1995, -3403,  1215,
   -1138,  -310, -3403, -3403, -3403,  1692, -3403, -3403, -3403,    38,
      39, -3403,   168, -3403, -3403, -3403,  1697, -3403, -3403,  1686,
   -3403,  1315,   744, -3403,   211, -3403,  1214, -3403, -3403,  -236,
   -3403, -3403,  2283, -3403, -3403,  2092, -3403, -3403,  -238, -3403,
   -3403,  -206,  -399, -3403,  1668, -3403, -3403,  1676, -3403, -3403,
   -3403,  3788,  1689, -3403, -3403,  1971, -3403, -3403,  1698, -3403,
   -3403,  -230,  1957,    89, -1848, -1994,  2693,  -676, -3403, -1239,
   -3403, -3403, -3403,  3408, -3403, -3403, -3402, -3403,  1421,  -819,
   -3403, -3403,  3415, -3403, -3403,  3409, -3403, -3222, -3403, -1709,
   -3403, -3403, -3403,  1827, -3403, -3403,  3791, -3403, -3403, -3403,
   -3403, -3403, -3403, -3403, -3403, -3403, -3318,   401, -3403,   421,
   -3403,  3793, -3403, -3155,   582, -3403,  3796, -3403, -3403,  2209,
     555, -3403,   182, -3403,   550, -3403, -3403, -3403, -3403, -3403,
   -3403, -3403, -3403, -3403,  3267, -3403, -3403, -3403, -3403, -3403,
    2091, -3403, -3403, -3403, -3403, -3403, -3403,  2154, -3403, -3403,
     -94,   418,  -632, -3403,  2131, -3403, -3403, -3403, -3403, -3403,
   -3403, -3403,  3006, -3403, -3403, -3403,  1966, -3403,  1984, -3403,
    -294, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403,
   -3403,   -86,  2344, -3403, -3403,  2342, -3403, -3403,  1809, -3403,
   -3403,  1798, -3403, -3403,  1765, -3403, -3403,  1802, -3403, -3403,
    1770, -3403, -3403,  1774, -3403, -3403,  1786, -3403, -3403,  1807,
   -3403, -3403,  1878, -3403,  2037, -3403,  2014, -3403,  1960, -3403,
    2339, -3403, -3403, -3403,  3423, -3403, -3403,  2232, -3403, -3403,
    2360, -3403, -3403, -3403,  3749, -3403, -3403, -3403,  2043, -3403,
    2380, -3403, -3403,  2169, -3403,  1410,  -968, -3403, -3403,  2284,
   -3403, -3403, -3131, -3403, -3403,  3356, -3403,  1448,  -931, -3403,
    2051, -3403, -3403,   546, -1178,  2072, -3403,   531, -1452, -3403,
    -125, -3403, -3403, -3403, -3403, -3403,  -165,  -141, -3403,  -247,
   -3403, -3403, -3403,  -213,  -163, -3403, -3403, -3403, -3403,   502,
   -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403,
   -3403, -3403, -3403, -3403,  -172, -3403, -3403, -3403, -3403, -3403,
   -3403,  -243, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403,
   -3403, -3403,  -173, -3403, -3403, -3403,  -190,   -87,  -250, -3403,
   -3403, -3403,  -166, -3403, -3403,  -240, -3403, -3403, -3403, -3403,
   -3008, -2945, -2874, -3403, -3403, -2866, -2823, -3403, -3403, -3403,
   -2821, -2810, -3403, -3403,  -179,  -254, -3403,  -266,  -170, -3403,
   -3403,  -298, -3403, -3403, -3403, -3403, -3403, -3403,   178, -3403,
   -3403, -3403, -3403, -3403,   180, -3403, -3403,  -275, -3403, -1649,
   -2235,  1767, -3403,  -257, -3403,  -364, -3403, -3403, -3403, -3403,
   -3403,    70, -3403, -3403, -3403, -3403,  -249,  -129, -3403, -3403,
   -3403, -3403,  -111, -3403, -3403, -3403, -3403,   110, -3403,  -112,
   -3403, -3403, -3403, -3403,  -192,  -234, -3403, -3403,   -90,   -78,
    -235, -3403,  -262, -3403,  -220, -3403,    61,    94,  -149,   -24,
     -75, -3403, -3403, -3403, -3403,   -64,   -51, -3403,  -168,   -28,
    -156,   -27, -3403,  -284, -3403,  -132,  -109,   -26,   -21,   -13,
     -97,   -83,   -69,   -65, -3403, -3403, -3403, -3403, -3403, -3403,
   -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403,
   -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403,
   -3403, -3403, -3403, -3403,  -248,  -177, -3403, -3403, -3403, -3403,
   -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403,
    -354, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403,
   -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403,
   -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403,  -346,  -341,
   -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403,   131,  -252,
   -3403, -3403, -3403,  -375,  -370,  -369,  -358,  -330, -3403, -3403,
   -3403, -3403, -3403,  -324,  -323,  -320, -3403,  -315, -3403, -3403,
   -3403,  -288,  -265,  -256, -3403, -3403, -3403, -3403, -3403, -3403,
   -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403,
   -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403,
   -3403,  -386, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403,
     124,  -283, -3403, -3403, -3403, -3403, -3403,     7,    11,    31,
   -3403,    85,   149, -3403,  -212,  -241, -3403, -3403, -3403, -3403,
   -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403,
   -3403,   -76, -3403, -3403, -3403, -3403, -3403, -3403, -3403,  -371,
    -350,  -359, -3403, -3403,  -245,  -205,  -198,  -197,  -398,  -174,
    -135, -3403, -3403,  -260,  -337, -3403, -3403, -3403, -3403, -3403,
     -48, -3403,    34,    54, -3403, -3403, -3403, -3403, -3403, -3403,
    -164,  -153, -3403, -3403,  -261,   -56, -3403, -3403, -3403, -3403,
   -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403,
   -3403, -3403, -3403, -3403, -3403, -3403, -3403,   -43,   -40,   -32,
     -20,   -11,    -6, -3403, -3403, -3403, -3403, -3403, -3403, -3403,
   -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -3403, -1542,
   -2414, -3403, -1560, -3403, -2114, -3403, -1713, -3403,   514, -3403,
   -2318,     0, -2483
  };

  const short
  parser::yydefgoto_[] =
  {
      -1,   132,   133,   134,   135,   136,  3209,  3921,   137,  2859,
    3878,   138,  3049,  3048,   139,  3096,  1344,  1345,   140,  1353,
    1354,   141,  1349,  2345,  2346,   142,  1291,  1292,  3061,   143,
    3580,  3787,  3788,  4190,  4191,  4192,  4019,  4020,  4021,  4158,
    4159,   144,  1359,  1360,  3911,   145,   146,   147,   148,   149,
    2163,  1076,  1077,   369,   371,   373,   323,   377,   383,   150,
     517,  2638,   151,   152,  3693,  2597,  3647,  3696,   153,   154,
     155,   589,   590,   156,   871,   872,   157,   158,  1734,  2516,
    2517,  3279,   159,   860,   861,   956,   957,   160,   944,  3463,
    2105,  2106,  2861,  2862,  2107,  2210,  3511,  2108,   161,  1150,
    1151,  1152,   162,   420,  2505,  2506,  3923,  4165,  3925,  4166,
    4034,  4035,  4036,   163,   164,  1726,  1727,   165,  1738,  1739,
     166,   971,  3677,   167,  4051,  2244,  2245,   168,  1202,   527,
     169,   528,   529,   170,   967,   968,   171,  1116,  1185,   172,
    1129,  1186,  1773,   173,  1843,  1844,   174,  1774,  1775,   175,
     176,  1756,  1757,   177,  1187,  1188,   178,  1748,  1749,   179,
    1207,  1243,  1209,  3573,  3574,  2827,  1895,  2723,  2724,  2725,
    3849,   180,   821,   822,   823,  2793,  3697,   181,   832,   833,
     182,   827,   828,   183,   852,   853,  3943,  2794,   850,   851,
     184,   185,  1454,  1455,   186,   187,   188,  1859,   189,  2599,
    3668,  2547,  3707,  3985,  3971,  4126,  3655,  3656,  3604,  3605,
     190,   191,   192,  3373,  3374,   193,   194,   195,   696,   697,
    3415,  3416,  3974,  3975,  3418,  3419,   196,   375,  1278,   197,
     376,  1280,   198,   984,   985,   199,   200,   987,   201,  1011,
    1012,   202,   203,   204,   205,   206,   207,   899,   900,   208,
     306,  1896,  3288,  3462,   307,   209,   327,  2208,   210,   211,
     212,  1250,  1251,   213,   214,  1254,  1255,  1238,  1239,  1244,
    1256,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     458,   459,   460,   224,   482,   483,   225,  1514,  1515,   226,
    1597,  1598,   227,  1703,  1704,   228,  1579,  1580,   229,  1696,
    1697,   230,  1685,  1686,   231,  1671,  1672,   232,  1630,  1631,
     233,   234,  1395,  1396,  1160,  1161,  1220,  1221,  1311,  1312,
     568,   569,   235,   876,   877,   236,   862,   863,   237,   543,
     544,   238,   239,   551,   552,   240,  1201,  2258,  2259,   241,
     495,   496,   242,   980,   981,   978,   979,  2889,   243,   841,
     842,   244,  3718,   245,   973,   974,   246,   938,   939,   247,
    1194,  1195,   248,  1180,  1181,  2990,   249,  1463,  1464,  1013,
    1014,  1015,  1132,  1133,  1134,   958,  1016,  1017,  1018,  1019,
    1020,  1021,  1022,  1023,  1024,  1025,  1026,  1027,  1210,  1028,
     844,   845,   846,   531,  1135,  1211,  1257,  1029,  1030,  1136,
    1137,   532,  1031,   959,   533,  1139,   960,  1032,  1033,  1034,
    1035,  1036,  1456,  2347,  2348,  2349,  2350,  3101,  2351,  1346,
    1347,  1457,   461,  1361,  1362,  1348,  1781,  1782,   462,  1355,
    1356,  1357,  1038,   709,   710,   463,  1458,  1459,   711,  1460,
    3657,  3658,  3659,  3660,  3609,  3661,  3662,  3375,  3376,  3377,
    3663,  3664,  3665,  3614,   464,   465,   714,   715,  1039,   717,
    1313,  1166,  1167,  1168,  1226,  1227,  1228,  1229,  1040,   570,
    1314,  1315,   571,  1316,  1041,   572,  1317,  1169,   573,  3398,
    3399,  1860,   484,   720,   547,   721,   722,   723,   724,   725,
     726,  1788,   728,   729,   730,   731,  1789,  1790,   734,   735,
     736,   737,  1791,   739,   740,   741,   742,  1792,  1140,  1793,
     745,   746,   747,   748,  1043,   485,   751,   752,  1044,   501,
    1045,   756,   757,   758,   502,   962,  1046,  1047,   466,   467,
     505,   763,   764,   765,   766,   468,   469,   769,   506,  1798,
    1048,  1049,   774,  1246,  1241,  1050,  1051,  1802,  1803,  1804,
    1052,  1053,  1054,  1055,  1318,   574,  1319,  1320,  1321,   575,
     576,  1322,  1323,   577,   578,   579,  1324,  1325,   580,  1326,
    1327,  1328,  1329,   581,  1330,   582,   470,   471,   472,   473,
     474,   475,   476,   486,  1056,  1057,   786,   787,   788,   789,
     790,   791,   792,   793,   794,  1413,  1414,  1415,  1416,  1417,
     913,  1419,  1420,  1421,  1422,  1423,  1424,  1425,  1426,  1427,
    1428,  1429,  1430,  1431,  1432,  1433,  1434,  1435,  1436,  1437,
    1438,  1439,  1440,  1441,   914,  1442,  1443,  1444,   915,   916,
     917,   918,   919,   535,   536,   537,   538,   548,   507,   795,
    1214,  1673,  1674,  1518,  1519,  1520,  1521,  1522,  1523,  1524,
    1525,  1526,  1527,  1528,  1529,  1530,  1531,  1532,  1533,  1534,
    1535,  1536,  1537,  1538,  1647,  1539,  1540,  1541,  1542,  1543,
    1544,  1545,  1546,  1547,  1548,  1549,  1550,  1551,  1552,  1553,
    1554,  1555,  1556,  1557,  1558,  1559,  1560,  1561,  1562,  1058,
    1059,  1728,  1729,  1730,  1731,  1732,  1733,  1741,  1742,  1743,
    1811,  1247,  1750,  1751,  1752,  1753,   797,   508,   509,  1812,
     801,  1581,  1582,  1650,  1583,  1563,  1652,  1653,  1654,  1655,
    1656,  1657,  1658,  1659,  1660,  1661,  1662,  1663,  1664,  1665,
    1666,  1584,  1678,  1679,  1690,  1691,  1692,  1693,  1694,  1585,
    1586,  1587,  1701,  1606,  1588,  1589,  1590,  1591,  3666,  1593,
    1594,  1718,  1258,   802,   922,   803,   804,   805,   806,   807,
    1061,  1062,  1814,  1815,  1143,  1196,  1197,  1198,  1199,  1200,
    1144,  1145,  1758,  1759,  1176,  1177,   583,  1845,  1816,  1846,
    1817,  1847,  1818,  1848,  1819,  1849,  1820,  1850,  1821,  1851,
    1822,  1852,  1823,  1824,  1825,  1826,  1827,  1063,  1064,  1065,
    1066,  1067,  1068,   923,   924,   925,   926,   927,   928,   929,
     930,   931,   932,   933,   934,  2617,  2856,  3067,  3739,  3383,
    3384,  2612,  2613,  3092,  3093,  2734,  3270,  3590,  3271,  3129,
    3130,  1897,  4150
  };

  const short
  parser::yytable_[] =
  {
     250,   970,  2238,   258,  1962,   935,  2069,  2097,  1592,   258,
    2133,  2401,  2228,  2046,   258,  1267,   498,  1272,   534,  1277,
     713,  1715,  2792,   258,   707,   732,   784,   700,   905,   868,
    1842,   703,   911,  1408,   921,   308,  1635,  1740,  1603,   755,
     750,  1636,  1637,  1418,   258,   258,   324,   903,  1709,   258,
    1605,  1445,   258,  1638,   759,   258,  1446,  1225,  1700,  1604,
    1448,   701,   258,   258,   941,   258,  1245,   258,   982,  1710,
     258,   370,   372,   374,  1240,  1242,   378,   499,   258,   384,
    1230,  1639,   749,   497,   705,  2835,  2865,  1640,  1641,  1163,
    1010,  1642,   257,  1117,  1232,   712,  1643,   785,   267,  1164,
    1213,   704,   910,   275,   716,  1223,   770,   503,   708,   699,
    2866,   702,   287,   258,  1203,  1224,   865,   847,   772,  1171,
    1331,   545,  1208,  1644,   906,   760,   912,  1130,   848,   901,
     258,  1403,   250,   321,   322,  1411,   530,  1447,   329,   983,
    1407,   334,   775,  1402,   340,   733,  1645,  1399,  1409,   698,
    1397,   353,   356,   902,   361,  1646,   365,  1400,  1119,   367,
    1165,  1138,   744,   738,  1607,   776,  1162,   382,   481,  1517,
    1651,  1174,  1119,  1138,  1711,   587,   588,   780,  1783,  1783,
    1809,  1809,  1222,   909,   753,  1779,  1779,   706,  1784,  1784,
    1172,   781,  3274,  1795,  1795,  2167,   754,  1601,  3387,   762,
    3695,  2949,   407,  1689,  1608,   782,   942,  1707,  1131,   783,
     767,  1609,  1610,   966,  1712,  1777,  1777,  1937,  1401,   431,
    1131,  1713,  1714,   768,  1398,   530,   808,  1404,  2098,  1412,
    1516,   811,   504,  1037,   812,  1611,  1794,  1794,  1632,  3106,
    3107,  1147,   813,  2669,  2670,  1716,   771,   773,   777,  1461,
     761,  1810,  1810,   778,   814,  1780,  1780,   512,  1785,  1785,
    3385,   779,  1633,   815,   553,  1778,  1778,   512,   816,   308,
     308,   591,  1799,  1799,  1612,   512,   824,   829,   834,  1796,
    1796,   798,  3555,   854,  1717,   799,  3455,   512,   870,   873,
    2735,  2736,   878,  3794,  1943,   591,  1800,  1800,   940,  1233,
     308,  3469,  2668,  1776,  1776,   800,  2030,   308,   809,  2063,
    2065,  2114,  2121,  3411,   975,  1173,  3606,   986,   988,  1801,
    1801,   512,   512,  1073,  2036,  1332,  2695,  1113,   810,   512,
    2156,  1805,  1805,  1602,   512,   308,  2215,  1677,  3736,  3471,
     512,  1182,  2222,  1708,   727,  1806,  1806,  3382,  2248,  2261,
    1962,  1080,   435,   512,  3409,   439,   512,   251,  2265,  1807,
    1807,   512,  2626,  1808,  1808,   512,   500,   512,  2611,  1265,
    3836,  1270,  3382,  1275,  1462,  1279,  1281,  1284,  2276,  3607,
    1813,  1813,   512,  1336,   743,  1828,  1828,  1634,  1829,  1829,
    1042,  3836,  1080,   549,  1141,  1363,  1830,  1830,   796,  1465,
    1081,  1467,  2278,  4200,  1797,  1797,  1141,   512,  1831,  1831,
    2288,  2317,  2338,  2609,  2693,  2355,  2697,  1832,  1832,  2358,
    2398,  2513,  1833,  1833,  2519,   920,  2525,  1142,  1261,  2529,
    4002,   512,  2692,  1285,  2696,  1858,  1861,  1865,  1869,  1142,
    1901,  1081,  2732,   585,  1060,  3379,  3160,   253,  3440,  1170,
    3608,  2529,   718,  3919,   719,  3977,  4200,  3837,  3610,  3405,
    4089,  1148,  1212,  1074,   866,   259,   867,  -867,  4219,  3776,
    1175,  3867,   907,  1754,   908,   554,   555,  2552,  3837,   263,
    3103,  3651,   556,  3679,  3679,  3688,  1231,   557,   558,  3691,
    3730,   594,   879,   595,  1599,  3753,  1648,  3679,  1675,  3806,
    1687,  3611,  1698,  3612,  1705,  3821,  3830,  1410,  2247,  3897,
    1927,  3651,  3832,  3651,  3613,  3965,  3830,  4058,  2053,  3830,
    1266,  1341,  -869,  4055,  1080,  4148,  1271,  1342,  3556,  1080,
    3381,  1350,  3651,  3651,  3830,  3830,  3651,  3830,  3266,  3785,
     976,  2977,  1276,  2053,  1946,  2742,  2743,  2159,  3983,   559,
    1945,  3865,   262,  1449,  1450,  3553,  2293,   268,  1600,  -871,
    1649,  2978,  1676,   325,  1688,  2297,  1699,  2132,  1706,  3171,
     560,  3772,  3467,  1081,  4149,  1405,  2284,  1406,  1081,  3773,
    1451,  1452,  2501,  2301,   513,  1293,  1294,  1351,  1080,   591,
    1295,  1296,  1297,  3280,  4148,  3226,  2918,  1298,  1299,  3474,
     612,   613,  3743,  1300,  1301,   510,  1786,  1786,  1787,  1787,
     561,   562,  1286,  3227,  2124,  3078,  3079,  3382,   264,  3786,
     343,  3050,  3262,  3715,  3716,  -443,  1287,  3516,  2998,   510,
     326,  2209,  2999,  2876,   619,  3000,  1080,  1081,  3263,   269,
    2340,   276,    21,  4149,   450,   622,  2770,  2771,   880,  2783,
     270,  3053,   277,  1080,  2341,   282,  1148,  2241,  2242,  1302,
    1568,  2125,  2502,  3449,  2503,  2504,    21,  3450,   450,  1148,
     514,   515,   516,  1080,  3077,  4119,  3735,  2720,  2227,   283,
    1303,  2877,   284,  -330,   288,  1081,  3150,  3151,  2772,  2209,
     291,  3760,  3056,   292,   491,   297,   451,  1080,  2241,  2242,
    4014,   563,  1081,  1571,  3019,  2705,   977,  3889,  4083,   300,
    3026,  3890,   301,  1080,  1216,  1577,  1695,  1288,  2160,  2161,
    1304,  1305,  1081,  3595,  3596,  3597,  3598,  3599,  3600,  3601,
    3602,   335,   664,   977,   313,  3206,  4124,   666,  2706,  2707,
    1453,  1080,  1249,   314,  3215,  1112,  1081,  3218,  4135,   317,
     672,  2784,   318,   881,   882,  3915,  3916,   260,   261,  2515,
    1075,   492,  1081,   541,   546,   977,   669,   670,   977,  1289,
    2783,  2054,  1755,  1149,   348,   883,   676,  4210,  2785,  2786,
    2787,   362,  2763,   843,  4090,  4091,  3380,  1262,   864,    40,
    1081,   366,  4220,  4221,   379,   542,   904,  2342,  3606,   391,
    3618,  3554,  4119,  3595,  3653,  3597,  3654,  3599,  3600,  3601,
    3602,  1306,  3868,    40,  1938,  4053,  1307,  1075,  2032,  2744,
    2033,   824,  3777,  1075,  2099,  2038,  2039,   829,   683,  4065,
    2043,  2044,   834,  1118,   550,  2241,  2242,   564,  4130,  1075,
    1080,  3551,   884,   885,  1075,  3329,  3785,  1118,    21,  1080,
     392,  1217,   854,  1075,  3161,  3162,   452,  4068,  4069,  3386,
    4209,  3607,  1075,  1156,  4056,   541,   252,  4075,   565,  4076,
    2119,   873,  2784,   456,   457,   422,   878,  3717,  3172,  3173,
    1075,  3557,  1290,  1157,  3671,  3456,  1343,   492,  2165,  1081,
    1870,  1944,  3795,  1075,  2788,  1218,  1352,  3470,  1081,  2785,
    2786,  2787,  4144,  2031,   969,    69,  2064,  2066,  2115,  2122,
    2294,  2295,  3412,   510,   886,  2298,  2299,  2343,  1075,  2037,
    2302,  2303,  3603,  3917,  2610,    21,  3786,  2157,   436,    69,
    1157,  2501,  3608,  2216,  3472,   591,  1871,   440,   940,  2223,
    3610,  2610,  2721,  2722,  1113,  2249,  2262,  1158,  1075,  1872,
      21,   586,  2733,   510,  3504,  2266,   254,  3888,  3283,  2241,
    2242,  1873,  1874,  2824,   308,  3838,   969,  3669,  1149,  2123,
    4177,  3672,  2708,   975,  3302,  2277,  3282,   393,  1308,  2241,
    2242,  1149,  3315,  3611,   986,  3612,  3885,  2140,   510,  1075,
      21,  2789,  3301,   394,  1158,    40,  3613,  1075,  4201,  2279,
    3314,  1875,  3603,  2241,  2242,  1075,  2344,  2289,  2318,  2339,
     510,  2502,  2356,  2503,  2504,  2788,  2359,  2399,  2514,  2241,
    2242,  2520,   424,  2526,   395,    21,  2530,  1309,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,    21,  2531, -2207,
    1894,  4231,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,  2158,    40,   432,  2553,  2164,  2164,  3104,  3652,   437,
    3680,  3682,  3689,  4252,  3128,   438,  3692,  3731,  1113,  1113,
    3685,   441,  3754,   477,  3774,   550,  3807,    40,   566,  2824,
     567,   592,  3822,  3831, -2207,   510,  3898,   849,  3964,  1113,
    3982,    69,  2789,  4047,  4059,  3506,  4064,   887,   888,   889,
     890,   891,   892,   893,   894,   895,   896,   897,   898,  4123,
    4134,  4176,  4182,  4208,  4234,   875,  2979,    40,  2211,  2212,
    2213, -2207,    21,   398,  2790,   835,  2241,  2242,  2225,  2226,
     401,  3642,  2660,  2661,  2662,  1876,  1877,  1080,   271,   272,
    1080,  1878,  1879,  1880,  1881,  1882,  1883,  1884,  1885,  1886,
    1887,  1888,    40,   404,  3644,  1889,  1890,  1891,  1892,  1667,
    1182,   421,  1722,   423,  1080,   278,   279,   510,    69,  1235,
    1735,  1736,   874,  1737,    40,  1576,   936,  3570,  3407,  1075,
     425,  2260,  2205,  2206,  3532,  2207,  1081,   426,  1310,  1081,
     427,  2243,   428,    69,  1110,   280,   281,  1219,  1080,  3427,
    2825,  2826,   510,   429,    21,  3408,  1720,  2602,  3793,   937,
    2605,  3001,   679,  1081,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,    69,   943,  3527,  2628,  1159,   969,    21,
    2663,  2664,  2665,  2292,  2666,  2790,   972,  1081,  2296,   961,
    4120,  4121,   963,  2300,  1079,  1576,  2593,  2594,  2306,  2595,
    2309,  2921,  2310,  1080,  2924,  1078,  3575,  3576,    69,    40,
    3577,  3444,  2197,  2198,  2199,  2200,  2201,  2202,  2203,  2204,
    2205,  2206,  1668,  2207,  2203,  2204,  2205,  2206,  1114,  2207,
      69,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
    3823,  1153,  1081,  1184,  2330,  1337,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,  2867,  2825,  3737,   289,   290,
    1080,  1183,  1112,   293,   294,  3409,   295,   296,  4127,   298,
     299,    40,  1669,  2746,  2747,  2748,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,  1249,  3880,  4140,  4121,  1338,
    2832,  2720,  1339,  1080,  1340,    69,    40,  1893,  3694,  1081,
    1719,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
    1466,  1236,  1237,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,  1081,  2197,  2198,  2199,  2200,  2201,  2202,  2203,
    2204,  2205,  2206,  1465,  2207,  2403,  2241,  2242,   539,  1564,
     540,   855,   856,   857,   858,   859,  3738,  1721,  1854,  2629,
    2630,  2631,  2632,  2633,  2634,  2166,  1902,    69,  1903,  2585,
    2586,  2587,  2588,  2589,  2590,  2591,  2592,  2593,  2594,  1904,
    2595,  1905,  1722,  1723,  1724,  1725,  1112,  1112,  2749,  2750,
    3675,  1906,  2585,  2586,  2587,  2588,  2589,  2590,  2591,  2592,
    2593,  2594,    69,  2595,  2241,  2242,  1907,  1112,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   836,  2766,  2767,
    3683,  3505,  1080,  2753,  2754,  2755,  3589,  2585,  2586,  2587,
    2588,  2589,  2590,  2591,  2592,  2593,  2594,  1908,  2595,  3002,
    2663,  2664,  2665,  1909,  2666,  1910,  3854,  1911,  2663,  2664,
    2665,  1912,  2666,  2982,  2983,  3729,  2756,  2757,  2758,  2241,
    2242,  2663,  2664,  2665,  1913,  2666,  3071,  3072,  3073,  2142,
    1914,  1081,  1915,  2591,  2592,  2593,  2594,  3765,  2595,  1917,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,  2585,
    2586,  2587,  2588,  2589,  2590,  2591,  2592,  2593,  2594,  1916,
    2595,  1918,  1568,   302,   303,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,  1919,   602,  2721,  2722,  1189,  1190,
    3370,  3371,  3372,  2197,  2198,  2199,  2200,  2201,  2202,  2203,
    2204,  2205,  2206,   837,  2207,  1571,   498,  1744,  1745,  1746,
    1747,   309,   310,  1920,   534,  1921,   541,  1922,   492,  1923,
     541,  1080,  3766,  4214,  4215,   311,   312,  1670,  1578,  2241,
    2242,  1924,  3507,  2865,  2197,  2198,  2199,  2200,  2201,  2202,
    2203,  2204,  2205,  2206,  1925,  2207,  2280,  2281,  2282,  2283,
    2667,  1926,   542,  1928,   612,   613,  4239,  2866,  2694,   315,
     316,  1929,   330,   331,   332,   333,  1948,   499,  3643,   838,
    1081,  3076,  1930,   497,  4253,   336,   337,   341,   342,  1931,
    3851,   344,   345,  3845,  1080,   346,   347,   349,   350,  4092,
    4093,  3645,  4265,  4266,   357,   358,   713,   503,   385,   386,
     707,   732,   784,   700,  3769,  3219,  1568,   703,   387,   388,
     389,   390,   396,   397,  1932,   755,   750,  1933,   839,   840,
    1191,  1192,   545,  2919,  2920,   399,   400,  1934,   868,  1193,
     759,  1935,   530,  1081,  2607,  3251,  3252,   701,  1936,  3789,
     402,   403,   408,   409,   410,   411,   905,  1939,  1570,  1571,
     911,  1940,   921,  1941,   481,  1942,   412,   413,   749,  1949,
     705,  4050,  3976,  1950,  3978,   903,  1680,  1681,  1682,  1683,
    1684,   712,  1951,   785,  1952,  2659,  1953,   704,  2241,  2242,
     716,  1954,   770,  1955,   708,   699,   664,   702,   414,   415,
    1957,   666,   416,   417,   772,   418,   419,  4222,  4223,  2691,
    1956,   760,  4240,  4241,  4151,  4152,  3445,   982,   847,  3569,
    3571,  3290,  3291,  1958,  3997,   865,  3999,   541,   775,   848,
     910,   733,   504,  1959,  1960,   698,  2730,  1963,   308,  3810,
    1964,  2740,  1965,  2616,  2618,  1966,  1967,  1968,   744,   738,
    1969,   776,   906,  1970,   912,   258,  1010,   901,  2639,  1971,
    2868,  1972,  1973,   780,  1974,  1975,  1976,  3051,  3052,  1977,
     753,  3054,  3055,   706,  1978,  3057,  3058,   781,  2658,   308,
    1979,   902,   754,  1980,  2671,   762,   258,  1981,   983,   258,
     258,   782,  1982,  1983,  1984,   783,   767,  1985,  2686,  1986,
    1987,  3881,  3846,   308,  1225,  2175,  2176,  2966,  2829,   768,
    1988,   909,   808,  1989,  3035,  1163,  1990,   811,  2839,  1991,
     812,  1992,  1240,  1242,  1993,  1164,  2196,  1230,   813,  2729,
     308,  2852,   771,   773,   777,   308,   761,  2241,  2242,   778,
     814,  1232,  2752,  1213,  2636,  1171,  2973,   779,  1994,   815,
    1995,  1996,  1223,  1997,   816,  3016,  3847,  1998,  1408,  1999,
    3843,   258,  1224,  2000,  2001,  1208,   500,   798,  1418,  2002,
    2003,   799,  1119,  2004,  2005,  2674,  1445,  4131,  2677,  2679,
    1138,  1446,  2905,  2006,  2007,  1448,  1165,  3410,  3413,  2008,
    2009,   800,  1162,  2010,   809,  1592,   258,  1174,  1331,  1037,
    2241,  2242,   308,  2011,   549,  1119,  1138,  2012,  2013,  2014,
    4141,  3926,   308,  2015,   810,  3929,  1172,  2016,  2017,  3933,
    2018,  3944,  3945,  2019,  1603,   308,  2020,  1131,  2854,  1222,
     727,  1715,  2021,  2022,  2863,  1113,  1605,  2023,  1635,  2024,
    3852,  2025,  3091,  1636,  1637,  1604,  2026,   308,  2027,  2028,
    2780,  2029,  2042,  1131,  2047,  1638,  1403,  2048,  1709,  2888,
    1411,  2890,  1447,  1740,  2049,  1407,   530,  1700,  1402,  2050,
     743,  2899,  1399,  1409,  2052,  1397,   308,  1842,  2051,  1710,
    2057,  2058,  1400,  1639,   796,  2821,  3005,   258,  3007,  1640,
    1641,  2059,  2164,  1642,  2067,  2164,  4211,  2060,  1643,  1113,
    1113,  1113,  1113,  2929,  2930,  2061,  2062,  1113,  1113,  1113,
    1113,  1113,  1113,  1113,  1113,  1113,  1113,  1113,  1113,  1113,
    1113,  1113,  1113,  1113,  1113,  1644,  2070,  1113,  1113,  1113,
    1113,  1113,  1113,  1113,  1113,  1113,  1113,  1113,   718,  2963,
     719,  1173,  2071,  1401,  2072,  1517,  1233,  2075,  1645,  1398,
    1607,  2076,  1404,   920,  1412,  3070,  1042,  1646,  2077,  2078,
    2079,  2080,  2985,  2986,   258,  2081,  2991,  2091,  2082,  2991,
    2994,  2083,  1651,   866,  2084,   867,  2917,  2085,  2086,  1461,
     308,  2087,   308,  1601,  1711,  2088,  2089,   258,  2260,  4172,
    1608,  2090,  2092,  3110,  2094,  2095,   258,  1609,  1610,  2102,
     907,   258,   908,  1332,  2109,  2100,  1516,  2101,  2110,   258,
    1060,  2111,  1689,  1141,  2112,  2113,  2116,  1707,  2120,   258,
    1783,  1611,  1809,  2117,  1712,  2126,  1783,  1779,  1809,  3148,
    1784,  1713,  1714,  1779,  3059,  1795,  1784,  3060,  2129,  1141,
    1632,  1795,  3062,  2130,  3064,  3065,  1142,  3167,  2131,   308,
    2134,  2135,  2247,  2988,  3528,  1716,  3080,  1777,   258,  2138,
    1612,  2143,  2144,  1777,  1633,  3089,  2145,  4003,  1075,  3097,
    2146,  2169,  1142,  2147,  2148,  1170,  3012,  2149,  1794,  2150,
    2151,  2152,  3105,  2153,  1794,  3022,  2154,   308,  1363,  3211,
    3028,  3213,  3214,  1810,  1717,  2155,  1175,  1780,  3037,  1810,
    1785,  2168,  2214,  1780,  1462,  1212,  1785,  1778,  3047,  2228,
     518,  2170,  2171,  1778,  1799,   519,   520,   521,  2172,  1602,
    1799,  1796,  3404,   308,  3149,  2173,  2174,  1796,  2177,  2178,
    2179,  2180,  3156,  1231,  3158,  2181,  2182,  2217,  1800,  2218,
    2183,   308,  1677,  2184,  1800,  1776,   522,  3083,  2185,  2219,
    2186,  1776,  2187,  1708,  2188,  2189,  3565,  2190,  2220,  2191,
    2221,  1801,  2224,  3294,  2192,  2193,  2194,  1801,   523,  2229,
    2195,   524,  3307,  1805,  2230,   546,  2231,  2232,  2233,  1805,
    3320,  2234,  2235,   308,  2236,   308,   308,  1806,  2239,  1634,
    2240,  2250,  2401,  1806,   258,  2585,  2586,  2587,  2588,  2589,
    2590,  1807,  2255,  2593,  2594,  1808,  2595,  1807,  2251,  2252,
    2253,  1808,  2254,  2256,  2263,  2264,  2267,  2567,  2568,  2268,
    2269,  2270,  1813,  2272,  2273,  2271,  2274,  1828,  1813,  2275,
    1829,  2286,  1410,  1828,  2584,  2287,  1829,  2133,  1830,  2290,
    2291,  2311,  2312,  2331,  1830,  2313,  1797,  2314,  2315,  2316,
    1831,  2097,  1797,  1112,  2319,  2320,  1831,   308,  2321,  1832,
    2322,  2323,  2324,  2325,  1833,  1832,   308,  2326,  2327,   258,
    1833,  2329,  2328,  2332,   308,   258,  2335,  2336,  3325,  3326,
    1599,  2333,  1861,  3223,   843,  3330,  3331,  2337,  3333,  3334,
    3335,  3446,  3337,  3481,  2334,  2352,  2353,   864,  1648,  2354,
    1405,  2357,  1406,  1675,  2681,  2360,   970,  2069,  2361,  1687,
    2362,  1698,  2363,  2364,  1705,  2365,  2366,  1112,  1112,  1112,
    1112,  3433,   526,  3410,   904,  1112,  1112,  1112,  1112,  1112,
    1112,  1112,  1112,  1112,  1112,  1112,  1112,  1112,  1112,  1112,
    1112,  1112,  1112,  2046,  1600,  1112,  1112,  1112,  1112,  1112,
    1112,  1112,  1112,  1112,  1112,  1112,  2367,  2368,  3311,  2369,
    2370,  2371,  1649,  2372,  3322,   518,   512,  1676,  3394,  2373,
     519,   520,   521,  1688,  2374,  1699,  2375,  2791,  1706,  2376,
    2377,   258,  2378,  2798,  2379,  2380,  2381,  2382,  2802,  2383,
    2384,  2385,   450,  2386,  2387,  2388,  2389,  2390,  2811,  2391,
    2392,   522,  2393,  2394,   512,  2395,  2396,   512,  2405,   512,
    2397,   450,   591,  2404,  2406,  2407,  2831,  2408,   487,   488,
     451,  1565,  2409,   523,  2410,  3546,   524,  2449,  3547,   258,
    2411,  3548,  2412,  2413,  2414,  2415,  2416,  2417,  2418,   451,
    2419,  2420,  2421,  2422,  2423,  1566,  1567,  1118,  1786,  2424,
    1787,  2425,  2426,  2427,  1786,  2428,  1787,  1154,  2429,  2430,
    2238,  2431,  2432,  3684,  2433,  3686,  2434,  2435,  2436,  2437,
    3395,  2438,  2439,  2440,  2441,  2442,  2443,  2444,  2445,  2895,
    1118,  2898,  2446,  2447,  2448,  2450,   489,  2451,   442,   443,
     444,  2452,  2453,  2454,   445,   446,   447,   448,  2455,  2456,
    2457,  2458,   490,  2459,  2460,   489,  2461,  2462,  2463,  3461,
     512,  3421,   449,  1565,   966,  2464,  2465,  2466,  3406,  2467,
    2468,   490,   450,  2469,  2470,  3425,  2471,  3741,  2483,  3428,
    2472,  3483,  2473,   834,  2474,   964,  2515,  1566,  1567,  2475,
    2476,  2477,  2478,  2479,   491,  2480,  2481,  2482,   525,  1962,
     451,   512,  3438,  2484,  2485,  2488,  2486,  2487,   873,  3934,
    2489,  2490,  2491,   491,  2492,  3935,  3936,  3937,  3938,  3939,
    3940,  2494,    21,  2493,  2495,  2496,  2498,   526,  2497,  3002,
    3941,   591,  2499,  2500,  2997,  2507,  2508,   940,  3942,  1113,
    2509,  1962,  2510,  1155,  2511,  2539,  2512,  1113,  2518,   452,
    2521,   258,  2540,   308,  2522,  2523,  1156,  2524,   308,  2527,
    2528,   492,  2532,  2533,  2534,  3031,  2535,  2536,   454,  2537,
    2538,  3038,  3039,  3040,  3041,  2541,  2542,  3477,  2543,  2544,
     492,  2545,  2546,  2548,  2550,  1568,  1569,   454,  2551,  2549,
    3484,  2554,  2558,  2555,  2604,  2556,  2562,   512,  2559,  2606,
    2557,  2608,  2560,  2561,  3063,  2614,  3615,  2684,  2563,  2585,
    2586,  2587,  2588,  2589,  2590,  2591,  2592,  2593,  2594,  3287,
    2595,  3287,  3287,  1157,  2564,  2565,  2566,  1570,  1571,  2569,
    1572,  1573,  2570,  1574,  1575,  1576,  1702,  2571,  2572,  2573,
    3460,  2574,  2575,  2576,  1113,  2577,  2578,  2579,  2580,  2581,
    2582,  1578,  2583,  2598,  3825,  2615,  3513,  3514,  2649,  2620,
     452,   453,  2600,   456,   457,  2621,  2623,  2625,   512,    40,
    3521,  3501,  2610,  3521,  2640,  2641,  2642,  1568,  1569,  2645,
    2647,  2652,   456,   457,  3625,  2651,   258,  1158,   258,  2653,
    2655,  3848,   512,  2656,  3853,  2657,  2672,  2680,   454,   455,
    1111,  3626,   512,  2683,  2682,  2690,    21,  2698,   512,  2699,
     258,  2701,  2703,  2704,  2716,  2717,  2718,   512,  2719,  1570,
    1571,  1596,  1572,  1573,  2726,  1574,  1575,   512,  1113,  1113,
    2727,   304,  1577,  2731,  2733,  2741,  2925,  2926,  2927,  2928,
    2751,  1113,  2760,  1578,  2931,  2932,  2933,  2934,  2935,  2936,
    2937,  2938,  2939,  2940,  2941,  2942,  2943,  2944,  2945,  2946,
    2947,  2948,  2759,   512,  2951,  2952,  2953,  2954,  2955,  2956,
    2957,  2958,  2959,  2960,  2961,  3530,  3560,  3531,  3561,  3562,
    3563,  2761,  3566,  2765,  2769,    69,  2774,  2775,  2781,  2777,
    2773,  2782,  2795,   456,   457,  2796,  2797,  2799,  2800,  3537,
    2801,  3928,  2804,  2803,  2805,  3932,   493,   494,  2806,  2808,
    2809,  2810,  2812,   258,   258,   258,  2813,  2818,   258,  2197,
    2198,  2199,  2200,  2201,  2202,  2203,  2204,  2205,  2206,  3699,
    2207,  2814,  3960,  2833,  2822,  2834,  2823,  2815,  2125,  2197,
    2198,  2199,  2200,  2201,  2202,  2203,  2204,  2205,  2206,   258,
    2207,  2816,  2828,    40,  3338,  3339,  3340,  3341,  2830,  2836,
    3342,  3343,  3344,  3345,  3346,  3347,  3348,  3349,  3350,  3351,
    3352,  3353,  3354,  3355,  3356,  2848,  3358,  3359,  3360,  3361,
    3362,  3363,  3364,  3365,  3366,  3367,  3368,  2837,  2840,  1113,
    2841,  2842,  2846,  2847,  2855,  2850,  4001,  2860,  2851,  2872,
    2853,  2902,  2857,   512,  2871,  2903,  2858,  2907,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,  2873,  2197,  2198,
    2199,  2200,  2201,  2202,  2203,  2204,  2205,  2206,  3581,  2207,
    2908,   964,  2880,  2875,  3899,  2910,  2879,  2912,   258,  2913,
    1159,  2883,  2914,  2884,  2885,  2922,  2207,  1112,  2965,  2970,
    2972,  2976,  2984,  3009,  2886,  1112,  3015,  3032,  3023,    69,
    2887,  2891,  3024,  4052,   442,   443,   444,  3025,    21,  2892,
     445,   446,   447,   448,  3043,  2894,   478,  3066,  2896,  3074,
    2962,   512,  3075,  3081,  3085,  3090,  2964,   479,   449,  3098,
    4052,  3099,   512,  3100,  2967,  2974,  2975,  3102,   450,  2197,
    2198,  2199,  2200,  2201,  2202,  2203,  2204,  2205,  2206,  3113,
    2207,  2980,  2585,  2586,  2587,  2588,  2589,  2590,  2591,  2592,
    2593,  2594,  3114,  2595,  2981,  2992,   451,  3588,  3004,  2585,
    2586,  2587,  2588,  2589,  2590,  2591,  2592,  2593,  2594,  3091,
    2595,  3006,  3115,  3008,   480,  4122,  3010,  3116,  3017,  3117,
    3034,  4128,  1112,  3030,  3118,  3261,  1898,  3119,  3673,  3042,
    2595,  3120,  3674,  3121,  3069,   512,  3900,  4122,  3086,  3122,
     965,  3123,  3124,  3087,   591,  3088,   512,  3426,  3615,  3125,
    3109,  3429,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,  3127,   834,  3136,  3112,  3128,  3137,  3140,  3152,  3133,
    3163,  3164,   873,  4173,  3146,    40,   591,  3134,  3165,  3135,
    3166,  1565,   940,  3154,  3957,  3168,  1113,  1113,  3170,  3174,
     512,  3138,  3175,  1113,  3169,  3176,  1112,  1112,  3155,  3157,
    3177,  3740,  3159,  3178,  3181,  1566,  1567,  3182,  3183,  1112,
    3958,  3184,  3185,  1113,  1113,  3186,  3188,  2585,  2586,  2587,
    2588,  2589,  2590,  2591,  2592,  2593,  2594,  3189,  2595,  3190,
    3191,  3192,  3193,  3194,  1113,  3195,  1113,   304,  3196,  3197,
    3479,  3198,   258,  3199,  3200,  3201,   452,   453,  3202,  3761,
    3979,  3203,  3204,  3205,  3210,  3208,  3212,  3216,   510,  3217,
     512,   512,  3220,  3231,  3225,  3233,  3234,   512,  2585,  2586,
    2587,  2588,  2589,  2590,  2591,  2592,  2593,  2594,  3237,  2595,
    3238,  3239,  3240,  3244,   454,   455,  3245,  4015,  3778,  3246,
    3247,    69,  3249,  3250,  1113,    21,  3253,  3255,  3258,  3257,
    3272,  3260,  3264,   512,   945,  3265,  3268,   946,  3275,  3269,
    3276,   512,  3278,  3289,  3295,  3285,  3299,  3293,   512,  3515,
    3572,  3297,  3298,  3300,  3303,  3308,  3309,  3313,  3316,  3324,
     947,  3755,  2197,  2198,  2199,  2200,  2201,  2202,  2203,  2204,
    2205,  2206,  3529,  2207,   948,  3397,  3808,  3396,  3328,  3811,
    3369,  3378,  3814,  3389,  3390,  3414,  3534,  1112,  3388,  3422,
    2053,  3417,  3424,   510,   949,  3423,  3883,  1111,  2199,  2200,
    2201,  2202,  2203,  2204,  2205,  2206,  3439,  2207,  3440,   456,
     457,  3441,  3443,  3447,  3448,  3451,  2118,  3454,  4084,  4085,
    3457,  3466,  3458,  3467,  3473,  1568,  1569,  3487,  3488,  3482,
      21,  3509, -2208,  3512,  3523,  3526,  3533,  3564,  3842,  3550,
    3568,  3578,  3584,  3585,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,  3579,  3586,  3587,  3591,  1570,  1571,  3592,
    1572,  1573,    40,  1574,  1575,  1576,  3616,  3619,  2209,  3875,
    1577,  3876,  3622,  3879, -2207,   950,   951,  4145,  4146,  3648,
     308,  1578,  1113,  3617,  2197,  2198,  2199,  2200,  2201,  2202,
    2203,  2204,  2205,  2206,   952,  2207,  3453,  3620,  3621,  3623,
    3624,  3649,  1113,  1113,  3459,   512,  3650,  3667,  -868,  3382,
    3670,  3676,  1182,  3687,  3678,  3690,  3698,  3701,  3706,  3703,
    3912,  3912,  3708,  3709,  3711,  3719,  3714,  3720,  3721,  3724,
    3733,  1111,  1111,  3742,  1465,  3749,  3775,  3791,  3756,  4184,
    3922,  3757,  2585,  2586,  2587,  2588,  2589,  2590,  2591,  2592,
    2593,  2594,  1111,  2595,  3744,  3767,  3797,  3752,   953,  3762,
    3780,  3798,  3951,  3781,  3799,  3954,  3782,    40,  2585,  2586,
    2587,  2588,  2589,  2590,  2591,  2592,  2593,  2594,    69,  2595,
    3783,  3784,  3792,  3800,  3801,   593,  3802,  3987,   954,  3803,
    3804,  3805,  3809,  3812,  3813,   598,  3815,  3816,  3827,  3828,
     600,  3510,  3829,  3833,  3844,  3835,  3464,  3834,  2585,  2586,
    2587,  2588,  2589,  2590,  2591,  2592,  2593,  2594,  3856,  2595,
    3857,  3858,  3863,  3870,  1112,  1112,  3866,  2246,  3992,  3872,
    1113,  1112,  3892,  3874,   603,   604,  3877,   450,  3886,  3887,
    3893,   605,   606,   607,  3918,  3924,  3435,  3907,  3966,  1113,
    1113,  1112,  1112,  3988,  3947,  3891,  3963,  3948,  1182,  3967,
    3949,  4013,   609,  4013,  1465,   451,  3952,  3968,  3969,  3972,
     955,  4028,  1112,  3970,  1112,  2587,  2588,  2589,  2590,  2591,
    2592,  2593,  2594,    69,  2595,  3544,  3545,  3973,  3984,  -870,
    3989,  3993,  3995,  3996,  3998,   612,   613,  4000,  3549,  4018,
    4024,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
    4022,  4037,  4023,  4049,   615,   616,   617,  4025,  4029,  4038,
    3646,  4048,  1112,  4039,  4054,  4057,  4040,  4060,   510,  4061,
    4070,  4041,  4046,  4071,  4098,  4042,  4066,   490,   625,   626,
     450,   627,   628,  4043,  4063,  4074,  4103,  4106,  4077,  4107,
    3839,  4082,  4110,  4113,  4078,  4081,  4117,  -872,  4139,  4155,
    4086,  4157,  4094,  4095,  4088,    21,  4097,   643,   644,  4087,
    4168,  4160,  4169,  4179,  4170,  4180,  4096,  4185,  3700,  4101,
    4109,  4186,  4112,  4125,  3705,  4116,  4133,  4137,  4138,  4187,
    4142,  4143,  4189,  4175,  4156,  3712,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   452,  4197,   664,  4161,  4203,
    4162,  4178,   666,  4181,  4183,  4225,  4193,  4147,  3745,  4207,
     669,   670,  4204,   671,  4198,  1834,  3582,  1120,  1121,  4212,
    4216,  4163,  4226,  4227,  4235,  4236,  4167,  4237,  4217,  4218,
    4229,  4233,   674,  1122,  4244,  4245,  4247,  4248,  4246,   523,
    4249,   676,  1123,   511,  4254,  4251,  4255,  3759,  4256,  4258,
    4260,   525,  4259,  4261,  4264,  1124,  4263,  4269,  3763,   679,
    2585,  2586,  2587,  2588,  2589,  2590,  2591,  2592,  2593,  2594,
    1112,  2595,  4268,  4270,  4272,  4188,   434,  4273,  3094,  3108,
     526,  4195,  4196,  3567,  3111,  3068,   681,   682,  4167,  3913,
    1112,  1112,    40,   683,  3920,  2585,  2586,  2587,  2588,  2589,
    2590,  2591,  2592,  2593,  2594,  4213,  2595,  4194,  3442,  3281,
    2817,  2874,  3732,  4224,  1125,  3725,  3517,  3267,  4228,  1002,
    4230,  3468,  3796,  4105,  4199,  3284,  4202,  4073,   456,   457,
    3277,  3734,  3525,  2882,  3323,  1760,  3312,  4238,  3296,  3003,
    2648,   541,  3020,  3292,  3432,  3153,  1857,  3946,   584,  2035,
    1864,  3962,  1003,  3826,  1868,   593,  3817,  3818,   595,  2778,
    4129,  3855,  2041,  3850,   258,   598,  2849,  2915,  2878,   989,
     600,  2137,  4262,  3819,  3045,  3820,  2285,   512,  3207,  2619,
    3033,  2056,  2624,  3224,  3259,  3221,  3256,  1126,  3254,  4271,
    3147,  1127,  2989,   526,  3248,  1128,  2197,  2198,  2199,  2200,
    2201,  2202,  2203,  2204,  2205,  2206,  3029,  2207,    69,  3084,
    3243,   605,   606,   607,   990,   991,  2675,  2819,  1112,  2074,
    1947,  3014,  3475,  2654,  2893,  3452,  2637,  3011,  3908,  3859,
    3860,  2993,  3862,   510,  3931,  3914,     0,  1112,  1112,  3327,
    3869,     0,   685,   839,   840,     0,   992,     0,  3873,  2128,
       0,     0,     0,  4257,   993,     0,  2807,     0,     0,     0,
       0,     0,     0,  3726,  3727,   612,   613,   614,     0,     0,
      21,     0,     0,     0,     0,     0,   994,   995,   996,     0,
       0,     0,     0,     0,     0,     0,     0,  3904,  3905,     0,
    3747,  3748,     0,     0,   615,   616,   617,     0,  3910,     0,
       0,     0,     0,     0,   997,     0,     0,     0,     0,     0,
       0,  3750,     0,  3751,     0,     0,     0,     0,   688,     0,
       0,  4136,     0,     0,     0,     0,     0,     0,     0,   998,
       0,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
       0,     0,  3959,     0,     0,     0,     0,     0,   646,     0,
    3961,     0,     0,     0,  1835,  1836,  1837,  1838,  1839,  1840,
    1841,  3779,     0,     0,     0,     0,   690,   691,   692,   693,
     694,   695,     0,     0,  2585,  2586,  2587,  2588,  2589,  2590,
    2591,  2592,  2593,  2594,     0,  2595,     0,   664,   999,     0,
    1000,     0,   666,     0,     0,  1001,  1002,     0,     0,     0,
     669,   670,   510,   671,     0,   672,     0,    40,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   673,   541,  2585,
    2586,  2587,  2588,  2589,  2590,  2591,  2592,  2593,  2594,  1003,
    2595,     0,     0,     0,     0,     0,     0,     0,  1004,    21,
    1005,   525,     0,     0,  4033,  2950,     0,     0,     0,   679,
     542,  1006,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1007,  1008,  1009,     0,     0,     0,     0,     0,     0,
     526,     0,     0,     0,     0,     0,   681,   682,  4044,  4045,
       0,     0,     0,   683,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   817,     0,     0,     0,     0,     0,     0,
    4062,     0,     0,     0,     0,  2601,  2246,  2603,  4067,  2246,
       0,  2585,  2586,  2587,  2588,  2589,  2590,  2591,  2592,  4102,
    2594,  2622,  2595,    69,     0,     0,  2627,     0,     0,     0,
       0,     0,     0,     0,     0,  2643,  2644,     0,  2646,     0,
       0,     0,  2650,     0,     0,     0,     0,     0,     0,  3901,
    3902,  2567,  2568,     0,     0,     0,  4104,  2197,  2198,  2199,
    2200,  2201,  2202,  2203,  2204,  2205,  2206,     0,  2207,     0,
    2685,  4118,  2687,  2688,  2689,     0,     0,     0,     0,     0,
       0,     0,  2700,     0,  2702,     0,    40,     0,  2709,  2710,
    2711,  2712,  2713,  2714,  2715,     0,     0,     0,     0,  2246,
       0,  2197,  2198,  2199,  2200,  2201,  2202,  2203,  2204,  2205,
    2206,  2745,  2207,  4153,  4154,     0,     0,     0,     0,     0,
       0,  2762,  2764,  3366,     0,  2768,     0,     0,     0,     0,
       0,  2776,   685,  3357,     0,     0,     0,     0,     0,     0,
       0,     0,  4174,     0,     0,     0,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3994,  3476,  2246,
       0,     0,     0,     0,     0,     0,  4033,     0,     0,  2843,
    2844,  2845,     0,  4205,     0,     0,  4004,  4005,     0,     0,
       0,     0,    69,     0,     0,     0,     0,     0,  1111,     0,
       0,     0,  2869,  2870,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2881,  2197,  2198,  2199,  2200,  2201,  2202,
    2203,  2204,  2205,  2206,     0,  2207,     0,     0,     0,     0,
       0,     0,     0,  4242,  4243,     0,  2901,     0,     0,     0,
    2906,     0,     0,  2909,     0,  2911,  4250,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   690,   691,   692,   693,
     694,   695,  1111,  1111,  1111,  1111,     0,     0,     0,     0,
    1111,  1111,  1111,  1111,  1111,  1111,  1111,  1111,  1111,  1111,
    1111,  1111,  1111,  1111,  1111,  1111,  1111,  1111,     0,     0,
    1111,  1111,  1111,  1111,  1111,  1111,  1111,  1111,  1111,  1111,
    1111,     0,     0,     0,     0,     0,  3485,     0,   869,     0,
    2968,  2969,     0,  2971,     0,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,  2995,  2996,     0,     0,  2246,     0,
     510,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3486,     0,     0,     0,     0,     0,  3018,  2197,  2198,  2199,
    2200,  2201,  2202,  2203,  2204,  2205,  2206,     0,  2207,     0,
       0,     0,     0,   433,     0,     0,     0,    21,     0,     0,
    3044,     0,     0,     0,     0,     0,     0,     1,     2,  2197,
    2198,  2199,  2200,  2201,  2202,  2203,  2204,  2205,  2206,     0,
    2207,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     3,     4,     5,     6,     7,     0,     0,     0,
       8,     0,     0,     0,     0,     0,     0,     9,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    10,    11,    12,
       0,     0,     0,    13,     0,    14,    15,    16,    17,    18,
       0,     0,  1071,     0,     0,     0,     0,     0,    19,    20,
       0,    21,     0,     0,     0,     0,  3126,     0,    22,  3131,
    3132,     0,     0,  3489,    23,     0,     0,  3139,     0,  3141,
    3142,  3143,  3144,  3145,     0,     0,     0,  1069,     0,    21,
      24,    25,    26,    27,     0,     0,     0,     0,     0,     0,
       0,     0,    28,     0,    29,    30,     0,     0,     0,     0,
       0,     0,     0,     0,  3179,  3180,     0,     0,    31,     0,
       0,     0,  3187,     0,    40,  2197,  2198,  2199,  2200,  2201,
    2202,  2203,  2204,  2205,  2206,     0,  2207,    32,     0,     0,
       0,     0,     0,     0,     0,    33,     0,     0,     0,     0,
       0,     0,     0,     0,  2246,     0,     0,     0,     0,     0,
       0,  3228,  3229,  3230,     0,  3232,     0,     0,  3235,  3236,
      34,    35,    36,    37,  3241,  3242,    38,     0,     0,     0,
       0,     0,     0,     0,  2246,  2246,     0,    39,  2585,  2586,
    2587,  2588,  2589,  2590,  2591,  2592,  2593,  2594,     0,  2595,
       0,     0,     0,  3273,     0,     0,     0,     0,    40,     0,
       0,     0,     0,    41,     0,     0,  3490,  2585,  2586,  2587,
    2588,  2589,  2590,  2591,  2592,  2593,  2594,     0,  2595,     0,
       0,     0,     0,    42,     0,    43,    40,    44,    45,     0,
      69,     0,     0,     0,     0,     0,    46,     0,  3491,    47,
       0,    48,    49,     0,     0,     0,    50,    51,  2197,  2198,
    2199,  2200,  2201,  2202,  2203,  2204,  2205,  2206,     0,  2207,
    2197,  2198,  2199,  2200,  2201,  2202,  2203,  2204,  2205,  2206,
       0,  2207,     0,    52,    53,     0,   510,    54,    55,    56,
       0,    57,    58,     0,     0,     0,     0,    59,     0,     0,
      60,     0,     0,     0,     0,    61,    62,     0,     0,     0,
       0,    63,     0,     0,     0,    64,    65,    66,     0,     0,
      67,     0,    68,    21,    69,     0,    70,     0,     0,     0,
       0,     0,    71,    72,    73,     0,    74,    75,    76,     0,
      77,    78,    79,    80,    81,    82,     0,     0,    83,     0,
       0,     0,    69,     0,     0,    84,    85,     0,     0,     0,
       0,    86,     0,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,     0,     0,  3492,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    87,    88,     0,     0,     0,     0,
       0,   510,  2197,  2198,  2199,  2200,  2201,  2202,  2203,  2204,
    2205,  2206,     0,  2207,  2995,  2996,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2246,  2246,     0,    89,
       0,     0,     0,     0,    90,     0,     0,     0,    21,     0,
       0,     0,     0,     0,     0,  2596,     0,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,     0,     0,     0,     0,
      40,     0,     0,     0,  2900,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,     0,     0,     0,   110,     0,     0,
       0,   111,   112,   510,     0,   113,   114,     0,   115,   116,
     117,   118,   119,   120,     0,     0,     0,  3493,     0,     0,
       0,   121,     0,     0,     0,     0,   122,   123,   124,  3494,
       0,     0,     0,     0,   125,  1070,     0,     0,     0,     0,
      21,     0,     0,     0,   510,     0,     0,     0,     0,     0,
       1,     2,  1111,     0,     0,     0,   126,   127,     0,     0,
    1111,     0,     0,     0,     0,     0,     0,   128,   129,     0,
       0,     0,     0,  3465,     0,     3,     4,     5,     6,     7,
       0,    21,     0,     8,     0,    40,    69,     0,     0,     0,
       9,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      10,    11,    12,     0,     0,     0,    13,     0,    14,    15,
      16,    17,    18,   510,     0,     0,   130,     0,   131,     0,
       0,    19,    20,     0,    21,     0,     0,     0,     0,     0,
       0,    22,     0,     0,     0,     0,     0,    23,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1072,     0,     0,
      21,     0,     0,    24,    25,    26,    27,  1111,     0,     0,
       0,  3495,     0,     0,     0,    28,     0,    29,    30,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    31,     0,     0,     0,     0,     0,    40,     0,     0,
       0,  2246,     0,  2246,     0,     0,     0,     0,     0,     0,
      32,    69,     0,     0,     0,     0,     0,     0,    33,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,    40,     0,
       0,     0,     0,    34,    35,    36,    37,     0,     0,    38,
       0,  1111,  1111,     0,     0,     0,     0,     0,     0,     0,
      39,     0,     0,     0,  1111,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    40,     0,     0,     0,     0,    41,  2585,  2586,  2587,
    2588,  2589,  2590,  2591,  2592,  2593,  2594,     0,  2595,     0,
       0,     0,     0,     0,     0,  2246,    42,    40,    43,     0,
      44,    45,     0,    69,     0,     0,     0,     0,     0,    46,
       0,   510,    47,     0,    48,    49,     0,     0,     0,    50,
      51,  2246,  2246,     0,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,     0,    69,     0,    52,    53,    21,     0,
      54,    55,    56,     0,    57,    58,     0,     0,     0,     0,
      59,     0,     0,    60,     0,     0,     0,     0,    61,    62,
       0,     0,   510,     0,    63,     0,     0,     0,    64,    65,
      66,  1115,    21,    67,     0,    68,     0,    69,     0,    70,
       0,     0,     0,     0,     0,    71,    72,    73,     0,    74,
      75,    76,  1111,    77,    78,    79,    80,    81,    82,    21,
       0,    83,     0,    69,     0,     0,     0,     0,    84,    85,
       0,     0,   510,     0,    86,     0,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,  2197,  2198,  2199,  2200,  2201,
    2202,  2203,  2204,  2205,  2206,     0,  2207,    87,    88,    21,
       0,     0,  2246,     0,     0,     0,     0,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,     0,     0,     0,     0,
       0,     0,    89,     0,     0,    40,  1146,    90,  2585,  2586,
    2587,  2588,  2589,  2590,  2591,  2592,  2593,  2594,     0,  2595,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,    40,
       0,     0,     0,     0,  3403,     0,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,     0,    40,     0,     0,     0,
     110,     0,     0,     0,   111,   112,     0,     0,   113,   114,
       0,   115,   116,   117,   118,   119,   120,     0,     0,     0,
       0,     0,     0,     0,   121,     0,     0,     0,     0,   122,
     123,   124,     0,     0,     0,     0,     0,   125,  1178,     0,
       0,     0,  2246,     0,  2246,     0,    40,     0,     0,     0,
       0,    69,     0,     0,     0,     0,     0,     0,     0,   126,
     127,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     128,   129,     0,     0,     0,     0,     0,     0,     0,  1215,
       0,     0,     0,     0,     0,    69,     0,     0,     0,  1111,
    1111,     0,     0,     0,     0,     0,  1111,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2246,     0,     0,     0,
       0,     0,    69,     0,     0,     0,  1111,  1111,     0,   130,
       0,   131,  2197,  2198,  2199,  2200,  2201,  2202,  2203,  2204,
    2205,  2206,     0,  2207,     0,     0,     0,  1111,     0,  1111,
       0,     0,     0,     0,  3496,     0,     0,     0,  1234,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2246,     0,
       0,     0,    69,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,     0,     0,  -766,     0,  1111,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,     0,     0,     0,
       0,     0,     0,     0,     0,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2197,  2198,  2199,  2200,  2201,
    2202,  2203,  2204,  2205,  2206,     0,  2207,     0,     0,     0,
       0,     0,  3824,  2246,     0,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,     0,     0,     0,  2197,  2198,  2199,
    2200,  2201,  2202,  2203,  2204,  2205,  2206,     0,  2207,     0,
    2246,     0,     0,  2246,  2197,  2198,  2199,  2200,  2201,  2202,
    2203,  2204,  2205,  2206,     0,  2207,     0,     0,   593,   594,
       0,   595,   596,     0,   597,     0,  1248,     0,   598,     0,
       0,   599,     0,   600,     0,  2197,  2198,  2199,  2200,  2201,
    2202,  2203,  2204,  2205,  2206,  1111,  2207,     0,     0,     0,
       0,   601,     0,     0,     0,     0,     0,     0,     0,   602,
     449,  3497,     0,  2257,     0,  1111,  1111,   603,   604,     0,
     450,     0,     0,     0,   605,   606,   607,  2197,  2198,  2199,
    2200,  2201,  2202,  2203,  2204,  2205,  2206,  1259,  2207,     0,
       0,     0,   608,     0,     0,   609,   487,   488,   610,     0,
       0,     0,   611,     0,     0,     0,     0,     0,     0,     0,
    2246,     0,  3930,     0,  2246,     0,   480,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   612,   613,
     614,     0,     0,     0,     0,     0,     0,  1260,     0,     0,
       0,  2246,     0,  2197,  2198,  2199,  2200,  2201,  2202,  2203,
    2204,  2205,  2206,     0,  2207,     0,     0,   615,   616,   617,
       0,   618,   619,   620,   489,     0,     0,     0,     0,     0,
       0,     0,   621,   622,     0,     0,     0,   623,   624,     0,
     490,   625,   626,     0,   627,   628,     0,     0,     0,     0,
       0,     0,     0,  1111,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,  3498,  2246,   639,   640,   641,   642,
     643,   644,  1111,  1111,     0,     0,     0,     0,     0,     0,
     645,   646,   491,   647,   648,   649,   650,   651,   652,     0,
     653,   654,     0,     0,   655,   656,     0,     0,     0,   657,
       0,     0,     0,   658,   659,   660,  3499,     0,     0,   661,
       0,   662,     0,     0,   663,     0,     0,     0,   452,   453,
     664,     0,   665,  3500,     0,   666,   667,   668,     0,     0,
       0,     0,     0,   669,   670,     0,   671,     0,   672,     0,
       0,     0,  2246,     0,     0,     0,     0,     0,     0,     0,
     673,     0,     0,     0,  3502,   674,   454,   455,     0,     0,
     675,     0,     0,     0,   676,     0,     0,     0,     0,  2246,
       0,     0,     0,     0,   525,   677,   678,     0,     0,     0,
       0,     0,   679,     0,  2585,  2586,  2587,  2588,  2589,  2590,
    2591,  2592,  2593,  2594,     0,  2595,  3503,     0,   680,     0,
       0,     0,     0,   526,     0,     0,     0,     0,     0,   681,
     682,   593,     0,     0,     0,     0,   683,     0,     0,     0,
       0,   598,     0,     0,  2246,     0,   600,     0,     0,     0,
    2246,     0,   684,  2585,  2586,  2587,  2588,  2589,  2590,  2591,
    2592,  2593,  2594,     0,  2595,     0,  2246,     0,     0,     0,
       0,   456,   457,     0,     0,     0,     0,     0,     0,     0,
     603,   604,  3508,   450,     0,     0,     0,   605,   606,   607,
       0,  1761,  2585,  2586,  2587,  2588,  2589,  2590,  2591,  2592,
    2593,  2594,     0,  2595,     0,     0,     0,     0,   609,     0,
       0,   451,  2246,  2585,  2586,  2587,  2588,  2589,  2590,  2591,
    2592,  2593,  2594,     0,  2595,  2585,  2586,  2587,  2588,  2589,
    2590,  2591,  2592,  2593,  2594,     0,  2595,     0,     0,     0,
       0,   612,   613,   593,     0,     0,   595,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   599,   989,  2585,  2586,
    2587,  2588,  2589,  2590,  2591,  2592,  2593,  2594,     0,  2595,
     615,   616,   617,  2585,  2586,  2587,  2588,  2589,  2590,  2591,
    2592,  2593,  2594,     0,  2595,   685,     0,     0,     0,     0,
       0,     0,     0,   490,   625,   626,     0,   627,   628,   605,
     606,   607,   990,   991,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   686,   493,   494,     0,     0,     0,     0,
     687,     0,     0,   643,   644,     0,     0,  2585,  2586,  2587,
    2588,  2589,  2590,  2591,  2592,  2593,  2594,   593,  2595,     0,
     595,     0,   993,     0,     0,     0,     0,     0,     0,     0,
       0,   989,     0,   612,   613,   614,     0,     0,     0,     0,
       0,   688,   689,  3524,   994,   995,   996,     0,  1204,     0,
       0,   452,     0,   664,     0,     0,     0,     0,   666,     0,
       0,     0,   615,   616,   617,     0,   669,   670,     0,   671,
       0,  1762,     0,   605,   606,   607,   990,   991,     0,     0,
       0,     0,     0,     0,     0,   490,     0,     0,   674,     0,
       0,     0,  3627,     0,     0,     0,     0,   676,     0,   690,
     691,   692,   693,   694,   695,     0,     0,   525,     0,     0,
       0,     0,     0,     0,     0,   679,   993,  1235,     0,     0,
       0,     0,     0,     0,     0,     0,   646,   612,   613,   614,
       0,  3628,     0,     0,     0,     0,   526,     0,   994,   995,
     996,     0,   681,   682,     0,     0,     0,     0,     0,   683,
       0,     0,  3629,     0,     0,     0,   615,   616,   617,     0,
       0,     0,     0,     0,  3630,   664,   999,     0,  1000,     0,
     666,     0,     0,  1001,  1002,     0,     0,     0,   669,   670,
       0,     0,     0,   672,   456,   457,     0,     0,     0,     0,
       0,  1252,     0,     0,     0,   673,   541,  3631,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1003,     0,     0,
       0,     0,  3632,     0,     0,     0,  1004,     0,  1005,   525,
     646,     0,     0,     0,     0,     0,     0,   679,   542,  1006,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1007,
    1008,  1009,     0,     0,     0,     0,     0,     0,   526,     0,
       0,     0,     0,     0,   681,   682,     0,     0,     0,   664,
     999,   683,  1000,     0,   666,     0,  3633,  1001,  1002,     0,
       0,     0,   669,   670,     0,     0,     0,   672,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   673,
     541,     0,     0,     0,     0,     0,     0,     0,   685,     0,
    1205,  1003,     0,     0,     0,     0,     0,     0,     0,     0,
    1004,     0,  1005,   525,     0,     0,     0,     0,     0,     0,
       0,   679,   542,  1006,     0,     0,  1263,     0,     0,     0,
       0,     0,     0,  1007,  1008,  1009,     0,     0,     0,     0,
     593,     0,   526,   595,     0,     0,     0,     0,   681,   682,
       0,  2141,     0,     0,   989,   683,     0,     0,     0,  1236,
       0,     0,  1253,    21,  2585,  2586,  2587,  2588,  2589,  2590,
    2591,  2592,  2593,  2594,   688,  2595,     0,     0,     0,     0,
    1206,  2897,     0,     0,     0,     0,     0,     0,    21,  1080,
       0,     0,     0,     0,     0,     0,   605,   606,   607,   990,
     991,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     685,     0,     0,     0,     0,     0,     0,     0,    21,  1080,
    1763,  1764,  1765,  1766,  1767,  1768,  1769,  1770,  1771,  1772,
    1870,     0,   690,   691,   692,   693,   694,   695,  1081,   993,
    1235,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     612,   613,   614,     0,     0,     0,     0,     0,     0,     0,
    1870,   994,   995,   996,     0,     0,     0,     0,  1081,     0,
    1268,     0,     0,     0,     0,     0,  1871,     0,     0,   615,
     616,   617,     0,     0,     0,     0,     0,     0,     0,  1872,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1273,
       0,  1873,  1874,     0,   685,     0,  1871,    21,     0,     0,
      40,     0,     0,     0,     0,     0,     0,     0,     0,  1872,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1873,  1874,     0,     0,    40,    21,     0,     0,     0,
       0,  1875,     0,   646,   690,   691,   692,   693,   694,   695,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1282,     0,     0,     0,     0,    40,     0,     0,     0,     0,
       0,  1875,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   664,   999,   510,  1000,     0,   666,     0,     0,
    1001,  1002,     0,     0,     0,   669,   670,    21,     0,     0,
     672,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   673,   541,     0,     0,  1334,     0,     0,     0,
       0,    21,     0,  3634,  1003,     0,    69,     0,     0,     0,
       0,     0,     0,  1004,     0,  1005,   525,     0,   690,   691,
     692,   693,   694,   695,   679,   542,  1006,     0,   510,     0,
       0,    69,     0,    21,    40,     0,  1007,  1008,  1009,     0,
       0,     0,     0,     0,     0,   526,     0,     0,     0,     0,
       0,   681,   682,     0,     0,   510,     0,     0,   683,     0,
       0,    69,  1236,    40,     0,    21,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1876,  1877,     0,     0,     0,
       0,  1878,  1879,  1880,  1881,  1882,  1883,  1884,  1885,  1886,
    1887,  1888,    21,     0,     0,  1889,  1890,  1891,  1892,     0,
       0,     0,     0,     0,     0,  1876,  1877,     0,     0,     0,
       0,  1878,  1879,  1880,  1881,  1882,  1883,  1884,  1885,  1886,
    1887,  1888,     0,     0,    40,  1889,  1890,  1891,  1892,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,    40,     0,
      69,     0,     0,     0,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,     0,     0,     0,  2304,     0,     0,    69,
      40,     0,     0,     0,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,     0,     0,     0,     0,   685,     0,     0,
       0,     0,    40,    21,  2585,  2586,  2587,  2588,  2589,  2590,
    2591,  2592,  2593,  2594,     0,  2595,     0,     0,  2307,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    40,
      69,  2585,  2586,  2587,  2588,  2589,  2590,  2591,  2592,  2593,
    2594,     0,  2595,     0,     0,   510,     0,     0,     0,     0,
       0,     0,     0,     0,    69,    21,     0,     0,     0,     0,
       0,     0,     0,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,    21,  3392,     0,     0,    69,     0,     0,     0,
       0,  1264,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   510,     0,     0,     0,     0,     0,  1893,    69,     0,
      21,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   690,   691,   692,   693,   694,   695,     0,     0,   510,
       0,     0,     0,     0,     0,    69,     0,  1893,    21,     0,
      40,     0,     0,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,     0,     0,     0,     0,    21,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   510,     0,     0,     0,
      21,     0,    40,     0,     0,     0,     0,     0,     0,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   510,    40,
       0,     0,     0,    21,     0,  1269,     0,     0,     0,     0,
       0,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
       0,     0,     0,  3635,  1274,    21,    69,    40,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,     0,     0,     0,
    3636,     0,     0,     0,     0,    40,     0,  2585,  2586,  2587,
    2588,  2589,  2590,  2591,  2592,  2593,  2594,     0,  2595,     0,
       0,     0,     0,     0,   510,     0,     0,     0,    69,     0,
       0,     0,     0,    40,     0,  1283,  2585,  2586,  2587,  2588,
    2589,  2590,  2591,  2592,  2593,  2594,     0,  2595,     0,     0,
       0,   510,     0,     0,     0,    69,     0,    40,     0,  1333,
       0,    21,  2585,  2586,  2587,  2588,  2589,  2590,  2591,  2592,
    2593,  2594,     0,  2595,     0,     0,     0,     0,     0,     0,
       0,   510,     0,     0,     0,     0,     0,     0,    21,     0,
      40,  1335,     0,    69,     0,     0,     0,     0,     0,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,    21,     0,
       0,    69,    40,  1595,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3519,  2585,  2586,  2587,  2588,  2589,  2590,
    2591,  2592,  2593,  2594,     0,  2595,     0,     0,     0,    69,
    1853,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
      21,     0,  3519,    69,     0,     0,     0,     0,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,     0,     0,   510,
       0,     0,     0,     0,     0,     0,    69,     0,    40,    21,
       0,     0,     0,     0,     0,     0,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,    40,    21,     0,    69,     0,
       0,     0,     0,     0,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,     0,     0,    40,  3637,     0,    21,     0,
       0,  2305,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,     0,     0,     0,     0,  3638,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,     0,   510,    40,  2728,     0,
       0,  3639,     0,  2308,    69,     0,     0,     0,     0,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   510,     0,
    3391,    69,     0,    21,     0,     0,    40,     0,     0,     0,
       0,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
       0,    69,     0,    40,     0,    21,     0,     0,  3393,     0,
       0,   510,     0,  3640,  2585,  2586,  2587,  2588,  2589,  2590,
    2591,  2592,  2593,  2594,     0,  2595,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    40,  3400,     0,  2585,  2586,
    2587,  2588,  2589,  2590,  2591,  2592,  2593,  2594,    21,  2595,
     510,     0,     0,    69,  2197,  2198,  2199,  2200,  2201,  2202,
    2203,  2204,  2205,  2206,  3401,  2207,     0,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,  3558,    21,     0,     0,
    2923,     0,    69,     0,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   510,     0,     0,     0,     0,     0,    69,
      40,  3402,     0,    21,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,     0,     0,     0,     0,     0,     0,     0,
      21,    69,    40,  3420,     0,     0,     0,     0,     0,   510,
    2585,  2586,  2587,  2588,  2589,  2590,  2591,  2592,  2593,  2594,
       0,  2595,     0,     0,     0,     0,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,    40,    21,     0,   510,  2197,
    2198,  2199,  2200,  2201,  2202,  2203,  2204,  2205,  2206,     0,
    2207,     0,     0,     0,     0,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,    40,    21,    69,     0,     0,  3434,
       0,     0,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,     0,     0,     0,     0,     0,  3480,     0,    69,     0,
      40,    21,     0,  3641,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,     0,     0,  3430,  3518,    40,  2197,  2198,
    2199,  2200,  2201,  2202,  2203,  2204,  2205,  2206,   510,  2207,
       0,    69,     0,  3723,  2197,  2198,  2199,  2200,  2201,  2202,
    2203,  2204,  2205,  2206,     0,  2207,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    40,  3990,    21,     0,     0,  3520,     0,
      69,     0,     0,     0,     0,     0,     0,     0,     0,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,  4011,     0,
       0,    21,    40,     0,     0,     0,    69,  3522,     0,     0,
       0,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
       0,     0,     0,    69,  3535,    21,     0,  4011,    40,  3764,
       0,  2197,  2198,  2199,  2200,  2201,  2202,  2203,  2204,  2205,
    2206,     0,  2207,     0,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,     0,    21,     0,  4026,     0,  3770,    69,
    2197,  2198,  2199,  2200,  2201,  2202,  2203,  2204,  2205,  2206,
       0,  2207,     0,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,    40,    21,     0,   510,     0,     0,    69,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,    40,     0,
       0,  3536,    21,     0,    69,     0,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,     0,     0,  3771,     0,     0,
       0,     0,    40,  3538,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3790,     0,     0,     0,     0,     0,     0,
       0,     0,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,    40,     0,     0,     0,     0,  3543,     0,    69,  2585,
    2586,  2587,  2588,  2589,  2590,  2591,  2592,  2593,  2594,     0,
    2595,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
      40,     0,     0,     0,    69,  3552,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,     0,     0,    69,    40,
    3895,  3559,     0,   818,     0,  2585,  2586,  2587,  2588,  2589,
    2590,  2591,  2592,  2593,  2594,     0,  2595,     0,     0,     0,
       0,     0,     0,     0,     0,  2034,     0,     0,  3583,     0,
       0,     0,     0,     0,     0,     0,     0,    69,     0,  3896,
       0,     0,     0,     0,    21,     0,     0,     0,     0,     0,
       0,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
       0,     0,     0,     0,  3593,   818,    69,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    21,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,     0,     0,     0,     0,
       0,     0,     0,  3594,     0,    69,    21,     0,     0,     0,
       0,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   255,
     256,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3909,     0,
       0,    40,     0,     0,     0,     0,     0,     0,     0,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,     0,     0,
       0,     0,     0,  3903,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    40,     0,     0,     0,     0,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,  2864,   819,  3991,
       0,     0,     0,    40,  3955,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    21,  1080,     0,     0,
       0,     0,     0,     0,  3884,     0,     0,   820,     0,     0,
       0,     0,     0,  4012,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    21,  1080,  3013,     0,    69,  2585,  2586,
    2587,  2588,  2589,  2590,  2591,  2592,  2593,  2594,     0,  2595,
       0,     0,     0,     0,    21,     0,  1081,     0,     0,     0,
     819,     0,  4016,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    69,
      21,     0,     0,  1081,     0,     0,     0,     0,     0,   820,
       0,     0,     0,     0,  1082,     0,     0,     0,     0,     0,
       0,  4027,     0,     0,     0,     0,     0,  1083,     0,    69,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1084,
    1085,  1082,     0,     0,     0,     0,     0,     0,    21,     0,
       0,     0,     0,     0,  1083,     0,     0,     0,     0,     0,
    4267,     0,     0,     0,     0,     0,  1084,  1085,     0,     0,
       0,     0,     0,    40,     0,     0,     0,     0,     0,     0,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,     0,
      40,  2585,  2586,  2587,  2588,  2589,  2590,  2591,  2592,  2593,
    2594,     0,  2595,     0,     0,     0,     0,     0,     0,     0,
       0,    40,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,     0,     0,     0,     0,     0,     0,    40,     0,     0,
       0,     0,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,     0,  2197,  2198,  2199,  2200,  2201,  2202,  2203,  2204,
    2205,  2206,     0,  2207,     0,     0,     0,     0,     0,    69,
       0,     0,     0,     0,     0,    40,     0,     0,     0,     0,
       0,     0,     0,     0,  1086,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    69,  3956,     0,     0,
       0,     0,     0,     0,     0,  1087,     0,     0,     0,     0,
       0,  1086,     0,  1088,  1089,     0,     0,    69,     0,  1090,
    1091,  1092,  1093,  1094,  1095,  1096,  1097,  1098,  1099,  1100,
    1101,  1102,  1087,  1103,  1104,  1105,  1106,  1107,  1108,     0,
    1088,  1089,     0,    69,     0,     0,  1090,  1091,  1092,  1093,
    1094,  1095,  1096,  1097,  1098,  1099,  1100,  1101,  1102,     0,
    1103,  1104,  1105,  1106,  1107,  1108,     0,     0,     0,     0,
       0,     0,     0,     0,   265,   266,  2197,  2198,  2199,  2200,
    2201,  2202,  2203,  2204,  2205,  2206,     0,  2207,     0,     0,
       0,    69,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,     0,     0,     0,     0,     0,     0,     0,     0,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,  3478,    21,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,     0,
      21,  1080,   594,   879,   595,     0,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,     0,     0,     0,     0,  2838,
    2197,  2198,  2199,  2200,  2201,  2202,  2203,  2204,  2205,  2206,
       0,  2207,   602,     0,     0,     0,     0,     0,     0,     0,
    1081,  4006,     0,   450,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,     0,     0,     0,     0,     0,     0,     0,
       0,   451,     0,     0,     0,     0,     0,     0,  1082,  2585,
    2586,  2587,  2588,  2589,  2590,  2591,  2592,  2593,  2594,     0,
    2595,  1083,     0,     0,     0,  1109,     0,  2103,     0,  2104,
       0,   612,   613,  1084,  1085,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    40,  1364,     0,     0,
       0,     0,  1109,     0,  2103,     0,  2104,     0,     0,     0,
       0,     0,     0,     0,     0,   619,     0,    40,    21,  1080,
       0,     0,     0,     0,     0,  2257,   622,     0,     0,   880,
       0,     0,     0,   490,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  4079,     0,   629,   273,   274,
       0,     0,     0,     0,     0,     0,     0,     0,   304,     0,
    1870,     0,     0,     0,   644,     0,    21,  1080,  1081,     0,
       0,     0,     0,     0,     0,   491,     0,     0,     0,     0,
       0,     0,     0,  2585,  2586,  2587,  2588,  2589,  2590,  2591,
    2592,  2593,  2594,     0,  2595,     0,   285,   286,     0,     0,
       0,     0,     0,     0,     0,     0,  1871,     0,     0,     0,
       0,   452,    69,   664,     0,     0,  1081,     0,   666,  1872,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1873,  1874,    69,     0,  2585,  2586,  2587,  2588,  2589,
    2590,  2591,  2592,  2593,  2594,     0,  2595,     0,  1086,   454,
     455,     0,     0,     0,  1082,     0,     0,     0,     0,  4080,
       0,     0,     0,     0,     0,    40,     0,  1083,     0,  1087,
       0,  1875,     0,     0,     0,     0,     0,  1088,  1089,  1084,
    1085,     0,     0,  1090,  1091,  1092,  1093,  1094,  1095,  1096,
    1097,  1098,  1099,  1100,  1101,  1102,     0,  1103,  1104,  1105,
    1106,  1107,  1108,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    40,    21,     0,     0,     0,  4114,     0,
       0,     0,     0,   884,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,     0,     0,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,     0,     0,     0,     0,     0,
       0,    69,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1365,  1366,  1367,  1368,   886,  1369,  1370,  1371,  1372,
    1373,  1374,  1375,  1376,  1377,  1378,  1379,  1380,  1381,  1382,
    1383,  1384,  1385,  1386,  1387,  1388,  1389,  1390,  1391,     0,
       0,     0,     0,     0,     0,  4030,  4031,     0,     0,    69,
       0,  1878,  1879,  1880,  1881,  1882,  1883,  1884,  1885,  1886,
    1887,  1888,  4115,     0,  1086,  1889,  1890,  1891,  1892,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    40,     0,     0,     0,  1087,     0,     0,     0,     0,
       0,     0,     0,  1088,  1089,     0,     0,     0,     0,  1090,
    1091,  1092,  1093,  1094,  1095,  1096,  1097,  1098,  1099,  1100,
    1101,  1102,  3539,  1103,  1104,  1105,  1106,  1107,  1108,    21,
    1080,     0,     0,     0,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   304,     0,     0,     0,     0,     0,  1109,
       0,  2103,     0,  2104,    21,  1080,     0,     0,     0,     0,
       0,  1870,     0,     0,     0,     0,  1392,  1393,  1394,  1081,
       0,     0,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,     0,     0,     0,     0,     0,  1870,    69,     0,     0,
       0,     0,     0,     0,  1081,     0,  4032,  1871,  2585,  2586,
    2587,  2588,  2589,  2590,  2591,  2592,  2593,  2594,     0,  2595,
    1872,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1873,  1874,     0,     0,     0,     0,     0,     0,
       0,     0,  1871,  2585,  2586,  2587,  2588,  2589,  2590,  2591,
    2592,  2593,  2594,     0,  2595,  1872,     0,     0,     0,     0,
       0,    21,  1080,     0,     0,     0,    40,  1873,  1874,     0,
       0,     0,  1875,  2585,  2586,  2587,  2588,  2589,  2590,  2591,
    2592,  2593,  2594,     0,  2595,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1893,    21,  1080,
       0,    40,     0,  1870,     0,     0,     0,  1875,     0,     0,
       0,  1081,     0,     0,     0,     0,     0,     0,     0,     0,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,     0,
    1870,     0,     0,     0,    21,  1109,     0,     0,  1081,  1871,
    2585,  2586,  2587,  2588,  2589,  2590,  2591,  2592,  2593,  2594,
       0,  2595,  1872,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1873,  1874,     0,     0,    21,     0,
       0,     0,    69,     0,     0,     0,  1871,  2585,  2586,  2587,
    2588,  2589,  2590,  2591,  2592,  2593,  2594,     0,  2595,  1872,
       0,     0,     0,     0,     0,     0,     0,     0,    40,     0,
       0,  1873,  1874,    21,  1875,     0,     0,    69,     0,     0,
       0,     0,     0,     0,     0,     0,  1876,  1877,     0,     0,
       0,     0,  1878,  1879,  1880,  1881,  1882,  1883,  1884,  1885,
    1886,  1887,  1888,     0,     0,    40,  1889,  1890,  1891,  1892,
       0,  1875,    21,     0,     0,     0,     0,     0,     0,     0,
       0,  1876,  1877,     0,     0,  3540,     0,  1878,  1879,  1880,
    1881,  1882,  1883,  1884,  1885,  1886,  1887,  1888,     0,     0,
       0,  1889,  1890,  1891,  1892,     0,    21,     0,     0,     0,
       0,    40,     0,   305,     0,     0,     0,     0,     0,     0,
       0,     0,  4171,     0,     0,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,    69,    40,    21,     0,     0,     0,
       0,     0,  4206,     0,     0,     0,     0,     0,     0,     0,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,    21,
      40,    69,     0,     0,     0,     0,     0,     0,  1876,  1877,
       0,     0,     0,     0,  1878,  1879,  1880,  1881,  1882,  1883,
    1884,  1885,  1886,  1887,  1888,     0,     0,  4099,  1889,  1890,
    1891,  1892,     0,     0,     0,     0,     0,     0,     0,    40,
       0,     0,     0,    21,     0,  1876,  1877,    69,     0,  4232,
       0,  1878,  1879,  1880,  1881,  1882,  1883,  1884,  1885,  1886,
    1887,  1888,  4100,     0,     0,  1889,  1890,  1891,  1892,     0,
       0,     0,     0,    40,     0,     0,    21,     0,     0,     0,
       0,    69,     0,     0,  3541,     0,     0,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,     0,     0,     0,     0,
       0,    21,     0,    40,     0,     0,    69,     0,  1893,     0,
       0,     0,     0,     0,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,     0,     0,     0,    40,     0,     0,     0,
       0,    21,     0,  1893,     0,    69,  2585,  2586,  2587,  2588,
    2589,  2590,  2591,  2592,  2593,  2594,     0,  2595,     0,  4164,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,    69,
      40,    21,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,    40,    21,     0,     0,     0,     0,    69,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,    40,    21,
    1893,     0,    69,     0,  2585,  2586,  2587,  2588,  2589,  2590,
    2591,  2592,  2593,  2594,     0,  2595,     0,     0,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,  1893,    40,     0,
       0,    21,     0,     0,     0,     0,    69,     0,     0,     0,
       0,     0,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,     0,     0,     0,    21,     0,     0,     0,    40,    69,
       0,     0,   319,   320,     0,     0,     0,     0,     0,     0,
       0,     0,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,    40,     0,    21,    69,     0,   338,   339,     0,     0,
       0,     0,     0,     0,     0,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,     0,     0,    40,     0,     0,    21,
       0,   351,   352,  3542,    69,     0,  2197,  2198,  2199,  2200,
    2201,  2202,  2203,  2204,  2205,  2206,     0,  2207,     0,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,    40,    21,
     354,   355,     0,     0,    69,     0,     0,     0,     0,     0,
       0,     0,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,    40,    21,     0,   359,   360,     0,    69,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,     0,    21,     0,     0,
      40,  3702,    69,     0,   363,   364,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,    40,   380,   381,    21,
       0,     0,     0,     0,    69,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,    40,    69,     0,    21,
       0,   405,   406,     0,     0,     0,     0,     0,     0,     0,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,    40,
       0,    21,     0,     0,     0,   328,    69,     0,     0,     0,
       0,     0,     0,     0,     0,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,    40,     0,     0,    21,     0,     0,
     368,     0,    69,  3728,     0,  2585,  2586,  2587,  2588,  2589,
    2590,  2591,  2592,  2593,  2594,     0,  2595,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,    40,    21,     0,   430,
       0,     0,    69,     0,     0,     0,     0,     0,     0,     0,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,     0,
       0,    21,     0,     0,     0,    69,    40,     0,     0,  2635,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,    40,    21,
      69,     0,  2673,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,    40,     0,     0,  2676,     0,     0,
       0,     0,    69,     0,     0,     0,     0,     0,     0,     0,
     450,     0,     0,     0,     0,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,    40,     0,     0,     0,     0,  2678,
       0,     0,    69,     0,     0,     0,     0,     0,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,     0,    40,     0,
       0,     0,  2779,     0,    69,     0,     0,     0,     0,     0,
       0,     0,     0,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,     0,     0,     0,     0,    40,     0,     0,     0,
      69,  2820,  3746,  2585,  2586,  2587,  2588,  2589,  2590,  2591,
    2592,  2593,  2594,     0,  2595,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,     0,     0,     0,  2916,     0,     0,
      69,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,    69,   450,     0,  2987,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,     0,     0,     0,     0,
    3021,     0,    69,     0,     0,     0,     0,     0,     0,     0,
     825,   480,     0,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,  2040,     0,     0,  3027,  2585,  2586,  2587,  2588,
    2589,  2590,  2591,  2592,  2593,  2594,     0,  2595,     0,     0,
       0,    21,     0,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,     0,     0,     0,     0,     0,  3036,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,     0,     0,     0,     0,
       0,   456,   457,     0,     0,     0,     0,  3046,     0,     0,
       0,     0,     0,     0,   830,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,     0,     0,  2045,     0,     0,  3082,
    3758,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    21,     0,     0,     0,     0,
       0,     0,   830,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3095,  1468,  1469,  1470,  1471,
    1472,     0,     0,     0,  3431,   830,     0,     0,    40,  1478,
    1479,  1480,     0,     0,     0,     0,  1485,  1613,     0,  1486,
    1487,     0,     0,    21,   825,     0,     0,  3704,     0,     0,
       0,     0,     0,     0,     0,  3222,     0,     0,     0,     0,
       0,     0,     0,     0,  1493,     0,    21,     0,     0,     0,
       0,   830,     0,  2585,  2586,  2587,  2588,  2589,  2590,  2591,
    2592,  2593,  2594,     0,  2595,    21,     0,     0,     0,  3310,
       0,  1568,     0,     0,     0,     0,     0,     0,     0,  1855,
    2585,  2586,  2587,  2588,  2589,  2590,  2591,  2592,  2593,  2594,
       0,  2595,    21,     0,     0,     0,     0,     0,     0,  1862,
       0,     0,     0,  3768,   826,     0,     0,  3321,     0,     0,
       0,     0,     0,     0,  1571,     0,     0,     0,  1614,     0,
      21,     0,    40,     0,    69,     0,     0,     0,  2162,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1513,     0,
      21,  1615,  1616,  1617,  1618,  1619,  1620,  1621,  1622,  1856,
    1623,  1624,  1625,  1626,  1627,  1628,  1629,     0,     0,     0,
       0,     0,     0,     0,     0,    21,     0,     0,     0,  1863,
      40,  1468,  1469,  1470,  1471,  1472,  1473,  1474,  1475,  1476,
    1358,     0,     0,  1477,  1478,  1479,  1480,  1481,  1482,  1483,
    1484,  1485,     0,    40,  1486,  1487,  1488,  1489,  1490,  1491,
    1492,     0,     0,  2402,     0,     0,     0,     0,     0,     0,
       0,     0,    40,    21,     0,     0,     0,     0,   831,  1493,
    1494,  1495,  1496,  1497,     0,     0,  1498,  1499,  1500,  1501,
    1502,  1503,  1504,  1505,  1506,  1507,  1508,  1509,    69,    40,
      21,  1510,  1511,  1512,     0,     0,   510,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   831,    40,  2585,  2586,
    2587,  2588,  2589,  2590,  2591,  2592,  2593,  2594,     0,  2595,
       0,     0,  1866,    21,     0,     0,    69,    40,     0,   831,
    2197,  2198,  2199,  2200,  2201,  2202,  2203,  2204,  2205,  2206,
       0,  2207,     0,     0,     0,     0,     0,     0,   826,    69,
    3861,     0,    40,  1513,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    21,     0,     0,     0,     0,    69,     0,
       0,     0,     0,     0,     0,   831,     0,  3864,  1961,  2585,
    2586,  2587,  2588,  2589,  2590,  2591,  2592,  2593,  2594,     0,
    2595,     0,  1867,     0,     0,    69,     0,    21,     0,     0,
      40,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
       0,     0,     0,    69,     0,     0,     0,    40,     0,  2585,
    2586,  2587,  2588,  2589,  2590,  2591,  2592,  2593,  2594,     0,
    2595,     0,     0,    69,     0,     0,     0,     0,     0,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,    69,     0,
      40,     0,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
      40,     0,     0,     0,     0,     0,    69,     0,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,     0,     0,     0,
       0,     0,     0,    69,    40,     0,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,  3871,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,     0,    69,  3882,     0,     0,
       0,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
    2237,  2585,  2586,  2587,  2588,  2589,  2590,  2591,  2592,  2593,
    2594,     0,  2595,     0,     0,     0,    69,     0,     0,    21,
       0,     0,     0,     0,     0,     0,  3894,     0,     0,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,     0,     0,
      69,     0,     0,     0,     0,     0,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,  4009,  3906,     0,  2585,  2586,
    2587,  2588,  2589,  2590,  2591,  2592,  2593,  2594,     0,  2595,
       0,     0,     0,     0,    21,     0,     0,     0,     0,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,  2055,  2585,
    2586,  2587,  2588,  2589,  2590,  2591,  2592,  2593,  2594,     0,
    2595,     0,     0,     0,     0,     0,     0,    21,     0,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,     0,     0,
       0,     0,     0,     0,     0,     0,    40,     0,     0,     0,
       0,     0,     0,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,  2068,  2585,  2586,  2587,  2588,  2589,  2590,  2591,
    2592,  2593,  2594,     0,  2595,     0,     0,     0,     0,     0,
       0,    21,     0,     0,     0,     0,     0,  2073,  2585,  2586,
    2587,  2588,  2589,  2590,  2591,  2592,  2593,  2594,  1179,  2595,
       0,     0,     0,     0,     0,     0,    21,  2093,     0,     0,
       0,    40,     0,     0,  2585,  2586,  2587,  2588,  2589,  2590,
    2591,  2592,  2593,  2594,     0,  2595,    21,     0,  3927,     0,
    2096,  2585,  2586,  2587,  2588,  2589,  2590,  2591,  2592,  2593,
    2594,     0,  2595,     0,     0,     0,     0,     0,     0,    21,
    2127,     0,    69,     0,    40,     0,  2197,  2198,  2199,  2200,
    2201,  2202,  2203,  2204,  2205,  2206,     0,  2207,     0,    21,
    2136,     0,     0,  1179,  2585,  2586,  2587,  2588,  2589,  2590,
    2591,  2592,  2593,  2594,     0,  2595,     0,     0,     0,    21,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2139,  3980,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    21,     0,     0,     0,    69,    40,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3981,     0,     0,  2400,
       0,     0,     0,    40,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    21,     0,
      69,     0,     0,    40,     0,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,     0,     0,    40,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    40,     0,     0,     0,
    3986,  3681,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    40,     0,     0,     0,
      21,     0,     0,     0,    69,  4007,     0,     0,     0,     0,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,    69,
      40,  4008,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    21,     0,  4010,    69,
       0,     0,     0,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,    69,  4072,     0,    40,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3710,     0,
       0,  4132,    69,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    21,     0,     0,
       0,     0,    69,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,    69,    40,    21,     0,
       0,     0,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,     0,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,    69,     0,    40,     0,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,    21,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,     0,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,    40,   304,     0,     0,     0,     0,
       0,     0,     0,    69,     0,     0,     0,     0,     0,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,  3713,     0,
       0,     0,     0,     0,     0,    40,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    21,     0,    69,
       0,     0,     0,     0,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,    21,  1080,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3722,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   304,     0,     0,
       0,    40,     0,     0,     0,    21,  4017,     0,     0,     0,
      69,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1081,     0,    21,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,     0,    21,     0,     0,     0,
       0,    69,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   304,     0,    21,     0,     0,     0,     0,
       0,     0,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,    21,     0,  3304,    40,  3305,  3306,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1898,  1899,
       0,     0,     0,     0,     0,  2904,    21,    69,     0,     0,
      40,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,    40,  3435,  3436,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    21,     0,     0,
       0,     0,    40,     0,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,    40,     0,  3317,     0,  3318,  3319,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    21,     0,
      69,     0,    40,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3839,
    3840,     0,     0,    21,     0,     0,    69,     0,    40,     0,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,  2737,
    2738,  2739,     0,    40,     0,     0,     0,     0,    69,     0,
       0,  3336,     0,     0,   304,     0,     0,     0,     0,     0,
    2241,  2242,     0,     0,    21,     0,     0,     0,    69,     0,
       0,     0,     0,     0,     0,     0,  3953,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    69,
       0,     0,     0,     0,    40,     0,     0,     0,     0,     0,
       0,     0,     0,    21,     0,   304,     0,     0,    69,     0,
       0,     0,     0,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,    21,     0,    69,    40,     0,     0,     0,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,    21,    69,
      40,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
       0,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
      69,    40,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
    1900,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
      40,    69,     0,     0,     0,     0,     0,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,  3437,    69,    21,     0,    40,
       0,     0,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,    21,     0,     0,     0,    40,     0,     0,     0,     0,
       0,     0,  1179,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    21,     0,     0,     0,     0,    69,     0,     0,
       0,     0,     0,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,  3841,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  4111,     0,    69,  3286,     0,     0,
       0,     0,     0,     0,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,     0,     0,    69,     0,     0,     0,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,     0,     0,
       0,    69,     0,     0,    40,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    40,     0,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,    40,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,  3332,     0,     0,     0,
      69,     0,     0,     0,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,     0,    69,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    69,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,  3950,     0,     0,     0,     0,     0,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,     0,     0,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,  4108,  1120,  1121,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1122,     0,     0,     0,     0,     0,   523,
       0,     0,  1123,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1124,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1125,     0,     0,     0,     0,  1002,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1003,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1126,     0,     0,
       0,  1127,     0,   526,     0,  1128,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   839,   840
  };

  const short
  parser::yycheck_[] =
  {
       0,   311,  1180,     3,   589,   295,   871,   938,   406,     9,
     978,  1463,  1150,   832,    14,   370,   256,   372,   261,   374,
     274,   419,  2036,    23,   274,   274,   274,   274,   294,   286,
     429,   274,   294,   397,   294,    35,   411,   423,   409,   274,
     274,   411,   411,   397,    44,    45,    46,   294,   419,    49,
     409,   397,    52,   411,   274,    55,   397,   355,   417,   409,
     397,   274,    62,    63,   299,    65,   360,    67,   316,   419,
      70,    71,    72,    73,   358,   358,    76,   256,    78,    79,
     355,   411,   274,   256,   274,  2079,  2105,   411,   411,   339,
     320,   411,     3,   331,   355,   274,   411,   274,     9,   339,
     352,   274,   294,    14,   274,   355,   274,   256,   274,   274,
    2105,   274,    23,   113,   350,   355,   286,   281,   274,   339,
     381,   262,   352,   411,   294,   274,   294,   333,   281,   294,
     130,   397,   132,    44,    45,   397,   261,   397,    49,   316,
     397,    52,   274,   397,    55,   274,   411,   397,   397,   274,
     397,    62,    63,   294,    65,   411,    67,   397,   331,    70,
     339,   333,   274,   274,   409,   274,   339,    78,   254,   403,
     411,   339,   345,   345,   419,   269,   270,   274,   428,   429,
     428,   429,   355,   294,   274,   428,   429,   274,   428,   429,
     339,   274,  2510,   428,   429,  1076,   274,   409,  2612,   274,
    3422,  2195,   113,   415,   409,   274,   300,   419,   333,   274,
     274,   409,   409,   307,   419,   428,   429,    51,   397,   130,
     345,   419,   419,   274,   397,   350,   274,   397,    51,   397,
     403,   274,   256,   320,   274,   409,   428,   429,   411,  2353,
    2354,   335,   274,  1952,  1953,   419,   274,   274,   274,   398,
     274,   428,   429,   274,   274,   428,   429,   257,   428,   429,
      51,   274,   411,   274,   264,   428,   429,   267,   274,   269,
     270,   271,   428,   429,   409,   275,   276,   277,   278,   428,
     429,   274,    51,   283,   419,   274,    51,   287,   288,   289,
    2003,  2004,   292,    51,    51,   295,   428,   429,   298,   355,
     300,    51,  1951,   428,   429,   274,    51,   307,   274,    51,
      51,    51,    51,    51,   314,   339,  3324,   317,   318,   428,
     429,   321,   322,   323,    51,   381,  1975,   327,   274,   329,
      51,   428,   429,   409,   334,   335,    51,   413,  3469,    51,
     340,   341,    51,   419,   274,   428,   429,   138,    51,    51,
     935,    89,    71,   353,    51,    71,   356,   138,    51,   428,
     429,   361,  1922,   428,   429,   365,   256,   367,  1910,   369,
      51,   371,   138,   373,   398,   375,   376,   377,    51,  3324,
     428,   429,   382,   383,   274,   428,   429,   411,   428,   429,
     320,    51,    89,   262,   333,   395,   428,   429,   274,   399,
     138,   401,    51,    51,   428,   429,   345,   407,   428,   429,
      51,    51,    51,   138,  1974,    51,  1976,   428,   429,    51,
      51,    51,   428,   429,    51,   294,    51,   333,   171,    51,
     138,   431,  1974,    78,  1976,   435,   436,   437,   438,   345,
     440,   138,  2002,   138,   320,   151,   138,   138,   138,   339,
    3324,    51,   274,    69,   274,  3857,    51,   138,  3324,  2694,
      71,    47,   352,   350,   286,   647,   286,    71,    71,   297,
     339,   151,   294,   286,   294,    19,    20,    51,   138,   646,
      51,    51,    26,    51,    51,    51,   355,    31,    32,    51,
      51,     4,     5,     6,   409,    51,   411,    51,   413,    51,
     415,  3324,   417,  3324,   419,    51,    51,   397,  1184,    51,
     510,    51,  3667,    51,  3324,  3833,    51,    51,   395,    51,
     350,   257,    71,   151,    89,    89,   350,   263,   297,    89,
      51,   257,    51,    51,    51,    51,    51,    51,    69,   462,
      69,    51,   350,   395,    69,   217,   218,   350,  3866,    93,
     550,  3706,   647,    56,    57,    51,   350,   138,   409,    71,
     411,    71,   413,    71,   415,   350,   417,    69,   419,   235,
     114,   130,   276,   138,   138,   397,    69,   397,   138,   138,
      83,    84,   462,   350,   273,    19,    20,   313,    89,   589,
      24,    25,    26,    69,    89,   473,   350,    31,    32,    69,
     113,   114,    69,    37,    38,    51,   428,   429,   428,   429,
     154,   155,   257,   491,    69,  2324,  2325,   138,   647,   542,
      71,   350,   543,   395,   396,   647,   271,   331,   646,    51,
     138,   653,   650,   156,   147,    51,    89,   138,   559,   647,
     257,   646,    88,   138,    55,   158,    49,    50,   161,    10,
     647,   350,   646,    89,   271,   647,    47,   395,   396,    93,
     526,   971,   542,   648,   544,   545,    88,   652,    55,    47,
     359,   360,   361,    89,  2323,    51,    69,   130,    69,   646,
     114,   204,   647,   647,   647,   138,  2395,  2396,    91,   653,
     647,    69,   350,   646,   207,   647,    83,    89,   395,   396,
     350,   245,   138,   569,  2264,    58,   235,   648,   350,   647,
    2270,   652,   647,    89,   101,   581,   582,   362,  1073,  1074,
     154,   155,   138,   104,   105,   106,   107,   108,   109,   110,
     111,   647,   245,   235,   646,  2448,  4054,   250,    91,    92,
     243,    89,   235,   646,  2457,   327,   138,  2460,  4066,   646,
     263,   112,   646,   266,   267,   373,   374,   646,   647,   235,
     647,   274,   138,   276,   262,   235,   258,   259,   235,   414,
      10,   648,   585,   359,   646,   288,   289,  4179,   139,   140,
     141,   646,   130,   281,   395,   396,   492,   530,   286,   235,
     138,   646,   395,   396,   647,   308,   294,   414,  3806,   646,
     652,   297,    51,   104,   105,   106,   107,   108,   109,   110,
     111,   245,   492,   235,   648,  3970,   250,   647,   818,   491,
     820,   821,   650,   647,   647,   825,   826,   827,   341,  3984,
     830,   831,   832,   331,   359,   395,   396,   381,  4060,   647,
      89,  3076,   355,   356,   647,  2554,   462,   345,    88,    89,
     647,   238,   852,   647,   546,   547,   243,  3988,  3989,   650,
    4178,  3806,   647,   250,   492,   276,   647,  3998,   412,  4000,
     964,   871,   112,   376,   377,   646,   876,   649,   544,   545,
     647,   650,   527,   317,   650,   650,   622,   274,    51,   138,
     130,   648,   650,   647,   255,   282,   622,   647,   138,   139,
     140,   141,   350,   648,   359,   351,   648,   648,   648,   648,
    1265,  1266,   650,    51,   427,  1270,  1271,   534,   647,   646,
    1275,  1276,   303,   541,   649,    88,   542,   648,   647,   351,
     317,   462,  3806,   648,   646,   935,   176,   653,   938,   648,
    3806,   649,   395,   396,   944,   648,   648,   381,   647,   189,
      88,   646,   649,    51,    51,   648,   647,   647,  2518,   395,
     396,   201,   202,   138,   964,   646,   359,  3381,   359,   969,
    4125,  3385,   325,   973,  2534,   648,  2518,   647,   412,   395,
     396,   359,  2542,  3806,   984,  3806,   646,   987,    51,   647,
      88,   352,  2534,   647,   381,   235,  3806,   647,   646,   648,
    2542,   241,   303,   395,   396,   647,   623,   648,   648,   648,
      51,   542,   648,   544,   545,   255,   648,   648,   648,   395,
     396,   648,   646,   648,   647,    88,   648,   461,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,    88,   648,   653,
     439,   646,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,  1071,   235,   653,   648,  1075,  1076,   648,   648,    71,
     648,   648,   648,   647,   649,    71,   648,   648,  1088,  1089,
     650,   646,   648,   646,   648,   359,   648,   235,   642,   138,
     644,    35,   648,   648,   653,    51,   648,    90,   648,  1109,
     648,   351,   352,   648,   648,    51,   648,   630,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   640,   641,   648,
     648,   648,   648,   648,   648,    79,   646,   235,   304,   305,
     306,   653,    88,   647,   505,    12,   395,   396,  1148,  1149,
     647,    51,   384,   385,   386,   395,   396,    89,   646,   647,
      89,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   235,   647,    51,   415,   416,   417,   418,    63,
    1180,   647,   549,   647,    89,   646,   647,    51,   351,   103,
     557,   558,    35,   560,   235,   576,    35,   650,   130,   647,
     647,  1201,   397,   398,   650,   400,   138,   647,   642,   138,
     647,   647,   647,   351,   327,   646,   647,   604,    89,    51,
     395,   396,    51,   647,    88,   130,   273,  1903,   650,    79,
    1906,   647,   307,   138,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   351,   173,   647,    67,   644,   359,    88,
     487,   488,   489,  1263,   491,   505,   270,   138,  1268,   175,
     646,   647,   647,  1273,   646,   576,   397,   398,  1278,   400,
    1280,  2162,  1282,    89,  2165,   138,  3134,  3135,   351,   235,
    3138,    51,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   186,   400,   395,   396,   397,   398,   276,   400,
     351,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
    3648,   270,   138,   649,  1334,   350,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,    71,   395,   396,   646,   647,
      89,   235,   944,   646,   647,    51,   646,   647,   297,   646,
     647,   235,   256,   221,   222,   223,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   235,    71,   646,   647,   227,
    2076,   130,   227,    89,   227,   351,   235,   647,  3422,   138,
     646,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     235,   345,   346,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   138,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,  1463,   400,  1465,   395,   396,    44,   531,
      46,    96,    97,    98,    99,   100,  3470,   524,   492,   290,
     291,   292,   293,   294,   295,   648,    71,   351,    71,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,    71,
     400,    71,   549,   550,   551,   552,  1088,  1089,   225,   226,
     648,    71,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   351,   400,   395,   396,    71,  1109,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   127,    91,    92,
     648,   648,    89,   231,   232,   233,  3269,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,    71,   400,  2245,
     487,   488,   489,    71,   491,    71,  3690,    71,   487,   488,
     489,    71,   491,   339,   340,   648,   231,   232,   233,   395,
     396,   487,   488,   489,    71,   491,   384,   385,   386,   988,
      71,   138,    51,   395,   396,   397,   398,   648,   400,    71,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   648,
     400,    71,   526,   646,   647,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,    71,    44,   395,   396,   136,   137,
     133,   134,   135,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   263,   400,   569,  1926,   562,   563,   564,
     565,   646,   647,    51,  1937,   648,   276,    71,   274,    71,
     276,    89,   648,  4186,  4187,   646,   647,   591,   592,   395,
     396,    71,   648,  3732,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   648,   400,   391,   392,   393,   394,
     647,    51,   308,   648,   113,   114,  4219,  3732,   647,   646,
     647,    71,   646,   647,   646,   647,    51,  1926,   648,   329,
     138,   647,    71,  1926,  4237,   646,   647,   646,   647,    71,
     297,   646,   647,    88,    89,   646,   647,   646,   647,   397,
     398,   648,  4255,  4256,   646,   647,  2030,  1926,   646,   647,
    2030,  2030,  2030,  2030,   648,  2461,   526,  2030,   646,   647,
     646,   647,   646,   647,    71,  2030,  2030,    71,   378,   379,
     268,   269,  1943,  2158,  2159,   646,   647,    71,  2065,   277,
    2030,    71,  1937,   138,  1908,  2491,  2492,  2030,    71,   648,
     646,   647,   646,   647,   646,   647,  2092,    71,   568,   569,
    2092,    71,  2092,    71,  1920,    71,   646,   647,  2030,    71,
    2030,   647,  3856,    71,  3858,  2092,   586,   587,   588,   589,
     590,  2030,    71,  2030,    71,  1949,    71,  2030,   395,   396,
    2030,    71,  2030,    71,  2030,  2030,   245,  2030,   646,   647,
      51,   250,   646,   647,  2030,   646,   647,   397,   398,  1973,
     648,  2030,  4220,  4221,  4090,  4091,   646,  2135,  2052,  3128,
    3129,  2523,  2524,   646,  3888,  2065,  3890,   276,  2030,  2052,
    2092,  2030,  1926,   648,   648,  2030,  2000,    71,  1908,  3618,
     648,  2005,    71,  1913,  1914,    71,    71,    71,  2030,  2030,
      71,  2030,  2092,    71,  2092,  1925,  2156,  2092,  1928,    71,
     646,    71,    71,  2030,    71,    71,    71,  2292,  2293,    71,
    2030,  2296,  2297,  2030,    71,  2300,  2301,  2030,  1948,  1949,
      71,  2092,  2030,    71,  1954,  2030,  1956,    71,  2135,  1959,
    1960,  2030,    71,    71,    71,  2030,  2030,    71,  1968,    71,
      71,   646,   297,  1973,  2272,  1088,  1089,  2215,  2072,  2030,
      71,  2092,  2030,    71,  2278,  2235,    71,  2030,  2082,    71,
    2030,    71,  2276,  2276,    71,  2235,  1109,  2272,  2030,  1999,
    2000,  2095,  2030,  2030,  2030,  2005,  2030,   395,   396,  2030,
    2030,  2272,  2012,  2265,  1925,  2235,  2222,  2030,    71,  2030,
      71,    71,  2272,    71,  2030,  2261,   351,    71,  2392,    71,
    3679,  2031,  2272,    71,    71,  2265,  1926,  2030,  2392,    71,
      71,  2030,  2215,    71,    71,  1956,  2392,  4061,  1959,  1960,
    2222,  2392,  2146,    71,    71,  2392,  2235,  2733,  2734,    71,
      71,  2030,  2235,    71,  2030,  2463,  2066,  2235,  2329,  2156,
     395,   396,  2072,    71,  1943,  2248,  2248,    71,    71,    71,
    4074,  3794,  2082,    71,  2030,  3798,  2235,    71,    71,  3802,
      71,  3804,  3805,    71,  2465,  2095,    71,  2222,  2098,  2272,
    2030,  2499,    71,    71,  2104,  2105,  2465,    71,  2483,    71,
     647,    71,   649,  2483,  2483,  2465,    71,  2117,    71,    71,
    2031,    71,    51,  2248,    51,  2483,  2392,   648,  2499,  2129,
    2392,  2131,  2392,  2519,    71,  2392,  2261,  2496,  2392,    71,
    2030,  2141,  2392,  2392,    51,  2392,  2146,  2546,   648,  2499,
      51,    71,  2392,  2483,  2030,  2066,  2250,  2157,  2252,  2483,
    2483,    71,  2162,  2483,   648,  2165,  4180,    71,  2483,  2169,
    2170,  2171,  2172,  2173,  2174,    71,    71,  2177,  2178,  2179,
    2180,  2181,  2182,  2183,  2184,  2185,  2186,  2187,  2188,  2189,
    2190,  2191,  2192,  2193,  2194,  2483,   647,  2197,  2198,  2199,
    2200,  2201,  2202,  2203,  2204,  2205,  2206,  2207,  2030,  2209,
    2030,  2235,   648,  2392,    71,  2449,  2272,    51,  2483,  2392,
    2465,    71,  2392,  2092,  2392,  2319,  2156,  2483,    71,    71,
      71,    71,  2232,  2233,  2234,    71,  2236,   648,    71,  2239,
    2240,    71,  2483,  2065,    71,  2065,  2157,    71,    71,  2398,
    2250,    71,  2252,  2465,  2499,    71,    71,  2257,  2258,   647,
    2465,    71,    51,  2357,   648,    71,  2266,  2465,  2465,    71,
    2092,  2271,  2092,  2329,    71,   648,  2449,   648,    71,  2279,
    2156,    71,  2494,  2222,    71,    71,    71,  2499,   647,  2289,
    2540,  2465,  2540,   648,  2499,   648,  2546,  2540,  2546,  2393,
    2540,  2499,  2499,  2546,  2304,  2540,  2546,  2307,    51,  2248,
    2483,  2546,  2312,   646,  2314,  2315,  2222,  2411,    51,  2319,
     648,    51,  2998,  2234,  3000,  2499,  2326,  2540,  2328,   647,
    2465,    71,    71,  2546,  2483,  2335,    71,  3897,   647,  2339,
      71,   647,  2248,    71,    71,  2235,  2257,    71,  2540,    71,
      71,    71,  2352,    71,  2546,  2266,    71,  2357,  2358,  2453,
    2271,  2455,  2456,  2540,  2499,    71,  2235,  2540,  2279,  2546,
    2540,   646,    71,  2546,  2398,  2265,  2546,  2540,  2289,  3517,
     116,   647,   647,  2546,  2540,   121,   122,   123,   647,  2465,
    2546,  2540,  2682,  2393,  2394,   647,   647,  2546,   647,   647,
     647,   647,  2402,  2272,  2404,   647,   647,    71,  2540,    71,
     647,  2411,  2488,   647,  2546,  2540,   152,  2328,   647,    71,
     647,  2546,   647,  2499,   647,   647,  3102,   647,    71,   647,
      71,  2540,   648,  2527,   647,   647,   647,  2546,   174,   648,
     647,   177,  2536,  2540,    71,  1943,    71,    71,    71,  2546,
    2544,   648,    51,  2453,    71,  2455,  2456,  2540,    71,  2483,
      71,    71,  3914,  2546,  2464,   389,   390,   391,   392,   393,
     394,  2540,   648,   397,   398,  2540,   400,  2546,    71,    71,
      71,  2546,    71,    51,    71,    71,    71,  1876,  1877,    71,
      71,    71,  2540,    51,    71,   648,    71,  2540,  2546,    71,
    2540,    71,  2392,  2546,  1893,    71,  2546,  3475,  2540,    71,
      71,    71,    71,   350,  2546,    71,  2540,    71,    71,    71,
    2540,  3452,  2546,  2105,    71,    71,  2546,  2527,    71,  2540,
      71,    71,    71,    71,  2540,  2546,  2536,    71,    71,  2539,
    2546,    51,   648,   648,  2544,  2545,    71,    71,  2548,  2549,
    2465,   648,  2552,  2464,  2052,  2555,  2556,    71,  2558,  2559,
    2560,  2851,  2562,  2918,   648,    71,    71,  2065,  2483,    71,
    2392,    71,  2392,  2488,  1963,    71,  2886,  3442,    71,  2494,
      71,  2496,    71,    71,  2499,    71,    71,  2169,  2170,  2171,
    2172,    51,   328,  3269,  2092,  2177,  2178,  2179,  2180,  2181,
    2182,  2183,  2184,  2185,  2186,  2187,  2188,  2189,  2190,  2191,
    2192,  2193,  2194,  3432,  2465,  2197,  2198,  2199,  2200,  2201,
    2202,  2203,  2204,  2205,  2206,  2207,    71,    71,  2539,    71,
      71,    71,  2483,    71,  2545,   116,  2636,  2488,  2638,    71,
     121,   122,   123,  2494,    71,  2496,    71,  2036,  2499,    71,
      71,  2651,    71,  2042,    71,    71,    71,    71,  2047,    71,
      71,    71,    55,    71,    71,    71,    71,    71,  2057,   648,
      51,   152,    71,    71,  2674,    71,    71,  2677,   648,  2679,
      71,    55,  2682,    71,    71,    71,  2075,    71,    81,    82,
      83,   312,    71,   174,    71,  3050,   177,    51,  3053,  2699,
      71,  3056,    71,    71,    71,    71,    71,    71,    71,    83,
      71,    71,    71,    71,    71,   336,   337,  2215,  2540,    71,
    2540,    71,    71,    71,  2546,    71,  2546,   101,    71,    71,
    3908,    71,    71,  3409,    71,  3411,    71,    71,    71,    71,
    2651,    71,    71,    71,    71,    71,    71,    71,    71,  2138,
    2248,  2140,    71,    71,    71,   648,   149,    71,    21,    22,
      23,    71,    71,    71,    27,    28,    29,    30,    71,    71,
      71,    71,   165,    71,    71,   149,    71,    71,    51,  2873,
    2780,  2781,    45,   312,  2878,   648,    51,   648,  2699,    71,
      71,   165,    55,    71,    71,  2795,    71,  3473,    51,  2799,
      71,    51,    71,  2803,    71,    51,   235,   336,   337,    71,
      71,    71,    71,    71,   207,    71,    71,    71,   299,  3404,
      83,  2821,  2822,   648,    71,    51,    71,    71,  2828,   475,
     648,    71,    71,   207,    71,   481,   482,   483,   484,   485,
     486,    51,    88,    71,   648,    51,    71,   328,   648,  3525,
     496,  2851,    51,   648,  2243,    71,    71,  2857,   504,  2859,
      71,  3446,    71,   237,    71,   648,    71,  2867,    71,   243,
      71,  2871,    51,  2873,    71,    71,   250,    71,  2878,    71,
      71,   274,    71,    71,    71,  2274,    71,    71,   281,    71,
      71,  2280,  2281,  2282,  2283,    71,    71,  2897,    71,    71,
     274,   648,    51,   647,   646,   526,   527,   281,   653,   647,
      51,    71,   653,   647,   138,   647,   653,  2917,   647,   138,
     646,   138,   647,   646,  2313,   138,  3324,   297,   647,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,  2521,
     400,  2523,  2524,   317,   647,   647,   647,   568,   569,   647,
     571,   572,   647,   574,   575,   576,   577,   647,   647,   647,
    2871,   647,   647,   647,  2964,   647,   647,   647,   647,   647,
     647,   592,   647,   647,  3650,   138,  2976,  2977,   646,   138,
     243,   244,   653,   376,   377,   138,   138,   138,  2988,   235,
    2990,    51,   649,  2993,   138,   138,   138,   526,   527,   138,
     138,   138,   376,   377,    51,   647,  3006,   381,  3008,   138,
     646,  3687,  3012,   646,  3690,   646,   138,   646,   281,   282,
     327,    51,  3022,   138,   646,   138,    88,   138,  3028,   647,
    3030,   138,   138,   138,   138,   138,   138,  3037,   138,   568,
     569,   570,   571,   572,   138,   574,   575,  3047,  3048,  3049,
     138,   297,   581,   138,   649,   138,  2169,  2170,  2171,  2172,
     138,  3061,   138,   592,  2177,  2178,  2179,  2180,  2181,  2182,
    2183,  2184,  2185,  2186,  2187,  2188,  2189,  2190,  2191,  2192,
    2193,  2194,   647,  3083,  2197,  2198,  2199,  2200,  2201,  2202,
    2203,  2204,  2205,  2206,  2207,  3006,  3096,  3008,  3098,  3099,
    3100,   138,  3102,   138,   138,   351,   138,   138,    51,   138,
     647,   646,    51,   376,   377,    51,   646,    51,    51,  3030,
     646,  3797,   138,   646,   138,  3801,   519,   520,   646,   138,
     646,   646,   297,  3133,  3134,  3135,   297,   646,  3138,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,    51,
     400,   297,  3828,   138,   653,   138,   646,   297,  3468,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,  3169,
     400,   297,   646,   235,  2563,  2564,  2565,  2566,   646,   138,
    2569,  2570,  2571,  2572,  2573,  2574,  2575,  2576,  2577,  2578,
    2579,  2580,  2581,  2582,  2583,   646,  2585,  2586,  2587,  2588,
    2589,  2590,  2591,  2592,  2593,  2594,  2595,   138,   138,  3209,
     138,   138,   138,   138,   138,   646,  3892,   235,   646,   138,
     646,   138,   646,  3223,   647,   138,   646,   138,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   647,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,  3169,   400,
     138,    51,   647,   646,    51,   138,   648,   138,  3268,   138,
     644,   646,   138,   646,   646,    71,   400,  2859,   138,   138,
     138,    51,   138,   138,   646,  2867,    71,   350,   138,   351,
     646,   646,   138,  3969,    21,    22,    23,   138,    88,   646,
      27,    28,    29,    30,   138,   646,    33,   138,   646,   138,
     646,  3311,   138,   138,   350,   138,   647,    44,    45,    71,
    3996,    71,  3322,    71,   646,   646,   646,    71,    55,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   138,
     400,   646,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   138,   400,   646,   646,    83,  3268,   646,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   649,
     400,   647,   138,   647,   101,  4051,   646,   138,   646,   138,
     646,  4057,  2964,   647,   138,   541,   150,   138,  3388,   646,
     400,   138,  3392,   138,   646,  3395,    51,  4073,   646,   138,
     646,   138,   138,   646,  3404,   646,  3406,  2796,  3806,   138,
     646,  2800,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   138,  3432,   138,   646,   649,   138,   138,   138,   647,
     138,   138,  3442,  4119,   646,   235,  3446,   647,   138,   647,
     138,   312,  3452,   646,    51,   138,  3456,  3457,   138,   138,
    3460,   647,   138,  3463,   647,   138,  3048,  3049,   646,   646,
     138,  3471,   646,   138,   138,   336,   337,   138,   138,  3061,
      51,   138,   138,  3483,  3484,   138,   138,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   138,   400,   138,
     138,   138,   138,   138,  3504,   138,  3506,   297,   138,   138,
    2899,   138,  3512,   138,   138,   138,   243,   244,   138,  3519,
      51,   138,   138,   138,   138,   646,   138,   138,    51,   138,
    3530,  3531,   138,   138,   646,   138,   138,  3537,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   138,   400,
     138,   138,   138,   646,   281,   282,   138,  3912,  3558,   138,
     138,   351,   646,   138,  3564,    88,   138,   646,   138,   646,
     138,   646,   646,  3573,     8,   646,   649,    11,   138,   649,
     138,  3581,   646,   138,   138,   646,   138,   646,  3588,  2978,
     652,   646,   646,   138,   138,   138,   138,   138,   138,   647,
      34,  3512,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,  3001,   400,    48,   648,  3616,   276,   646,  3619,
     647,   647,  3622,   646,   646,   297,  3015,  3209,   652,    51,
     395,   297,    51,    51,    68,   646,  3730,   944,   391,   392,
     393,   394,   395,   396,   397,   398,   138,   400,   138,   376,
     377,   648,   648,   648,    51,   648,   963,    71,  4013,  4014,
      71,   648,   646,   276,    71,   526,   527,   648,   648,   297,
      88,   648,   400,   648,   648,   646,   646,    71,  3678,   652,
     646,   646,   138,   138,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   648,   646,   646,    71,   568,   569,   646,
     571,   572,   235,   574,   575,   576,    51,    51,   653,  3719,
     581,  3721,    51,  3723,   653,   159,   160,  4082,  4083,    71,
    3730,   592,  3732,   648,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   178,   400,  2859,   648,   653,   648,
     653,    71,  3752,  3753,  2867,  3755,    71,   647,    71,   138,
     652,   138,  3762,    51,   653,    51,    51,    51,   647,   646,
    3770,  3771,   653,    71,   646,    51,   646,   138,    51,   297,
     648,  1088,  1089,   646,  3784,   297,   297,    51,    71,  4144,
    3790,    71,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,  1109,   400,   646,    71,    71,   647,   242,   646,
     648,    71,  3812,   648,    71,  3815,   648,   235,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   351,   400,
     648,   646,   646,    71,    71,     3,    71,    51,   272,    71,
      71,    71,   653,   653,   492,    13,   653,   151,   646,    71,
      18,  2964,    71,   647,   646,   652,   646,   138,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,    51,   400,
      51,    51,   646,   646,  3456,  3457,   647,  1184,  3878,   646,
    3880,  3463,    71,   646,    52,    53,   646,    55,   646,   646,
     646,    59,    60,    61,   543,   541,   150,   646,   138,  3899,
    3900,  3483,  3484,    51,   646,   648,   646,   648,  3908,   138,
     648,  3911,    80,  3913,  3914,    83,   648,   652,   358,   653,
     354,  3921,  3504,   647,  3506,   391,   392,   393,   394,   395,
     396,   397,   398,   351,   400,  3048,  3049,   297,   647,    71,
      51,   350,   646,   358,    51,   113,   114,    51,  3061,   556,
     138,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     647,   138,   647,   138,   142,   143,   144,   646,   350,   541,
    3369,   652,  3564,   653,   647,    51,   653,    51,    51,    51,
    3990,   653,   646,   350,   350,   653,   647,   165,   166,   167,
      55,   169,   170,   653,   646,   652,    71,    51,   648,   138,
     150,  4011,   492,   151,   648,   646,   138,    71,   350,    51,
     646,   541,  4022,  4023,   646,    88,  4026,   195,   196,   647,
      51,   350,   653,    51,   653,    51,   646,    51,  3427,   647,
    4040,    71,  4042,   647,  3433,   646,   646,   646,   646,    71,
     646,   646,   556,   646,   648,  3444,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   243,    51,   245,   647,   492,
     647,   647,   250,   646,   648,    51,   647,  4087,  3477,   646,
     258,   259,   151,   261,   647,   263,  3209,   152,   153,   646,
     648,  4101,    51,   138,    51,    51,  4106,    71,   647,   646,
     646,   646,   280,   168,   648,   138,   648,    51,   138,   174,
     646,   289,   177,   646,    51,   138,    71,  3516,    71,   648,
     138,   299,   648,   648,   138,   190,   646,    51,  3527,   307,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
    3732,   400,   648,   648,   648,  4155,   132,   646,  2338,  2355,
     328,  4161,  4162,  3103,  2358,  2317,   334,   335,  4168,  3771,
    3752,  3753,   235,   341,  3787,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,  4185,   400,  4158,  2828,  2516,
    2063,  2114,  3463,  4193,   249,  3455,  2981,  2505,  4198,   254,
    4200,  2886,  3591,  4035,  4165,  2519,  4168,  3996,   376,   377,
    2513,  3467,  2998,  2121,  2546,   427,  2540,  4217,  2529,  2248,
    1937,   276,  2265,  2525,  2803,  2398,   435,  3806,   646,   821,
     437,  3830,   287,  3651,   438,     3,  3625,  3626,     6,  2030,
    4058,  3691,   827,  3688,  4244,    13,  2092,  2156,  2117,    17,
      18,   984,  4252,  3642,  2288,  3644,  1250,  4257,  2449,  1915,
    2276,   852,  1920,  2465,  2499,  2463,  2496,   322,  2494,  4269,
    2392,   326,  2235,   328,  2488,   330,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,  2272,   400,   351,  2329,
    2483,    59,    60,    61,    62,    63,  1957,  2065,  3880,   876,
     551,  2258,  2892,  1943,  2135,  2857,  1926,  2256,  3762,  3698,
    3699,  2239,  3701,    51,  3800,  3784,    -1,  3899,  3900,  2552,
    3709,    -1,   490,   378,   379,    -1,    94,    -1,  3717,   973,
      -1,    -1,    -1,  4244,   102,    -1,  2052,    -1,    -1,    -1,
      -1,    -1,    -1,  3456,  3457,   113,   114,   115,    -1,    -1,
      88,    -1,    -1,    -1,    -1,    -1,   124,   125,   126,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3756,  3757,    -1,
    3483,  3484,    -1,    -1,   142,   143,   144,    -1,  3767,    -1,
      -1,    -1,    -1,    -1,   152,    -1,    -1,    -1,    -1,    -1,
      -1,  3504,    -1,  3506,    -1,    -1,    -1,    -1,   566,    -1,
      -1,   650,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   177,
      -1,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
      -1,    -1,  3821,    -1,    -1,    -1,    -1,    -1,   206,    -1,
    3829,    -1,    -1,    -1,   612,   613,   614,   615,   616,   617,
     618,  3564,    -1,    -1,    -1,    -1,   624,   625,   626,   627,
     628,   629,    -1,    -1,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,    -1,   400,    -1,   245,   246,    -1,
     248,    -1,   250,    -1,    -1,   253,   254,    -1,    -1,    -1,
     258,   259,    51,   261,    -1,   263,    -1,   235,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   275,   276,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   287,
     400,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   296,    88,
     298,   299,    -1,    -1,  3923,   648,    -1,    -1,    -1,   307,
     308,   309,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   319,   320,   321,    -1,    -1,    -1,    -1,    -1,    -1,
     328,    -1,    -1,    -1,    -1,    -1,   334,   335,  3957,  3958,
      -1,    -1,    -1,   341,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   646,    -1,    -1,    -1,    -1,    -1,    -1,
    3979,    -1,    -1,    -1,    -1,  1902,  1903,  1904,  3987,  1906,
      -1,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,  1918,   400,   351,    -1,    -1,  1923,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1932,  1933,    -1,  1935,    -1,
      -1,    -1,  1939,    -1,    -1,    -1,    -1,    -1,    -1,  3752,
    3753,  4030,  4031,    -1,    -1,    -1,  4035,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,    -1,   400,    -1,
    1967,  4050,  1969,  1970,  1971,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1979,    -1,  1981,    -1,   235,    -1,  1985,  1986,
    1987,  1988,  1989,  1990,  1991,    -1,    -1,    -1,    -1,  1996,
      -1,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,  2008,   400,  4092,  4093,    -1,    -1,    -1,    -1,    -1,
      -1,  2018,  2019,  4102,    -1,  2022,    -1,    -1,    -1,    -1,
      -1,  2028,   490,   648,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4121,    -1,    -1,    -1,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3880,   648,  2076,
      -1,    -1,    -1,    -1,    -1,    -1,  4165,    -1,    -1,  2086,
    2087,  2088,    -1,  4172,    -1,    -1,  3899,  3900,    -1,    -1,
      -1,    -1,   351,    -1,    -1,    -1,    -1,    -1,  2105,    -1,
      -1,    -1,  2109,  2110,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2120,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,    -1,   400,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4222,  4223,    -1,  2143,    -1,    -1,    -1,
    2147,    -1,    -1,  2150,    -1,  2152,  4235,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   624,   625,   626,   627,
     628,   629,  2169,  2170,  2171,  2172,    -1,    -1,    -1,    -1,
    2177,  2178,  2179,  2180,  2181,  2182,  2183,  2184,  2185,  2186,
    2187,  2188,  2189,  2190,  2191,  2192,  2193,  2194,    -1,    -1,
    2197,  2198,  2199,  2200,  2201,  2202,  2203,  2204,  2205,  2206,
    2207,    -1,    -1,    -1,    -1,    -1,   648,    -1,   646,    -1,
    2217,  2218,    -1,  2220,    -1,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,  2241,  2242,    -1,    -1,  2245,    -1,
      51,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     648,    -1,    -1,    -1,    -1,    -1,  2263,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,    -1,   400,    -1,
      -1,    -1,    -1,     0,    -1,    -1,    -1,    88,    -1,    -1,
    2287,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,    -1,
     400,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    39,    40,    41,    42,    43,    -1,    -1,    -1,
      47,    -1,    -1,    -1,    -1,    -1,    -1,    54,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,    65,    66,
      -1,    -1,    -1,    70,    -1,    72,    73,    74,    75,    76,
      -1,    -1,    51,    -1,    -1,    -1,    -1,    -1,    85,    86,
      -1,    88,    -1,    -1,    -1,    -1,  2373,    -1,    95,  2376,
    2377,    -1,    -1,   648,   101,    -1,    -1,  2384,    -1,  2386,
    2387,  2388,  2389,  2390,    -1,    -1,    -1,   646,    -1,    88,
     117,   118,   119,   120,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   129,    -1,   131,   132,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2421,  2422,    -1,    -1,   145,    -1,
      -1,    -1,  2429,    -1,   235,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,    -1,   400,   164,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   172,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2461,    -1,    -1,    -1,    -1,    -1,
      -1,  2468,  2469,  2470,    -1,  2472,    -1,    -1,  2475,  2476,
     197,   198,   199,   200,  2481,  2482,   203,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2491,  2492,    -1,   214,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,    -1,   400,
      -1,    -1,    -1,  2510,    -1,    -1,    -1,    -1,   235,    -1,
      -1,    -1,    -1,   240,    -1,    -1,   648,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,    -1,   400,    -1,
      -1,    -1,    -1,   260,    -1,   262,   235,   264,   265,    -1,
     351,    -1,    -1,    -1,    -1,    -1,   273,    -1,   648,   276,
      -1,   278,   279,    -1,    -1,    -1,   283,   284,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,    -1,   400,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
      -1,   400,    -1,   310,   311,    -1,    51,   314,   315,   316,
      -1,   318,   319,    -1,    -1,    -1,    -1,   324,    -1,    -1,
     327,    -1,    -1,    -1,    -1,   332,   333,    -1,    -1,    -1,
      -1,   338,    -1,    -1,    -1,   342,   343,   344,    -1,    -1,
     347,    -1,   349,    88,   351,    -1,   353,    -1,    -1,    -1,
      -1,    -1,   359,   360,   361,    -1,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,   372,    -1,    -1,   375,    -1,
      -1,    -1,   351,    -1,    -1,   382,   383,    -1,    -1,    -1,
      -1,   388,    -1,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,    -1,    -1,   648,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   421,   422,    -1,    -1,    -1,    -1,
      -1,    51,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,    -1,   400,  2721,  2722,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2733,  2734,    -1,   456,
      -1,    -1,    -1,    -1,   461,    -1,    -1,    -1,    88,    -1,
      -1,    -1,    -1,    -1,    -1,   646,    -1,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,    -1,    -1,    -1,    -1,
     235,    -1,    -1,    -1,   646,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,    -1,    -1,    -1,   524,    -1,    -1,
      -1,   528,   529,    51,    -1,   532,   533,    -1,   535,   536,
     537,   538,   539,   540,    -1,    -1,    -1,   648,    -1,    -1,
      -1,   548,    -1,    -1,    -1,    -1,   553,   554,   555,   648,
      -1,    -1,    -1,    -1,   561,   646,    -1,    -1,    -1,    -1,
      88,    -1,    -1,    -1,    51,    -1,    -1,    -1,    -1,    -1,
      14,    15,  2859,    -1,    -1,    -1,   583,   584,    -1,    -1,
    2867,    -1,    -1,    -1,    -1,    -1,    -1,   594,   595,    -1,
      -1,    -1,    -1,  2880,    -1,    39,    40,    41,    42,    43,
      -1,    88,    -1,    47,    -1,   235,   351,    -1,    -1,    -1,
      54,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      64,    65,    66,    -1,    -1,    -1,    70,    -1,    72,    73,
      74,    75,    76,    51,    -1,    -1,   643,    -1,   645,    -1,
      -1,    85,    86,    -1,    88,    -1,    -1,    -1,    -1,    -1,
      -1,    95,    -1,    -1,    -1,    -1,    -1,   101,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   646,    -1,    -1,
      88,    -1,    -1,   117,   118,   119,   120,  2964,    -1,    -1,
      -1,   648,    -1,    -1,    -1,   129,    -1,   131,   132,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   145,    -1,    -1,    -1,    -1,    -1,   235,    -1,    -1,
      -1,  2998,    -1,  3000,    -1,    -1,    -1,    -1,    -1,    -1,
     164,   351,    -1,    -1,    -1,    -1,    -1,    -1,   172,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   235,    -1,
      -1,    -1,    -1,   197,   198,   199,   200,    -1,    -1,   203,
      -1,  3048,  3049,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     214,    -1,    -1,    -1,  3061,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   235,    -1,    -1,    -1,    -1,   240,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,    -1,   400,    -1,
      -1,    -1,    -1,    -1,    -1,  3102,   260,   235,   262,    -1,
     264,   265,    -1,   351,    -1,    -1,    -1,    -1,    -1,   273,
      -1,    51,   276,    -1,   278,   279,    -1,    -1,    -1,   283,
     284,  3128,  3129,    -1,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,    -1,   351,    -1,   310,   311,    88,    -1,
     314,   315,   316,    -1,   318,   319,    -1,    -1,    -1,    -1,
     324,    -1,    -1,   327,    -1,    -1,    -1,    -1,   332,   333,
      -1,    -1,    51,    -1,   338,    -1,    -1,    -1,   342,   343,
     344,   646,    88,   347,    -1,   349,    -1,   351,    -1,   353,
      -1,    -1,    -1,    -1,    -1,   359,   360,   361,    -1,   363,
     364,   365,  3209,   367,   368,   369,   370,   371,   372,    88,
      -1,   375,    -1,   351,    -1,    -1,    -1,    -1,   382,   383,
      -1,    -1,    51,    -1,   388,    -1,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,    -1,   400,   421,   422,    88,
      -1,    -1,  3269,    -1,    -1,    -1,    -1,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,    -1,    -1,    -1,    -1,
      -1,    -1,   456,    -1,    -1,   235,   646,   461,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,    -1,   400,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   235,
      -1,    -1,    -1,    -1,   646,    -1,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,    -1,   235,    -1,    -1,    -1,
     524,    -1,    -1,    -1,   528,   529,    -1,    -1,   532,   533,
      -1,   535,   536,   537,   538,   539,   540,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   548,    -1,    -1,    -1,    -1,   553,
     554,   555,    -1,    -1,    -1,    -1,    -1,   561,   646,    -1,
      -1,    -1,  3409,    -1,  3411,    -1,   235,    -1,    -1,    -1,
      -1,   351,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   583,
     584,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     594,   595,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   646,
      -1,    -1,    -1,    -1,    -1,   351,    -1,    -1,    -1,  3456,
    3457,    -1,    -1,    -1,    -1,    -1,  3463,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3473,    -1,    -1,    -1,
      -1,    -1,   351,    -1,    -1,    -1,  3483,  3484,    -1,   643,
      -1,   645,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,    -1,   400,    -1,    -1,    -1,  3504,    -1,  3506,
      -1,    -1,    -1,    -1,   648,    -1,    -1,    -1,   646,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3525,    -1,
      -1,    -1,   351,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,    -1,    -1,   646,    -1,  3564,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,    -1,   400,    -1,    -1,    -1,
      -1,    -1,  3649,  3650,    -1,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,    -1,    -1,    -1,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,    -1,   400,    -1,
    3687,    -1,    -1,  3690,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,    -1,   400,    -1,    -1,     3,     4,
      -1,     6,     7,    -1,     9,    -1,   646,    -1,    13,    -1,
      -1,    16,    -1,    18,    -1,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,  3732,   400,    -1,    -1,    -1,
      -1,    36,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    44,
      45,   648,    -1,   649,    -1,  3752,  3753,    52,    53,    -1,
      55,    -1,    -1,    -1,    59,    60,    61,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   646,   400,    -1,
      -1,    -1,    77,    -1,    -1,    80,    81,    82,    83,    -1,
      -1,    -1,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3797,    -1,  3799,    -1,  3801,    -1,   101,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   113,   114,
     115,    -1,    -1,    -1,    -1,    -1,    -1,   646,    -1,    -1,
      -1,  3828,    -1,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,    -1,   400,    -1,    -1,   142,   143,   144,
      -1,   146,   147,   148,   149,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   157,   158,    -1,    -1,    -1,   162,   163,    -1,
     165,   166,   167,    -1,   169,   170,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3880,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   648,  3892,   191,   192,   193,   194,
     195,   196,  3899,  3900,    -1,    -1,    -1,    -1,    -1,    -1,
     205,   206,   207,   208,   209,   210,   211,   212,   213,    -1,
     215,   216,    -1,    -1,   219,   220,    -1,    -1,    -1,   224,
      -1,    -1,    -1,   228,   229,   230,   648,    -1,    -1,   234,
      -1,   236,    -1,    -1,   239,    -1,    -1,    -1,   243,   244,
     245,    -1,   247,   648,    -1,   250,   251,   252,    -1,    -1,
      -1,    -1,    -1,   258,   259,    -1,   261,    -1,   263,    -1,
      -1,    -1,  3969,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     275,    -1,    -1,    -1,   648,   280,   281,   282,    -1,    -1,
     285,    -1,    -1,    -1,   289,    -1,    -1,    -1,    -1,  3996,
      -1,    -1,    -1,    -1,   299,   300,   301,    -1,    -1,    -1,
      -1,    -1,   307,    -1,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,    -1,   400,   648,    -1,   323,    -1,
      -1,    -1,    -1,   328,    -1,    -1,    -1,    -1,    -1,   334,
     335,     3,    -1,    -1,    -1,    -1,   341,    -1,    -1,    -1,
      -1,    13,    -1,    -1,  4051,    -1,    18,    -1,    -1,    -1,
    4057,    -1,   357,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,    -1,   400,    -1,  4073,    -1,    -1,    -1,
      -1,   376,   377,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      52,    53,   648,    55,    -1,    -1,    -1,    59,    60,    61,
      -1,    63,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,    -1,   400,    -1,    -1,    -1,    -1,    80,    -1,
      -1,    83,  4119,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,    -1,   400,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,    -1,   400,    -1,    -1,    -1,
      -1,   113,   114,     3,    -1,    -1,     6,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    16,    17,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,    -1,   400,
     142,   143,   144,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,    -1,   400,   490,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   165,   166,   167,    -1,   169,   170,    59,
      60,    61,    62,    63,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   518,   519,   520,    -1,    -1,    -1,    -1,
     525,    -1,    -1,   195,   196,    -1,    -1,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,     3,   400,    -1,
       6,    -1,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    17,    -1,   113,   114,   115,    -1,    -1,    -1,    -1,
      -1,   566,   567,   648,   124,   125,   126,    -1,   128,    -1,
      -1,   243,    -1,   245,    -1,    -1,    -1,    -1,   250,    -1,
      -1,    -1,   142,   143,   144,    -1,   258,   259,    -1,   261,
      -1,   263,    -1,    59,    60,    61,    62,    63,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   165,    -1,    -1,   280,    -1,
      -1,    -1,   648,    -1,    -1,    -1,    -1,   289,    -1,   624,
     625,   626,   627,   628,   629,    -1,    -1,   299,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   307,   102,   103,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   206,   113,   114,   115,
      -1,   648,    -1,    -1,    -1,    -1,   328,    -1,   124,   125,
     126,    -1,   334,   335,    -1,    -1,    -1,    -1,    -1,   341,
      -1,    -1,   648,    -1,    -1,    -1,   142,   143,   144,    -1,
      -1,    -1,    -1,    -1,   648,   245,   246,    -1,   248,    -1,
     250,    -1,    -1,   253,   254,    -1,    -1,    -1,   258,   259,
      -1,    -1,    -1,   263,   376,   377,    -1,    -1,    -1,    -1,
      -1,   177,    -1,    -1,    -1,   275,   276,   648,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   287,    -1,    -1,
      -1,    -1,   648,    -1,    -1,    -1,   296,    -1,   298,   299,
     206,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   319,
     320,   321,    -1,    -1,    -1,    -1,    -1,    -1,   328,    -1,
      -1,    -1,    -1,    -1,   334,   335,    -1,    -1,    -1,   245,
     246,   341,   248,    -1,   250,    -1,   648,   253,   254,    -1,
      -1,    -1,   258,   259,    -1,    -1,    -1,   263,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   275,
     276,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   490,    -1,
     380,   287,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     296,    -1,   298,   299,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   307,   308,   309,    -1,    -1,    51,    -1,    -1,    -1,
      -1,    -1,    -1,   319,   320,   321,    -1,    -1,    -1,    -1,
       3,    -1,   328,     6,    -1,    -1,    -1,    -1,   334,   335,
      -1,    51,    -1,    -1,    17,   341,    -1,    -1,    -1,   345,
      -1,    -1,   348,    88,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   566,   400,    -1,    -1,    -1,    -1,
     460,    51,    -1,    -1,    -1,    -1,    -1,    -1,    88,    89,
      -1,    -1,    -1,    -1,    -1,    -1,    59,    60,    61,    62,
      63,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     490,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    88,    89,
     612,   613,   614,   615,   616,   617,   618,   619,   620,   621,
     130,    -1,   624,   625,   626,   627,   628,   629,   138,   102,
     103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     113,   114,   115,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     130,   124,   125,   126,    -1,    -1,    -1,    -1,   138,    -1,
      51,    -1,    -1,    -1,    -1,    -1,   176,    -1,    -1,   142,
     143,   144,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   189,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    51,
      -1,   201,   202,    -1,   490,    -1,   176,    88,    -1,    -1,
     235,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   189,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   201,   202,    -1,    -1,   235,    88,    -1,    -1,    -1,
      -1,   241,    -1,   206,   624,   625,   626,   627,   628,   629,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      51,    -1,    -1,    -1,    -1,   235,    -1,    -1,    -1,    -1,
      -1,   241,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   245,   246,    51,   248,    -1,   250,    -1,    -1,
     253,   254,    -1,    -1,    -1,   258,   259,    88,    -1,    -1,
     263,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   275,   276,    -1,    -1,    51,    -1,    -1,    -1,
      -1,    88,    -1,   648,   287,    -1,   351,    -1,    -1,    -1,
      -1,    -1,    -1,   296,    -1,   298,   299,    -1,   624,   625,
     626,   627,   628,   629,   307,   308,   309,    -1,    51,    -1,
      -1,   351,    -1,    88,   235,    -1,   319,   320,   321,    -1,
      -1,    -1,    -1,    -1,    -1,   328,    -1,    -1,    -1,    -1,
      -1,   334,   335,    -1,    -1,    51,    -1,    -1,   341,    -1,
      -1,   351,   345,   235,    -1,    88,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   395,   396,    -1,    -1,    -1,
      -1,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,    88,    -1,    -1,   415,   416,   417,   418,    -1,
      -1,    -1,    -1,    -1,    -1,   395,   396,    -1,    -1,    -1,
      -1,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,    -1,    -1,   235,   415,   416,   417,   418,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   235,    -1,
     351,    -1,    -1,    -1,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,    -1,    -1,    -1,    51,    -1,    -1,   351,
     235,    -1,    -1,    -1,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,    -1,    -1,    -1,    -1,   490,    -1,    -1,
      -1,    -1,   235,    88,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,    -1,   400,    -1,    -1,    51,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   235,
     351,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,    -1,   400,    -1,    -1,    51,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   351,    88,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,    88,    51,    -1,    -1,   351,    -1,    -1,    -1,
      -1,   646,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,    51,    -1,    -1,    -1,    -1,    -1,   647,   351,    -1,
      88,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   624,   625,   626,   627,   628,   629,    -1,    -1,    51,
      -1,    -1,    -1,    -1,    -1,   351,    -1,   647,    88,    -1,
     235,    -1,    -1,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,    -1,    -1,    -1,    -1,    88,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,    51,    -1,    -1,    -1,
      88,    -1,   235,    -1,    -1,    -1,    -1,    -1,    -1,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,    51,   235,
      -1,    -1,    -1,    88,    -1,   646,    -1,    -1,    -1,    -1,
      -1,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
      -1,    -1,    -1,   648,   646,    88,   351,   235,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,    -1,    -1,    -1,
     648,    -1,    -1,    -1,    -1,   235,    -1,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,    -1,   400,    -1,
      -1,    -1,    -1,    -1,    51,    -1,    -1,    -1,   351,    -1,
      -1,    -1,    -1,   235,    -1,   646,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,    -1,   400,    -1,    -1,
      -1,    51,    -1,    -1,    -1,   351,    -1,   235,    -1,   646,
      -1,    88,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,    -1,   400,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    51,    -1,    -1,    -1,    -1,    -1,    -1,    88,    -1,
     235,   646,    -1,   351,    -1,    -1,    -1,    -1,    -1,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,    88,    -1,
      -1,   351,   235,   646,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    51,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,    -1,   400,    -1,    -1,    -1,   351,
     646,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
      88,    -1,    51,   351,    -1,    -1,    -1,    -1,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,    -1,    -1,    51,
      -1,    -1,    -1,    -1,    -1,    -1,   351,    -1,   235,    88,
      -1,    -1,    -1,    -1,    -1,    -1,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   235,    88,    -1,   351,    -1,
      -1,    -1,    -1,    -1,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,    -1,    -1,   235,   648,    -1,    88,    -1,
      -1,   646,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,    -1,    -1,    -1,    -1,   648,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,    -1,    51,   235,   138,    -1,
      -1,   648,    -1,   646,   351,    -1,    -1,    -1,    -1,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,    51,    -1,
     646,   351,    -1,    88,    -1,    -1,   235,    -1,    -1,    -1,
      -1,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
      -1,   351,    -1,   235,    -1,    88,    -1,    -1,   646,    -1,
      -1,    51,    -1,   648,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,    -1,   400,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   235,   646,    -1,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,    88,   400,
      51,    -1,    -1,   351,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   646,   400,    -1,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,    51,    88,    -1,    -1,
     648,    -1,   351,    -1,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,    51,    -1,    -1,    -1,    -1,    -1,   351,
     235,   646,    -1,    88,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      88,   351,   235,   646,    -1,    -1,    -1,    -1,    -1,    51,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
      -1,   400,    -1,    -1,    -1,    -1,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   235,    88,    -1,    51,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,    -1,
     400,    -1,    -1,    -1,    -1,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   235,    88,   351,    -1,    -1,   646,
      -1,    -1,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,    -1,    -1,    -1,    -1,    -1,   646,    -1,   351,    -1,
     235,    88,    -1,   648,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,    -1,    -1,   646,   646,   235,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,    51,   400,
      -1,   351,    -1,   648,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,    -1,   400,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   235,    51,    88,    -1,    -1,   646,    -1,
     351,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,    51,    -1,
      -1,    88,   235,    -1,    -1,    -1,   351,   646,    -1,    -1,
      -1,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
      -1,    -1,    -1,   351,   646,    88,    -1,    51,   235,   648,
      -1,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,    -1,   400,    -1,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,    -1,    88,    -1,    51,    -1,   648,   351,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
      -1,   400,    -1,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   235,    88,    -1,    51,    -1,    -1,   351,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   235,    -1,
      -1,   646,    88,    -1,   351,    -1,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,    -1,    -1,   648,    -1,    -1,
      -1,    -1,   235,   646,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   648,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   235,    -1,    -1,    -1,    -1,   646,    -1,   351,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,    -1,
     400,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     235,    -1,    -1,    -1,   351,   646,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,    -1,    -1,   351,   235,
     648,   646,    -1,    47,    -1,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,    -1,   400,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    69,    -1,    -1,   646,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   351,    -1,   648,
      -1,    -1,    -1,    -1,    88,    -1,    -1,    -1,    -1,    -1,
      -1,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
      -1,    -1,    -1,    -1,   646,    47,   351,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    88,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   646,    -1,   351,    88,    -1,    -1,    -1,
      -1,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   646,
     647,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   648,    -1,
      -1,   235,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,    -1,    -1,
      -1,    -1,    -1,   646,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   235,    -1,    -1,    -1,    -1,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,    69,   302,   646,
      -1,    -1,    -1,   235,   648,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    88,    89,    -1,    -1,
      -1,    -1,    -1,    -1,    69,    -1,    -1,   331,    -1,    -1,
      -1,    -1,    -1,   646,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    88,    89,    69,    -1,   351,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,    -1,   400,
      -1,    -1,    -1,    -1,    88,    -1,   138,    -1,    -1,    -1,
     302,    -1,   646,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   351,
      88,    -1,    -1,   138,    -1,    -1,    -1,    -1,    -1,   331,
      -1,    -1,    -1,    -1,   176,    -1,    -1,    -1,    -1,    -1,
      -1,   646,    -1,    -1,    -1,    -1,    -1,   189,    -1,   351,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   201,
     202,   176,    -1,    -1,    -1,    -1,    -1,    -1,    88,    -1,
      -1,    -1,    -1,    -1,   189,    -1,    -1,    -1,    -1,    -1,
     646,    -1,    -1,    -1,    -1,    -1,   201,   202,    -1,    -1,
      -1,    -1,    -1,   235,    -1,    -1,    -1,    -1,    -1,    -1,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,    -1,
     235,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,    -1,   400,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   235,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,    -1,    -1,    -1,    -1,    -1,    -1,   235,    -1,    -1,
      -1,    -1,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,    -1,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,    -1,   400,    -1,    -1,    -1,    -1,    -1,   351,
      -1,    -1,    -1,    -1,    -1,   235,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   366,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   351,   648,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   387,    -1,    -1,    -1,    -1,
      -1,   366,    -1,   395,   396,    -1,    -1,   351,    -1,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   387,   415,   416,   417,   418,   419,   420,    -1,
     395,   396,    -1,   351,    -1,    -1,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,    -1,
     415,   416,   417,   418,   419,   420,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   646,   647,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,    -1,   400,    -1,    -1,
      -1,   351,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   646,    88,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,    -1,
      88,    89,     4,     5,     6,    -1,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,    -1,    -1,    -1,    -1,   138,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
      -1,   400,    44,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     138,   648,    -1,    55,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    83,    -1,    -1,    -1,    -1,    -1,    -1,   176,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,    -1,
     400,   189,    -1,    -1,    -1,   647,    -1,   649,    -1,   651,
      -1,   113,   114,   201,   202,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   235,   129,    -1,    -1,
      -1,    -1,   647,    -1,   649,    -1,   651,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   147,    -1,   235,    88,    89,
      -1,    -1,    -1,    -1,    -1,   649,   158,    -1,    -1,   161,
      -1,    -1,    -1,   165,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   648,    -1,   179,   646,   647,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   297,    -1,
     130,    -1,    -1,    -1,   196,    -1,    88,    89,   138,    -1,
      -1,    -1,    -1,    -1,    -1,   207,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,    -1,   400,    -1,   646,   647,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   176,    -1,    -1,    -1,
      -1,   243,   351,   245,    -1,    -1,   138,    -1,   250,   189,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   201,   202,   351,    -1,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,    -1,   400,    -1,   366,   281,
     282,    -1,    -1,    -1,   176,    -1,    -1,    -1,    -1,   648,
      -1,    -1,    -1,    -1,    -1,   235,    -1,   189,    -1,   387,
      -1,   241,    -1,    -1,    -1,    -1,    -1,   395,   396,   201,
     202,    -1,    -1,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,    -1,   415,   416,   417,
     418,   419,   420,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   235,    88,    -1,    -1,    -1,   648,    -1,
      -1,    -1,    -1,   355,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,    -1,    -1,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,    -1,    -1,    -1,    -1,    -1,
      -1,   351,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,   449,   450,    -1,
      -1,    -1,    -1,    -1,    -1,   395,   396,    -1,    -1,   351,
      -1,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   648,    -1,   366,   415,   416,   417,   418,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   235,    -1,    -1,    -1,   387,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   395,   396,    -1,    -1,    -1,    -1,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   646,   415,   416,   417,   418,   419,   420,    88,
      89,    -1,    -1,    -1,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   297,    -1,    -1,    -1,    -1,    -1,   647,
      -1,   649,    -1,   651,    88,    89,    -1,    -1,    -1,    -1,
      -1,   130,    -1,    -1,    -1,    -1,   578,   579,   580,   138,
      -1,    -1,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,    -1,    -1,    -1,    -1,    -1,   130,   351,    -1,    -1,
      -1,    -1,    -1,    -1,   138,    -1,   556,   176,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,    -1,   400,
     189,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   201,   202,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   176,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,    -1,   400,   189,    -1,    -1,    -1,    -1,
      -1,    88,    89,    -1,    -1,    -1,   235,   201,   202,    -1,
      -1,    -1,   241,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,    -1,   400,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   647,    88,    89,
      -1,   235,    -1,   130,    -1,    -1,    -1,   241,    -1,    -1,
      -1,   138,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,    -1,
     130,    -1,    -1,    -1,    88,   647,    -1,    -1,   138,   176,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
      -1,   400,   189,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   201,   202,    -1,    -1,    88,    -1,
      -1,    -1,   351,    -1,    -1,    -1,   176,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,    -1,   400,   189,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   235,    -1,
      -1,   201,   202,    88,   241,    -1,    -1,   351,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   395,   396,    -1,    -1,
      -1,    -1,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,    -1,    -1,   235,   415,   416,   417,   418,
      -1,   241,    88,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   395,   396,    -1,    -1,   646,    -1,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,    -1,    -1,
      -1,   415,   416,   417,   418,    -1,    88,    -1,    -1,    -1,
      -1,   235,    -1,   647,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   648,    -1,    -1,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   351,   235,    88,    -1,    -1,    -1,
      -1,    -1,   648,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,    88,
     235,   351,    -1,    -1,    -1,    -1,    -1,    -1,   395,   396,
      -1,    -1,    -1,    -1,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,    -1,    -1,   556,   415,   416,
     417,   418,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   235,
      -1,    -1,    -1,    88,    -1,   395,   396,   351,    -1,   648,
      -1,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   556,    -1,    -1,   415,   416,   417,   418,    -1,
      -1,    -1,    -1,   235,    -1,    -1,    88,    -1,    -1,    -1,
      -1,   351,    -1,    -1,   646,    -1,    -1,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,    -1,    -1,    -1,    -1,
      -1,    88,    -1,   235,    -1,    -1,   351,    -1,   647,    -1,
      -1,    -1,    -1,    -1,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,    -1,    -1,    -1,   235,    -1,    -1,    -1,
      -1,    88,    -1,   647,    -1,   351,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,    -1,   400,    -1,   556,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   351,
     235,    88,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   235,    88,    -1,    -1,    -1,    -1,   351,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   235,    88,
     647,    -1,   351,    -1,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,    -1,   400,    -1,    -1,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   647,   235,    -1,
      -1,    88,    -1,    -1,    -1,    -1,   351,    -1,    -1,    -1,
      -1,    -1,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,    -1,    -1,    -1,    88,    -1,    -1,    -1,   235,   351,
      -1,    -1,   646,   647,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   235,    -1,    88,   351,    -1,   646,   647,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,    -1,    -1,   235,    -1,    -1,    88,
      -1,   646,   647,   646,   351,    -1,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,    -1,   400,    -1,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   235,    88,
     646,   647,    -1,    -1,   351,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   235,    88,    -1,   646,   647,    -1,   351,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,    -1,    88,    -1,    -1,
     235,   646,   351,    -1,   646,   647,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   235,   646,   647,    88,
      -1,    -1,    -1,    -1,   351,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   235,   351,    -1,    88,
      -1,   646,   647,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   235,
      -1,    88,    -1,    -1,    -1,   647,   351,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   235,    -1,    -1,    88,    -1,    -1,
     647,    -1,   351,   646,    -1,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,    -1,   400,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   235,    88,    -1,   646,
      -1,    -1,   351,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,    -1,
      -1,    88,    -1,    -1,    -1,   351,   235,    -1,    -1,   646,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   235,    88,
     351,    -1,   646,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   235,    -1,    -1,   646,    -1,    -1,
      -1,    -1,   351,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      55,    -1,    -1,    -1,    -1,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   235,    -1,    -1,    -1,    -1,   646,
      -1,    -1,   351,    -1,    -1,    -1,    -1,    -1,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,    -1,   235,    -1,
      -1,    -1,   646,    -1,   351,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,    -1,    -1,    -1,    -1,   235,    -1,    -1,    -1,
     351,   646,   646,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,    -1,   400,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,    -1,    -1,    -1,   646,    -1,    -1,
     351,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   351,    55,    -1,   646,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,    -1,    -1,    -1,    -1,
     646,    -1,   351,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      47,   101,    -1,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,    69,    -1,    -1,   646,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,    -1,   400,    -1,    -1,
      -1,    88,    -1,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,    -1,    -1,    -1,    -1,    -1,   646,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,    -1,    -1,    -1,    -1,
      -1,   376,   377,    -1,    -1,    -1,    -1,   646,    -1,    -1,
      -1,    -1,    -1,    -1,    47,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,    -1,    -1,    69,    -1,    -1,   646,
     646,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    88,    -1,    -1,    -1,    -1,
      -1,    -1,    47,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   646,   451,   452,   453,   454,
     455,    -1,    -1,    -1,    69,    47,    -1,    -1,   235,   464,
     465,   466,    -1,    -1,    -1,    -1,   471,   472,    -1,   474,
     475,    -1,    -1,    88,    47,    -1,    -1,    69,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   646,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   499,    -1,    88,    -1,    -1,    -1,
      -1,    47,    -1,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,    -1,   400,    88,    -1,    -1,    -1,   646,
      -1,   526,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    47,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
      -1,   400,    88,    -1,    -1,    -1,    -1,    -1,    -1,    47,
      -1,    -1,    -1,   646,   331,    -1,    -1,   646,    -1,    -1,
      -1,    -1,    -1,    -1,   569,    -1,    -1,    -1,   573,    -1,
      88,    -1,   235,    -1,   351,    -1,    -1,    -1,    51,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   593,    -1,
      88,   596,   597,   598,   599,   600,   601,   602,   603,   117,
     605,   606,   607,   608,   609,   610,   611,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    88,    -1,    -1,    -1,   117,
     235,   451,   452,   453,   454,   455,   456,   457,   458,   459,
      55,    -1,    -1,   463,   464,   465,   466,   467,   468,   469,
     470,   471,    -1,   235,   474,   475,   476,   477,   478,   479,
     480,    -1,    -1,    51,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   235,    88,    -1,    -1,    -1,    -1,   331,   499,
     500,   501,   502,   503,    -1,    -1,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   351,   235,
      88,   521,   522,   523,    -1,    -1,    51,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   331,   235,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,    -1,   400,
      -1,    -1,    47,    88,    -1,    -1,   351,   235,    -1,   331,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
      -1,   400,    -1,    -1,    -1,    -1,    -1,    -1,   331,   351,
     646,    -1,   235,   593,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    88,    -1,    -1,    -1,    -1,   351,    -1,
      -1,    -1,    -1,    -1,    -1,   331,    -1,   646,    69,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,    -1,
     400,    -1,   117,    -1,    -1,   351,    -1,    88,    -1,    -1,
     235,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
      -1,    -1,    -1,   351,    -1,    -1,    -1,   235,    -1,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,    -1,
     400,    -1,    -1,   351,    -1,    -1,    -1,    -1,    -1,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   351,    -1,
     235,    -1,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     235,    -1,    -1,    -1,    -1,    -1,   351,    -1,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,    -1,    -1,    -1,
      -1,    -1,    -1,   351,   235,    -1,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   646,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,    -1,   351,   646,    -1,    -1,
      -1,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
      69,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,    -1,   400,    -1,    -1,    -1,   351,    -1,    -1,    88,
      -1,    -1,    -1,    -1,    -1,    -1,   646,    -1,    -1,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,    -1,    -1,
     351,    -1,    -1,    -1,    -1,    -1,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,    69,   646,    -1,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,    -1,   400,
      -1,    -1,    -1,    -1,    88,    -1,    -1,    -1,    -1,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,    69,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,    -1,
     400,    -1,    -1,    -1,    -1,    -1,    -1,    88,    -1,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   235,    -1,    -1,    -1,
      -1,    -1,    -1,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,    69,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,    -1,   400,    -1,    -1,    -1,    -1,    -1,
      -1,    88,    -1,    -1,    -1,    -1,    -1,    69,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   297,   400,
      -1,    -1,    -1,    -1,    -1,    -1,    88,    69,    -1,    -1,
      -1,   235,    -1,    -1,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,    -1,   400,    88,    -1,   646,    -1,
      69,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,    -1,   400,    -1,    -1,    -1,    -1,    -1,    -1,    88,
      69,    -1,   351,    -1,   235,    -1,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,    -1,   400,    -1,    88,
      69,    -1,    -1,   297,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,    -1,   400,    -1,    -1,    -1,    88,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    69,   646,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    88,    -1,    -1,    -1,   351,   235,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   646,    -1,    -1,    69,
      -1,    -1,    -1,   235,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    88,    -1,
     351,    -1,    -1,   235,    -1,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,    -1,    -1,   235,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   235,    -1,    -1,    -1,
     646,    69,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   235,    -1,    -1,    -1,
      88,    -1,    -1,    -1,   351,   646,    -1,    -1,    -1,    -1,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   351,
     235,   646,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    88,    -1,   646,   351,
      -1,    -1,    -1,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   351,   646,    -1,   235,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    69,    -1,
      -1,   646,   351,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    88,    -1,    -1,
      -1,    -1,   351,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   351,   235,    88,    -1,
      -1,    -1,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,    -1,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   351,    -1,   235,    -1,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,    88,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,    -1,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   235,   297,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   351,    -1,    -1,    -1,    -1,    -1,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,    69,    -1,
      -1,    -1,    -1,    -1,    -1,   235,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    88,    -1,   351,
      -1,    -1,    -1,    -1,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,    88,    89,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    69,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   297,    -1,    -1,
      -1,   235,    -1,    -1,    -1,    88,    69,    -1,    -1,    -1,
     351,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   138,    -1,    88,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,    -1,    88,    -1,    -1,    -1,
      -1,   351,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   297,    -1,    88,    -1,    -1,    -1,    -1,
      -1,    -1,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,    88,    -1,   495,   235,   497,   498,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   150,   151,
      -1,    -1,    -1,    -1,    -1,   138,    88,   351,    -1,    -1,
     235,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   235,   150,   151,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    88,    -1,    -1,
      -1,    -1,   235,    -1,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   235,    -1,   495,    -1,   497,   498,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    88,    -1,
     351,    -1,   235,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   150,
     151,    -1,    -1,    88,    -1,    -1,   351,    -1,   235,    -1,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,    -1,   235,    -1,    -1,    -1,    -1,   351,    -1,
      -1,   151,    -1,    -1,   297,    -1,    -1,    -1,    -1,    -1,
     395,   396,    -1,    -1,    88,    -1,    -1,    -1,   351,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   151,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   351,
      -1,    -1,    -1,    -1,   235,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    88,    -1,   297,    -1,    -1,   351,    -1,
      -1,    -1,    -1,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,    88,    -1,   351,   235,    -1,    -1,    -1,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,    88,   351,
     235,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
      -1,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     351,   235,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     235,   351,    -1,    -1,    -1,    -1,    -1,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   351,    88,    -1,   235,
      -1,    -1,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,    88,    -1,    -1,    -1,   235,    -1,    -1,    -1,    -1,
      -1,    -1,   297,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    88,    -1,    -1,    -1,    -1,   351,    -1,    -1,
      -1,    -1,    -1,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   151,    -1,   351,   297,    -1,    -1,
      -1,    -1,    -1,    -1,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,    -1,    -1,   351,    -1,    -1,    -1,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,    -1,    -1,
      -1,   351,    -1,    -1,   235,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   235,    -1,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   235,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,    -1,    -1,    -1,
     351,    -1,    -1,    -1,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,    -1,   351,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   351,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,    -1,    -1,    -1,    -1,    -1,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,    -1,    -1,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   152,   153,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   168,    -1,    -1,    -1,    -1,    -1,   174,
      -1,    -1,   177,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   190,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   249,    -1,    -1,    -1,    -1,   254,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   287,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   322,    -1,    -1,
      -1,   326,    -1,   328,    -1,   330,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   378,   379
  };

  const unsigned short
  parser::yystos_[] =
  {
       0,    14,    15,    39,    40,    41,    42,    43,    47,    54,
      64,    65,    66,    70,    72,    73,    74,    75,    76,    85,
      86,    88,    95,   101,   117,   118,   119,   120,   129,   131,
     132,   145,   164,   172,   197,   198,   199,   200,   203,   214,
     235,   240,   260,   262,   264,   265,   273,   276,   278,   279,
     283,   284,   310,   311,   314,   315,   316,   318,   319,   324,
     327,   332,   333,   338,   342,   343,   344,   347,   349,   351,
     353,   359,   360,   361,   363,   364,   365,   367,   368,   369,
     370,   371,   372,   375,   382,   383,   388,   421,   422,   456,
     461,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     524,   528,   529,   532,   533,   535,   536,   537,   538,   539,
     540,   548,   553,   554,   555,   561,   583,   584,   594,   595,
     643,   645,   655,   656,   657,   658,   659,   662,   665,   668,
     672,   675,   679,   683,   695,   699,   700,   701,   702,   703,
     713,   716,   717,   722,   723,   724,   727,   730,   731,   736,
     741,   752,   756,   767,   768,   771,   774,   777,   781,   784,
     787,   790,   793,   797,   800,   803,   804,   807,   810,   813,
     825,   831,   834,   837,   844,   845,   848,   849,   850,   852,
     864,   865,   866,   869,   870,   871,   880,   883,   886,   889,
     890,   892,   895,   896,   897,   898,   899,   900,   903,   909,
     912,   913,   914,   917,   918,   925,   926,   927,   928,   929,
     930,   931,   932,   933,   937,   940,   943,   946,   949,   952,
     955,   958,   961,   964,   965,   976,   979,   982,   985,   986,
     989,   993,   996,  1002,  1005,  1007,  1010,  1013,  1016,  1020,
    1485,   138,   647,   138,   647,   646,   647,   817,  1485,   647,
     646,   647,   647,   646,   647,   646,   647,   817,   138,   647,
     647,   646,   647,   646,   647,   817,   646,   646,   646,   647,
     646,   647,   647,   646,   647,   646,   647,   817,   647,   646,
     647,   647,   646,   646,   647,   646,   647,   647,   646,   647,
     647,   647,   646,   647,   297,   647,   904,   908,  1485,   646,
     647,   646,   647,   646,   646,   646,   647,   646,   646,   646,
     647,   817,   817,   710,  1485,    71,   138,   910,   647,   817,
     646,   647,   646,   647,   817,   647,   646,   647,   646,   647,
     817,   646,   647,    71,   646,   647,   646,   647,   646,   646,
     647,   646,   647,   817,   646,   647,   817,   646,   647,   646,
     647,   817,   646,   646,   647,   817,   646,   817,   647,   707,
    1485,   708,  1485,   709,  1485,   881,   884,   711,  1485,   647,
     646,   647,   817,   712,  1485,   646,   647,   646,   647,   646,
     647,   646,   647,   647,   647,   647,   646,   647,   647,   646,
     647,   647,   646,   647,   647,   646,   647,   817,   646,   647,
     646,   647,   646,   647,   646,   647,   646,   647,   646,   647,
     757,   647,   646,   647,   646,   647,   647,   647,   647,   647,
     646,   817,   653,     0,   656,    71,   647,    71,    71,    71,
     653,   646,    21,    22,    23,    27,    28,    29,    30,    45,
      55,    83,   243,   244,   281,   282,   376,   377,   934,   935,
     936,  1076,  1082,  1089,  1108,  1109,  1182,  1183,  1189,  1190,
    1230,  1231,  1232,  1233,  1234,  1235,  1236,   646,    33,    44,
     101,   935,   938,   939,  1136,  1169,  1237,    81,    82,   149,
     165,   207,   274,   519,   520,   994,   995,  1076,  1089,  1108,
    1161,  1173,  1178,  1182,  1183,  1184,  1192,  1292,  1361,  1362,
      51,   646,  1485,   273,   359,   360,   361,   714,   116,   121,
     122,   123,   152,   174,   177,   299,   328,   783,   785,   786,
    1024,  1047,  1055,  1058,  1065,  1287,  1288,  1289,  1290,    44,
      46,   276,   308,   983,   984,  1031,  1043,  1138,  1291,  1292,
     359,   987,   988,  1485,    19,    20,    26,    31,    32,    93,
     114,   154,   155,   245,   381,   412,   642,   644,   974,   975,
    1123,  1126,  1129,  1132,  1209,  1213,  1214,  1217,  1218,  1219,
    1222,  1227,  1229,  1430,   646,   138,   646,   904,   904,   725,
     726,  1485,    35,     3,     4,     6,     7,     9,    13,    16,
      18,    36,    44,    52,    53,    59,    60,    61,    77,    80,
      83,    87,   113,   114,   115,   142,   143,   144,   146,   147,
     148,   157,   158,   162,   163,   166,   167,   169,   170,   179,
     180,   181,   182,   183,   184,   185,   186,   187,   188,   191,
     192,   193,   194,   195,   196,   205,   206,   208,   209,   210,
     211,   212,   213,   215,   216,   219,   220,   224,   228,   229,
     230,   234,   236,   239,   245,   247,   250,   251,   252,   258,
     259,   261,   263,   275,   280,   285,   289,   300,   301,   307,
     323,   334,   335,   341,   357,   490,   518,   525,   566,   567,
     624,   625,   626,   627,   628,   629,   872,   873,  1024,  1030,
    1033,  1037,  1038,  1065,  1076,  1080,  1081,  1082,  1086,  1087,
    1088,  1092,  1108,  1109,  1110,  1111,  1112,  1113,  1122,  1128,
    1137,  1139,  1140,  1141,  1142,  1143,  1144,  1145,  1146,  1147,
    1148,  1149,  1150,  1151,  1152,  1153,  1154,  1155,  1156,  1157,
    1158,  1159,  1160,  1161,  1163,  1164,  1165,  1166,  1167,  1168,
    1169,  1170,  1171,  1172,  1173,  1174,  1175,  1176,  1177,  1178,
    1182,  1183,  1184,  1185,  1186,  1187,  1188,  1189,  1190,  1191,
    1192,  1193,  1194,  1195,  1196,  1199,  1200,  1201,  1202,  1203,
    1204,  1205,  1206,  1207,  1238,  1239,  1240,  1241,  1242,  1243,
    1244,  1245,  1246,  1247,  1248,  1293,  1354,  1360,  1361,  1362,
    1363,  1364,  1407,  1409,  1410,  1411,  1412,  1413,  1414,  1416,
    1417,  1451,  1452,  1453,  1454,  1455,  1456,   646,    47,   302,
     331,   826,   827,   828,  1485,    47,   331,   835,   836,  1485,
      47,   331,   832,   833,  1485,    12,   127,   263,   329,   378,
     379,  1003,  1004,  1043,  1044,  1045,  1046,  1424,  1425,    90,
     842,   843,   838,   839,  1485,    96,    97,    98,    99,   100,
     737,   738,   980,   981,  1043,  1112,  1122,  1128,  1137,   646,
    1485,   728,   729,  1485,    35,    79,   977,   978,  1485,     5,
     161,   266,   267,   288,   355,   356,   427,   630,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   640,   641,   901,
     902,  1030,  1031,  1033,  1043,  1111,  1112,  1122,  1128,  1156,
    1168,  1176,  1192,  1254,  1278,  1282,  1283,  1284,  1285,  1286,
    1292,  1407,  1408,  1457,  1458,  1459,  1460,  1461,  1462,  1463,
    1464,  1465,  1466,  1467,  1468,   725,    35,    79,  1011,  1012,
    1485,  1174,   904,   173,   742,     8,    11,    34,    48,    68,
     159,   160,   178,   242,   272,   354,   739,   740,  1029,  1057,
    1060,   175,  1179,   647,    51,   646,   904,   788,   789,   359,
     755,   775,   270,  1008,  1009,  1485,    69,   235,   999,  1000,
     997,   998,  1238,  1239,   887,   888,  1485,   891,  1485,    17,
      62,    63,    94,   102,   124,   125,   126,   152,   177,   246,
     248,   253,   254,   287,   296,   298,   309,   319,   320,   321,
     815,   893,   894,  1023,  1024,  1025,  1030,  1031,  1032,  1033,
    1034,  1035,  1036,  1037,  1038,  1039,  1040,  1041,  1043,  1051,
    1052,  1056,  1061,  1062,  1063,  1064,  1065,  1081,  1086,  1112,
    1122,  1128,  1145,  1168,  1172,  1174,  1180,  1181,  1194,  1195,
    1199,  1200,  1204,  1205,  1206,  1207,  1238,  1239,  1343,  1344,
    1354,  1414,  1415,  1451,  1452,  1453,  1454,  1455,  1456,   646,
     646,    51,   646,  1485,   350,   647,   705,   706,   138,   646,
      89,   138,   176,   189,   201,   202,   366,   387,   395,   396,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   415,   416,   417,   418,   419,   420,   647,
     748,   820,   905,  1485,   276,   646,   791,   792,  1043,  1076,
     152,   153,   168,   177,   190,   249,   322,   326,   330,   794,
     795,  1024,  1026,  1027,  1028,  1048,  1053,  1054,  1058,  1059,
    1162,  1180,  1181,  1418,  1424,  1425,   646,   904,    47,   359,
     753,   754,   755,   270,   101,   237,   250,   317,   381,   644,
     968,   969,  1076,  1082,  1089,  1108,  1115,  1116,  1117,  1131,
    1161,  1178,  1182,  1183,  1192,  1292,  1428,  1429,   646,   297,
    1017,  1018,  1485,   235,   649,   792,   795,   808,   809,   136,
     137,   268,   269,   277,  1014,  1015,  1419,  1420,  1421,  1422,
    1423,   990,   782,   783,   128,   380,   460,   814,   815,   816,
    1042,  1049,  1161,  1293,  1294,   646,   101,   238,   282,   604,
     970,   971,  1076,  1082,  1089,  1115,  1118,  1119,  1120,  1121,
    1131,  1292,  1428,  1429,   646,   103,   345,   346,   921,   922,
    1197,  1198,  1355,   815,   923,   924,  1197,  1355,   646,   235,
     915,   916,   177,   348,   919,   920,   924,  1050,  1406,   646,
     646,   171,   530,    51,   646,  1485,   350,   706,    51,   646,
    1485,   350,   706,    51,   646,  1485,   350,   706,   882,  1485,
     885,  1485,    51,   646,  1485,    78,   257,   271,   362,   414,
     527,   680,   681,    19,    20,    24,    25,    26,    31,    32,
      37,    38,    93,   114,   154,   155,   245,   250,   412,   461,
     642,   972,   973,  1114,  1124,  1125,  1127,  1130,  1208,  1210,
    1211,  1212,  1215,  1216,  1220,  1221,  1223,  1224,  1225,  1226,
    1228,  1428,  1429,   646,    51,   646,  1485,   350,   227,   227,
     227,   257,   263,   622,   670,   671,  1073,  1074,  1079,   676,
     257,   313,   622,   673,   674,  1083,  1084,  1085,    55,   696,
     697,  1077,  1078,  1485,   129,   423,   424,   425,   426,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,   448,
     449,   450,   578,   579,   580,   966,   967,  1033,  1076,  1082,
    1089,  1108,  1109,  1111,  1112,  1122,  1128,  1137,  1139,  1150,
    1161,  1176,  1192,  1249,  1250,  1251,  1252,  1253,  1254,  1255,
    1256,  1257,  1258,  1259,  1260,  1261,  1262,  1263,  1264,  1265,
    1266,  1267,  1268,  1269,  1270,  1271,  1272,  1273,  1274,  1275,
    1276,  1277,  1279,  1280,  1281,  1282,  1283,  1407,  1408,    56,
      57,    83,    84,   243,   846,   847,  1066,  1075,  1090,  1091,
    1093,  1182,  1183,  1021,  1022,  1485,   235,  1485,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   474,   475,   476,   477,
     478,   479,   480,   499,   500,   501,   502,   503,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     521,   522,   523,   593,   941,   942,  1076,  1169,  1297,  1298,
    1299,  1300,  1301,  1302,  1303,  1304,  1305,  1306,  1307,  1308,
    1309,  1310,  1311,  1312,  1313,  1314,  1315,  1316,  1317,  1319,
    1320,  1321,  1322,  1323,  1324,  1325,  1326,  1327,  1328,  1329,
    1330,  1331,  1332,  1333,  1334,  1335,  1336,  1337,  1338,  1339,
    1340,  1341,  1342,  1369,   531,   312,   336,   337,   526,   527,
     568,   569,   571,   572,   574,   575,   576,   581,   592,   950,
     951,  1365,  1366,  1368,  1385,  1393,  1394,  1395,  1398,  1399,
    1400,  1401,  1402,  1403,  1404,   646,   570,   944,   945,  1365,
    1366,  1368,  1385,  1393,  1394,  1395,  1397,  1398,  1399,  1400,
    1401,  1403,  1404,   472,   573,   596,   597,   598,   599,   600,
     601,   602,   603,   605,   606,   607,   608,   609,   610,   611,
     962,   963,  1076,  1182,  1183,  1297,  1298,  1299,  1300,  1301,
    1307,  1308,  1309,  1311,  1315,  1316,  1317,  1318,  1365,  1366,
    1367,  1369,  1370,  1371,  1372,  1373,  1374,  1375,  1376,  1377,
    1378,  1379,  1380,  1381,  1382,  1383,  1384,    63,   186,   256,
     591,   959,   960,  1295,  1296,  1365,  1366,  1385,  1386,  1387,
     586,   587,   588,   589,   590,   956,   957,  1365,  1366,  1368,
    1388,  1389,  1390,  1391,  1392,   582,   953,   954,  1365,  1366,
    1395,  1396,   577,   947,   948,  1365,  1366,  1368,  1385,  1393,
    1394,  1398,  1399,  1400,  1401,  1402,  1403,  1404,  1405,   646,
     273,   524,   549,   550,   551,   552,   769,   770,  1345,  1346,
    1347,  1348,  1349,  1350,   732,   557,   558,   560,   772,   773,
    1345,  1351,  1352,  1353,   562,   563,   564,   565,   811,   812,
    1356,  1357,  1358,  1359,   286,   585,   805,   806,  1426,  1427,
     805,    63,   263,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   796,   801,   802,  1024,  1037,  1038,  1065,
    1076,  1080,  1081,  1082,  1089,  1112,  1122,  1128,  1145,  1150,
    1151,  1156,  1161,  1163,  1168,  1174,  1182,  1183,  1193,  1194,
    1199,  1200,  1201,  1202,  1203,  1204,  1205,  1206,  1207,  1238,
    1239,  1354,  1363,  1414,  1416,  1417,  1432,  1434,  1436,  1438,
    1440,  1442,  1444,  1446,  1447,  1448,  1449,  1450,  1451,  1452,
    1453,  1454,  1455,  1456,   263,   612,   613,   614,   615,   616,
     617,   618,   796,   798,   799,  1431,  1433,  1435,  1437,  1439,
    1441,  1443,  1445,   646,   492,    47,   117,   850,  1485,   851,
    1135,  1485,    47,   117,   865,  1485,    47,   117,   870,  1485,
     130,   176,   189,   201,   202,   241,   395,   396,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   415,
     416,   417,   418,   647,   718,   820,   905,  1485,   150,   151,
     492,  1485,    71,    71,    71,    71,    71,    71,    71,    71,
      71,    71,    71,    71,    71,    51,   648,    71,    71,    71,
      51,   648,    71,    71,    71,   648,    51,  1485,   648,    71,
      71,    71,    71,    71,    71,    71,    71,    51,   648,    71,
      71,    71,    71,    51,   648,  1485,    69,   988,    51,    71,
      71,    71,    71,    71,    71,    71,   648,    51,   646,   648,
     648,    69,   726,    71,   648,    71,    71,    71,    71,    71,
      71,    71,    71,    71,    71,    71,    71,    71,    71,    71,
      71,    71,    71,    71,    71,    71,    71,    71,    71,    71,
      71,    71,    71,    71,    71,    71,    71,    71,    71,    71,
      71,    71,    71,    71,    71,    71,    71,    71,    71,    71,
      71,    71,    71,    71,    71,    71,    71,    71,    71,    71,
      71,    71,    71,    71,    71,    71,    71,    71,    71,    71,
      51,   648,  1485,  1485,    69,   827,    51,   646,  1485,  1485,
      69,   836,    51,  1485,  1485,    69,   833,    51,   648,    71,
      71,   648,    51,   395,   648,    69,   839,    51,    71,    71,
      71,    71,    71,    51,   648,    51,   648,   648,    69,   729,
     647,   648,    71,    69,   978,    51,    71,    71,    71,    71,
      71,    71,    71,    71,    71,    71,    71,    71,    71,    71,
      71,   648,    51,    69,   648,    71,    69,  1012,    51,   647,
     648,   648,    71,   649,   651,   744,   745,   748,   751,    71,
      71,    71,    71,    71,    51,   648,    71,   648,   820,   904,
     647,    51,   648,  1485,    69,   755,   648,    69,  1009,    51,
     646,    51,    69,  1000,   648,    51,    69,   888,   647,    69,
    1485,    51,   718,    71,    71,    71,    71,    71,    71,    71,
      71,    71,    71,    71,    71,    71,    51,   648,  1485,   350,
     706,   706,    51,   704,  1485,    51,   648,   704,   646,   647,
     647,   647,   647,   647,   647,   748,   748,   647,   647,   647,
     647,   647,   647,   647,   647,   647,   647,   647,   647,   647,
     647,   647,   647,   647,   647,   647,   748,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   400,   911,   653,
     749,   304,   305,   306,    71,    51,   648,    71,    71,    71,
      71,    71,    51,   648,   648,  1485,  1485,    69,   754,   648,
      71,    71,    71,    71,   648,    51,    71,    69,  1018,    71,
      71,   395,   396,   647,   779,   780,   820,   821,    51,   648,
      71,    71,    71,    71,    71,   648,    51,   649,   991,   992,
    1485,    51,   648,    71,    71,    51,   648,    71,    71,    71,
      71,   648,    51,    71,    71,    71,    51,   648,    51,   648,
     391,   392,   393,   394,    69,   916,    71,    71,    51,   648,
      71,    71,  1485,   350,   706,   706,  1485,   350,   706,   706,
    1485,   350,   706,   706,    51,   646,  1485,    51,   646,  1485,
    1485,    71,    71,    71,    71,    71,    71,    51,   648,    71,
      71,    71,    71,    71,    71,    71,    71,    71,   648,    51,
    1485,   350,   648,   648,   648,    71,    71,    71,    51,   648,
     257,   271,   414,   534,   623,   677,   678,  1067,  1068,  1069,
    1070,  1072,    71,    71,    71,    51,   648,    71,    51,   648,
      71,    71,    71,    71,    71,    71,    71,    71,    71,    71,
      71,    71,    71,    71,    71,    71,    71,    71,    71,    71,
      71,    71,    71,    71,    71,    71,    71,    71,    71,    71,
      71,   648,    51,    71,    71,    71,    71,    71,    51,   648,
      69,  1022,    51,  1485,    71,   648,    71,    71,    71,    71,
      71,    71,    71,    71,    71,    71,    71,    71,    71,    71,
      71,    71,    71,    71,    71,    71,    71,    71,    71,    71,
      71,    71,    71,    71,    71,    71,    71,    71,    71,    71,
      71,    71,    71,    71,    71,    71,    71,    71,    71,    51,
     648,    71,    71,    71,    71,    71,    71,    71,    71,    71,
      71,    71,    71,    51,   648,    51,   648,    71,    71,    71,
      71,    71,    71,    71,    71,    71,    71,    71,    71,    71,
      71,    71,    71,    51,   648,    71,    71,    71,    51,   648,
      71,    71,    71,    71,    51,   648,    51,   648,    71,    51,
     648,   462,   542,   544,   545,   758,   759,    71,    71,    71,
      71,    71,    71,    51,   648,   235,   733,   734,    71,    51,
     648,    71,    71,    71,    71,    51,   648,    71,    71,    51,
     648,   648,    71,    71,    71,    71,    71,    71,    71,   648,
      51,    71,    71,    71,    71,   648,    51,   855,   647,   647,
     646,   653,    51,   648,    71,   647,   647,   646,   653,   647,
     647,   646,   653,   647,   647,   647,   647,   718,   718,   647,
     647,   647,   647,   647,   647,   647,   647,   647,   647,   647,
     647,   647,   647,   647,   718,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   400,   646,   719,   647,   853,
     653,   820,   821,   820,   138,   821,   138,   904,   138,   138,
     649,  1473,  1475,  1476,   138,   138,  1485,  1469,  1485,   936,
     138,   138,   820,   138,   939,   138,  1476,   820,    67,   290,
     291,   292,   293,   294,   295,   646,   817,   994,   715,  1485,
     138,   138,   138,   820,   820,   138,   820,   138,   786,   646,
     820,   647,   138,   138,   984,   646,   646,   646,  1485,   904,
     384,   385,   386,   487,   488,   489,   491,   647,  1133,   843,
     843,  1485,   138,   646,   817,   974,   646,   817,   646,   817,
     646,   718,   646,   138,   297,   820,  1485,   820,   820,   820,
     138,   904,  1473,  1476,   647,  1133,  1473,  1476,   138,   647,
     820,   138,   820,   138,   138,    58,    91,    92,   325,   820,
     820,   820,   820,   820,   820,   820,   138,   138,   138,   138,
     130,   395,   396,   821,   822,   823,   138,   138,   138,  1485,
     904,   138,  1476,   649,  1479,  1480,  1480,   493,   494,   495,
     904,   138,   217,   218,   491,   820,   221,   222,   223,   225,
     226,   138,  1485,   231,   232,   233,   231,   232,   233,   647,
     138,   138,   820,   130,   820,   138,    91,    92,   820,   138,
      49,    50,    91,   647,   138,   138,   820,   138,   873,   646,
     817,    51,   646,    10,   112,   139,   140,   141,   255,   352,
     505,   718,   721,   829,   841,    51,    51,   646,   718,    51,
      51,   646,   718,   646,   138,   138,   646,  1003,   138,   646,
     646,   718,   297,   297,   297,   297,   297,   738,   646,   981,
     646,   817,   653,   646,   138,   395,   396,   819,   646,   904,
     646,   718,   821,   138,   138,   819,   138,   138,   138,   904,
     138,   138,   138,   820,   820,   820,   138,   138,   646,   901,
     646,   646,   904,   646,  1485,   138,  1470,   646,   646,   663,
     235,   746,   747,  1485,    69,   745,   751,    71,   646,   820,
     820,   647,   138,   647,   739,   646,   156,   204,   908,   648,
     647,   820,   789,   646,   646,   646,   646,   646,  1485,  1001,
    1485,   646,   646,   997,   646,   718,   646,    51,   718,  1485,
     646,   820,   138,   138,   138,   904,   820,   138,   138,   820,
     138,   820,   138,   138,   138,   894,   646,   817,   350,   706,
     706,   704,    71,   648,   704,   748,   748,   748,   748,  1485,
    1485,   748,   748,   748,   748,   748,   748,   748,   748,   748,
     748,   748,   748,   748,   748,   748,   748,   748,   748,   819,
     648,   748,   748,   748,   748,   748,   748,   748,   748,   748,
     748,   748,   646,  1485,   647,   138,   792,   646,   820,   820,
     138,   820,   138,   795,   646,   646,    51,    51,    71,   646,
     646,   646,   339,   340,   138,  1485,  1485,   646,   817,   968,
    1019,  1485,   646,  1019,  1485,   820,   820,   718,   646,   650,
      51,   647,   821,   809,   646,   904,   647,   904,   647,   138,
     646,  1014,   817,    69,   992,    71,   783,   646,   820,  1476,
     816,   646,   817,   138,   138,   138,  1476,   646,   817,   970,
     647,   718,   350,   922,   646,   924,   646,   817,   718,   718,
     718,   718,   646,   138,   820,   920,   646,   817,   667,   666,
     350,   706,   706,   350,   706,   706,   350,   706,   706,  1485,
    1485,   682,  1485,   718,  1485,  1485,   138,  1471,   681,   646,
     904,   384,   385,   386,   138,   138,   647,  1133,   843,   843,
    1485,   138,   646,   817,   972,   350,   646,   646,   646,  1485,
     138,   649,  1477,  1478,   671,   646,   669,  1485,    71,    71,
      71,  1071,    71,    51,   648,  1485,  1478,  1478,   674,   646,
     904,   697,   646,   138,   138,   138,   138,   138,   138,   138,
     138,   138,   138,   138,   138,   138,   820,   138,   649,  1483,
    1484,   820,   820,   647,   647,   647,   138,   138,   647,   820,
     138,   820,   820,   820,   820,   820,   646,   966,   904,  1485,
     843,   843,   138,   847,   646,   646,  1485,   646,  1485,   646,
     138,   546,   547,   138,   138,   138,   138,   904,   138,   647,
     138,   235,   544,   545,   138,   138,   138,   138,   138,   820,
     820,   138,   138,   138,   138,   138,   138,   820,   138,   138,
     138,   138,   138,   138,   138,   138,   138,   138,   138,   138,
     138,   138,   138,   138,   138,   138,  1480,   942,   646,   660,
     138,   904,   138,   904,   904,  1480,   138,   138,  1480,   821,
     138,   951,   646,   817,   945,   646,   473,   491,   820,   820,
     820,   138,   820,   138,   138,   820,   820,   138,   138,   138,
     138,   820,   820,   963,   646,   138,   138,   138,   960,   646,
     138,   821,   821,   138,   957,   646,   954,   646,   138,   948,
     646,   541,   543,   559,   646,   646,    69,   759,   649,   649,
    1480,  1482,   138,   820,  1484,   138,   138,   770,   646,   735,
      69,   734,  1473,  1476,   773,   646,   297,   905,   906,   138,
     906,   906,   812,   646,   904,   138,   806,   646,   646,   138,
     138,  1473,  1476,   138,   495,   497,   498,   904,   138,   138,
     646,   817,   801,   138,  1473,  1476,   138,   495,   497,   498,
     904,   646,   817,   798,   647,  1485,  1485,  1135,   646,   843,
    1485,  1485,   492,  1485,  1485,  1485,   151,  1485,   718,   718,
     718,   718,   718,   718,   718,   718,   718,   718,   718,   718,
     718,   718,   718,   718,   718,   718,   718,   648,   718,   718,
     718,   718,   718,   718,   718,   718,   718,   718,   718,   647,
     133,   134,   135,   867,   868,  1101,  1102,  1103,   647,   151,
     492,    51,   138,  1473,  1474,    51,   650,  1474,   652,   646,
     646,   646,    51,   646,  1485,   817,   276,   648,  1133,  1134,
     646,   646,   646,   646,   725,  1134,   817,   130,   130,    51,
     821,    51,   650,   821,   297,   874,   875,   297,   878,   879,
     646,  1485,    51,   646,    51,  1485,   718,    51,  1485,   718,
     646,    69,   832,    51,   646,   150,   151,   492,  1485,   138,
     138,   648,   728,   648,    51,   646,   725,   648,    51,   648,
     652,   648,  1011,   748,    71,    51,   650,    71,   646,   748,
     817,   904,   907,   743,   646,   820,   648,   276,   775,    51,
     647,    51,   646,    71,    69,   999,   648,  1485,   646,   718,
     646,   706,   297,    51,    51,   648,   648,   648,   648,   648,
     648,   648,   648,   648,   648,   648,   648,   648,   648,   648,
     648,    51,   648,   648,    51,   648,    51,   648,   648,   648,
     748,   750,   648,  1485,  1485,   718,   331,   753,   646,    51,
     646,  1485,   646,   648,   648,   780,   646,   647,   821,   718,
     817,   817,   650,   646,   718,   646,   646,   817,   646,   646,
     646,   646,   646,   646,   748,   748,   706,   706,   706,   748,
     652,  1134,   646,    51,   297,    51,   297,   650,    51,   646,
    1485,  1485,  1485,  1485,    71,   821,  1485,   678,   646,   823,
     650,   823,   652,   817,   818,   818,   818,   818,   646,   648,
     684,   817,   748,   646,   138,   138,   646,   646,   817,  1480,
    1481,    71,   646,   646,   646,   104,   105,   106,   107,   108,
     109,   110,   111,   303,   862,   863,  1094,  1095,  1096,  1098,
    1099,  1100,  1104,  1105,  1107,  1402,    51,   648,   652,    51,
     648,   653,    51,   648,   653,    51,    51,   648,   648,   648,
     648,   648,   648,   648,   648,   648,   648,   648,   648,   648,
     648,   648,    51,   648,    51,   648,   718,   720,    71,    71,
      71,    51,   648,   105,   107,   860,   861,  1094,  1095,  1096,
    1097,  1099,  1100,  1104,  1105,  1106,  1402,   647,   854,  1474,
     652,   650,  1474,  1485,  1485,   648,   138,   776,   653,    51,
     648,    69,   648,   648,   821,   650,   821,    51,    51,   648,
      51,    51,   648,   718,   721,   841,   721,   830,    51,    51,
     718,    51,   646,   646,    69,   718,   647,   856,   653,    71,
      69,   646,   718,    69,   646,   395,   396,   649,  1006,    51,
     138,    51,    69,   648,   297,   747,   748,   748,   646,   648,
      51,   648,   744,   648,   776,    69,  1006,   396,   819,  1472,
    1485,   821,   646,    69,   646,   718,   646,   748,   748,   297,
     748,   748,   647,    51,   648,   817,    71,    71,   646,   718,
      69,  1485,   646,   718,   648,   648,   648,    71,   646,   648,
     648,   648,   130,   138,   648,   297,   297,   650,  1485,   748,
     648,   648,   648,   648,   646,   462,   542,   685,   686,   648,
     648,    51,   646,   650,    51,   650,   718,    71,    71,    71,
      71,    71,    71,    71,    71,    71,    51,   648,  1485,   653,
     843,  1485,   653,   492,  1485,   653,   151,   718,   718,   718,
     718,    51,   648,  1484,   820,   821,   868,   646,    71,    71,
      51,   648,   867,   647,   138,   652,    51,   138,   646,   150,
     151,   492,  1485,  1133,   646,    88,   297,   351,   821,   824,
     874,   297,   647,   821,  1478,   878,    51,    51,    51,   718,
     718,   646,   718,   646,   646,   867,   647,   151,   492,   718,
     646,   646,   646,   718,   646,  1485,  1485,   646,   664,  1485,
      71,   646,   646,   904,    69,   646,   646,   646,   647,   648,
     652,   648,    71,   646,   646,   648,   648,    51,   648,    51,
      51,   748,   748,   646,   718,   718,   646,   646,  1017,   648,
     718,   698,  1485,   698,  1021,   373,   374,   541,   543,    69,
     686,   661,  1485,   760,   541,   762,  1480,   646,   821,  1480,
     820,  1482,   821,  1480,   475,   481,   482,   483,   484,   485,
     486,   496,   504,   840,  1480,  1480,   863,   646,   648,   648,
     492,  1485,   648,   151,  1485,   648,   648,    51,    51,   718,
     821,   718,   861,   646,   648,   860,   138,   138,   652,   358,
     647,   858,   653,   297,   876,   877,   721,   830,   721,    51,
     646,   646,   648,   860,   647,   857,   646,    51,    51,    51,
      51,   646,  1485,   350,   748,   646,   358,   819,    51,   819,
      51,   821,   138,  1476,   748,   748,   648,   646,   646,    69,
     646,    51,   646,  1485,   350,   706,   646,    69,   556,   690,
     691,   692,   647,   647,   138,   646,    51,   646,  1485,   350,
     395,   396,   556,   718,   764,   765,   766,   138,   541,   653,
     653,   653,   653,   653,   718,   718,   646,   648,   652,   138,
     647,   778,   821,   867,   647,   151,   492,    51,    51,   648,
      51,    51,   718,   646,   648,   867,   647,   718,  1006,  1006,
    1485,   350,   646,   778,   652,  1006,  1006,   648,   648,   648,
     648,   646,  1485,   350,   706,   706,   646,   647,   646,    71,
     395,   396,   397,   398,  1485,  1485,   646,  1485,   350,   556,
     556,   647,   397,    71,   718,   766,    51,   138,   492,  1485,
     492,   151,  1485,   151,   648,   648,   646,   138,   718,    51,
     646,   647,   821,   648,   860,   647,   859,   297,   821,   876,
     841,   721,   646,   646,   648,   860,   650,   646,   646,   350,
     646,   819,   646,   646,   350,   706,   706,  1485,    89,   138,
    1486,   691,   691,   718,   718,    51,   648,   541,   693,   694,
     350,   647,   647,  1485,   556,   761,   763,  1485,    51,   653,
     653,   648,   647,   821,   718,   646,   648,   867,   647,    51,
      51,   646,   648,   648,   706,    51,    71,    71,  1485,   556,
     687,   688,   689,   647,   694,  1485,  1485,    51,   647,   764,
      51,   646,   763,   492,   151,   718,   648,   646,   648,   860,
     830,   721,   646,  1485,  1486,  1486,   648,   647,   646,    71,
     395,   396,   397,   398,  1485,    51,    51,   138,  1485,   646,
    1485,   646,   648,   646,   648,    51,    51,    71,  1485,  1486,
     688,   688,   718,   718,   648,   138,   138,   648,    51,   646,
     718,   138,   647,  1486,    51,    71,    71,   817,   648,   648,
     138,   648,  1485,   646,   138,  1486,  1486,   646,   648,    51,
     648,  1485,   648,   646
  };

  const unsigned short
  parser::yyr1_[] =
  {
       0,   654,   655,   655,   656,   656,   656,   656,   656,   656,
     656,   656,   656,   656,   656,   656,   656,   656,   656,   656,
     656,   656,   656,   656,   656,   656,   656,   656,   656,   656,
     656,   656,   656,   656,   656,   656,   656,   656,   656,   656,
     656,   656,   656,   656,   656,   656,   656,   656,   656,   656,
     656,   656,   656,   656,   656,   656,   656,   656,   656,   656,
     656,   656,   656,   656,   656,   656,   656,   656,   656,   656,
     656,   656,   656,   656,   656,   656,   656,   656,   656,   656,
     656,   656,   656,   656,   656,   656,   656,   656,   656,   656,
     656,   656,   656,   656,   656,   656,   656,   656,   656,   656,
     656,   656,   656,   656,   656,   656,   656,   656,   656,   656,
     656,   656,   656,   656,   656,   656,   656,   657,   657,   658,
     660,   659,   661,   661,   661,   661,   661,   661,   663,   662,
     664,   664,   664,   664,   664,   664,   665,   666,   665,   667,
     665,   668,   668,   669,   669,   669,   670,   670,   671,   671,
     671,   672,   673,   673,   674,   674,   674,   676,   675,   677,
     677,   678,   678,   678,   678,   678,   679,   680,   680,   681,
     682,   681,   681,   681,   681,   681,   681,   684,   683,   685,
     685,   686,   686,   686,   686,   686,   687,   687,   687,   688,
     688,   689,   690,   690,   690,   691,   691,   692,   693,   693,
     694,   695,   696,   696,   697,   697,   698,   698,   698,   698,
     698,   698,   698,   698,   698,   698,   698,   698,   699,   700,
     701,   702,   703,   704,   705,   705,   705,   705,   706,   706,
     707,   707,   707,   707,   707,   707,   707,   707,   707,   707,
     707,   707,   708,   708,   708,   708,   708,   708,   708,   708,
     708,   708,   708,   708,   709,   709,   709,   709,   709,   709,
     709,   709,   709,   709,   709,   709,   710,   710,   710,   710,
     710,   710,   710,   710,   710,   710,   710,   710,   711,   711,
     711,   712,   712,   712,   712,   712,   712,   713,   714,   714,
     714,   714,   715,   715,   715,   716,   716,   717,   718,   718,
     718,   718,   718,   718,   718,   718,   718,   718,   718,   718,
     718,   718,   718,   718,   718,   718,   718,   718,   718,   718,
     718,   718,   718,   718,   718,   718,   718,   718,   718,   718,
     719,   718,   718,   718,   718,   718,   718,   718,   718,   720,
     720,   721,   721,   722,   722,   723,   724,   724,   725,   725,
     726,   727,   727,   728,   728,   729,   730,   732,   731,   733,
     733,   735,   734,   736,   737,   737,   738,   738,   738,   738,
     738,   739,   739,   739,   739,   739,   739,   739,   739,   739,
     739,   739,   739,   740,   740,   742,   741,   743,   741,   744,
     744,   744,   744,   745,   745,   745,   745,   746,   746,   747,
     747,   748,   748,   748,   748,   748,   748,   748,   748,   748,
     748,   748,   748,   748,   748,   748,   748,   748,   748,   748,
     748,   748,   748,   748,   748,   748,   748,   748,   748,   748,
     748,   748,   748,   748,   748,   748,   748,   748,   748,   748,
     748,   748,   748,   749,   748,   748,   748,   748,   748,   748,
     748,   750,   750,   751,   752,   752,   753,   753,   754,   754,
     754,   754,   754,   755,   757,   756,   758,   758,   759,   759,
     760,   761,   759,   759,   759,   762,   762,   763,   763,   764,
     764,   765,   765,   766,   766,   766,   766,   767,   768,   769,
     769,   770,   770,   770,   770,   770,   770,   771,   772,   772,
     773,   773,   773,   773,   774,   774,   775,   775,   776,   776,
     776,   776,   776,   776,   777,   778,   778,   778,   778,   778,
     778,   779,   779,   780,   780,   780,   780,   780,   780,   781,
     781,   782,   782,   783,   783,   783,   783,   783,   783,   783,
     783,   784,   784,   785,   785,   786,   786,   787,   787,   788,
     788,   789,   790,   790,   791,   791,   792,   792,   793,   793,
     794,   794,   795,   795,   795,   795,   795,   795,   795,   795,
     795,   795,   795,   795,   795,   795,   795,   796,   796,   796,
     796,   796,   796,   796,   796,   796,   796,   796,   796,   796,
     796,   796,   796,   796,   796,   796,   796,   796,   796,   796,
     796,   796,   796,   796,   796,   796,   796,   796,   796,   796,
     796,   796,   796,   796,   796,   796,   796,   796,   796,   796,
     796,   796,   796,   797,   797,   798,   798,   799,   799,   799,
     799,   799,   799,   799,   799,   799,   800,   800,   801,   801,
     802,   802,   802,   802,   802,   802,   802,   802,   802,   802,
     802,   802,   802,   803,   804,   805,   805,   806,   806,   807,
     807,   808,   808,   809,   809,   810,   811,   811,   812,   812,
     812,   812,   813,   813,   813,   813,   814,   814,   815,   815,
     815,   815,   815,   815,   815,   815,   815,   815,   815,   815,
     815,   815,   815,   815,   815,   815,   815,   815,   815,   815,
     815,   815,   815,   815,   815,   815,   815,   815,   815,   815,
     815,   815,   815,   815,   815,   815,   815,   815,   815,   815,
     815,   815,   815,   815,   815,   815,   815,   815,   816,   816,
     816,   816,   816,   816,   817,   817,   817,   818,   818,   819,
     819,   819,   820,   820,   821,   821,   821,   822,   822,   822,
     823,   823,   824,   824,   825,   826,   826,   827,   827,   828,
     828,   828,   828,   829,   829,   829,   829,   829,   830,   830,
     830,   830,   831,   831,   831,   832,   832,   833,   833,   833,
     834,   835,   835,   836,   836,   836,   837,   838,   838,   839,
     840,   840,   840,   840,   840,   840,   840,   840,   840,   841,
     841,   841,   841,   841,   841,   841,   841,   842,   843,   843,
     844,   845,   846,   846,   847,   847,   847,   847,   847,   847,
     847,   848,   849,   850,   850,   850,   851,   851,   853,   852,
     854,   852,   855,   852,   856,   852,   857,   852,   858,   852,
     859,   852,   860,   860,   861,   861,   861,   861,   861,   861,
     861,   861,   861,   861,   862,   862,   863,   863,   863,   863,
     863,   863,   863,   863,   863,   863,   864,   865,   865,   865,
     865,   865,   865,   866,   866,   866,   866,   866,   866,   867,
     867,   868,   868,   868,   869,   870,   870,   870,   870,   870,
     870,   871,   871,   871,   871,   872,   872,   873,   873,   873,
     873,   873,   873,   873,   873,   873,   873,   873,   873,   873,
     873,   873,   873,   873,   873,   873,   873,   873,   873,   873,
     873,   873,   873,   873,   873,   873,   873,   873,   873,   873,
     873,   873,   873,   873,   873,   873,   873,   873,   873,   873,
     873,   873,   873,   873,   873,   873,   873,   873,   873,   873,
     873,   873,   873,   873,   873,   873,   873,   873,   873,   873,
     873,   873,   873,   873,   873,   873,   873,   873,   873,   873,
     873,   873,   873,   873,   873,   873,   873,   873,   873,   873,
     873,   873,   873,   873,   873,   873,   873,   873,   873,   873,
     873,   873,   873,   873,   873,   873,   873,   873,   873,   873,
     873,   873,   873,   873,   873,   873,   873,   873,   873,   873,
     873,   873,   873,   873,   873,   873,   874,   874,   874,   875,
     875,   876,   876,   877,   877,   878,   878,   878,   878,   879,
     879,   881,   880,   882,   882,   882,   884,   883,   885,   885,
     885,   886,   887,   887,   888,   889,   890,   891,   891,   891,
     891,   892,   893,   893,   894,   894,   894,   894,   894,   894,
     894,   895,   895,   895,   895,   896,   896,   897,   897,   898,
     899,   900,   900,   901,   901,   902,   902,   902,   902,   902,
     902,   902,   902,   902,   902,   902,   902,   902,   902,   902,
     902,   902,   902,   902,   902,   902,   902,   902,   902,   902,
     902,   902,   902,   902,   902,   902,   902,   902,   902,   903,
     903,   904,   904,   905,   905,   906,   906,   907,   907,   908,
     908,   908,   908,   908,   908,   910,   911,   909,   912,   912,
     913,   913,   913,   913,   914,   915,   915,   916,   916,   916,
     916,   917,   918,   918,   918,   918,   919,   919,   920,   920,
     920,   921,   921,   922,   922,   922,   923,   923,   924,   924,
     924,   925,   925,   926,   926,   927,   927,   928,   929,   929,
     929,   929,   930,   930,   930,   930,   931,   931,   931,   931,
     932,   932,   932,   932,   933,   933,   934,   934,   934,   934,
     934,   934,   934,   935,   935,   935,   935,   935,   935,   935,
     935,   935,   935,   936,   936,   937,   937,   938,   938,   938,
     938,   939,   939,   940,   940,   941,   941,   941,   941,   941,
     941,   941,   941,   941,   941,   941,   941,   941,   941,   941,
     941,   941,   941,   941,   941,   941,   941,   941,   941,   941,
     941,   941,   941,   941,   941,   941,   941,   941,   941,   941,
     941,   941,   941,   941,   941,   941,   941,   941,   941,   941,
     941,   941,   941,   942,   942,   943,   943,   944,   944,   944,
     944,   944,   944,   944,   944,   944,   944,   944,   944,   944,
     944,   945,   945,   946,   946,   947,   947,   947,   947,   947,
     947,   947,   947,   947,   947,   947,   947,   947,   947,   948,
     948,   949,   949,   950,   950,   950,   950,   950,   950,   950,
     950,   950,   950,   950,   950,   950,   950,   951,   951,   952,
     952,   952,   952,   953,   953,   953,   953,   954,   954,   955,
     955,   956,   956,   956,   956,   956,   956,   956,   956,   957,
     957,   958,   958,   959,   959,   959,   959,   959,   959,   959,
     960,   960,   961,   961,   962,   962,   962,   962,   962,   962,
     962,   962,   962,   962,   962,   962,   962,   962,   962,   962,
     962,   962,   962,   962,   962,   962,   962,   962,   962,   962,
     962,   962,   962,   962,   962,   962,   962,   962,   962,   963,
     963,   964,   964,   965,   965,   966,   966,   967,   967,   967,
     967,   967,   967,   967,   967,   967,   967,   967,   967,   967,
     967,   967,   967,   967,   967,   967,   967,   967,   967,   967,
     967,   967,   967,   967,   967,   967,   967,   967,   967,   967,
     967,   967,   967,   967,   967,   967,   967,   967,   967,   967,
     967,   967,   967,   967,   967,   967,   967,   967,   967,   968,
     968,   969,   969,   969,   969,   969,   969,   969,   969,   969,
     969,   969,   969,   969,   969,   969,   969,   970,   970,   971,
     971,   971,   971,   971,   971,   971,   971,   971,   971,   971,
     971,   972,   972,   973,   973,   973,   973,   973,   973,   973,
     973,   973,   973,   973,   973,   973,   973,   973,   973,   973,
     973,   973,   973,   974,   974,   975,   975,   975,   975,   975,
     975,   975,   975,   975,   975,   975,   975,   975,   975,   976,
     977,   977,   978,   978,   979,   979,   979,   979,   980,   980,
     981,   981,   981,   981,   981,   982,   983,   983,   984,   984,
     984,   984,   984,   985,   985,   986,   987,   987,   988,   990,
     989,   991,   991,   992,   992,   993,   993,   993,   993,   994,
     994,   995,   995,   995,   995,   995,   995,   995,   995,   995,
     995,   995,   995,   995,   996,   996,   996,   996,   997,   997,
     998,   998,   999,   999,  1000,  1001,  1001,  1002,  1002,  1003,
    1003,  1004,  1004,  1004,  1004,  1004,  1004,  1005,  1006,  1006,
    1006,  1007,  1008,  1008,  1009,  1009,  1009,  1010,  1010,  1011,
    1011,  1012,  1012,  1012,  1013,  1013,  1014,  1014,  1015,  1015,
    1015,  1015,  1015,  1016,  1016,  1017,  1017,  1018,  1018,  1019,
    1019,  1019,  1020,  1020,  1021,  1021,  1022,  1022,  1023,  1024,
    1025,  1026,  1027,  1028,  1029,  1030,  1031,  1032,  1033,  1034,
    1035,  1036,  1037,  1038,  1039,  1040,  1041,  1042,  1043,  1044,
    1045,  1046,  1047,  1048,  1049,  1049,  1050,  1051,  1052,  1053,
    1054,  1055,  1056,  1056,  1057,  1058,  1059,  1060,  1061,  1062,
    1063,  1064,  1065,  1066,  1067,  1068,  1069,  1071,  1070,  1072,
    1072,  1073,  1074,  1075,  1076,  1077,  1078,  1079,  1080,  1081,
    1082,  1082,  1083,  1084,  1085,  1086,  1086,  1087,  1087,  1088,
    1089,  1090,  1091,  1092,  1093,  1094,  1095,  1096,  1097,  1098,
    1099,  1100,  1101,  1102,  1103,  1104,  1105,  1106,  1107,  1108,
    1109,  1110,  1111,  1112,  1112,  1113,  1113,  1114,  1115,  1116,
    1117,  1117,  1118,  1119,  1120,  1121,  1122,  1123,  1124,  1125,
    1125,  1126,  1127,  1128,  1128,  1129,  1129,  1130,  1130,  1131,
    1132,  1133,  1133,  1133,  1133,  1134,  1134,  1135,  1136,  1137,
    1138,  1139,  1140,  1141,  1142,  1143,  1144,  1144,  1145,  1146,
    1147,  1148,  1149,  1150,  1151,  1151,  1152,  1153,  1154,  1155,
    1156,  1157,  1158,  1159,  1160,  1161,  1162,  1163,  1164,  1165,
    1166,  1166,  1166,  1167,  1168,  1169,  1170,  1171,  1172,  1173,
    1174,  1175,  1176,  1177,  1178,  1179,  1179,  1180,  1181,  1182,
    1183,  1184,  1185,  1186,  1187,  1188,  1189,  1190,  1191,  1192,
    1193,  1194,  1195,  1196,  1197,  1198,  1199,  1199,  1200,  1201,
    1201,  1201,  1201,  1202,  1203,  1204,  1204,  1204,  1205,  1206,
    1207,  1208,  1209,  1210,  1211,  1212,  1213,  1214,  1215,  1216,
    1216,  1216,  1217,  1217,  1217,  1218,  1219,  1220,  1221,  1222,
    1223,  1224,  1225,  1226,  1227,  1228,  1229,  1230,  1231,  1232,
    1233,  1234,  1235,  1236,  1237,  1238,  1239,  1240,  1241,  1241,
    1241,  1242,  1243,  1243,  1243,  1244,  1244,  1245,  1246,  1247,
    1247,  1247,  1248,  1248,  1248,  1249,  1250,  1251,  1252,  1253,
    1254,  1255,  1256,  1257,  1258,  1259,  1260,  1261,  1262,  1263,
    1264,  1265,  1266,  1267,  1268,  1269,  1270,  1271,  1272,  1273,
    1274,  1275,  1276,  1277,  1278,  1278,  1279,  1280,  1281,  1282,
    1283,  1284,  1285,  1286,  1287,  1288,  1289,  1290,  1291,  1292,
    1292,  1292,  1292,  1292,  1292,  1292,  1293,  1294,  1295,  1296,
    1297,  1297,  1297,  1298,  1299,  1300,  1301,  1302,  1303,  1304,
    1305,  1306,  1306,  1306,  1307,  1308,  1309,  1310,  1311,  1312,
    1313,  1314,  1315,  1316,  1317,  1318,  1318,  1319,  1320,  1321,
    1322,  1323,  1324,  1325,  1326,  1327,  1328,  1329,  1330,  1331,
    1332,  1333,  1334,  1335,  1336,  1337,  1338,  1339,  1340,  1341,
    1342,  1343,  1344,  1345,  1346,  1347,  1347,  1348,  1349,  1350,
    1351,  1352,  1353,  1353,  1354,  1355,  1356,  1357,  1358,  1358,
    1359,  1359,  1360,  1361,  1362,  1363,  1364,  1365,  1366,  1367,
    1368,  1369,  1370,  1371,  1372,  1373,  1374,  1375,  1376,  1377,
    1378,  1379,  1380,  1381,  1382,  1383,  1384,  1385,  1386,  1387,
    1388,  1389,  1390,  1391,  1392,  1393,  1394,  1395,  1396,  1397,
    1398,  1399,  1400,  1401,  1402,  1402,  1403,  1404,  1405,  1406,
    1407,  1408,  1409,  1410,  1411,  1411,  1411,  1411,  1412,  1413,
    1414,  1415,  1416,  1417,  1418,  1419,  1420,  1421,  1422,  1423,
    1424,  1425,  1426,  1427,  1428,  1428,  1429,  1430,  1431,  1432,
    1433,  1434,  1435,  1435,  1436,  1436,  1437,  1438,  1439,  1440,
    1441,  1441,  1441,  1441,  1442,  1442,  1442,  1442,  1443,  1444,
    1445,  1446,  1447,  1448,  1449,  1450,  1451,  1452,  1453,  1454,
    1455,  1456,  1457,  1458,  1459,  1460,  1461,  1462,  1463,  1464,
    1465,  1466,  1467,  1468,  1469,  1470,  1471,  1471,  1472,  1472,
    1473,  1474,  1474,  1475,  1475,  1475,  1475,  1476,  1476,  1477,
    1477,  1477,  1477,  1478,  1478,  1479,  1479,  1479,  1479,  1480,
    1480,  1481,  1481,  1482,  1482,  1483,  1483,  1484,  1485,  1485,
    1485,  1485,  1485,  1485,  1485,  1485,  1485,  1485,  1485,  1485,
    1485,  1485,  1485,  1485,  1485,  1485,  1485,  1485,  1485,  1485,
    1486,  1486
  };

  const unsigned char
  parser::yyr2_[] =
  {
       0,     2,     1,     2,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     3,     4,     3,
       0,     9,     2,     3,     1,     3,     4,     2,     0,     9,
       2,     3,     1,     3,     4,     2,     3,     0,     9,     0,
       9,     5,     6,     2,     3,     1,     3,     1,     1,     1,
       1,     5,     3,     1,     1,     1,     1,     0,     6,     3,
       1,     1,     1,     1,     1,     1,     5,     1,     3,     3,
       0,     4,     3,     3,     3,     3,     3,     0,     9,     2,
       1,     5,     7,     4,    10,    14,     5,     5,     3,     3,
       3,     6,     5,     5,     3,     3,     3,     8,     2,     1,
       6,     5,     3,     1,     1,     1,     2,     3,     1,     3,
       4,     2,     3,     4,     2,     4,     5,     3,     3,     3,
       3,     3,     3,     3,     2,     3,     2,     3,     2,     3,
       2,     3,     1,     3,     4,     2,     3,     4,     2,     4,
       5,     3,     2,     3,     1,     3,     4,     2,     3,     4,
       2,     4,     5,     3,     2,     3,     1,     3,     4,     2,
       3,     4,     2,     4,     5,     3,     2,     3,     1,     3,
       4,     2,     3,     4,     2,     4,     5,     3,     2,     3,
       1,     2,     3,     1,     3,     4,     2,     6,     1,     1,
       1,     1,     1,     2,     3,     3,     4,     4,     3,     1,
       1,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     2,     2,     4,     4,     4,     4,     4,     4,
       4,     4,     4,     4,     4,     4,     4,     4,     6,     6,
       0,     5,     8,     4,     8,     4,     4,     1,     1,     1,
       3,     0,     1,     5,     8,     7,     5,     8,     2,     1,
       4,     5,     8,     2,     1,     7,     7,     0,     6,     2,
       1,     0,     5,     5,     3,     1,     3,     3,     3,     3,
       3,     1,     1,     1,     1,     1,     1,     1,     5,     1,
       5,     1,     3,     3,     1,     0,     6,     0,     9,     2,
       2,     1,     1,     4,     2,     7,     5,     3,     1,     3,
       1,     3,     1,     2,     2,     2,     1,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     7,     4,
       4,     2,     2,     4,     4,     6,     8,     8,     4,     4,
       4,     4,     4,     4,     4,     4,     4,     4,     4,     4,
       4,     6,     6,     0,     5,     8,     4,     8,     4,     4,
       4,     1,     3,     5,     5,     8,     2,     1,     1,     6,
       5,     7,     7,     9,     0,     6,     2,     1,     5,     3,
       0,     0,    10,     2,     2,     6,     5,     3,     1,     1,
       1,     1,     2,     6,     7,     7,     8,     2,     5,     3,
       1,     1,     1,     1,     1,     1,     1,     5,     3,     1,
       1,     1,     1,     1,     5,     8,     2,     1,     3,     2,
       5,     4,     3,     1,     6,     5,     4,     3,     3,     2,
       1,     3,     1,     5,     3,     4,     2,     3,     1,     2,
       5,     3,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     2,     5,     3,     1,     1,     1,     2,     5,     3,
       1,     0,     2,     5,     3,     1,     1,     1,     2,     5,
       3,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     5,     6,     3,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     5,     6,     3,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     5,     5,     3,     1,     1,     1,     2,
       5,     3,     1,     1,     1,     5,     3,     1,     1,     1,
       1,     1,     2,     5,     3,     6,     3,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     2,     3,     1,     1,     1,     2,
       2,     1,     1,     1,     2,     2,     1,     2,     2,     1,
       1,     1,     1,     1,     5,     2,     1,     4,     2,     2,
       1,     4,     1,     3,     5,     9,     1,     5,     3,     5,
       7,     9,     5,     7,     8,     2,     1,     5,     7,     4,
       5,     2,     1,     7,     9,     6,     5,     2,     1,     6,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     3,
       5,     5,     3,     1,     1,     1,     1,     1,     1,     1,
       1,     5,     4,     3,     6,     8,     3,     1,     0,     8,
       0,    10,     0,     8,     0,    11,     0,    13,     0,    13,
       0,    15,     3,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     3,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     4,     3,     5,     6,
       8,     8,    10,     7,     9,    10,    12,    12,    14,     3,
       1,     1,     1,     1,     4,     3,     5,     6,     8,     8,
      10,     2,     5,     3,     6,     3,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     3,     3,     3,     1,
       3,     3,     3,     1,     3,     3,     3,     3,     5,     1,
       3,     0,     4,     2,     3,     1,     0,     4,     2,     3,
       1,     5,     2,     1,     5,     3,     5,     4,     6,     3,
       5,     3,     3,     1,     1,     1,     1,     1,     1,     1,
       1,     2,     5,     3,     6,     5,     6,     5,     6,     5,
       5,     2,     5,     3,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     3,
       6,     1,     1,     1,     3,     1,     1,     1,     3,     1,
       4,     2,     5,     3,     6,     0,     0,     5,     2,     5,
       2,     5,     3,     6,     5,     2,     1,     4,     4,     4,
       4,     2,     2,     5,     3,     6,     3,     1,     1,     1,
       1,     3,     1,     1,     1,     1,     3,     1,     1,     1,
       1,     2,     5,     2,     5,     2,     5,     2,     2,     5,
       3,     6,     2,     5,     3,     6,     2,     5,     3,     6,
       2,     5,     3,     6,     2,     3,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     3,     1,     3,     6,     1,     1,     1,
       1,     3,     1,     3,     6,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     3,     1,     2,     5,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     3,     1,     2,     5,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     3,
       1,     2,     5,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     3,     1,     2,
       5,     3,     6,     1,     1,     1,     1,     3,     1,     2,
       5,     1,     1,     1,     1,     1,     1,     1,     1,     3,
       1,     2,     5,     1,     1,     1,     1,     1,     1,     1,
       3,     1,     2,     5,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     3,
       1,     2,     5,     2,     5,     3,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     3,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     3,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     3,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     3,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     5,
       1,     2,     6,     4,     2,     5,     3,     6,     1,     3,
       1,     1,     1,     1,     1,     5,     1,     3,     1,     1,
       1,     1,     1,     3,     8,     5,     1,     2,     9,     0,
       6,     2,     1,     4,     6,     2,     5,     3,     6,     3,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     4,     5,     7,     8,     3,     1,
       1,     1,     2,     1,     4,     5,     3,     2,     5,     3,
       1,     1,     1,     1,     1,     1,     1,     2,     5,     1,
       1,     5,     1,     2,     6,     9,     9,     5,     8,     1,
       2,     6,     9,     9,     2,     5,     3,     1,     1,     1,
       1,     1,     1,     5,    10,     2,     1,     4,     4,     3,
       2,     1,     5,    10,     2,     1,     3,     4,     3,     3,
       3,     3,     1,     1,     1,     3,     3,     3,     3,     1,
       1,     1,     3,     5,     3,     3,     3,     3,     3,     3,
       3,     1,     3,     3,     1,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     1,     3,
       3,     3,     3,     3,     3,     3,     3,     0,     4,     3,
       3,     3,     3,     3,     3,     3,     1,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     1,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     1,     1,     1,     1,     1,     1,     3,
       3,     3,     3,     3,     3,     3,     1,     1,     1,     1,
       3,     3,     3,     3,     5,     3,     5,     3,     5,     1,
       1,     1,     1,     1,     1,     1,     3,     5,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     1,     5,     5,
       3,     1,     3,     3,     3,     3,     1,     3,     3,     3,
       3,     3,     3,     1,     1,     1,     1,     1,     1,     1,
       3,     3,     1,     3,     1,     3,     1,     1,     1,     1,
       1,     1,     3,     3,     3,     3,     3,     1,     1,     3,
       3,     3,     3,     3,     1,     3,     1,     1,     1,     1,
       3,     1,     1,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     1,     1,     1,     1,     1,     1,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     1,
       1,     3,     3,     1,     1,     1,     1,     3,     3,     3,
       3,     3,     1,     3,     3,     1,     1,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     5,     5,     5,     3,     3,     5,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     1,     5,     3,
       3,     3,     3,     3,     3,     3,     1,     1,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     5,
       3,     3,     3,     3,     3,     1,     1,     3,     1,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     1,     1,     3,     3,     3,     3,     3,     3,     5,
       1,     1,     3,     3,     1,     5,     3,     3,     3,     1,
       3,     1,     1,     1,     1,     1,     3,     3,     3,     1,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     1,
       3,     1,     3,     3,     3,     1,     3,     1,     1,     1,
       3,     3,     3,     3,     1,     3,     1,     3,     3,     3,
       1,     3,     1,     3,     3,     3,     3,     3,     1,     1,
       3,     3,     1,     1,     1,     3,     5,     3,     3,     5,
       1,     1,     3,     3,     1,     3,     3,     3,     3,     3,
       1,     1,     3,     3,     3,     3,     1,     1,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     1,     1,
       1,     1,     3,     3,     3,     1,     1,     1,     1,     3,
       3,     3,     1,     1,     1,     1,     1,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     6,
       1,     1,     3,     2,     3,     2,     3,     2,     3,     2,
       3,     2,     3,     2,     3,     2,     3,     2,     3,     2,
       3,     3,     1,     3,     1,     2,     2,     2,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1
  };



  // YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
  // First, the terminals, then, starting at \a yyntokens_, nonterminals.
  const char*
  const parser::yytname_[] =
  {
  "$end", "error", "$undefined", "AIM_SOLVER", "ANALYTIC_DERIVATION",
  "ANALYTIC_DERIVATION_MODE", "AR", "POSTERIOR_SAMPLING_METHOD",
  "BALANCED_GROWTH_TEST_TOL", "BAYESIAN_IRF", "BETA_PDF", "BLOCK",
  "USE_CALIBRATION", "SILENT_OPTIMIZER", "BVAR_DENSITY", "BVAR_FORECAST",
  "NODECOMPOSITION", "DR_DISPLAY_TOL", "HUGE_NUMBER", "FIG_NAME",
  "WRITE_XLS", "BVAR_PRIOR_DECAY", "BVAR_PRIOR_FLAT", "BVAR_PRIOR_LAMBDA",
  "INTERACTIVE", "SCREEN_SHOCKS", "STEADYSTATE", "BVAR_PRIOR_MU",
  "BVAR_PRIOR_OMEGA", "BVAR_PRIOR_TAU", "BVAR_PRIOR_TRAIN", "DETAIL_PLOT",
  "TYPE", "BVAR_REPLIC", "BYTECODE", "ALL_VALUES_REQUIRED",
  "PROPOSAL_DISTRIBUTION", "REALTIME", "VINTAGE", "CALIB_SMOOTHER",
  "CHANGE_TYPE", "CHECK", "CONDITIONAL_FORECAST",
  "CONDITIONAL_FORECAST_PATHS", "CONF_SIG", "CONSTANT",
  "CONTROLLED_VAREXO", "CORR", "CUTOFF", "CYCLE_REDUCTION",
  "LOGARITHMIC_REDUCTION", "COMMA", "CONSIDER_ALL_ENDOGENOUS",
  "CONSIDER_ONLY_OBSERVED", "INITIAL_CONDITION_DECOMPOSITION", "DATAFILE",
  "FILE", "SERIES", "DOUBLING", "DR_CYCLE_REDUCTION_TOL",
  "DR_LOGARITHMIC_REDUCTION_TOL", "DR_LOGARITHMIC_REDUCTION_MAXITER",
  "DR_ALGO", "DROP", "DSAMPLE", "DYNASAVE", "DYNATYPE", "CALIBRATION",
  "DIFFERENTIATE_FORWARD_VARS", "END", "ENDVAL", "EQUAL", "ESTIMATION",
  "ESTIMATED_PARAMS", "ESTIMATED_PARAMS_BOUNDS", "ESTIMATED_PARAMS_INIT",
  "EXTENDED_PATH", "ENDOGENOUS_PRIOR", "EXPRESSION", "FILENAME", "DIRNAME",
  "FILTER_STEP_AHEAD", "FILTERED_VARS", "FIRST_OBS", "LAST_OBS",
  "SET_TIME", "OSR_PARAMS_BOUNDS",
  "KEEP_KALMAN_ALGO_IF_SINGULARITY_IS_DETECTED", "FALSE", "FLOAT_NUMBER",
  "DATES", "DEFAULT", "FIXED_POINT", "FLIP", "OPT_ALGO",
  "COMPILATION_SETUP", "COMPILER", "ADD_FLAGS", "SUBSTITUTE_FLAGS",
  "ADD_LIBS", "SUBSTITUTE_LIBS", "FORECAST", "K_ORDER_SOLVER",
  "INSTRUMENTS", "SHIFT", "MEAN", "STDEV", "VARIANCE", "MODE", "INTERVAL",
  "SHAPE", "DOMAINN", "GAMMA_PDF", "GRAPH", "GRAPH_FORMAT",
  "CONDITIONAL_VARIANCE_DECOMPOSITION", "NOCHECK", "STD", "HISTVAL",
  "HISTVAL_FILE", "HOMOTOPY_SETUP", "HOMOTOPY_MODE", "HOMOTOPY_STEPS",
  "HOMOTOPY_FORCE_CONTINUE", "HP_FILTER", "HP_NGRID",
  "FILTERED_THEORETICAL_MOMENTS_GRID", "HYBRID", "ONE_SIDED_HP_FILTER",
  "IDENTIFICATION", "INF_CONSTANT", "INITVAL", "INITVAL_FILE", "BOUNDS",
  "JSCALE", "INIT", "INFILE", "INVARS", "INT_NUMBER", "INV_GAMMA_PDF",
  "INV_GAMMA1_PDF", "INV_GAMMA2_PDF", "IRF", "IRF_SHOCKS",
  "IRF_PLOT_THRESHOLD", "IRF_CALIBRATION", "FAST_KALMAN_FILTER",
  "KALMAN_ALGO", "KALMAN_TOL", "DIFFUSE_KALMAN_TOL", "SUBSAMPLES",
  "OPTIONS", "TOLF", "TOLX", "PLOT_INIT_DATE", "PLOT_END_DATE", "LAPLACE",
  "LIK_ALGO", "LIK_INIT", "LINEAR", "LINEAR_DECOMPOSITION",
  "LOAD_IDENT_FILES", "LOAD_MH_FILE", "LOAD_RESULTS_AFTER_LOAD_MH",
  "LOAD_PARAMS_AND_STEADY_STATE", "LOGLINEAR", "LOGDATA", "LYAPUNOV",
  "LINEAR_APPROXIMATION", "LYAPUNOV_FIXED_POINT_TOL",
  "LYAPUNOV_DOUBLING_TOL", "LOG_DEFLATOR", "LOG_TREND_VAR",
  "LOG_GROWTH_FACTOR", "MARKOWITZ", "MARGINAL_DENSITY", "MAX", "MAXIT",
  "MFS", "MH_CONF_SIG", "MH_DROP", "MH_INIT_SCALE", "MH_JSCALE",
  "MH_TUNE_JSCALE", "MH_MODE", "MH_NBLOCKS", "MH_REPLIC", "MH_RECOVER",
  "POSTERIOR_MAX_SUBSAMPLE_DRAWS", "MIN", "MINIMAL_SOLVING_PERIODS",
  "MODE_CHECK", "MODE_CHECK_NEIGHBOURHOOD_SIZE",
  "MODE_CHECK_SYMMETRIC_PLOTS", "MODE_CHECK_NUMBER_OF_POINTS",
  "MODE_COMPUTE", "MODE_FILE", "MODEL", "MODEL_COMPARISON", "MODEL_INFO",
  "MSHOCKS", "ABS", "SIGN", "MODEL_DIAGNOSTICS", "MODIFIEDHARMONICMEAN",
  "MOMENTS_VARENDO", "CONTEMPORANEOUS_CORRELATION", "DIFFUSE_FILTER",
  "SUB_DRAWS", "TAPER_STEPS", "GEWEKE_INTERVAL", "RAFTERY_LEWIS_QRS",
  "RAFTERY_LEWIS_DIAGNOSTICS", "MCMC_JUMPING_COVARIANCE",
  "MOMENT_CALIBRATION", "NUMBER_OF_PARTICLES", "RESAMPLING", "SYSTEMATIC",
  "GENERIC", "RESAMPLING_THRESHOLD", "RESAMPLING_METHOD", "KITAGAWA",
  "STRATIFIED", "SMOOTH", "CPF_WEIGHTS", "AMISANOTRISTANI",
  "MURRAYJONESPARSLOW", "WRITE_EQUATION_TAGS",
  "NONLINEAR_FILTER_INITIALIZATION", "FILTER_ALGORITHM",
  "PROPOSAL_APPROXIMATION", "CUBATURE", "UNSCENTED", "MONTECARLO",
  "DISTRIBUTION_APPROXIMATION", "NAME",
  "USE_PENALIZED_OBJECTIVE_FOR_HESSIAN", "INIT_STATE", "FAST_REALTIME",
  "RESCALE_PREDICTION_ERROR_COVARIANCE", "GENERATE_IRFS", "NAN_CONSTANT",
  "NO_STATIC", "NOBS", "NOCONSTANT", "NODISPLAY", "NOCORR", "NODIAGNOSTIC",
  "NOFUNCTIONS", "NO_HOMOTOPY", "NOGRAPH", "POSTERIOR_NOGRAPH",
  "POSTERIOR_GRAPH", "NOMOMENTS", "NOPRINT", "NORMAL_PDF", "SAVE_DRAWS",
  "MODEL_NAME", "STDERR_MULTIPLES", "DIAGONAL_ONLY", "OBSERVATION_TRENDS",
  "OPTIM", "OPTIM_WEIGHTS", "ORDER", "OSR", "OSR_PARAMS",
  "MAX_DIM_COVA_GROUP", "ADVANCED", "OUTFILE", "OUTVARS", "OVERWRITE",
  "DISCOUNT", "PARALLEL_LOCAL_FILES", "PARAMETERS", "PARAMETER_SET",
  "PARTIAL_INFORMATION", "PERIODS", "PERIOD", "PLANNER_OBJECTIVE",
  "PLOT_CONDITIONAL_FORECAST", "PLOT_PRIORS", "PREFILTER", "PRESAMPLE",
  "PERFECT_FORESIGHT_SETUP", "PERFECT_FORESIGHT_SOLVER",
  "NO_POSTERIOR_KERNEL_DENSITY", "FUNCTION", "PRINT", "PRIOR_MC",
  "PRIOR_TRUNC", "PRIOR_MODE", "PRIOR_MEAN", "POSTERIOR_MODE",
  "POSTERIOR_MEAN", "POSTERIOR_MEDIAN", "MLE_MODE", "PRUNING",
  "QUOTED_STRING", "QZ_CRITERIUM", "QZ_ZERO_THRESHOLD", "DSGE_VAR",
  "DSGE_VARLAG", "DSGE_PRIOR_WEIGHT", "TRUNCATE", "PIPE_E", "PIPE_X",
  "PIPE_P", "RELATIVE_IRF", "REPLIC", "SIMUL_REPLIC", "RPLOT",
  "SAVE_PARAMS_AND_STEADY_STATE", "PARAMETER_UNCERTAINTY", "TARGETS",
  "SHOCKS", "SHOCK_DECOMPOSITION", "SHOCK_GROUPS", "USE_SHOCK_GROUPS",
  "SIGMA_E", "SIMUL", "SIMUL_ALGO", "SIMUL_SEED",
  "ENDOGENOUS_TERMINAL_PERIOD", "SMOOTHER", "SMOOTHER2HISTVAL",
  "SQUARE_ROOT_SOLVER", "STACK_SOLVE_ALGO", "STEADY_STATE_MODEL",
  "SOLVE_ALGO", "SOLVER_PERIODS", "ROBUST_LIN_SOLVE", "STDERR", "STEADY",
  "STOCH_SIMUL", "SYLVESTER", "SYLVESTER_FIXED_POINT_TOL", "REGIMES",
  "REGIME", "REALTIME_SHOCK_DECOMPOSITION", "CONDITIONAL", "UNCONDITIONAL",
  "TEX", "RAMSEY_MODEL", "RAMSEY_POLICY", "RAMSEY_CONSTRAINTS",
  "PLANNER_DISCOUNT", "PLANNER_DISCOUNT_LATEX_NAME",
  "DISCRETIONARY_POLICY", "DISCRETIONARY_TOL",
  "EVALUATE_PLANNER_OBJECTIVE", "TEX_NAME", "TRUE", "UNIFORM_PDF",
  "UNIT_ROOT_VARS", "USE_DLL", "USEAUTOCORR", "GSA_SAMPLE_FILE",
  "USE_UNIVARIATE_FILTERS_IF_SINGULARITY_IS_DETECTED", "VALUES", "VAR",
  "VAREXO", "VAREXO_DET", "VARIABLE", "VAROBS", "VAREXOBS",
  "PREDETERMINED_VARIABLES", "VAR_EXPECTATION", "VAR_EXPECTATION_MODEL",
  "PLOT_SHOCK_DECOMPOSITION", "MODEL_LOCAL_VARIABLE",
  "WRITE_LATEX_DYNAMIC_MODEL", "WRITE_LATEX_STATIC_MODEL",
  "WRITE_LATEX_ORIGINAL_MODEL", "CROSSEQUATIONS", "COVARIANCE",
  "WRITE_LATEX_STEADY_STATE_MODEL", "XLS_SHEET", "XLS_RANGE", "LMMCP",
  "OCCBIN", "BANDPASS_FILTER", "COLORMAP", "VAR_MODEL", "PAC_MODEL", "QOQ",
  "YOY", "AOA", "PAC_EXPECTATION", "TREND_COMPONENT_MODEL", "EQUAL_EQUAL",
  "EXCLAMATION_EQUAL", "LESS", "GREATER", "LESS_EQUAL", "GREATER_EQUAL",
  "PLUS", "MINUS", "TIMES", "DIVIDE", "UNARY", "POWER", "EXP", "LOG", "LN",
  "LOG10", "SIN", "COS", "TAN", "ASIN", "ACOS", "ATAN", "ERF", "DIFF",
  "ADL", "AUXILIARY_MODEL_NAME", "SQRT", "CBRT", "NORMCDF", "NORMPDF",
  "STEADY_STATE", "EXPECTATION", "VAR_ESTIMATION", "DYNARE_SENSITIVITY",
  "MORRIS", "STAB", "REDFORM", "PPRIOR", "PRIOR_RANGE", "PPOST", "ILPTAU",
  "MORRIS_NLIV", "MORRIS_NTRA", "NSAM", "LOAD_REDFORM", "LOAD_RMSE",
  "LOAD_STAB", "ALPHA2_STAB", "LOGTRANS_REDFORM", "THRESHOLD_REDFORM",
  "KSSTAT_REDFORM", "ALPHA2_REDFORM", "NAMENDO", "NAMLAGENDO", "NAMEXO",
  "RMSE", "LIK_ONLY", "VAR_RMSE", "PFILT_RMSE", "ISTART_RMSE",
  "ALPHA_RMSE", "ALPHA2_RMSE", "FREQ", "INITIAL_YEAR", "INITIAL_SUBPERIOD",
  "FINAL_YEAR", "FINAL_SUBPERIOD", "DATA", "VLIST", "VLISTLOG", "VLISTPER",
  "SPECTRAL_DENSITY", "INIT2SHOCKS", "RESTRICTION", "RESTRICTION_FNAME",
  "CROSS_RESTRICTIONS", "NLAGS", "CONTEMP_REDUCED_FORM",
  "REAL_PSEUDO_FORECAST", "DUMMY_OBS", "NSTATES", "INDXSCALESSTATES",
  "NO_BAYESIAN_PRIOR", "SPECIFICATION", "SIMS_ZHA", "ALPHA", "BETA",
  "ABAND", "NINV", "CMS", "NCMS", "CNUM", "GAMMA", "INV_GAMMA",
  "INV_GAMMA1", "INV_GAMMA2", "NORMAL", "UNIFORM", "EPS", "PDF", "FIG",
  "DR", "NONE", "PRIOR", "PRIOR_VARIANCE", "HESSIAN", "IDENTITY_MATRIX",
  "DIRICHLET", "DIAGONAL", "OPTIMAL", "GSIG2_LMDM", "Q_DIAG", "FLAT_PRIOR",
  "NCSK", "NSTD", "WEIBULL", "WEIBULL_PDF", "INDXPARR", "INDXOVR",
  "INDXAP", "APBAND", "INDXIMF", "INDXFORE", "FOREBAND", "INDXGFOREHAT",
  "INDXGIMFHAT", "INDXESTIMA", "INDXGDLS", "EQ_MS", "FILTER_COVARIANCE",
  "FILTER_DECOMPOSITION", "SMOOTHED_STATE_UNCERTAINTY", "EQ_CMS", "TLINDX",
  "TLNUMBER", "RESTRICTIONS", "POSTERIOR_SAMPLER_OPTIONS",
  "OUTPUT_FILE_TAG", "HORIZON", "SBVAR", "TREND_VAR", "DEFLATOR",
  "GROWTH_FACTOR", "MS_IRF", "MS_VARIANCE_DECOMPOSITION", "GROWTH",
  "MS_ESTIMATION", "MS_SIMULATION", "MS_COMPUTE_MDD",
  "MS_COMPUTE_PROBABILITIES", "MS_FORECAST", "SVAR_IDENTIFICATION",
  "EQUATION", "EXCLUSION", "LAG", "UPPER_CHOLESKY", "LOWER_CHOLESKY",
  "MONTHLY", "QUARTERLY", "MARKOV_SWITCHING", "CHAIN", "DURATION",
  "NUMBER_OF_REGIMES", "NUMBER_OF_LAGS", "EPILOGUE", "SVAR",
  "SVAR_GLOBAL_IDENTIFICATION_CHECK", "COEFF", "COEFFICIENTS", "VARIANCES",
  "CONSTANTS", "EQUATIONS", "EXTERNAL_FUNCTION", "EXT_FUNC_NAME",
  "EXT_FUNC_NARGS", "FIRST_DERIV_PROVIDED", "SECOND_DERIV_PROVIDED",
  "SELECTED_VARIABLES_ONLY", "COVA_COMPUTE", "SIMULATION_FILE_TAG",
  "FILE_TAG", "NO_ERROR_BANDS", "ERROR_BAND_PERCENTILES",
  "SHOCKS_PER_PARAMETER", "NO_CREATE_INIT", "SHOCK_DRAWS",
  "FREE_PARAMETERS", "MEDIAN", "DATA_OBS_NBR", "NEIGHBORHOOD_WIDTH",
  "PVALUE_KS", "PVALUE_CORR", "FILTERED_PROBABILITIES",
  "REAL_TIME_SMOOTHED", "PRIOR_FUNCTION", "POSTERIOR_FUNCTION",
  "SAMPLING_DRAWS", "PROPOSAL_TYPE", "PROPOSAL_UPPER_BOUND",
  "PROPOSAL_LOWER_BOUND", "PROPOSAL_DRAWS", "USE_MEAN_CENTER",
  "ADAPTIVE_MH_DRAWS", "THINNING_FACTOR",
  "COEFFICIENTS_PRIOR_HYPERPARAMETERS", "SMM_ESTIMATION", "GMM_ESTIMATION",
  "CONVERGENCE_STARTING_VALUE", "CONVERGENCE_ENDING_VALUE",
  "CONVERGENCE_INCREMENT_VALUE", "MAX_ITERATIONS_STARTING_VALUE",
  "MAX_ITERATIONS_INCREMENT_VALUE", "MAX_BLOCK_ITERATIONS",
  "MAX_REPEATED_OPTIMIZATION_RUNS", "FUNCTION_CONVERGENCE_CRITERION",
  "SAVE_REALTIME", "PARAMETER_CONVERGENCE_CRITERION",
  "NUMBER_OF_LARGE_PERTURBATIONS", "NUMBER_OF_SMALL_PERTURBATIONS",
  "NUMBER_OF_POSTERIOR_DRAWS_AFTER_PERTURBATION", "MAX_NUMBER_OF_STAGES",
  "RANDOM_FUNCTION_CONVERGENCE_CRITERION",
  "RANDOM_PARAMETER_CONVERGENCE_CRITERION", "CENTERED_MOMENTS", "AUTOLAG",
  "RECURSIVE_ORDER_ESTIMATION", "BARTLETT_KERNEL_LAG", "WEIGHTING_MATRIX",
  "PENALIZED_ESTIMATOR", "VERBOSE", "SIMULATION_MULTIPLE", "SEED",
  "BOUNDED_SHOCK_SUPPORT", "EQTAGS", "STEADY_STATE_GROWTH",
  "ANALYTICAL_GIRF", "IRF_IN_PERCENT", "EMAS_GIRF", "EMAS_DROP",
  "EMAS_TOLF", "EMAS_MAX_ITER", "NO_IDENTIFICATION_STRENGTH",
  "NO_IDENTIFICATION_REDUCEDFORM", "NO_IDENTIFICATION_MOMENTS",
  "NO_IDENTIFICATION_MINIMAL", "NO_IDENTIFICATION_SPECTRUM",
  "NORMALIZE_JACOBIANS", "GRID_NBR", "TOL_RANK", "TOL_DERIV", "TOL_SV",
  "CHECKS_VIA_SUBSETS", "MAX_DIM_SUBSETS_GROUPS", "MAX_NROWS",
  "SQUEEZE_SHOCK_DECOMPOSITION", "WITH_EPILOGUE", "SYMBOL_VEC", "';'",
  "'('", "')'", "'['", "']'", "'#'", "':'", "'.'", "$accept",
  "statement_list", "statement", "dsample", "rplot", "trend_var", "$@1",
  "trend_var_list", "log_trend_var", "$@2", "log_trend_var_list", "var",
  "$@3", "$@4", "var_model", "var_symbol_list", "var_model_options_list",
  "var_model_options", "trend_component_model",
  "trend_component_model_options_list", "trend_component_model_options",
  "pac_model", "$@5", "pac_model_options_list", "pac_model_options",
  "var_expectation_model", "var_expectation_model_options_list",
  "var_expectation_model_option", "$@6", "restrictions", "$@7",
  "restrictions_list", "restriction", "restriction_equation_equality",
  "restriction_equation_equality_side", "coeff_def",
  "restriction_crossequation_equality",
  "restriction_crossequation_equality_side", "coeff_def1",
  "restriction_exclusion_equation_list", "restriction_exclusion_equation",
  "var_estimation", "var_estimation_options_list",
  "var_estimation_options", "nonstationary_var_list", "varexo",
  "varexo_det", "predetermined_variables", "parameters",
  "model_local_variable", "named_var_elem", "named_var_1", "named_var",
  "var_list", "varexo_list", "varexo_det_list", "parameter_list",
  "predetermined_variables_list", "model_local_variable_list",
  "change_type", "change_type_arg", "change_type_var_list", "periods",
  "init_param", "expression", "$@8", "comma_expression",
  "expression_or_empty", "initval", "initval_file", "endval",
  "initval_list", "initval_elem", "histval", "histval_list",
  "histval_elem", "histval_file", "epilogue", "$@9",
  "epilogue_equation_list", "epilogue_equation", "$@10",
  "compilation_setup", "compilation_setup_options_list",
  "compilation_setup_option", "model_options", "model_options_list",
  "model", "$@11", "$@12", "equation_list", "equation", "tags_list",
  "tag_pair", "hand_side", "$@13", "comma_hand_side", "pound_expression",
  "shocks", "shock_list", "shock_elem", "det_shock_elem",
  "svar_identification", "$@14", "svar_identification_list",
  "svar_identification_elem", "$@15", "$@16", "svar_equation_list",
  "svar_var_list", "restriction_expression", "restriction_expression_1",
  "restriction_elem_expression", "svar_global_identification_check",
  "markov_switching", "ms_options_list", "ms_options", "svar",
  "svar_options_list", "svar_options", "mshocks", "mshock_list",
  "period_list", "sigma_e", "value_list", "triangular_matrix",
  "triangular_row", "steady", "steady_options_list", "steady_options",
  "check", "check_options_list", "check_options", "model_info",
  "model_info_options_list", "model_info_options",
  "perfect_foresight_setup", "perfect_foresight_setup_options_list",
  "perfect_foresight_setup_options", "perfect_foresight_solver",
  "perfect_foresight_solver_options_list",
  "perfect_foresight_solver_options", "gmm_smm_common_option",
  "gmm_estimation", "gmm_estimation_options_list", "gmm_estimation_option",
  "smm_estimation", "smm_estimation_options_list", "smm_estimation_option",
  "prior_function", "posterior_function",
  "prior_posterior_function_options_list",
  "prior_posterior_function_options", "simul", "simul_options_list",
  "simul_options", "external_function", "external_function_options_list",
  "external_function_options", "stoch_simul", "stoch_simul_options_list",
  "stoch_simul_primary_options", "stoch_simul_options", "symbol_list",
  "symbol_list_ext", "signed_integer", "non_negative_number",
  "signed_number", "signed_inf", "signed_number_w_inf", "boolean",
  "estimated_params", "estimated_list", "estimated_elem",
  "estimated_elem1", "estimated_elem2", "estimated_elem3",
  "estimated_params_init", "estimated_init_list", "estimated_init_elem",
  "estimated_params_bounds", "estimated_bounds_list",
  "estimated_bounds_elem", "osr_params_bounds", "osr_bounds_list",
  "osr_bounds_elem", "prior_distribution", "prior_pdf", "date_str",
  "date_expr", "set_time", "data", "data_options_list", "data_options",
  "subsamples", "subsamples_eq", "subsamples_eq_opt",
  "subsamples_name_list", "prior", "$@17", "$@18", "$@19", "$@20", "$@21",
  "$@22", "$@23", "prior_options_list", "prior_options",
  "joint_prior_options_list", "joint_prior_options", "prior_eq",
  "prior_eq_opt", "options", "options_options_list", "options_options",
  "options_eq", "options_eq_opt", "estimation", "estimation_options_list",
  "estimation_options", "list_optim_option", "optim_options",
  "list_sub_sampling_option", "sub_sampling_options",
  "list_sampling_option", "sampling_options", "varobs", "$@24",
  "varobs_list", "varexobs", "$@25", "varexobs_list", "observation_trends",
  "trend_list", "trend_element", "unit_root_vars", "optim_weights",
  "optim_weights_list", "osr_params", "osr_options_list", "osr_options",
  "osr", "dynatype", "dynasave", "load_params_and_steady_state",
  "save_params_and_steady_state", "identification",
  "identification_options_list", "identification_option",
  "model_comparison", "filename", "namespace_qualified_symbol",
  "namespace_qualified_filename", "parallel_local_filename_list",
  "mc_filename_list", "planner_objective", "$@26", "$@27", "ramsey_model",
  "ramsey_policy", "ramsey_constraints", "ramsey_constraints_list",
  "ramsey_constraint", "evaluate_planner_objective",
  "discretionary_policy", "discretionary_policy_options_list",
  "discretionary_policy_options", "ramsey_model_options_list",
  "ramsey_model_options", "ramsey_policy_options_list",
  "ramsey_policy_options", "write_latex_dynamic_model",
  "write_latex_static_model", "write_latex_original_model",
  "write_latex_steady_state_model", "shock_decomposition",
  "realtime_shock_decomposition", "plot_shock_decomposition",
  "initial_condition_decomposition", "squeeze_shock_decomposition",
  "bvar_prior_option", "bvar_common_option", "bvar_density_options_list",
  "bvar_density", "bvar_forecast_option", "bvar_forecast_options_list",
  "bvar_forecast", "sbvar_option", "sbvar_options_list", "sbvar",
  "ms_variance_decomposition_option",
  "ms_variance_decomposition_options_list", "ms_variance_decomposition",
  "ms_forecast_option", "ms_forecast_options_list", "ms_forecast",
  "ms_irf_option", "ms_irf_options_list", "ms_irf",
  "ms_compute_probabilities_option",
  "ms_compute_probabilities_options_list", "ms_compute_probabilities",
  "ms_compute_mdd_option", "ms_compute_mdd_options_list", "ms_compute_mdd",
  "ms_simulation_option", "ms_simulation_options_list", "ms_simulation",
  "ms_estimation_option", "ms_estimation_options_list", "ms_estimation",
  "dynare_sensitivity", "dynare_sensitivity_options_list",
  "dynare_sensitivity_option", "shock_decomposition_options_list",
  "shock_decomposition_option",
  "realtime_shock_decomposition_options_list",
  "realtime_shock_decomposition_option",
  "plot_shock_decomposition_options_list",
  "plot_shock_decomposition_option",
  "initial_condition_decomposition_options_list",
  "initial_condition_decomposition_option", "homotopy_setup",
  "homotopy_list", "homotopy_item", "forecast", "forecast_options",
  "forecast_option", "conditional_forecast",
  "conditional_forecast_options", "conditional_forecast_option",
  "plot_conditional_forecast", "conditional_forecast_paths",
  "conditional_forecast_paths_shock_list",
  "conditional_forecast_paths_shock_elem", "steady_state_model", "$@28",
  "steady_state_equation_list", "steady_state_equation", "calib_smoother",
  "calib_smoother_options_list", "calib_smoother_option", "generate_irfs",
  "generate_irfs_options_list", "generate_irfs_option",
  "generate_irfs_element_list", "generate_irfs_element",
  "generate_irfs_exog_element_list", "extended_path",
  "extended_path_options_list", "extended_path_option",
  "model_diagnostics", "calibration_range", "moment_calibration",
  "moment_calibration_list", "moment_calibration_item", "irf_calibration",
  "irf_calibration_list", "irf_calibration_item", "smoother2histval",
  "smoother2histval_options_list", "smoother2histval_option",
  "shock_groups", "shock_group_list", "shock_group_element",
  "shock_name_list", "init2shocks", "init2shocks_list",
  "init2shocks_element", "o_dr_algo", "o_solve_algo", "o_simul_algo",
  "o_stack_solve_algo", "o_robust_lin_solve",
  "o_endogenous_terminal_period", "o_linear", "o_order", "o_replic",
  "o_drop", "o_ar", "o_nocorr", "o_nofunctions", "o_nomoments", "o_irf",
  "o_irf_shocks", "o_hp_filter", "o_hp_ngrid",
  "o_filtered_theoretical_moments_grid", "o_one_sided_hp_filter",
  "o_periods", "o_solver_periods", "o_extended_path_order", "o_hybrid",
  "o_steady_maxit", "o_simul_maxit", "o_bandpass_filter", "o_dp_maxit",
  "o_osr_maxit", "o_osr_tolf", "o_pf_tolf", "o_pf_tolx", "o_steady_tolf",
  "o_opt_algo", "o_cutoff", "o_markowitz", "o_minimal_solving_periods",
  "o_mfs", "o_simul", "o_simul_replic", "o_simul_seed", "o_qz_criterium",
  "o_qz_zero_threshold", "o_file", "o_pac_name", "o_pac_aux_model_name",
  "o_pac_discount", "o_pac_growth", "$@29", "o_pac_steady_state_growth",
  "o_var_name", "o_var_order", "o_series", "o_datafile", "o_var_datafile",
  "o_var_model_name", "o_var_eq_tags", "o_dirname", "o_huge_number",
  "o_nobs", "o_trend_component_model_name",
  "o_trend_component_model_targets", "o_trend_component_model_eq_tags",
  "o_conditional_variance_decomposition", "o_est_first_obs",
  "o_posterior_sampling_method", "o_first_obs", "o_data_first_obs",
  "o_data_last_obs", "o_keep_kalman_algo_if_singularity_is_detected",
  "o_data_nobs", "o_shift", "o_shape", "o_mode", "o_mean", "o_mean_vec",
  "o_truncate", "o_stdev", "o_jscale", "o_init", "o_bounds", "o_domain",
  "o_interval", "o_variance", "o_variance_mat", "o_prefilter",
  "o_presample", "o_lik_algo", "o_lik_init", "o_nograph",
  "o_posterior_nograph", "o_psd_nograph", "o_shock_decomposition_nograph",
  "o_init_state", "o_forecast_type", "o_shock_decomposition_presample",
  "o_shock_decomposition_forecast", "o_save_realtime", "o_fast_realtime",
  "o_nodisplay", "o_icd_nodisplay", "o_psd_nodisplay", "o_psd_init2shocks",
  "o_icd_max_nrows", "o_psd_max_nrows", "o_graph_format",
  "o_icd_graph_format", "o_psd_graph_format",
  "o_shock_decomposition_with_epilogue", "o_icd_with_epilogue",
  "allowed_graph_formats", "list_allowed_graph_formats",
  "o_subsample_name", "o_bvar_conf_sig", "o_forecasts_conf_sig",
  "o_conditional_forecast_conf_sig", "o_mh_conf_sig", "o_mh_replic",
  "o_posterior_max_subsample_draws", "o_mh_drop", "o_mh_jscale",
  "o_mh_tune_jscale", "o_optim", "o_posterior_sampler_options",
  "o_proposal_distribution", "o_no_posterior_kernel_density",
  "o_mh_init_scale", "o_mode_file", "o_mode_compute", "o_mode_check",
  "o_mode_check_neighbourhood_size", "o_mode_check_number_of_points",
  "o_mode_check_symmetric_plots", "o_prior_trunc", "o_mh_mode",
  "o_mh_nblocks", "o_load_mh_file", "o_load_results_after_load_mh",
  "o_loglinear", "o_linear_approximation", "o_logdata", "o_nodiagnostic",
  "o_bayesian_irf", "o_dsge_var", "o_dsge_varlag", "o_tex", "o_forecast",
  "o_smoother", "o_moments_varendo", "o_contemporaneous_correlation",
  "o_filtered_vars", "o_relative_irf", "o_fast_kalman_filter",
  "o_kalman_algo", "o_kalman_tol", "o_diffuse_kalman_tol",
  "o_marginal_density", "o_print", "o_noprint", "o_xls_sheet",
  "o_xls_range", "o_filter_step_ahead", "o_taper_steps",
  "o_geweke_interval", "o_raftery_lewis_diagnostics",
  "o_raftery_lewis_qrs", "o_constant", "o_noconstant", "o_mh_recover",
  "o_diffuse_filter", "o_plot_priors", "o_aim_solver",
  "o_partial_information", "o_sub_draws", "o_planner_discount",
  "o_planner_discount_latex_name", "o_sylvester",
  "o_sylvester_fixed_point_tol", "o_lyapunov",
  "o_lyapunov_fixed_point_tol", "o_lyapunov_doubling_tol", "o_dr",
  "o_dr_cycle_reduction_tol", "o_dr_logarithmic_reduction_tol",
  "o_dr_logarithmic_reduction_maxiter", "o_psd_detail_plot",
  "o_icd_detail_plot", "o_psd_interactive", "o_psd_screen_shocks",
  "o_psd_steadystate", "o_icd_steadystate", "o_icd_fig_name",
  "o_psd_fig_name", "o_psd_type", "o_icd_type", "o_icd_plot_init_date",
  "o_icd_plot_end_date", "o_psd_plot_init_date", "o_psd_plot_end_date",
  "o_icd_write_xls", "o_psd_write_xls", "o_psd_realtime", "o_psd_vintage",
  "o_psd_diff", "o_icd_diff", "o_psd_flip", "o_icd_flip",
  "o_bvar_prior_tau", "o_bvar_prior_decay", "o_bvar_prior_lambda",
  "o_bvar_prior_mu", "o_bvar_prior_omega", "o_bvar_prior_flat",
  "o_bvar_prior_train", "o_bvar_replic", "o_stderr_multiples",
  "o_diagonal_only", "o_number_of_particles", "o_resampling",
  "o_resampling_threshold", "o_resampling_method", "o_cpf_weights",
  "o_filter_algorithm", "o_nonlinear_filter_initialization",
  "o_proposal_approximation", "o_distribution_approximation",
  "o_gsa_identification", "o_gsa_morris", "o_gsa_stab", "o_gsa_redform",
  "o_gsa_pprior", "o_gsa_prior_range", "o_gsa_ppost", "o_gsa_ilptau",
  "o_gsa_morris_nliv", "o_gsa_morris_ntra", "o_gsa_nsam",
  "o_gsa_load_redform", "o_gsa_load_rmse", "o_gsa_load_stab",
  "o_gsa_alpha2_stab", "o_gsa_logtrans_redform", "o_gsa_threshold_redform",
  "o_gsa_ksstat_redform", "o_gsa_alpha2_redform", "o_gsa_namendo",
  "o_gsa_namlagendo", "o_gsa_namexo", "o_gsa_rmse", "o_gsa_lik_only",
  "o_gsa_var_rmse", "o_gsa_pfilt_rmse", "o_gsa_istart_rmse",
  "o_gsa_alpha_rmse", "o_gsa_alpha2_rmse", "o_gsa_sample_file",
  "o_gsa_neighborhood_width", "o_gsa_pvalue_ks", "o_gsa_pvalue_corr",
  "o_load_ident_files", "o_useautocorr", "o_prior_mc", "o_advanced",
  "o_max_dim_cova_group", "o_homotopy_mode", "o_homotopy_steps",
  "o_homotopy_force_continue", "o_nocheck", "o_controlled_varexo",
  "o_parameter_set", "o_nodecomposition", "o_spectral_density",
  "o_ms_drop", "o_ms_mh_replic", "o_freq", "o_initial_year",
  "o_initial_subperiod", "o_final_year", "o_final_subperiod", "o_data",
  "o_vlist", "o_vlistlog", "o_vlistper", "o_restriction_fname", "o_nlags",
  "o_cross_restrictions", "o_contemp_reduced_form",
  "o_real_pseudo_forecast", "o_no_bayesian_prior", "o_dummy_obs",
  "o_nstates", "o_indxscalesstates", "o_alpha", "o_beta", "o_gsig2_lmdm",
  "o_specification", "o_q_diag", "o_flat_prior", "o_ncsk", "o_nstd",
  "o_ninv", "o_indxparr", "o_indxovr", "o_aband", "o_indxap", "o_apband",
  "o_indximf", "o_indxfore", "o_foreband", "o_indxgforhat",
  "o_indxgimfhat", "o_indxestima", "o_indxgdls", "o_eq_ms", "o_cms",
  "o_ncms", "o_eq_cms", "o_tlindx", "o_tlnumber", "o_cnum",
  "o_k_order_solver", "o_pruning", "o_chain", "o_restrictions",
  "o_duration", "o_number_of_regimes", "o_number_of_lags", "o_parameters",
  "o_coefficients", "o_variances", "o_equations", "o_silent_optimizer",
  "o_instruments", "o_ext_func_name", "o_ext_func_nargs",
  "o_first_deriv_provided", "o_second_deriv_provided",
  "o_filter_covariance", "o_filter_decomposition",
  "o_smoothed_state_uncertainty", "o_selected_variables_only",
  "o_cova_compute", "o_output_file_tag", "o_file_tag", "o_no_create_init",
  "o_simulation_file_tag", "o_coefficients_prior_hyperparameters",
  "o_convergence_starting_value", "o_convergence_ending_value",
  "o_convergence_increment_value", "o_max_iterations_starting_value",
  "o_max_iterations_increment_value", "o_max_block_iterations",
  "o_max_repeated_optimization_runs", "o_function_convergence_criterion",
  "o_parameter_convergence_criterion", "o_number_of_large_perturbations",
  "o_number_of_small_perturbations",
  "o_number_of_posterior_draws_after_perturbation",
  "o_max_number_of_stages", "o_random_function_convergence_criterion",
  "o_random_parameter_convergence_criterion", "o_thinning_factor",
  "o_adaptive_mh_draws", "o_save_draws", "o_proposal_draws",
  "o_use_mean_center", "o_proposal_type", "o_proposal_lower_bound",
  "o_proposal_upper_bound", "o_parameter_uncertainty", "o_horizon",
  "o_filtered_probabilities", "o_real_time_smoothed", "o_no_error_bands",
  "o_error_band_percentiles", "o_shock_draws", "o_shocks_per_parameter",
  "o_free_parameters", "o_median", "o_regimes", "o_regime",
  "o_data_obs_nbr", "o_discretionary_tol", "o_analytic_derivation",
  "o_analytic_derivation_mode", "o_endogenous_prior",
  "o_use_univariate_filters_if_singularity_is_detected",
  "o_mcmc_jumping_covariance", "o_rescale_prediction_error_covariance",
  "o_use_penalized_objective_for_hessian", "o_irf_plot_threshold",
  "o_dr_display_tol", "o_consider_all_endogenous",
  "o_consider_only_observed", "o_no_homotopy", "o_infile", "o_invars",
  "o_period", "o_outfile", "o_outvars", "o_lmmcp", "o_occbin",
  "o_function", "o_sampling_draws", "o_use_shock_groups", "o_colormap",
  "o_icd_colormap", "o_gmm_order", "o_smm_order", "o_gmm_centered_moments",
  "o_smm_centered_moments", "o_gmm_autolag", "o_smm_autolag",
  "o_gmm_recursive_order_estimation", "o_smm_recursive_order_estimation",
  "o_gmm_bartlett_kernel_lag", "o_smm_bartlett_kernel_lag",
  "o_gmm_weighting_matrix", "o_smm_weighting_matrix",
  "o_gmm_penalized_estimator", "o_smm_penalized_estimator",
  "o_gmm_verbose", "o_smm_verbose", "o_smm_simulation_multiple",
  "o_smm_drop", "o_smm_seed", "o_smm_bounded_shock_support",
  "o_analytical_girf", "o_irf_in_percent", "o_emas_girf", "o_emas_drop",
  "o_emas_tolf", "o_emas_max_iter", "o_no_identification_strength",
  "o_no_identification_reducedform", "o_no_identification_moments",
  "o_no_identification_minimal", "o_no_identification_spectrum",
  "o_normalize_jacobians", "o_grid_nbr", "o_tol_rank", "o_tol_deriv",
  "o_tol_sv", "o_checks_via_subsets", "o_max_dim_subsets_groups", "range",
  "integer_range", "integer_range_w_inf", "signed_integer_range",
  "vec_int_number", "vec_int_elem", "vec_int_1", "vec_int", "vec_str_1",
  "vec_str", "vec_value_1", "vec_value", "vec_value_list",
  "vec_of_vec_value", "vec_value_1_w_inf", "vec_value_w_inf", "symbol",
  "number", YY_NULLPTR
  };

#if YYDEBUG
  const unsigned short
  parser::yyrline_[] =
  {
       0,   198,   198,   199,   202,   203,   204,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   317,   319,   323,
     325,   325,   329,   331,   333,   335,   337,   339,   343,   343,
     347,   349,   351,   353,   355,   357,   361,   362,   362,   364,
     364,   368,   369,   372,   374,   376,   380,   381,   384,   385,
     386,   389,   392,   393,   396,   397,   398,   401,   401,   403,
     404,   407,   408,   409,   410,   411,   414,   418,   419,   423,
     425,   425,   430,   432,   434,   436,   438,   442,   442,   446,
     447,   450,   452,   454,   456,   458,   462,   464,   469,   473,
     475,   482,   487,   489,   494,   498,   500,   507,   511,   512,
     515,   519,   523,   524,   527,   528,   531,   533,   535,   537,
     539,   541,   543,   545,   547,   549,   551,   553,   557,   560,
     562,   564,   567,   569,   572,   574,   576,   581,   588,   589,
     592,   594,   596,   598,   600,   602,   604,   606,   608,   610,
     612,   614,   618,   620,   622,   624,   626,   628,   630,   632,
     634,   636,   638,   640,   644,   646,   648,   650,   652,   654,
     656,   658,   660,   662,   664,   666,   670,   672,   674,   676,
     678,   680,   682,   684,   686,   688,   690,   692,   696,   698,
     700,   704,   706,   708,   710,   712,   714,   718,   722,   724,
     726,   728,   732,   734,   739,   746,   748,   752,   754,   756,
     758,   760,   762,   764,   766,   768,   770,   772,   774,   776,
     778,   780,   782,   784,   786,   788,   790,   792,   794,   796,
     798,   800,   802,   804,   806,   808,   810,   812,   814,   816,
     818,   818,   820,   822,   824,   826,   828,   830,   832,   836,
     838,   842,   844,   847,   849,   853,   857,   859,   863,   864,
     867,   869,   871,   875,   876,   879,   881,   885,   885,   889,
     890,   893,   893,   897,   899,   900,   903,   905,   907,   909,
     911,   915,   916,   917,   918,   919,   920,   921,   922,   923,
     924,   925,   926,   929,   930,   933,   933,   935,   935,   939,
     940,   941,   942,   945,   947,   949,   951,   955,   956,   959,
     961,   965,   967,   969,   971,   973,   975,   977,   979,   981,
     983,   985,   987,   989,   991,   993,   995,   997,   999,  1001,
    1003,  1005,  1007,  1009,  1011,  1013,  1015,  1017,  1019,  1021,
    1023,  1025,  1027,  1029,  1031,  1033,  1035,  1037,  1039,  1041,
    1043,  1045,  1047,  1049,  1049,  1051,  1053,  1055,  1057,  1059,
    1061,  1065,  1067,  1071,  1074,  1075,  1078,  1079,  1082,  1083,
    1085,  1087,  1089,  1093,  1097,  1097,  1101,  1102,  1105,  1107,
    1110,  1112,  1109,  1114,  1116,  1120,  1122,  1126,  1128,  1132,
    1133,  1136,  1137,  1140,  1142,  1144,  1146,  1150,  1154,  1158,
    1159,  1162,  1163,  1164,  1165,  1166,  1167,  1170,  1174,  1175,
    1178,  1179,  1180,  1181,  1184,  1185,  1188,  1189,  1192,  1194,
    1196,  1198,  1200,  1202,  1206,  1208,  1210,  1212,  1214,  1216,
    1218,  1222,  1224,  1228,  1230,  1232,  1234,  1236,  1238,  1242,
    1244,  1248,  1249,  1252,  1253,  1254,  1255,  1256,  1257,  1258,
    1259,  1262,  1264,  1268,  1269,  1272,  1273,  1276,  1278,  1282,
    1283,  1285,  1287,  1289,  1293,  1294,  1297,  1298,  1301,  1303,
    1307,  1308,  1311,  1312,  1313,  1314,  1315,  1316,  1317,  1318,
    1319,  1320,  1321,  1322,  1323,  1324,  1325,  1328,  1329,  1330,
    1331,  1332,  1333,  1334,  1335,  1336,  1337,  1338,  1339,  1340,
    1341,  1342,  1343,  1344,  1345,  1346,  1347,  1348,  1349,  1350,
    1351,  1352,  1353,  1354,  1355,  1356,  1357,  1358,  1359,  1360,
    1361,  1362,  1363,  1364,  1365,  1366,  1367,  1368,  1369,  1370,
    1371,  1372,  1373,  1376,  1378,  1382,  1383,  1386,  1387,  1388,
    1389,  1390,  1391,  1392,  1393,  1394,  1397,  1399,  1403,  1404,
    1407,  1408,  1409,  1410,  1411,  1412,  1413,  1414,  1415,  1416,
    1417,  1418,  1419,  1422,  1426,  1430,  1431,  1434,  1435,  1438,
    1440,  1444,  1445,  1448,  1449,  1452,  1456,  1457,  1460,  1461,
    1462,  1463,  1466,  1468,  1470,  1472,  1476,  1477,  1480,  1481,
    1482,  1483,  1484,  1485,  1486,  1487,  1488,  1489,  1490,  1491,
    1492,  1493,  1494,  1495,  1496,  1497,  1498,  1499,  1500,  1501,
    1502,  1503,  1504,  1505,  1506,  1507,  1508,  1509,  1510,  1511,
    1512,  1513,  1514,  1515,  1516,  1517,  1518,  1519,  1520,  1521,
    1522,  1523,  1524,  1525,  1526,  1527,  1528,  1529,  1532,  1533,
    1534,  1535,  1536,  1537,  1540,  1542,  1544,  1548,  1549,  1553,
    1555,  1560,  1563,  1564,  1567,  1569,  1574,  1577,  1579,  1581,
    1585,  1586,  1589,  1590,  1593,  1595,  1597,  1601,  1602,  1604,
    1609,  1614,  1620,  1627,  1631,  1636,  1643,  1647,  1655,  1660,
    1666,  1673,  1683,  1685,  1687,  1691,  1693,  1697,  1703,  1710,
    1718,  1721,  1723,  1727,  1734,  1742,  1751,  1754,  1756,  1760,
    1768,  1770,  1772,  1774,  1776,  1778,  1780,  1782,  1784,  1788,
    1790,  1792,  1794,  1796,  1798,  1800,  1802,  1806,  1808,  1809,
    1813,  1817,  1821,  1822,  1825,  1826,  1827,  1828,  1829,  1830,
    1831,  1834,  1838,  1842,  1844,  1846,  1850,  1851,  1854,  1854,
    1856,  1856,  1858,  1858,  1860,  1860,  1862,  1862,  1864,  1864,
    1866,  1866,  1870,  1871,  1874,  1875,  1876,  1877,  1878,  1879,
    1880,  1881,  1882,  1883,  1886,  1887,  1890,  1891,  1892,  1893,
    1894,  1895,  1896,  1897,  1898,  1899,  1902,  1907,  1909,  1911,
    1913,  1915,  1917,  1921,  1923,  1925,  1927,  1929,  1931,  1935,
    1936,  1939,  1940,  1941,  1944,  1949,  1951,  1953,  1955,  1957,
    1959,  1963,  1965,  1967,  1969,  1973,  1974,  1977,  1978,  1979,
    1980,  1981,  1982,  1983,  1984,  1985,  1986,  1987,  1988,  1989,
    1990,  1991,  1992,  1993,  1994,  1995,  1996,  1997,  1998,  1999,
    2000,  2001,  2002,  2003,  2004,  2005,  2006,  2007,  2008,  2009,
    2010,  2011,  2012,  2013,  2014,  2015,  2016,  2017,  2018,  2019,
    2020,  2021,  2022,  2023,  2024,  2025,  2026,  2027,  2028,  2029,
    2030,  2031,  2032,  2033,  2034,  2035,  2036,  2037,  2038,  2039,
    2040,  2041,  2042,  2043,  2044,  2045,  2046,  2047,  2048,  2049,
    2050,  2051,  2052,  2053,  2054,  2055,  2056,  2057,  2058,  2059,
    2060,  2061,  2062,  2063,  2064,  2065,  2066,  2067,  2068,  2069,
    2070,  2071,  2072,  2073,  2074,  2075,  2076,  2077,  2078,  2079,
    2080,  2081,  2082,  2083,  2084,  2085,  2086,  2087,  2088,  2089,
    2090,  2091,  2092,  2093,  2094,  2095,  2098,  2100,  2102,  2106,
    2107,  2110,  2112,  2116,  2117,  2121,  2123,  2125,  2127,  2131,
    2132,  2135,  2135,  2137,  2139,  2141,  2145,  2145,  2147,  2149,
    2151,  2155,  2157,  2158,  2161,  2163,  2165,  2167,  2169,  2171,
    2173,  2177,  2180,  2181,  2184,  2185,  2186,  2187,  2188,  2189,
    2190,  2193,  2195,  2197,  2199,  2203,  2205,  2209,  2211,  2215,
    2219,  2223,  2225,  2229,  2230,  2233,  2234,  2235,  2236,  2237,
    2238,  2239,  2240,  2241,  2242,  2243,  2244,  2245,  2246,  2247,
    2248,  2249,  2250,  2251,  2252,  2253,  2254,  2255,  2256,  2257,
    2258,  2259,  2260,  2261,  2262,  2263,  2264,  2265,  2266,  2269,
    2271,  2275,  2276,  2279,  2280,  2284,  2285,  2288,  2290,  2294,
    2296,  2298,  2300,  2302,  2304,  2308,  2309,  2308,  2311,  2313,
    2317,  2319,  2321,  2323,  2327,  2331,  2332,  2335,  2337,  2339,
    2341,  2345,  2349,  2351,  2353,  2355,  2359,  2360,  2363,  2364,
    2365,  2368,  2369,  2372,  2373,  2374,  2377,  2378,  2381,  2382,
    2383,  2386,  2388,  2392,  2394,  2398,  2400,  2404,  2408,  2410,
    2412,  2414,  2418,  2420,  2422,  2424,  2428,  2430,  2432,  2434,
    2438,  2440,  2442,  2444,  2448,  2450,  2454,  2455,  2456,  2457,
    2458,  2459,  2460,  2463,  2464,  2465,  2466,  2467,  2468,  2469,
    2470,  2471,  2472,  2475,  2476,  2479,  2481,  2485,  2486,  2487,
    2488,  2491,  2492,  2495,  2497,  2501,  2502,  2503,  2504,  2505,
    2506,  2507,  2508,  2509,  2510,  2511,  2512,  2513,  2514,  2515,
    2516,  2517,  2518,  2519,  2520,  2521,  2522,  2523,  2524,  2525,
    2526,  2527,  2528,  2529,  2530,  2531,  2532,  2533,  2534,  2535,
    2536,  2537,  2538,  2539,  2540,  2541,  2542,  2543,  2544,  2545,
    2546,  2547,  2548,  2551,  2552,  2555,  2557,  2561,  2562,  2563,
    2564,  2565,  2566,  2567,  2568,  2569,  2570,  2571,  2572,  2573,
    2574,  2577,  2578,  2581,  2583,  2587,  2588,  2589,  2590,  2591,
    2592,  2593,  2594,  2595,  2596,  2597,  2598,  2599,  2600,  2603,
    2604,  2607,  2609,  2613,  2614,  2615,  2616,  2617,  2618,  2619,
    2620,  2621,  2622,  2623,  2624,  2625,  2626,  2629,  2630,  2633,
    2635,  2637,  2639,  2643,  2644,  2645,  2646,  2649,  2650,  2653,
    2655,  2659,  2660,  2661,  2662,  2663,  2664,  2665,  2666,  2669,
    2670,  2673,  2675,  2679,  2680,  2681,  2682,  2683,  2684,  2685,
    2688,  2689,  2692,  2694,  2698,  2699,  2700,  2701,  2702,  2703,
    2704,  2705,  2706,  2707,  2708,  2709,  2710,  2711,  2712,  2713,
    2714,  2715,  2716,  2717,  2718,  2719,  2720,  2721,  2722,  2723,
    2724,  2725,  2726,  2727,  2728,  2729,  2730,  2731,  2732,  2735,
    2736,  2739,  2741,  2745,  2747,  2751,  2752,  2755,  2756,  2757,
    2758,  2759,  2760,  2761,  2762,  2763,  2764,  2765,  2766,  2767,
    2768,  2769,  2770,  2771,  2772,  2773,  2774,  2775,  2776,  2777,
    2778,  2779,  2780,  2781,  2782,  2783,  2784,  2785,  2786,  2787,
    2788,  2789,  2790,  2791,  2792,  2793,  2794,  2795,  2796,  2797,
    2798,  2799,  2800,  2801,  2802,  2803,  2804,  2805,  2806,  2809,
    2810,  2813,  2814,  2815,  2816,  2817,  2818,  2819,  2820,  2821,
    2822,  2823,  2824,  2825,  2826,  2827,  2828,  2831,  2832,  2835,
    2836,  2837,  2838,  2839,  2840,  2841,  2842,  2843,  2844,  2845,
    2846,  2849,  2850,  2853,  2854,  2855,  2856,  2857,  2858,  2859,
    2860,  2861,  2862,  2863,  2864,  2865,  2866,  2867,  2868,  2869,
    2870,  2871,  2872,  2875,  2876,  2879,  2880,  2881,  2882,  2883,
    2884,  2885,  2886,  2887,  2888,  2889,  2890,  2891,  2892,  2895,
    2898,  2899,  2902,  2904,  2908,  2909,  2910,  2911,  2914,  2915,
    2918,  2919,  2920,  2921,  2922,  2925,  2929,  2930,  2933,  2934,
    2935,  2936,  2937,  2940,  2942,  2946,  2950,  2951,  2954,  2958,
    2958,  2962,  2963,  2966,  2968,  2972,  2974,  2976,  2978,  2982,
    2983,  2986,  2987,  2988,  2989,  2990,  2991,  2992,  2993,  2994,
    2995,  2996,  2997,  2998,  3001,  3003,  3005,  3007,  3011,  3012,
    3015,  3016,  3019,  3020,  3023,  3027,  3029,  3033,  3035,  3039,
    3040,  3043,  3044,  3045,  3046,  3047,  3048,  3051,  3055,  3057,
    3059,  3063,  3067,  3068,  3071,  3073,  3075,  3079,  3081,  3085,
    3086,  3089,  3091,  3093,  3097,  3099,  3103,  3104,  3107,  3108,
    3109,  3110,  3111,  3114,  3116,  3120,  3121,  3124,  3125,  3128,
    3129,  3130,  3133,  3135,  3139,  3140,  3143,  3144,  3147,  3153,
    3154,  3160,  3161,  3162,  3163,  3164,  3165,  3166,  3167,  3168,
    3169,  3170,  3171,  3172,  3173,  3174,  3178,  3179,  3180,  3181,
    3182,  3183,  3184,  3185,  3186,  3187,  3193,  3194,  3195,  3196,
    3197,  3198,  3199,  3200,  3202,  3203,  3204,  3205,  3206,  3207,
    3208,  3209,  3210,  3211,  3212,  3213,  3214,  3215,  3215,  3216,
    3217,  3219,  3220,  3221,  3222,  3223,  3224,  3225,  3226,  3227,
    3228,  3230,  3233,  3234,  3235,  3236,  3238,  3241,  3243,  3246,
    3248,  3249,  3250,  3251,  3252,  3253,  3254,  3255,  3256,  3257,
    3258,  3259,  3260,  3261,  3262,  3263,  3264,  3265,  3266,  3267,
    3268,  3269,  3270,  3271,  3273,  3276,  3278,  3281,  3282,  3283,
    3284,  3286,  3288,  3289,  3290,  3291,  3292,  3293,  3294,  3295,
    3296,  3298,  3299,  3300,  3302,  3305,  3307,  3310,  3312,  3315,
    3316,  3317,  3319,  3321,  3323,  3326,  3327,  3330,  3333,  3334,
    3335,  3336,  3337,  3338,  3339,  3340,  3341,  3343,  3344,  3345,
    3346,  3347,  3350,  3351,  3352,  3353,  3354,  3355,  3356,  3357,
    3358,  3359,  3360,  3361,  3362,  3363,  3364,  3365,  3366,  3367,
    3368,  3370,  3372,  3375,  3376,  3377,  3378,  3379,  3380,  3381,
    3382,  3383,  3384,  3385,  3386,  3387,  3389,  3392,  3393,  3394,
    3395,  3396,  3397,  3398,  3399,  3400,  3401,  3402,  3403,  3404,
    3405,  3406,  3407,  3408,  3409,  3410,  3411,  3412,  3413,  3414,
    3415,  3416,  3417,  3418,  3419,  3420,  3421,  3422,  3423,  3424,
    3425,  3426,  3427,  3428,  3429,  3430,  3431,  3432,  3433,  3434,
    3436,  3438,  3441,  3443,  3445,  3448,  3449,  3450,  3451,  3452,
    3453,  3454,  3455,  3456,  3457,  3458,  3459,  3460,  3461,  3462,
    3463,  3464,  3465,  3466,  3467,  3468,  3469,  3470,  3471,  3472,
    3473,  3474,  3475,  3476,  3477,  3478,  3479,  3480,  3481,  3482,
    3483,  3484,  3485,  3486,  3487,  3490,  3491,  3492,  3493,  3494,
    3495,  3496,  3497,  3498,  3499,  3500,  3501,  3502,  3503,  3504,
    3505,  3506,  3507,  3508,  3509,  3510,  3511,  3512,  3513,  3514,
    3515,  3516,  3517,  3518,  3519,  3521,  3524,  3525,  3526,  3527,
    3528,  3529,  3530,  3531,  3533,  3534,  3535,  3536,  3538,  3539,
    3541,  3543,  3545,  3547,  3549,  3551,  3554,  3555,  3556,  3557,
    3558,  3560,  3562,  3565,  3566,  3567,  3568,  3569,  3570,  3571,
    3572,  3573,  3578,  3583,  3589,  3590,  3591,  3592,  3593,  3594,
    3595,  3596,  3597,  3598,  3599,  3600,  3602,  3605,  3606,  3607,
    3608,  3609,  3610,  3611,  3612,  3613,  3614,  3615,  3616,  3617,
    3618,  3619,  3620,  3621,  3622,  3623,  3624,  3625,  3626,  3627,
    3628,  3629,  3630,  3631,  3632,  3635,  3637,  3640,  3641,  3642,
    3643,  3644,  3645,  3647,  3650,  3651,  3653,  3654,  3655,  3657,
    3660,  3662,  3665,  3668,  3671,  3674,  3677,  3680,  3681,  3682,
    3683,  3684,  3686,  3688,  3690,  3692,  3694,  3696,  3698,  3700,
    3702,  3704,  3706,  3708,  3710,  3712,  3714,  3716,  3717,  3718,
    3719,  3720,  3721,  3722,  3723,  3724,  3725,  3726,  3727,  3728,
    3729,  3730,  3731,  3732,  3733,  3734,  3735,  3736,  3737,  3738,
    3739,  3740,  3741,  3742,  3743,  3744,  3746,  3748,  3751,  3752,
    3753,  3754,  3755,  3756,  3757,  3759,  3760,  3761,  3762,  3763,
    3764,  3765,  3766,  3767,  3768,  3769,  3771,  3772,  3774,  3775,
    3776,  3777,  3778,  3780,  3783,  3785,  3788,  3789,  3790,  3791,
    3792,  3794,  3796,  3798,  3801,  3803,  3805,  3807,  3810,  3811,
    3812,  3813,  3815,  3816,  3817,  3818,  3820,  3821,  3822,  3823,
    3824,  3825,  3828,  3829,  3830,  3831,  3832,  3833,  3834,  3835,
    3836,  3837,  3838,  3839,  3841,  3844,  3847,  3849,  3853,  3855,
    3858,  3862,  3863,  3871,  3873,  3875,  3880,  3887,  3888,  3891,
    3893,  3895,  3900,  3907,  3908,  3911,  3913,  3915,  3917,  3921,
    3923,  3927,  3929,  3932,  3934,  3937,  3939,  3943,  3946,  3947,
    3948,  3949,  3950,  3951,  3952,  3953,  3954,  3955,  3956,  3957,
    3958,  3959,  3960,  3961,  3962,  3963,  3964,  3965,  3966,  3967,
    3971,  3972
  };

  // Print the state stack on the debug stream.
  void
  parser::yystack_print_ ()
  {
    *yycdebug_ << "Stack now";
    for (stack_type::const_iterator
           i = yystack_.begin (),
           i_end = yystack_.end ();
         i != i_end; ++i)
      *yycdebug_ << ' ' << i->state;
    *yycdebug_ << '\n';
  }

  // Report on the debug stream that the rule \a yyrule is going to be reduced.
  void
  parser::yy_reduce_print_ (int yyrule)
  {
    unsigned yylno = yyrline_[yyrule];
    int yynrhs = yyr2_[yyrule];
    // Print the symbols being reduced, and their result.
    *yycdebug_ << "Reducing stack by rule " << yyrule - 1
               << " (line " << yylno << "):\n";
    // The symbols being reduced.
    for (int yyi = 0; yyi < yynrhs; yyi++)
      YY_SYMBOL_PRINT ("   $" << yyi + 1 << " =",
                       yystack_[(yynrhs) - (yyi + 1)]);
  }
#endif // YYDEBUG

  parser::token_number_type
  parser::yytranslate_ (int t)
  {
    // YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to
    // TOKEN-NUM as returned by yylex.
    static
    const token_number_type
    translate_table[] =
    {
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,   651,     2,     2,     2,     2,
     647,   648,     2,     2,     2,     2,   653,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   652,   646,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   649,     2,   650,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645
    };
    const unsigned user_token_number_max_ = 900;
    const token_number_type undef_token_ = 2;

    if (static_cast<int> (t) <= yyeof_)
      return yyeof_;
    else if (static_cast<unsigned> (t) <= user_token_number_max_)
      return translate_table[t];
    else
      return undef_token_;
  }

#line 25 "DynareBison.yy" // lalr1.cc:1242
} // Dynare
#line 14893 "DynareBison.cc" // lalr1.cc:1242
#line 3974 "DynareBison.yy" // lalr1.cc:1243


void
Dynare::parser::error(const Dynare::parser::location_type &l,
                      const string &m)
{
  driver.error(l, m);
}
